//O[oϐ
float4x4 VProjMat;
float4x4 ViewMat;
float4x4 ProjMat;
float4x4 WorldMat;
float4 Diffuse;
float4 Specular;
float Power;
texture MeshTex;
bool haveTex = false;
float4 Ambient;
float LightNum=4;
float4 Light[4];
float4 LightCol[4];
float4 BillDiffuse;
float Attenuate[4];
bool IsLightOn[4];
bool IsAttenuate[4];
float4x4 SkinningMat[40];
float4 vEye; 
float4 zeroVec = float4(0.f,0.f,0.f,0.f);
float4x4 LastWV;
float4x4 WV;
int FrameNum;
// VhE
/*
#define TEX_SIZE 2048
float4x4 WVProj;
float3 LightWPos;
float4x4 LightVProj;
float4 LightColor;
texture ShadowTex;
float Margin;
*/
struct VS_OUT
{
	float4 Pos : POSITION;
	float4 Col : COLOR0;
	float2 MeshUV : TEXCOORD0;
	float3 Normal : TEXCOORD1;
	float3 View : TEXCOORD2;
	float3 Light : TEXCOORD3;
};

struct BDVS_OUT
{
	float4 Pos : POSITION;
	float3 Normal : TEXCOORD1;
	float4 Col : COLOR0;
	float2 Decal : TEXCOORD;
};


struct VS_OUT_PHONG
{
	float4 Position : POSITION;
	float2 Decal : TEXCOORD;
	float3 Normal : TEXCOORD1;
	float3 View : TEXCOORD2;
};

//==============================================================
// eNX`Tv
sampler MeshSmp=sampler_state {
	Texture=<MeshTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU=CLAMP;
	AddressV=CLAMP;
};

//==============================================================

// XLjO_VF[_
VS_OUT SkinningVS (
	float4 pos : POSITION,
	float4 weights : BLENDWEIGHT,
	int4 indices : BLENDINDICES,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0
) {
    VS_OUT Out = (VS_OUT)0; 
	float    LastBlendWeight = 0.0f;        // Ō̍sɊ|d
	float4x4 comb = 0.0f;           // [hϊs
	float w[4] = (float[4])weights;
	int index[4]=(int[4])indices;
	// [hϊsuh
	for(int i=0; i<3; i++){
		LastBlendWeight += w[i];   // Ō̏d݂ŌvZĂ
		comb += SkinningMat[ index[i] ] * w[i];
		if(w[i] == 1 )
			break;
	}

   // Ō̏d݂𑫂Z
	if( w[0] != 1 )
		comb += SkinningMat[ index[3] ] * (1.0f-LastBlendWeight);	
	
	Out.Pos = mul( pos , comb );
	float3 PosWorld = Out.Pos;
	Out.Pos=mul(Out.Pos, VProjMat);
	Out.Normal = mul(normal, comb);
//	Out.Normal = normalize( Out.Normal );
	Out.MeshUV=mesh_uv;	
	Out.View = PosWorld.xyz - Light[1].xyz;  
	return Out;
}

// XLjO_VF[_
VS_OUT SkinningVSBlur (
	float4 pos : POSITION,
	float4 weights : BLENDWEIGHT,
	int4 indices : BLENDINDICES,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0
) {
    VS_OUT Out = (VS_OUT)0; 
    float    LastBlendWeight = 0.0f;        // Ō̍sɊ|d
	float4x4 comb = 0.0f;           // [hϊs
	float w[4] = (float[4])weights;
	int index[4]=(int[4])indices;
	// [hϊsuh
	for(int i=0; i<3; i++){
		LastBlendWeight += w[i];   // Ō̏d݂ŌvZĂ
		comb += SkinningMat[ index[i] ] * w[i];
		if(w[i] == 1 )
			break;
	}

   // Ō̏d݂𑫂Z
	if( w[0] != 1 )
		comb += SkinningMat[ index[3] ] * (1.0f-LastBlendWeight);	
//	Out.Pos = mul( pos , comb );
//	Out.Pos = mul( pos , WorldMat );
WV = comb * ViewMat;
//--------------------------------------------------------------
//L΂ɂ郂[Vu[
	// Wϊ
	float4 x1 = mul(pos, WV );			// ̃r[W
	float4 x0 = mul(pos, LastWV );		// mLastWVPt[Õr[W
	float4 v = x1-x0;					// x
//	float3 n = mul(Normal, sa);		// r[Wnł̖@
	Out.Normal = mul(normal, WV);		// r[Wnł̖@
	bool bFront = (0<=dot( Out.Normal, v.xyz));	// xĂH
	float4 x = bFront ? x1 : x0;		// ɂāAʒu߂
	
	Out.Pos = mul(x, ProjMat);				// ˉeԂɕϊ
//	Out.Normal = mul(normal, comb);
//--------------------------------------------------------------
	
//	Out.Pos.x -= 1.f;
	float3 PosWorld = Out.Pos;
//	Out.Pos=mul(Out.Pos, VProjMat);
//	Out.Normal = mul(normal, comb);
//	Out.Normal = normalize( Out.Normal );
	Out.MeshUV=mesh_uv;
	Out.View = PosWorld.xyz - Light[1].xyz;  
Diffuse.a = 0.2f;
//LastWV = WV;

	return Out;
}


//XLjOȂ_VF[_
VS_OUT PhongVS(float4 Pos : POSITION, float3 Normal : NORMAL , float2 mesh_uv : TEXCOORD )
{
    VS_OUT Out = (VS_OUT)0; 
    Out.Pos = mul(Pos, WorldMat );
    float4 PosWorld =Out.Pos; 
	Out.Pos=mul(Out.Pos, VProjMat);
    Out.MeshUV = mesh_uv;
    Out.View = PosWorld.xyz;
Out.Normal = mul(Normal, WorldMat); 

	return Out;
}

//r{[hp̒_VF[_
BDVS_OUT BoardVS(float4 Pos : POSITION,float3 Normal : NORMAL , float2 mesh_uv : TEXCOORD )
{
    BDVS_OUT Out = (BDVS_OUT)0; 
    Out.Pos = Pos;//mul(Pos, WorldMat );
//    float4 PosWorld =Out.Pos; 
	Out.Pos=mul(Out.Pos, VProjMat);
    Out.Decal = mesh_uv;
//    Out.View = PosWorld.xyz;
	Out.Normal = Normal;//mul(Normal, WorldMat); 

	return Out;
}

//r{[hp̃sNZVF[_
float4 BoardPS(BDVS_OUT In) : COLOR
{
	
	return tex2D(MeshSmp , In.Decal)*BillDiffuse;	
}

// sNZVF[_
float4 PhongPS(
	VS_OUT In
) : COLOR {
	for( int i=0;i<4;i++)
		IsAttenuate[i] = false;
//	IsAttenuate[0] = true;
	IsAttenuate[1] = true;
	IsAttenuate[2] = true;
	IsLightOn[0] = true;
	IsLightOn[1] = true;
	IsLightOn[2] = true;
//	IsLightOn[2] = true;
//*/	
//	Light[1] = float4( 16.7f,1.f,-3.3f,0.f);
	float3 PosWorld = In.View;
	float3 Normal = normalize( In.Normal );
	float3 ViewDir = normalize(In.View); 
	float3 temp = float3(0.f,0.f,0.f);
//	float4 LightDir;
	float3 NL = float3(0.1f,0.1f,0.1f);
	float3 view = float3(0.f,0.f,0.f);
	float le = 0.01f;
	bool isSpec = true;
	if( Specular.x == zeroVec.x )
		if( Specular.y == zeroVec.y )
			if( Specular.z == zeroVec.z )
				isSpec =false;
		
	for( int i=0;i<4;i++){
		if( IsLightOn[i] ){
//			LightDir = normalize( Light[i] );//normalize(Light);	
//			float3 t =saturate(dot(Normal, LightDir));
			float3 t =saturate(dot(Normal, Light[i].xyz));
			t *= LightCol[i];
//			if( i != 0 ){
				if( IsAttenuate[i] ){
					view = PosWorld - Light[ i ].xyz;   
					le = length( view );
					t /= le*le/Attenuate[i];									
				}
//			}
			NL += t;
			if( isSpec )
				temp += 2 * NL * Normal - Light[i].xyz;
		}
	}
	float3 specular = Specular.xyz;
	if( isSpec ){
		float3 Reflect = normalize( temp ); 
		specular *= pow(saturate(dot(Reflect, In.View)), Power );
	}
	
	float4 D = Diffuse * float4(NL,1.f);
	D.a = Diffuse.a;
	if( haveTex )
		return tex2D(MeshSmp, In.MeshUV) * D + float4(specular,0.f) + float4(Ambient.xyz,0.f);
	else
		return D + float4(specular,0.f) + float4(Ambient.xyz,0.f); 
}

// sNZVF[_
float4 PhongPSBlur(
	VS_OUT In
) : COLOR {
	Diffuse.a = 0.2f;
	if( haveTex )
		return tex2D(MeshSmp, In.MeshUV) * Diffuse;
	else
		return Diffuse;
}
//--------------
//eNjbN

technique Skinning{
	pass P0 {
		VertexShader=compile vs_2_0 SkinningVS();
		PixelShader=compile ps_2_0 PhongPS();
		ZEnable = TRUE; 		
		AlphaBlendEnable = TRUE;
		SrcBlend = SrcAlpha;
		DestBlend=InvSrcAlpha;
	}
	pass P1 {
		VertexShader=compile vs_2_0 SkinningVSBlur();
		PixelShader=compile ps_2_0 PhongPSBlur();
		ZEnable = TRUE; 		
		AlphaBlendEnable = TRUE;
		SrcBlend = SrcAlpha;
		DestBlend=InvSrcAlpha;
		
	}
}

technique Phong
{
    pass Phong
    {		
        VertexShader = compile vs_2_0 PhongVS();
        PixelShader  = compile ps_2_0 PhongPS();
   		ZEnable = TRUE; 		
		ZWriteEnable = TRUE;
		AlphaBlendEnable = TRUE;
		SrcBlend = SrcAlpha;
		DestBlend=InvSrcAlpha;
    }
}

technique Board
{
    pass Board
    {		
        VertexShader = compile vs_2_0 BoardVS();
        PixelShader  = compile ps_2_0 BoardPS();
   		ZEnable = FALSE;	
		ZWriteEnable = TRUE;
		AlphaBlendEnable = TRUE;
		SrcBlend = SrcAlpha;
		DestBlend=InvSrcAlpha;
    }
}
