function ChangeAnim( agent , animData )
	agent:getProcessor():process( "Animation" ):setData( animData );
	local arg = {
		ProcessName="Animation" ,
		ProcessMode=Process.INITIALIZING
	}
	StateFunctions["ChangeProcessMode"]( agent , arg );					
end

function CloneChara( originalName , cloneName )
	if IsKeyExist( CharaData , originalName ) then
		CharaData[ cloneName ]=CopyTable( CharaData[ originalName ] );
		CharaData[ cloneName ].name= cloneName;
	end
end

function Revive( name )
	local a = Character.get( name );
	if a then
		if a:isReady() then
--		if a:getFSM():currentStateName() == "Dead_State" then
			local charaname = a:name();
			if IsKeyExist( CharaData , charaname ) then				
				a:setVisible( true );
				a:getFSM():changeState( "Wait_State" );
				if a:model() then
					a:model():setAlpha(1);
				end
				a:activate( true );
				local hp = CharaData[ charaname ][ "hitPoint" ];
				a:setHitPoint( hp );
				local pos = a:position();
				local rand = Random():getInt( -1 , 1 );
				local prop = Character.getProperty( charaname );
				prop["physical"] = 100;
			
--				a:setPosition( Vec3( pos.x , pos.y , pos.z ) );
--]]
				return true;
			end
		end
	end
	return false;
end

--Agent̂goOɂȂ2b玀SbZ[W𑗂
function AgentDying(agent)
	if agent:hitpoint() == 0 then
		if agent:getFSM():Time() > 2 then
			local data={
				NodeID=agent:ID(),
				AgentID=agent:agentID(),
				Type=agent:entityType()
			};
			--listCe[gAgentScenedetacĥŁAtriggerł͂Ȃqueue
			GetEventManager():queueEvent( "AgentDying", data );
		end	
	end
end

function IsAnimationFinished(agent)
	local animCont = agent:animationControl();
	if animCont:Time() > animCont:currentAnimation():lastTime() -1 then
--[[		if IsKeyExist( AnimationParam , agent:modelName() ) then
			local t = AnimationParam[ agent:modelName() ];
			if IsKeyExist( t , agent:animationControl():currentAnimeName() ) then
				t = t[ agent:animationControl():currentAnimeName() ];
				if IsKeyExist( t , "IsSavePositionWhenAnimDone" ) then
					agent:setPosition( agent:model():findFrame( t[ "IsSavePositionWhenAnimDone" ] ):position() );
				end
			end
		end
--]]		
		local evtData={}
		evtData["name"]= agent:name();
		local rol =Character.getRollType( agent:name() );
		local evtType = rol..animCont:currentAnimeName().."AnimFinished";
		TriggerEvent( evtType , evtData );
		return true;
	end
	return false;
end

function AnimationPause(agent)
	if IsAnimationFinished(agent) then
		agent:animationControl():setMode(AnimationControl.PAUSE);
	end
end

function Pause( agent )
--TO DO :@|[Y̐lwł悤
	if agent:getFSM():Time() > 2 then
		agent:getFSM():processCompleted();
	end
end

function IsProcessCompleted(agent)
	if agent:getFSM():isProcessCompleted() then
		return true;
	else
		return false;
	end
end


function FindFuncAndExecute( agent , funcList , funcDictionary )
	for funcname1 , argList in pairs( funcList ) do
		for funcname2, Execute in pairs( funcDictionary ) do
			if funcname1 == funcname2 then
				for i=1,#argList, 1 do
					Execute( agent , argList[ i ] );
				end
			end
		end
	end
end

function ChangeAnimationData( agent , data )
	agent:getProcessor():process( "Animation" ):setData( data );
	agent:getProcessor():process( "Animation" ):changeMode( Process.INITIALIZING );
end

AttackNotHitStateName=
"Down_State\
StandUp_State\
 Thrown_State\
 Throw_State\
 Dead_State\
 BlewUpDown_State\
 BlewDown_State\
 BlewUp_State";

 function DamageToAgentBrain( attacker , attacked , pos , atkData , particleName )
	local atkedName = attacked:name();
	local dmgData={
		name=atkedName,
		damagePoint=atkData["DamagePoint"] 
	}
	local particleData={
		setname=particleName,
		pos={ pos.x , pos.y , pos.z }
	}
	for i=1,atkData["DamagePoint"]*10,1 do 
		Particle.trigger( particleData );
	end
	local chData = Character.getData( atkedName );
	particleData["setname"]="hitEffect";
	Particle.trigger( particleData );
	local role = Character.getRollType( attacked:name() );	
	TriggerEvent( role.."Damaged" , dmgData );
	GetSoundManager():playSe( atkData["HitSoundName"] );

	local prop = Character.getProperty( attacker:name() );
	local atten = 1; --_[WW
	--̗̑͂Ă΃_[W
	if prop["physical"] < 20 then
		atten = prop["physical"] / 100 + 0.3;
	end
	--_[Wf[^
	local ddata={
		attackedName = atkedName,
		attackerName =  attacker:name(),
		power = atten * atkData["DamagePoint"], --{̃_[W|CgɌW	
	}
	TriggerEvent( "Damage" , ddata );	
--[[
	local pdata = PainEvtData();
	pdata.AttackedName = atkedName;
	pdata.AttackerName =  attacker:name();
	pdata.Power = atkData["DamagePoint"];
	--Accept PulseData 
	local br = attacked:brain();
	if br then
		br:triggerEvent( "Pain" , pdata );	
	end
	attacked:damage( atkData["DamagePoint"] );
--]]
end
 
function AttackHit( attacker , attacked , data )
	local col = Native.PhysicsManager():collision( attacker:name() );
	local animname = attacker:animationControl():currentAnimeName();
	if not IsKeyExist( data , animname ) then
		return;
	end
	local aData = data[ animname ];
	local hitframename = aData[ "HitFrameName" ];
	local current =attacked:getFSM():currentStateName();
	col:enableDetect( hitframename , false );	
	local prop = Character.getProperty( attacked:name() );
	if  not string.find( AttackNotHitStateName , current ) then
		local framePos = attacker:model():findFrame( hitframename ):position();
		local attackedCurrAnim = attacked:animationControl():currentAnimeName();
		local isHit = true;
		if current == "Guard_State" then
			local particleData={
				setname="particleBlue",
				pos={framePos.x , framePos.y,framePos.z}
			}
			for i=1,aData["DamagePoint"]*5,1 do 
				Particle.trigger( particleData );
			end
			GetSoundManager():playSe( "hit_p0222223333" );
			
			local p1 = Vec3(0);
			attacker:getDirection( p1 );
			local p2 = Vec3(0);
			attacked:getDirection( p2 );
			local ip = p1:dot( p2 );
			if ip < 0 then
				isHit = false;
			end
			local dmg = aData["DamagePoint"];
			prop["physical"] = prop["physical"] -  1.5*dmg*dmg ;
			if prop["physical"] < 0 then
				attacked:getFSM():changeState( "MiddleDamaged_State" );
			end
		end
		if current == "Kawashi_State" then
			isHit = false;
			GetSoundManager():playSe( "hit_p0222223333" );		
			attacker:getFSM():changeState( "MiddleDamaged_State" );			
		end
		if isHit then
			DamageToAgentBrain( attacker , attacked , framePos , aData , "particleYellow" );
--			if aData.blewUp then
--			if aData["DamagePoint"] >= 4 then
			BlewUpTranslate( attacked , attacker , aData["DamagePoint"] );
--			end
		end
		
--		attacker:getProcessor():changeProcessMode( "JagMoved" , Process.INITIALIZING );
		attacked:getProcessor():changeProcessMode( "JagMoved" , Process.INITIALIZING );
	end	
--]]
end

function BlewUpTranslate( damagedAgent , attacker , damagePoint )
	local dir = Vec3();
	dir:setSub( damagedAgent:position() , attacker:position() );
	dir:normalize();
	dir.y = 0;
	local data={
		Dir=dir,
		Speed = damagePoint*0.01,--damagePoint*damagePoint*0.001,
		Animation={
			"BlewUp2",
			"BeatFallDown",
			"BlewUpDown",
		},
		Type="Add",
	}
	--TODO process( processname ) is late
	local proc = damagedAgent:getProcessor():process( "BlewUpTranslate" );
	proc:setData( data );
	proc:changeMode( Process.ACTIVATED );	
end

function AgentDie( agent , alpha )
	agent:model():setAlpha( alpha/255 );
end 
 
QueueEnemy=function( list )
	for i=1,#list,1 do
		local name = list[i]["name"];
		local chara = Character.get( name );
		if chara then
			chara:setVisible( true );
		end
		EnemyQueue.push_back( list[i] );
	end
end


Agent_State={}
Agent_State["Enter"]=function(agent, data)
	local role = Character.getRollType( agent:name() );
	TriggerEvent( role..agent:getFSM():currentStateName().."_Enter" , data );
	if IsKeyExist( data , "Enter" ) then
		FindFuncAndExecute( agent , data["Enter"] , StateFunctions );
	end
end
Agent_State["Update"]=function(agent,data)
	Dout(agent:name().."CurrentStateName:"..agent:getFSM():currentStateName() )
	if IsKeyExist( data , "Update" ) then
		FindFuncAndExecute( agent , data["Update"] , StateFunctions );
	end
end
Agent_State["Exit"]=function(agent,data)
	local role = Character.getRollType( agent:name() );
	TriggerEvent( role..agent:getFSM():currentStateName().."_Exit" , data );
	if IsKeyExist( data , "Exit" ) then
		FindFuncAndExecute( agent , data["Exit"] , StateFunctions );
	end
end

StateFunctions={
	SetAnimationData=function( agent ,data )
		agent:getProcessor():process( "Animation" ):setData( data );
	end,
	TransitionByInput=function( agent , args )
		if agent:command():isPushed( args["Button"] ) then
			agent:getFSM():changeState( args["NextState"] );
		end
	end,
	NotIsOnKey=function( agent , args )
		if not agent:command():isOn( args["Button"] ) then
			agent:getFSM():changeState( args["NextState"] );
		end
	end,
	IsProcessMode=function( agent , args )
		local ret = false;
		local process = agent:getProcessor():process( args["ProcessName"] );
		if process then
			ret = ( process:mode() == args["ProcessMode"]);
		end
		return ret;
	end,
	ChangeProcessModeByInput=function( agent , args )
		if agent:command():isPushed( args["Button"] ) then
			agent:getProcessor():changeProcessMode( args["ProcessName"] , args["ProcessMode"] );
		end
	end,
	ChangeProcessMode=function( agent , args )
		agent:getProcessor():changeProcessMode( args["ProcessName"] , args["ProcessMode"] );
	end,
	IsProcessModeThen=function( agent , args )
		local process = agent:getProcessor():process( args["ProcessName"] )
		if process then
			if process:mode() == args["ProcessMode"]  then
				agent:getFSM():changeState( args["NextState"] );
			end
		end
	end,
	IsPrevStateThen=function( agent , args )
		for k=1,#args["PrevState"],1 do
			if agent:getFSM():prevStateName() == args["PrevState"][k] then
				FindFuncAndExecute( agent , args , StateFunctions );
			end
		end
	end,
	IsProcessElapsedTimeThen=function( agent , args )
		local process = agent:getProcessor():process( args["ProcessName"] )
		if process then
			if process:mode() == args["ProcessMode"]  then
				agent:getFSM():changeState( args["NextState"] );
			end
		end
	end,
	
}

UNABLE_Guard={ ProcessName="Guard" , ProcessMode=Process.WAITING }
UNABLE_Move={ ProcessName="Move" , ProcessMode=Process.WAITING }
ENABLE_Move={ ProcessName="Move" , ProcessMode=Process.INITIALIZING }
UNABLE_Ladder={ ProcessName="Ladder" , ProcessMode=Process.WAITING }
ENABLE_Ladder={ ProcessName="Ladder" , ProcessMode=Process.INITIALIZING }
UNABLE_Gravity={ ProcessName="Gravity" , ProcessMode=Process.WAITING  }
ENABLE_Gravity={ ProcessName="Gravity" , ProcessMode=Process.INITIALIZING  }
UNABLE_Hit={ ProcessName="AttackHit" , ProcessMode=Process.WAITING  }
ENABLE_Hit={ ProcessName="AttackHit" , ProcessMode=Process.INITIALIZING  }
UNABLE_JumpUp={ ProcessName="JumpUp" , ProcessMode=Process.WAITING }
ENABLE_JumpUp={ ProcessName="JumpUp" , ProcessMode=Process.INITIALIZING  }
UNABLE_Animation={ ProcessName="Animation" , ProcessMode=Process.WAITING  }
ENABLE_Animation={ ProcessName="Animation" , ProcessMode=Process.INITIALIZING  }

gUntilAnimationFinished={
	Enter={
		ChangeProcessMode={
			{ ProcessName="Move" , ProcessMode=Process.WAITING },
			{ ProcessName="Animation" , ProcessMode=Process.INITIALIZING  },
--			{ ProcessName="Gravity" , ProcessMode=Process.WAITING  },	
--			{ ProcessName="Gravity" , ProcessMode=Process.INITIALIZING  },	
		}
	},
	Update={
		IsProcessModeThen={
			{ ProcessName="Animation" , ProcessMode=Process.WAITING , NextState="Wait_State" },
		}
	}
}
gThrown_State={
	Enter={
		ChangeProcessMode={
			{ ProcessName="Move" , ProcessMode=Process.WAITING },
			{ ProcessName="Animation" , ProcessMode=Process.INITIALIZING  },
		}
	},
	Update={
		IsProcessModeThen={
			{ ProcessName="Animation" , ProcessMode=Process.WAITING , NextState="BlewUpDown_State" },
		}
	}
}
gWait_State={
	Enter={
		ChangeProcessMode={
			UNABLE_Guard,
			ENABLE_Gravity,
			ENABLE_Hit,
		}
	},
	Update={
		IsProcessModeThen={
			{ ProcessName="Gravity" , ProcessMode=Process.ACTIVATED , NextState="Fall_State" },
		}			
	},		
}
gBoundWall_State={
	Enter={
		ChangeProcessMode={
			UNABLE_Move,
		}
	},
	Update={
		IsProcessModeThen={
			{ ProcessName="Animation" , ProcessMode=Process.WAITING , NextState="FrontFall_State" },
		}			
	},		
}
gFrontFall_State={
	Enter={
		ChangeProcessMode={
			ENABLE_Gravity,
		}
	},
	Update={
		IsProcessModeThen={
			{ ProcessName="Gravity" , ProcessMode=Process.WAITING , NextState="FaceDownLand_State" },
		}			
	},		
}
gFall_State={
	Enter={
		ChangeProcessMode={
			ENABLE_Move,
			ENABLE_Gravity,
		}
	},
	Update={
		IsProcessModeThen={
			{ ProcessName="Gravity" , ProcessMode=Process.WAITING , NextState="Land_State" },
		}			
	},		
}
gLand_State={
	Enter={
		ChangeProcessMode={
			ENABLE_Move,
		}
	},
	Update={
		IsProcessModeThen={
			{ ProcessName="Animation" , ProcessMode=Process.WAITING , NextState="Wait_State" },
		}
	}
}
gWalk_State={
	Enter={
		ChangeProcessMode={
			ENABLE_Move,
			ENABLE_Gravity,
			ENABLE_Hit
		}
	},
	Update={
		ChangeProcessMode={
			ENABLE_Gravity,
		},
		IsProcessModeThen={
			{ ProcessName="Gravity" , ProcessMode=Process.ACTIVATED , NextState="Fall_State" },
		}			
	},		
}
gLadder_State={
	Enter={
		ChangeProcessMode={
			ENABLE_Move,
			ENABLE_Hit,
			UNABLE_Gravity,
			
		}
	},
}
gRun_State={
	Enter={
		ChangeProcessMode={
			ENABLE_Move,
			ENABLE_Gravity,
			ENABLE_Hit
		}
	},
	Update={
		ChangeProcessMode={
			ENABLE_Gravity,
		},
		IsProcessModeThen={
			{ ProcessName="Gravity" , ProcessMode=Process.ACTIVATED , NextState="Fall_State" },
		}			
	},		
	Exit={
		ChangeProcessMode={
			{ ProcessName="Inertia" , ProcessMode=Process.INITIALIZING },
		}
	}
}
gJumpUp_State={
	Enter={
		ChangeProcessMode={
			ENABLE_Move,
			UNABLE_Gravity,
			ENABLE_JumpUp
		}
	},
	Update={
		IsProcessModeThen={
			{ ProcessName="JumpUp" , ProcessMode=Process.WAITING , NextState="Fall_State" },
		},
	},
}
gGrappling_State={
	Enter={
		ChangeProcessMode={
			UNABLE_Move,
			ENABLE_Animation,
			ENABLE_Hit
		}
	},	
}
gGrapplingJumpUp_State={
	Enter={
		ChangeProcessMode={
			ENABLE_Move,
			UNABLE_Gravity,
			ENABLE_Animation,
			ENABLE_JumpUp
		}
	},
	Update={
		IsProcessModeThen={
			{ ProcessName="JumpUp" , ProcessMode=Process.WAITING , NextState="GrapplingFall_State" },
		},
	},
}
gGrapplingFall_State={
	Enter={
		ChangeProcessMode={
			ENABLE_Move,
			ENABLE_Gravity,
		}
	},
	Update={
		IsProcessModeThen={
			{ ProcessName="Gravity" , ProcessMode=Process.WAITING , NextState="JumpUp_State" },
		}			
	},		
}
gGrappled_State={
	Enter={
		ChangeProcessMode={
			UNABLE_Move,
			ENABLE_Animation,
		}
	},	
}
gGrappledJumpUp_State={
	Enter={
		ChangeProcessMode={
			UNABLE_Move,
			UNABLE_Gravity,
			ENABLE_JumpUp
		}
	},
	Update={
		IsProcessModeThen={
			{ ProcessName="JumpUp" , ProcessMode=Process.WAITING , NextState="GrappledFall_State" },
		},
	},
}
gGrappledFall_State={
	Enter={
		ChangeProcessMode={
			UNABLE_Move,
			ENABLE_Gravity,
		}
	},
	Update={
		IsProcessModeThen={
			{ ProcessName="Gravity" , ProcessMode=Process.WAITING , NextState="BlewUp_State" },
		}			
	},		
}

gGrappledDamaged_State={
	Enter={
		ChangeProcessMode={
			UNABLE_Move,
			ENABLE_Animation,
		}
	},
	Update={
		IsProcessModeThen={
			{ ProcessName="Animation" , ProcessMode=Process.WAITING , NextState="Grappled_State" },
		},
	}
}
gMiddleDamaged_State={
	Enter={
		ChangeProcessMode={
			UNABLE_Move,
			ENABLE_Animation,
			{ ProcessName="MiddleDamagedWait" , ProcessMode=Process.INITIALIZING  },
		}
	},
	Update={
		IsProcessModeThen={
			{ ProcessName="MiddleDamagedWait" , ProcessMode=Process.WAITING , NextState="Wait_State" },
		},
	},
}
gBlewUp_State={
	Enter={
		ChangeProcessMode={
			UNABLE_Move,
			ENABLE_Animation,
			UNABLE_Gravity,
--			ENABLE_JumpUp
		}
	},	
	Update={
		IsProcessModeThen={
			{ ProcessName="JumpUp" , ProcessMode=Process.WAITING , NextState="BlewDown_State" },
		},
	},
}
gBlewDown_State={
	Enter={
		ChangeProcessMode={
			ENABLE_Move,
			ENABLE_Gravity
		}
	},
	Update={
		IsProcessModeThen={
			{ ProcessName="Gravity" , ProcessMode=Process.WAITING , NextState="Down_State" },
		}			
	},		
}
gBlewUpDown_State={
	Enter={
		ChangeProcessMode={
			UNABLE_Move,
--			ENABLE_Gravity,
			ENABLE_Animation,
--			ENABLE_JumpUp
		}
	},
	Update={
		IsProcessModeThen={
--			{ ProcessName="JumpUp" , ProcessMode=Process.WAITING , NextState="BlewDown_State" },
--			{ ProcessName="Gravity" , ProcessMode=Process.WAITING , NextState="Down_State" },
			{ ProcessName="Animation" , ProcessMode=Process.WAITING , NextState="Down_State" },
		}			
	},		
}
gBoundDown_State={
	Enter={
		ChangeProcessMode={
			UNABLE_Move,
--			ENABLE_Gravity,
			ENABLE_Animation,
		}
	},
	Update={
		IsProcessModeThen={
			{ ProcessName="Animation" , ProcessMode=Process.WAITING , NextState="Down_State" },			
		}			
	},		
}
gDown_State={
	Enter={
		ChangeProcessMode={
			UNABLE_Move,
			ENABLE_Animation,
			UNABLE_Gravity,
		}
	}
}	
gDead_State={
	Enter={
		ChangeProcessMode={
			UNABLE_Move,
			UNABLE_Gravity,
			UNABLE_JumpUp,
			UNABLE_Hit,
			ENABLE_Animation,
		}
	}
}	
gGuard_State={
	Update={
		NotIsOnKey={
			{ Button=PSController.PS_R1 , NextState="Wait_State" },
		}
	},
}

DestroyObject_StateMap={
	Wait_State=gWait_State,
	Fall_State=gFall_State,
	Land_State=gLand_State,
	SmallDamaged_State=gUntilAnimationFinished,
	MiddleDamaged_State=gMiddleDamaged_State,
	Down_State=gDown_State,
	Dead_State=gDead_State,
	BlewUpDown_State=gBlewUpDown_State,
}

Agent_StateMap={
	Wait_State=gWait_State,
	Fall_State=gFall_State,
	Walk_State=gWalk_State,
	Land_State=gLand_State,
	Ladder_State=gLadder_State,
	Run_State=gRun_State,
	JumpUp_State=gJumpUp_State,	
	Attack_State=gUntilAnimationFinished,
	Throw_State=gUntilAnimationFinished,
	Thrown_State=gUntilAnimationFinished,--gThrown_State,
	SmallDamaged_State=gUntilAnimationFinished,
	StandUp_State=gUntilAnimationFinished,
	Guard_State=gGuard_State,
	Grappling_State=gGrappling_State,
	Grappled_State=gGrappled_State,
	GrappledDamaged_State=gGrappledDamaged_State,
	GrapplingJumpUp_State=gGrapplingJumpUp_State,
	GrappledJumpUp_State=gGrappledJumpUp_State,
	GrapplingFall_State=gGrapplingFall_State,
	GrappledFall_State=gGrappledFall_State,
	MiddleDamaged_State=gMiddleDamaged_State,
	BlewUp_State=gBlewUp_State,
	BlewDown_State=gBlewDown_State,
	Down_State=gDown_State,
	Dead_State=gDead_State,
	BoundWall_State=gBoundWall_State,
	FrontFall_State=gFrontFall_State,
	FaceDownLand_State=gDown_State,
	GetItem_State=gUntilAnimationFinished,
	ThrowItem_State=gUntilAnimationFinished,
	ItemGettable_State=gWait_State,
	BlewUpDown_State=gBlewUpDown_State,
	BoundDown_State=gBoundDown_State,
	Relaxing_State=gWait_State,
	Kawashi_State=gUntilAnimationFinished,
	EventAct_State=gUntilAnimationFinished,
}


CollectionClass={}
CollectionClass.create=function()
	local o={}
	o.collection={}
	o.get=function(name)
		if IsKeyExist( o.collection , name ) then
			return o.collection[ name ];
		else
			return nil;
		end
	end
	o.collect=function( name , t )
		o.collection[ name ] = t;
	end
	return o;
end

Queue={}
Queue.create=function()
	local ret ={}
	ret.queue={}
	ret.push_back=function( t )
		table.insert( ret.queue , t );
	end
	ret.pop_front=function()
		if #ret.queue > 0 then
			table.remove( ret.queue , 1 );
		end
	end
	ret.front=function()
		if #ret.queue > 0 then
			return ret.queue[1];
		else
			return nil;
		end
	end
	ret.isEmpty=function()
		local t = ret.front();
		if t then
			return false;
		else
			return true;
		end
	end
	return ret;
end

File={}
File.createIn=function( filename )
	local o={}
	o.handle=io.open( filename , "r" );
	return o; 
end
File.createOut=function( filename )
	local o={}
	o.handle=io.open( filename , "w" );
	return o;
end

FSM={}
FSM.create=function()
	local o={}
	o.currentState=nil;
	o.prevState=nil;
	o.states={};
	o.changeState=function( name )
		if IsKeyExist( o.states , name ) then
			o.prevState = o.currentState;
			o.currentState = o.states[ name ];
			return o.currentState;
		else
			return nil;
		end
	end
	return o;
end

ProcessClass={}
ProcessClass.create=function( name , state , data , mode )
	local proc = Native.Methods.AttachProcess( name , state , data );
	proc:changeMode( mode );
	return proc;
end
--Change Process Mode Owned by Process Manager
ProcessClass.changeProcMode=function( name , mode )
	GetProcessManager():changeProcessMode( name , mode );
end

ProcessFSM={}
ProcessFSM.create=function( )
	local o={}
	o.fsm = FSM.create();
	o.createState=function( name , state , data )
		o.fsm.states[ name ] = Native.Methods.AttachProcess( name , state , data );
		o.fsm.currentState = o.fsm.states[ name ];
	end
	o.setState=function( name , state )
		o.fsm.states[ name ] = state;
		o.fsm.currentState = o.fsm.states[ name ];
	end	
	o.changeState=function( name )
		o.fsm.currentState = o.fsm.changeState( name );
		if o.fsm.currentState then
			o.fsm.currentState:changeMode( Process.INITIALIZING);
		end
	end
	o.changeModeCurrProcess=function( mode )
		if o.fsm.currentState then
			o.fsm.currentState:changeMode( mode );
		end
	end
	return o;
end

----------------------------------------------------
--Enable Command Queueing
----------------------------------------------------

CommandQueue={}
--[[
CommandQueue.create=function( name , list )
	local proc ={}
	proc.currPos = 1;
	proc.timer=StopWatch();
	proc.toNext=function()
	end
	proc.Initialize=function( p , d )
		if d[1] == "WAIT" then
			proc.timer:start(0);
			p:changeMode( Process.ACTIVATED );
			return;
		end		
		local ip = Interpreter();
		ip:setData( d[2] );
		TriggerEvent( d[1] , ip );
		
		proc.currPos = proc.currPos + 1;
		if proc.currPos <= #list then
			p:setData( list[ proc.currPos ] );
		else
			p:changeMode( Process.KILLED );
		end	
	end
	proc.Update=function( p , d )
		local any = p:getAny();
		local elapsed = proc.timer:milliSec(0);
		if  elapsed > d[2] then
			proc.currPos = proc.currPos + 1;
			if proc.currPos <= #list then
				p:setData( list[ proc.currPos ] );
			else
				TriggerEvent( name.."_Finished" , "abeshi!!" );
				p:changeMode( Process.KILLED );
			end
			p:changeMode( Process.INITIALIZING );
		end
	end
	ProcessClass.create( name , proc , list[1] , Process.INITIALIZING );
end
--]]
CommandQueue.create=function( name , list )
	local proc ={}
	proc.currPos = 1;
	proc.timer=StopWatch();
	proc.waitMilli=0;
	proc.toNext=function()
	end
	proc.Initialize=function( p , d )
		local ip = Interpreter();
		ip:setData( d );
		local token = ip:getToken();
		if token == "WAIT" then
			proc.timer:start(0);
			proc.waitMilli = ip:getInt();
			p:changeMode( Process.ACTIVATED );
			return;
		end
		TriggerEvent( token , ip );
	
		proc.currPos = proc.currPos + 1;
		if proc.currPos <= #list then
			p:setData( list[ proc.currPos ] );
		else
			TriggerEvent( name.."_Finished" , "abeshi!!" );
			p:changeMode( Process.KILLED );
		end	
	end
	proc.Update=function( p , d )
		local any = p:getAny();
		local elapsed = proc.timer:milliSec(0);
		if  elapsed > proc["waitMilli"] then
			proc.currPos = proc.currPos + 1;
			if proc.currPos <= #list then
				p:setData( list[ proc.currPos ] );
			else
				TriggerEvent( name.."_Finished" , "abeshi!!" );
				p:changeMode( Process.KILLED );
			end
			p:changeMode( Process.INITIALIZING );
		end
	end
	ProcessClass.create( name , proc , list[1] , Process.INITIALIZING );
end

Door={}
Door.create=function( data )
	
end

HitObject={}
HitObject.collection={}
HitObject.property={}
HitObject.get=function( name )
	return FindByKey( HitObject.collection , name );
end
HitObject.getProperty=function( name )
	return FindByKey( HitObject.property , name );
end
HitObject.create=function( data )
	local o=data;
	local m = GetSceneManager():get( data["name"] );
	o.moved = false;
	o.dir = 1;
	--vZXA^b`
--	o.jagProcess = ProcessClass.create( data["name"].."_Jag" , JagMoverProcess , data , Process.WAITING );
	o.moveProcess = ProcessClass.create( data["name"].."_Move" , MoveProcess , data , Process.WAITING );
	o.rotateProcess = ProcessClass.create( data["name"].."_Rotate" , SlerpProcess , data , Process.WAITING );
	--݂̃V[փA^b`
	o.attachScene=function()
--		_("ATTACH SCENE "..data["name"] );
	end
	o.move=function()
		o.dir = -o.dir;
		if o.sound then
			GetSoundManager():playSe( o["sound"] );	
		end
		o.moveProcess:changeMode( Process.INITIALIZING );
	end
	o.rotate=function()
		o.dir = -o.dir;
		if o.sound then
			GetSoundManager():playSe( o["sound"] );	
		end
		o.rotateProcess:changeMode( Process.INITIALIZING );
	end
	o.jag=function()
--		o.jagProcess:changeMode( Process.INITIALIZING );
	end
	
	HitObject.collection[ data["name"] ] = o;
	HitObject.property[ data["name"] ] = {};
	o.fsm=FSM.create();
	if data.collision then
		local colname = data["collision"];
		if FindByKey( CollisionMol , colname ) then
			GetPhysicsManager():createCollision( data["name"] , CollisionMol[ colname ] );	
		end
	end
--]]	
	return o;
end


--Wrapping Mesh Creation and 
Item={}
Item.collection={}
Item.property={}
Item.get=function( name )
	return FindByKey( Item.collection , name );
end
Item.getProperty=function( name )
	return FindByKey( Item.property , name );
end
Item.create=function( data )
	local o=data;
	--o^Ȃ烁bVCX^Xēo^
	local m = GetSceneManager():get( data["name"] );
	if not m then
		m = GameLib.CreateMesh( 
			data["name"] , data["file"],
			data["pos"] , data["angle"] , data["scale"] , 
			data["blend"] );
	end
	--vZXA^b`
	o.attachmentProcess = GameLib.CreateFrameAttachmentProcess();
	o.attachmentProcess:changeMode( Process.WAITING );
	o.attachmentProcess:setShape( m );
	o.translateProcess = GameLib.CreateTranslateProcess();
	o.translateProcess:setMover( m );
	o.translateProcess:changeMode( Process.WAITING );
	o.rotateProcess = GameLib.CreateRotateProcess();
	o.rotateProcess:setMover( m );
	o.gravityProcess = GameLib.CreateGravityProcess();
	o.gravityProcess:setMover( m );
	o.rotateProcess:changeMode( Process.WAITING );
	o.gravityProcess:changeMode( Process.INITIALIZING );
	--݂̃V[փA^b`
	o.attachScene=function()
		_("ATTACH SCENE "..data["name"] );
	end
	--f̃t[{[ɘAē悤ɂ
	o.attachAgent=function( agent , framename1 , framename2)
		o.translateProcess:changeMode( Process.WAITING );
		o.rotateProcess:changeMode( Process.WAITING );
		o.gravityProcess:changeMode( Process.WAITING );
		o.attachmentProcess:changeMode( Process.INITIALIZING );
		o.attachmentProcess:setModel( agent:model() );
		o.attachmentProcess:setFrameName( framename1 , framename2 );		
	end
	o.translate=function( tick )
		o.translateProcess:changeMode( Process.ACTIVATED );
--		o.rotateProcess:changeMode( Process.WAITING );
		o.attachmentProcess:changeMode( Process.WAITING );
		o.gravityProcess:changeMode( Process.INITIALIZING );
		o.translateProcess:setTick( tick );
	end
	o.rotate=function( tick )
--		o.translateProcess:changeMode( Process.WAITING );
		o.rotateProcess:changeMode( Process.ACTIVATED );
		o.gravityProcess:changeMode( Process.INITIALIZING );
		o.attachmentProcess:changeMode( Process.WAITING );
		o.rotateProcess:setTick( tick );		
	end
	o.stop=function()
		o.translateProcess:changeMode( Process.WAITING );
		o.rotateProcess:changeMode( Process.WAITING );
		o.attachmentProcess:changeMode( Process.WAITING );		
		o.gravityProcess:changeMode( Process.INITIALIZING );
	end
	Item.collection[ data["name"] ] = o;
	Item.property[ data["name"] ] = {};
	o.fsm=FSM.create();
	if data.collision then
		local colname = data["collision"];
		if FindByKey( CollisionMol , colname ) then
			GetPhysicsManager():createCollision( data["name"] , CollisionMol[ colname ] );	
		end
	end
	return o;
end

Camera={}
Camera.isLock=false;
Camera.id = 0;
Camera.init=function( cammap )
--	Camera.collection = CollectionClass.create();
	Camera.map=cammap;
	Camera.fsm = ProcessFSM.create();
end
Camera.changeState=function( name )
	Camera.fsm.changeState( name );
	if IsKeyExist( Camera.map ,  name ) then
		GetSceneManager():setCameraId( Camera.map[ name ] );
		Camera.id = Camera.map[ name ];
	end
end
Camera.lock=function( )
	Camera.isLock = true;
	Camera.fsm.changeModeCurrProcess( Process.WAITING );
end
Camera.unlock=function( )
	Camera.isLock = false;
--	Camera.fsm.changeModeCurrProcess( Process.ACTIVATED );
	Camera.fsm.changeModeCurrProcess( Process.INITIALIZING );
end
Camera.position=function()
	return GetSceneManager():camera( Camera.id ):position();
end
Camera.lookAtPos=function()
	return GetSceneManager():camera( Camera.id ):lookAt();
end
Camera.setPos=function( v )
	GetSceneManager():camera( Camera.id ):setPosition( v );
end
Camera.setPosId=function( v , ID )
	GetSceneManager():camera( ID ):setPosition( v );
end
Camera.setLookAt=function( v )
	GetSceneManager():camera( Camera.id ):setLookatPt( v );
end
Camera.setLookAtId=function( v ,ID )
	GetSceneManager():camera( ID ):setLookatPt( v );
end
Camera.addPos=function( v )
	GetSceneManager():camera( Camera.id ):addPos( v );
end
Camera.addLookAt=function( v )
	GetSceneManager():camera( Camera.id ):addLookat( v );
end
Camera.positionId=function( ID )
	return GetSceneManager():camera( ID ):position();
end
Camera.lookAtPosId=function( ID )
	return GetSceneManager():camera( ID ):lookAt();
end

Animation2D={
	fadeIn=function(data)
		ProcessClass.create( 
			data["name"].."FadeIn" ,
			FadeInProcess_State , data , data["mode"] );		
	end,
	fadeOut=function(data)
		ProcessClass.create(
			data["name"].."FadeOut" , 
			FadeOutProcess_State , data , data["mode"] );
	end,
	fly=function( data )
		ProcessClass.create(
			data["name"].."Fly" , 
			MoveImgProcess_State , data , data["mode"] );
	end,
	alphaWav=function( data )
		ProcessClass.create(
			data["name"].."Alpha" , 
			AlphaWaveProcess_State , data , data["mode"] );
	end,
	zoom=function( data )
		ProcessClass.create(
			data["name"].."Zoom" , 
			SizeUpProcess_State , data , data["mode"] );	
	end
}

TransitionEvent={}
TransitionEvent.create=function( data )
	local ret = data;
	local sceneName = data["name"];
	--Fade In and Wait a 
	local fadeInData={
		name="To"..data["name"].."FadeIn",
		state=FadeInProcess_State,
		data={
			name="transition1",
			alpha=0,
			speed=5,
			threshold=254,
		}
	}
	local waitData={
		name="To"..data["name"].."Wait",
		state=WaitProcess_State,
		data={
			time=0.5,
			after=Process.KILLED
		}
	}
	local fadeOutData={
		name="To"..data["name"].."FadeOut",
		state=FadeOutProcess_State,
		data={
			name="transition1",
			alpha=254,
			speed=5,
			threshold=0,
		}
	}
	local fadeInListener = function( d )
		_("ATTACH SCENE transition1");
	end

	local waitKilledListener = function( d )
		GetSceneManager():getFSM():changeState( sceneName );	
		GetSoundManager():stopBgm();
		Native.Methods.PlayBgm( sceneName );
--[[		if IsKeyExist( SoundMap , sceneName ) then
			GetSoundManager():playBgm( SoundMap[ sceneName ] );
			
		end
--]]
		if IsKeyExist( SceneInit , sceneName ) then
			SceneInit[ sceneName ]( );
		end
	end
	
	local fadeOutListener = function( d )
--		_("ATTACH SCENE transition1");
	end
	--Add to Event Manager 
	Native.Methods.addListener( "To"..data["name"].."FadeIn_PreInitialize" , fadeInListener );
	Native.Methods.addListener( "To"..data["name"].."Wait_Killed" , waitKilledListener );
	Native.Methods.addListener( "To"..data["name"].."FadeOut_PreInitialize" , fadeOutListener );

	fadeInData["next"]=waitData;
	waitData["next"]=fadeOutData;
	
	TriggerEvent( "PreProcessAttach", fadeInData );
end

FadeInAndOutProcessSampleData={
	name="TitleLogo1",
	fadeInSpeed=4,
	waitTime=2,
	fadeOutSpeed=4,
	alphaThreshold=250,
	fadeOutKilledEvent=function()
		_("CHANGE SCENE TitleMenu 0.2 10 ");
	end
}

FadeInAndOutProcess={}
FadeInAndOutProcess.create=function( data )
	local ret = data;
	--Fade In and Wait a 
	local fadeInData={
		name=data["name"].."FadeIn",
		state=FadeInProcess_State,
		data={
			name=data["name"],
			alpha=0,
			speed=data["fadeInSpeed"],
			threshold=data["alphaThreshold"],
		}
	}
	local waitData={
		name=data["name"].."Wait",
		state=WaitProcess_State,
		data={
			time=data["waitTime"],
			after=Process.KILLED
		}
	}
	local fadeOutData={
		name=data["name"].."FadeOut",
		state=FadeOutProcess_State,
		data={
			name=data["name"],
			alpha=data["alphaThreshold"],
			speed=data["fadeOutSpeed"],
			threshold=0,
		}
	}
	local fadeInListener = function( d )
--		_("ATTACH SCENE transition1");
	end

	local waitKilledListener = function( d )
		if data.waitKilledEvent then
			data.waitKilledEvent();
		end
	end
	
	local fadeOutListener = function( d )
		if data.fadeOutKilledEvent then
			data.fadeOutKilledEvent();
		end		
	end
	--Add to Event Manager 
	Native.Methods.addListener( data["name"].."FadeIn_PreInitialize" , fadeInListener );
	Native.Methods.addListener( data["name"].."Wait_Killed" , waitKilledListener );
	Native.Methods.addListener( data["name"].."FadeOut_Killed" , fadeOutListener );

	fadeInData["next"]=waitData;
	waitData["next"]=fadeOutData;
	
	TriggerEvent( "PreProcessAttach", fadeInData );
end

TriggerVolume={}
TriggerVolume.create = function( data )
	local obj=data;
	obj["trigger"]=function()
		local p = Character.get( data["chara"] );
		local vol = GetSceneManager():get( data["name"] );
		local ret = false;
		if p and vol then
--			_("VISIBLE "..data["name"].." false" );
--			Stage1View:mesh( data["name"] ):setVisible( false );
--			vol:setVisible( false );
--			local m = GetSceneManager():get( "toStage1_2Vol" );
--			m:setVisible( true );
			if data.alphaWav then
				local amp = data["alphaWav"]["amp"];
				local speed = data["alphaWav"]["speed"];
				local a = AbsCosWav( amp , speed );
				vol:setAlpha( a );				
			end
			if data.rotate then
				local rot = data["rotate"];
				local v = Vec3( rot[1] , rot[2] , rot[3] );
				vol:addAngle( v );
			end
			local epos = p:position();
			local vpos = vol:position();
			local diff = Vec3(0);
			diff:setSub( vpos , epos );
			local enter = false;
			local scl = vol:scale();
			if data.radious then
--				local radious = ( scl.x + scl.y + scl.z )/3;
				enter = ( diff:length() < data["radious"] );--vol:radious() );
			elseif data.box then
				local t = data["box"];
				enter = IsPointInsideBox( epos , vpos , t[1] , t[2] , t[3] )
			end				
			if enter then
				TriggerEvent( "TriggerVol_"..data["name"].."_Enter" , data );
				ret = true;
			end
		end
		return ret;
	end
		
	obj["activate"]=function()
		if GUI_Common.activate( obj ) and obj["active"] then
			SetVisible( data["name"] , true );
--			_("VISIBLE "..data["name"].." true");
			return true;
		else	
			SetVisible( data["name"] , false );
--			_("VISIBLE "..data["name"].." false");
			return false;
		end
	end
--	event=data["event"],
--	changeAfter=data["changeAfter"]
	if data.view then
		GetViewManager():view( data.view ):attachProcess( data["name"].."_Vol" , EventTriggerProcess_State , obj );
	else
		GameLib.AttachProcess( data["name"].."_Vol" , EventTriggerProcess_State , obj );
	end
	return obj;
end

LINEAR = Graphics.BLEND_LINEAR
Particle={}
Particle.collection={}
Particle.get=function( setname )
	local ret = nil;
	if IsKeyExist( Particle.collection , setname ) then
		local t = Particle.collection[ setname ];
		for i=1,#t,1 do
			local par = t[i];
			if not par["active"] then
				ret = par;
				break;
			end
		end
	end
	return ret;
end
Particle.create=function( data )
	local setname=data["name"]
	Particle.collection[ setname ] ={}
--	local root = data["name"].."_1";
	local root = nil;
	for i=1,data["allNum"] ,1 do
		data["name"]=data["name"].."_"..i;
		local bill =Native.Billboard.create( data );
		bill:setVisible( false );
		if i == 1 then
			root = bill;
		else
			root:setChild( bill );
		end
		table.insert( Particle.collection[ setname ] , 
			{ 
				instance=bill,
				lifetime=data["lifetime"],
				timeElapsed=os.clock(),
				active=false,
				isMove = data["isMove"],
				width=data["width"],
				height=data["height"],
				alpha = 255,
			}
		);		
	end
end
Particle.attach=function( setname )
	_("ATTACH SCENE "..setname.."_1" );		
end
Particle.trigger=function( data )
	local par = Particle.get( data["setname"] );
	if par then
		local p = data["pos"];
		par["active"] = true;
		par["timeElapsed"]=os.clock();
		par["instance"]:setPosition( Vec3( p[1],p[2],p[3] ) );
		par["instance"]:setVisible( true );
		par["alpha"] = 255;
		local ran = Random();
		local rX = ran:getInt( -10 , 10 );
		local rY = ran:getInt( -10 , 10 );
		local rZ = ran:getInt( -10 , 10 );
		local w = par["width"] + ran:getInt( 1 , 50 )/100;
		local h = par["height"] + ran:getInt( 1 , 50 )/100;
		par["instance"]:setWidthHeight( w,h );
		par["dir"] = Vec3( rX/1000 , rY/1000 , rZ/1000 );
	end
end
Particle.update=function()
	for k,v in pairs( Particle.collection ) do 
		for i=1,#v,1 do
			local par = v[i];
			if par["active"] then
				local bill = par["instance"];
				if par["isMove"] then
					bill:addPos( par["dir"] );
				end
				bill:setDiffuse( 255, 255,255, par["alpha"] );
				par["alpha"] = par["alpha"] - 10;
				if par["alpha"] < 0 then
					par["alpha"] = 0;
				end
				if os.difftime( os.clock() , par["timeElapsed"] ) > par["lifetime"] then
					par["active"] = false;
					bill:setVisible( false );
				end
			else
				par["instance"]:setVisible( false );
			end
		end
	end
end

--[[
--Find a Material by a Key
MaterialPallet={}
MaterialPallet.initialize=function()
	for k,v in pairs( MaterialData ) do
		gMaterialDataPallet[ k ] = v;
		gMaterialPallet[ k ] = Material( v );
		gMaterialDataPallet[ k ]["name"] = k;
	end
end
MaterialPallet.createMaterial=function( data )
	local mat = Material( data );
	gMaterialPallet[ data["name"] ] =mat;
	gMaterialDataPallet[ data["name"] ] = data;
	return mat;
end
MaterialPallet.get=function( name )
	local	ret = gMaterialDataPallet[ name ]--MaterialData[ name ] ;
	return ret;
end	
MaterialPallet.collect =function()
--	if IsKeyExist( gMaterialPallet , gCurrentEditMaterialData["name"] ) then
		
--	else
		MaterialPallet.createMaterial( gCurrentEditMaterialData );
--	end
end
MaterialPallet.materialNum=function()
	return CountTableKeyNum( gMaterialDataPallet );
end
MaterialPallet.materialName=function( index )
	
end
MaterialPallet.serialize=function()
	local o = GetOutput("lua/param/EditMaterial.lua");
	for k,v in pairs(gMaterialDataPallet) do
		o:write( "MaterialData[ \""..k.."\" ]=" );
		serialize( v , o );
	end
end

MaterialPallet.initialize()
--]];

--便利関数郡とグローバル定数

windowW = GetWindowWidth();
windowH = GetWindowHeight();

math.randomseed( os.time() );

function AddListenerCommon()
	local t={
	{ "LoadSubtitle" , LoadSubtitleListener },
	{ "StartLoadingModel" , StartLoadingModelListener },
	{ "PreProcessAttach" , PreProcessAttachListener },
	{ "ParseFile" , ParseFileListener },
	{ "BillEffect" , BillEffectListener },
	{ "MsgBoxClicked" , MsgBoxClickedListener },
	{ "WallCollided" , WallCollisionListener },

	{ "CreateImage" , CreateImageListener },
	{ "CreateMesh" , CreateMeshListener },
	{ "CreateAgent" , CreateAgentListener },
	{ "CreateBillboard" , CreateBillboardListener },
	{ "AttachNode" , AttachNodeListener },
	{ "CommandLineExec" , CommandLineExecListener },
--	{ "SCRIPT" , SCRIPT_TokenListener },
	{ "ACTIVATE" , ACTIVATE_CommandListener },
	{ "SET" , SET_CommandListener },
	{ "CHANGE" , CHANGE_CommandListener },
	{ "CHANGE_FOCUS_TEX" , CHANGE_FOCUS_TEX_CommandListener },
	{ "CHANGE_ANIM" , CHANGE_ANIM_CommandListener },
	{ "ATTACH" , ATTACH_CommandListener },
	{ "REVIVE" , REVIVE_CommandListener },
	{ "DISPLAY" , DISPLAY_CommandListener },
	{ "ENABLE" , ENABLE_CommandListener },
	{ "VISIBLE" , VISIBLE_CommandListener },
	{ "CAMERA" , CAMERA_CommandListener },
	{ "PLAY" , PLAY_CommandListener },
	{ "CHANGE_CAM" , CHANGE_CAM_CommandListener },
	{ "FADE" , FADE_CommandListener },
	{ "FLY" , FLY_CommandListener },
	{ "FLYGUI" , FLYGUI_CommandListener },
	{ "BLINK" , BLINK_CommandListener },
	{ "BLINK_ALPHA" , BLINK_ALPHA_CommandListener },
	{ "ZOOM" , ZOOM_CommandListener },
	{ "BUF_CAMPOS" , BUF_CAMPOS_CommandListener },
--	{ "#Camera0" , Camera0_CommandListener },
--	{ "#Camera1" , Camera1_CommandListener },
--	{ "#Camera2" , Camera2_CommandListener },
	{ "Contact" , AttackCollisionContactListener },
	{ "Contact" , ItemCollisionContactListener },
	{ "CollisionEnter" , ItemCollisionEnterListener },
	{ "CollisionOff" , ItemCollisionOffListener },
	{ "CollisionEnter" , HitObjColEnterListener },
	{ "CollisionOff" , HitObjColEnterListener },

--	{ "CollisionTriggered" , AttackCollisionListener },

--	{ "ProcessModeChanged" , ProcessModeChangedListener },
	}

	e = GetEventManager();
	for i=1,#t,1 do
		e:addScriptedListener( t[i][1] , t[i][2] );
	end
end

function CreateFuzzySet( data )
	local fuzzySet = GetFuzzyManager():create( data["name"] );
	if data.borderThreshold then
		fuzzySet:setBorderThreshold( data.borderThreshold , data.borderExpression );
	end
	for k,t in pairs( data["fuzzyVals"] ) do
		fuzzySet:createTriFuzzyVal( k , t["denom"] , t["nume"] , t["shift"] );
	end
end

function AddListenerBeltActionCommon()
	local t={
	{ "GOSIGN" , function ( data )
		ProcessClass.changeProcMode( "GoSign" , Process.ACTIVATED );
		--GS񂾂璼ɃS[TCo
		ShowGoSignData["times"] = 0; end
	},
		
	}
	e = GetEventManager();
	for i=1,#t,1 do
		e:addScriptedListener( t[i][1] , t[i][2] );
	end
end

function SetCurrentView( name )
	local vm = GetViewManager();
	local view = vm:view( name );
	if view then
		view:activate( true );
		GetViewManager():viewController():setCurrentView( view );	
	end
end

function DetachView( name )
	local vm = GetViewManager();
	vm:attach( name );
	local view = vm:view( name );
	if view then
		view:activate( false );
		view:setVisible( false );
--		view:enableUpdate( true );
--		GetViewManager():viewController():setCurrentView( view );	
	end
end

function AttachView( name )
	local vm = GetViewManager();
	vm:attach( name );
	local view = vm:view( name );
	if view then
		if IsKeyExist( ViewProp ,  name ) then
			if ViewProp[ name ].sound then
				Native.Methods.PlaySe( ViewProp[ name ]["sound"] );
			end
		end		
		view:activate( true );
		view:setVisible( true );
--		view:enableUpdate( true );
		GetViewManager():viewController():setCurrentView( view );	
	end
end

function AttachGlobalUIView()
	local gui = GetViewManager():view( "GlobalUI" );
	if gui then
		GetViewManager():attach( "GlobalUI" );
		gui:enableUpdate( true );
	end
end

function SetViewProp( view , prop )
	view:activate( prop["activate"] );
	if prop.image then
		view:setBackGroundImage( prop["image"] );	
		view:setSize( prop["size"][1] , prop["size"][2] );
		view:setPosition( prop["pos"][1] , prop["pos"][2] );
	end
	view:setZOrder( prop["zorder"] );
	if prop.alpha then
		view:setAlpha( prop["alpha"] );
	end
end

function _( data )
	CommandLineExecListener( data );
end

--recursively add processes to a agent's processor
function AddProcessList( agent , processList )
	for k,v in pairs( processList ) do
--	for i=1,#processList ,1 do
--		local t = processList[i];
--		local p = GameLib.AddProcessToAgent( agent , t["name"] ,t["state"],t["data"] ):changeMode( t["mode"] );
		local p = GameLib.AddProcessToAgent( agent , k ,v["state"],v["data"] ):changeMode( v["mode"] );		
		if v.children then
			for i=1,#v["children"],1 do 
				AddProcessList( agent , v["children"] );
			end
		end
	end	
end


function TriggerEvent( name , data )
	GetEventManager():triggerEvent( name , data );
end

function TriggerEvents( eventlist )
	for i=1,#eventlist,1 do
		TriggerEvent( eventlist[i][1] , eventlist[i][2] );
	end
end

function QueueEvent( name , data )
	GetEventManager():queueEvent( name , data );
end

function QueueEvents( eventlist )
	for i=1,#eventlist,1 do
		QueueEvent( eventlist[i][1] , eventlist[i][2] );
	end
end

function CharToNum( char )
	return char:byte(1);
end

function IsKeyTriggered( char )
	return IsKeyTriggeredFromCode( char:byte(1) );
end

function IsKeyOn( char )
	return IsKeyOnFromCode( char:byte(1) );
end

--gStopWatch = StopWatch();
--gStopWatch:start(0);
gFrames = 0;
gFPS = 60
gLast = os.clock()*1000--gStopWatch:milliSec(0)
function ShowFPS()
	gCurrent = os.clock()*1000--gStopWatch:milliSec(0)   
	gFrames = gFrames + 1;
	if 500 <= gCurrent - gLast then
		dt = (gCurrent - gLast) / 1000
		fps = gFrames / dt;
		gLast = gCurrent;
		gFrames = 0;
		gFPS = fps;
	end
	Dout2( 500,20 , "FPS:"..gFPS , 0xffffff00 );	
end

function GetTable()
	local t = {};
	return t;
end

function LuaRand(a,b)
	return math.random(a,b);
end

function GetRandVec2( a,b)
	local x,y;
	x = math.random(a,b);
	y = math.random(a,b);
	return Vec2( x, y );
end

function GetRandVec3( a,b)
	local x,y,z;
	x = math.random(a,b);
	y = math.random(a,b);
	z = math.random(a,b);
	return Vec3( x, y , z );
end

function AbsCosWav( amp , speed )
	return math.abs( amp*math.cos( speed * os.clock() ) );
end

function CosWav( amp , speed )
	return amp*math.cos( speed * os.clock() );
end

function SinWav( amp , speed )
	return amp*math.sin( speed * os.clock() );
end

local dstX=100;
local dstY=100;
local dirX = 1;
local dirY = 1;
function FloatingImage(img,speedX,speedY)
	dstX = dirX*speedX + dstX;
	dstY = dirY*speedY + dstY;
	if dstX > windowW then
		dirX = -1;
	elseif dstX<0 then
		dirX = 1;
	else end
	
	if dstY > windowH then
		dirY = -1;
	elseif dstY<0 then
		dirY = 1;
	else end
	
	img:setPosition( dstX , dstY );	
end

function RelativeSetPosUI( ui , x , y)
	local dstX = x * GetWindowWidth();
	local dstY = y * GetWindowHeight();
	ui:setPosition( dstX , dstY );
end

function CapMsg( data )
	local strL = data["Caption"]:size()*data["CharW"];
	if IsKeyExist( data , "Img" ) then
		local imgL = 20*data["CharW"];	
		if IsKeyExist( data , "Length" ) then
			 imgL = data["Length"]*data["CharW"];	
		end
		data["Img"]:setWidthHeight( imgL ,data["CharH"] );
		data["Img"]:setAlphaMode( "LINEAR" );
		if IsKeyExist( data , "RGB" ) and IsKeyExist( data , "Alpha" )then
			local color = ColorARGB( data["Alpha"] , data["RGB"][1] , data["RGB"][2] , data["RGB"][3] );
			data["Img"]:setColor(
				color,
				color,
				color,
				color );
		end
		if IsKeyExist( data , "DstX" ) then
			data["Img"]:setPosition( data["DstX"],data["DstY"] );
		end
		GetSceneManager():attachUI( data["Img"] );
	end
	data["Caption"]:setWidthHeight( data["CharW"],data["CharH"] );
	if IsKeyExist( data , "DstX" ) then
		data["Caption"]:setPosition(data["DstX"] - strL/2 ,data["DstY"] );
	end
	GetSceneManager():attachUI( data["Caption"] );
--]]
end

function SizeOfTable(a)
	return #a;
end

function CountTableKeyNum(t)
	local count=0;
	for k,v in pairs(t) do
		count = count + 1;
	end
	return count;
end

--マウスポインタが指定Eユーザーインターフェースの上にきてぁEばtrue
function HitTest1( ui )
	local MouseX = GetMouse():x();
	local MouseY = GetMouse():y();
	local W = ui:width()/2;
	local H = ui:height()/2;
	local left = ui:dstX() -W;
	local right = ui:dstX() + W;
	local top = ui:dstY() - H;
	local bottom = ui:dstY() + H;
	if MouseX > left and MouseX < right and MouseY > top and MouseY < bottom then
		return true;
	else
		return false;
	end
end

function HitTest2( ui )
	local MouseX = GetMouse():x();
	local MouseY = GetMouse():y();
	local W = ui:width();
	local H = ui:height();
	local left = ui:dstX() ;
	local right = ui:dstX() + W;
	local top = ui:dstY() ;
	local bottom = ui:dstY() + H;
	if MouseX > left and MouseX < right and MouseY > top and MouseY < bottom then
		return true;
	else
		return false;
	end
end


function CameraControlCurve(vBegin,vEnd,rate)
	vBar1 = Vec3(0,1,8);
	vBar2 = Vec3(0,1,0);
	hc = HermiteCurve( vBegin,vBar1,vEnd,vBar2 ,rate );
	CAMERA():setPosition( hc );
--	vEyePos = Vec3( CAMERA():position() );
	vLookat = Vec3(CAMERA():position() );
--	CAMERA():position().x;
--	vLookat.x = CAMERA():position().x;
--	vLookat.y = CAMERA():position().y;
	vLookat.z = vLookat.z + 2;-- + CAMERA():position().z;
--	vLookat = Vec3(0,0,1);
	CAMERA():setLookatPt( vLookat );
	
end

function IsAnimeName( agent , animname )
	if agent:animationControl():currentAnimeName() == animname then
		return true;
	else
		return false;
	end
end

function IsKeyExist( t , k )
	for key,value in pairs(t) do
		if key == k then
			return true;
		end
	end
	return false;
end

function RandomDst( vec , dx , dy , dz)
	
	local x = math.random()*dx;
	local y = math.random()*dy;
	local z = math.random()*dz;
	vec:set( vec.x + x , vec.y + y , vec.z + z );
	return vec;
end

function OffsetAgentPosition(agent , intersect )
	local sub = Vec3(0);
	local ray = agent:groundRay();
	sub:setSub( intersect , ray.End );
--	sub.y = sub.y - 0.05;
	agent:addPos( sub );
end

IsFirstAttached = true;
FunctionList = {
	Camera_Translate=CameraControlTranslate,
	Camera_Rotate=CameraControlRotate,
	Camera_Follow=CameraControlFollow,
	TileTranslate= TileEditTranslate,
	TileRotate=TileEditRotate,
	SaveAsLua=function()
		Level_State["Serialize"]();
	end,
	TestPlay= function()
		if IsFirstAttached then
			GetSceneManager():attachDynamic( AgentSet["Player"] );	
			CurrentModeUpdate= CameraControlRotate;
			IsFirstAttached = false;
		end
	end			
}

function ChangeMode( funcname )
	CurrentModeUpdate = FunctionList[ funcname ];
end

ParamTemplate ={
	AgentParam={
		Id="Who am I?",
		ModelName="Insert the Name",
		AnimSetName="What?",
		HitPoint=10,
		WalkSpeed=0.1,
		RunSpeed=0.1,
		JumpSpeed=0.2,
		JumpHeight=0.3,
		EntityType="NONE",
		Position={ 0,0,0 },
		Scale={ 1,1,1 },
		Angle={ 0,0,0 },
		IsAnimate = true,

	},
	TileTable={}
}

function GetOutput( filename )
	return io.open( filename , "w" );
end

function WriteOut( out , data )
	out:write( data );
end

function IsErrorTolerant( t , r , e )
	if math.abs( t - r ) <= e then
		return true;
	else
		return false;
	end
end

function InsertTable( t , o )
	table.insert( t, o);
end

function Maxn(t)
	return table.maxn(t);
end

function serialize( o , out )
	if type(o) == "number" then
		out:write(o)
	elseif type(o) == "string" then
		out:write(string.format("%q", o))
	elseif type(o) == "boolean" then
		if o then
			out:write( "true" )
		else
			out:write( "false" )
		end
	elseif type(o) == "table" then
		out:write("{")
		for k,v in pairs(o) do
			if type(k) == "string" then
				out:write("  ", k, " = ")
			end
			serialize( v , out )
			out:write(",")
		end
		out:write("}\n")
	else
--		error("cannot serialize a " .. type(o))
	end
end

function SaveAgentParam( filename )
	local out = io.open( "out.lua" , "w" );
	out:write( "AgentParam[ \"");
	out:write( ParamTemplate["AgentParam"]["Id"].."\" ]=\n");
	serialize( ParamTemplate["AgentParam"] , out );
end

function SetParam( tableName , key , val )
	ParamTemplate[ tableName ][ key ] = val;
end

function KeyConfig( )
	Dout("PS_CIRCLE BUTTON IS ..");
	
end	

function MenuProc( id )
	for i=1, #gMenuID,1 do
		if gMenuID[i][1] == id then
			gMenuID[i][2]();
		end
	end
end

function IsPointInsideRect( x , y , l , t , r , b )
	local X = ( l < x ) and ( x < r );
	local Y = ( b < y ) and ( y < t );
	return ( X and Y );
end

--all args given as Vec3 
function IsPointInsideBox( point , pos , wx , wy , wz )
	local xz={
		pos.x - wx/2 , pos.z + wz/2 , pos.x + wx/2 , pos.z - wz/2
	}
	local xy={
		pos.x - wx/2 , pos.y + wy/2 , pos.x + wx/2 , pos.y - wy/2
	}
	if IsPointInsideRect( point.x , point.z , xz[1] , xz[2] , xz[3] , xz[4] ) then
		if IsPointInsideRect( point.x , point.y , xy[1] , xy[2] , xy[3] , xy[4] ) then
			return true;
		end
	end
	return false;
end

function CopyData( o )
	local ret={}
	for k,v in pairs( o ) do
		ret[ k ] = v;
	end
	return ret;
end

function CopyTable( t )
	local ret={}
	for k,v in pairs( t ) do
		if type( v ) == "table" then
			ret[ k ] = CopyTable( v );
		else
			ret[ k ] = v;
		end
	end
	return ret;
end

function Enter( soundname )
	if IsKeyTriggeredFromCode( 128 ) or
		GameLib.IsJoyTriggered( 0 , 0) then
		if not ( soundname  == 0 ) then
			GetSoundManager():playSe( soundname );--"se_maoudamashii_system21" );
		end
		return true;
	else
		return false;
	end
end

function PlayCursorSound()
	if SeMap.cursor then
		GetSoundManager():playSe( SeMap["cursor"] );
	end
end

function CursorMove( x , y , minX, maxX , minY , maxY , dirFunc )
	local dir=dirFunc();
	if dir.y == -1 then
		y = y - 1;
		PlayCursorSound();	
	elseif dir.y == 1 then
		y = y + 1;
		PlayCursorSound();	
	end
	if y < minY then
		y = minY;
	elseif y > maxY then
		y = maxY;
	end
	if dir.x == -1 then
		x = x - 1;
		PlayCursorSound();	
	elseif dir.x == 1 then
		x = x + 1;
		PlayCursorSound();	
	end
	if x < minX then
		x = minX;
	elseif x > maxX then
		x = maxX;
	end
	return x , y;
end

function Blinking( image , th , speed , maxalpha , minalpha )
	if AbsCosWav( 255 , speed ) > th then
		image:setVisible( true );
--		image:setAlpha( maxalpha , maxalpha , maxalpha , maxalpha );
	else	
		image:setVisible( false );
--		image:setAlpha( minalpha , minalpha , minalpha , minalpha );
	end
end

function Blinking2( image , th , speed , maxalpha , minalpha )
	if AbsCosWav( 255 , speed ) > th then
--		image:setVisible( true );
		image:setAlpha( maxalpha );
	else	
--		image:setVisible( false );
		image:setAlpha( minalpha );
	end
end

function TriggerDirection()
	local dx = 0;
	local dy = 0;
	
	if IsKeyTriggeredFromCode( 148 ) or
		GameLib.IsJoyTriggered( Joystick.BUTTON_LEFT , 0) then
		dx = -1
	elseif IsKeyTriggeredFromCode( 149 ) or
		GameLib.IsJoyTriggered( Joystick.BUTTON_RIGHT , 0) then
		dx = 1;
	end
	if IsKeyTriggeredFromCode( 146 ) or
		GameLib.IsJoyTriggered( Joystick.BUTTON_UP , 0) then
		dy = -1;
	elseif IsKeyTriggeredFromCode( 147 ) or
		GameLib.IsJoyTriggered( Joystick.BUTTON_DOWN , 0) then
		dy = 1;
	end		
	return Vec2( dx, dy );
end

function OnDirection()
	local dx = 0;
	local dy = 0;
	if IsKeyOnFromCode( 148 ) or
		GameLib.IsJoyOn( Joystick.BUTTON_LEFT , 0) then
		dx = -1
	elseif IsKeyOnFromCode( 149 ) or
		GameLib.IsJoyOn( Joystick.BUTTON_RIGHT , 0) then
		dx = 1;
	end
	if IsKeyOnFromCode( 146 ) or
		GameLib.IsJoyOn( Joystick.BUTTON_UP , 0) then
		dy = -1;
	elseif IsKeyOnFromCode( 147 ) or
		GameLib.IsJoyOn( Joystick.BUTTON_DOWN , 0) then
		dy = 1;
	end		
	return Vec2( dx, dy );
end

function LeftRightCursorMove( num )
	local isLeft = 
		IsKeyTriggeredFromCode( 148 )
			or
		GameLib.IsJoyTriggered( Joystick.BUTTON_LEFT , 0);
	local isRight = 
		IsKeyTriggeredFromCode( 149 )
			or
		GameLib.IsJoyTriggered( Joystick.BUTTON_RIGHT , 0);
	if isLeft then
		num = num - 1;
		PlayCursorSound();
	elseif isRight then
		num = num + 1;
		PlayCursorSound();
	end
	--TODO num 4
--[[	if num < 1 then
		num = 1;
	elseif num > 4 then
		num = 4;
	end
--]]
	return num;
end

gImageId = 0;
gAttachedImageList={}
function AddImage2D( key , data )
	--Can't Attach the Same Key
--[[	if IsKeyExist( gAttachedImageList , key ) then
		return;
	end

	gAttachedImageList[ key ] = gImageId;
--	local image= GetSceneManager():image( gImageId );
--]]
	data[ "name" ] = key;
	GetEventManager():triggerEvent( "CreateImage" , data );
	local image= GetSceneManager():attach( );
	image:setVisible( true );
	image:setRenderMode( Image.RM_RECT );
	local posX = data["Pos"][1];
	local posY = data["Pos"][2];
	image:setPosition( posX , posY );
	image:setWidthHeight( data["Width"] , data["Height"] );
	image:setRect( posX , posY , posX + data["Width"] , posY + data["Height"] );
	image:setBlendMode( Graphics.BLEND_LINEAR );
	if IsKeyExist( data , "Texture" ) then
		image:setName( data["Texture"] )
		image:setTexture( data["Texture"] );
	end
	if IsKeyExist( data , "Material" ) then
		image:setMaterial( data["Material"] );
	end
	if IsKeyExist( data , "Color" ) then
		local col = data["Color"];
		image:setColor( col,col,col,col );
	end
	if IsKeyExist( data , "Alpha" ) then
		local a = data["Alpha"];
		image:setAlpha( a,a,a,a );
	end
	if IsKeyExist( data , "BlendMode" ) then
		image:setBlendMode( data["BlendMode"] );
	end
	gImageId = gImageId + 1;
	if gImageId >= MAX_IMAGE_NUM then
		gImageId = 0;
	end
end

function AddButton( key , data )
	gAttachedImageList[ key ] = gImageId;
	local image= GetSceneManager():image( gImageId );
	image:setVisible( true );
	image:setTexture( data["Texture"] );
	local posX = data["Pos"][1];
	local posY = data["Pos"][2];
	image:setPosition( posX , posY );
	image:setWidthHeight( data["Width"] , data["Height"] );
	image:setBlendMode( Graphics.BLEND_LINEAR );
	if IsKeyExist( data , "Color" ) then
		local col = data["Color"];
		image:setColor( col,col,col,col );
	end
	if IsKeyExist( data , "Alpha" ) then
		local a = data["Alpha"];
		image:setAlpha( a,a,a,a );
	end
	if IsKeyExist( data , "BlendMode" ) then
		image:setBlendMode( data["BlendMode"] );
	end
	gImageId = gImageId + 1;
	if gImageId >= MAX_IMAGE_NUM then
		gImageId = 0;
	end	
end

function FadeIn( data ) 
Dout("Fade IN");
	local img=GetAttachedImage( data["ImageName"] );
	data["Alpha"] = data["Alpha"] + data["Speed"];
	local a = data["Alpha"];
	if a > data["Threshold"] then
		data["Alpha"] = data["Threshold"] - 1;
		a = data["Alpha"];
		img:setAlpha( a,a,a,a );
		return true;
	else
		img:setAlpha( a,a,a,a );
		return false;
	end
end

function FadeOut( data )
Dout("Fade OUT" );
	local img=GetAttachedImage( data["ImageName"] );
	data["Alpha"] = data["Alpha"] - data["Speed"];
	local a = data["Alpha"];
	if a < data["Threshold"] then
		data["Alpha"] = data["Threshold"] + 1;
		a = data["Alpha"];
		img:setAlpha( a,a,a,a );
		return true;
	else
		img:setAlpha( a,a,a,a );
		return false;
	end
end

function Wait( data )
	if os.difftime( os.clock() , data["CurrentTime"] ) > data["WaitTime"] then
		return true;
	else
		return false;
	end
end

function GetAttachedImage( key )
	if IsKeyExist( gAttachedImageList , key ) then
		return GetSceneManager():image( gAttachedImageList[ key ] );
	else
		return 0;
	end
end

function FullWidth()
	if IsFullScreen() then
		return GetFullScreenWidth();
	else
		return GetWindowWidth();
	end
end

function FullHeight()
	if IsFullScreen() then
		return GetFullScreenHeight();
	else
		return GetWindowHeight();
	end
end

function RatioOffsetX( x )
	local ratioW = FullWidth()/840;
	return x*ratioW;
end

function RatioOffsetY( y )
	local ratioH =  FullHeight()/680;
	return y*ratioH;
end

function RatioOffset( x , y )
--	local ratioW = FullWidth()/840;
--	local ratioH =  FullHeight()/680;
	local ratioW = Native.Methods.windowWidth()/840;
	local ratioH =  Native.Methods.windowHeight()/680;
	return x*ratioW , y*ratioH;
end

function SetPos(img,x,y)
	local rx,ry = RatioOffset(x,y );
	img:setPosition(rx , ry);
end
   
function AddButton( scene , t , buttonData )
	local o=CheckedButtonClass.new( scene , buttonData )
	table.insert( t , o );
end

function AddButtonList( scene , t , data )
	for i=1,#data, 1 do
		AddButton( scene , t , data[i] );
	end
end

function AcceptDragAndDrop( funcmap )
	local di = Window():droppedItemNumber();
	if di > 0 then
		local pass = Window():droppedItem(0);
		local isAccept = false;
		for k,v in pairs( funcmap) do
			if string.find( pass , k ) then
				local file = GameLib.GetDroppedFileName( pass );
				v( file );
				isAccept = true;
				break;
			end
		end
--[[		if isAccept then
			GameLib.MessageBox( "File is Loaded ", "File is :"..file );
		else
			GameLib.MessageBox( "Not Loaded : ", "File is :"..file );
		end
--]]		Window():clearDroppedItem();
	end
end

function AcceptXFile( file )
	GameLib.LevelEditor():addMesh( file );
--	GameLib.CreateMesh( "mesh_"..gSerialMeshID , file , Vec3(0) , Vec3(0) , Vec3(1) , SceneNode.TYPE_STATIC_OPAQUE );
end

gTexFileCount=0
function AcceptTextureFile( file )
	local data={
		Texture=file,
		Pos={ FullWidth()/2 , FullHeight()/2 },
		Width=100,
		Height=100,
	}
	AddImage2D( file..gTexFileCount , data );
	gTexFileCount = gTexFileCount + 1;
end

function AcceptAnimationFile( file )
	GameLib.ParseFromFile( "data/Animation/"..file );
end

function AcceptLevelFile( file )
	GetEventManager():triggerEvent("LoadScript", "Lua/level/"..file );
	for i=1,#gLevelOut,1 do
		GameLib.LevelEditor():addMesh( gLevelOut[i]["File"] );
--		local mesh = AttachStaticObject( gLevelOut[i] );
--		gLevelOut[i]["Mesh"] = mesh;
--		table.insert( gAttachedMeshList , gLevelOut[i] );
	end	
end

function AcceptLuaModelFile( file )
	GetModelLoader():load( "NinjaFinal" , Mesh["NinjaFinal"] , RootFrames["NinjaFinal"] );
end

function CameraMove()
	local camera = CAMERA();
	local vx = -GetMouse():velocityX();
	local vy = - GetMouse():velocityY();
	local move = Vec3(0);
	if GameLib.JoystickNum() > 0 then
		local js = GameLib.GetJoystick( 0 );
		vx = js:analog(0);
		vy = js:analog(1);
--		vx = vx - 32517;
--		vy = vy - 32517;
--[[		local anaX = vx/100000-0.3;
		local anaY = vy/100000-0.3;
		if math.abs( anaX ) < 0.1 then
			anaX = 0;
		end
		if math.abs( anaY ) < 0.1 then
			anaY = 0;
		end
--]]
--[[		local anaX = vx/65535;
		local anaY = vy/65535;
		anaX = 2*math.abs( anaX * anaX );
		anaY = 2*math.abs( anaY * anaY );
		if vx < 0 then
			anaX = - anaX ;
		end
		if vy < 0 then
			anaY = - anaY ;
		end
		if math.abs( anaX ) < 0.1 then
			anaX = 0;
		end
		if math.abs( anaY ) < 0.1 then
			anaY = 0;
		end
Dout( "ANALOG 0:"..anaX );
Dout( "ANALOG 1:"..anaY );
--]]
		if vx or vy then
			move = Vec3(vx/30000,vy/30000,0);			
		end
	else
		if GetMouse():isOn( Mouse.BUTTON_LEFT ) then
			if vx or vy then
				move = Vec3(vx/20,0,vy/20);
			end
		end
	--	if GetMouse():isOn( Mouse.BUTTON_RIGHT ) then
		if GetMouse():wheel() > 0 then
			move = Vec3(0,0.4,0);
		elseif GetMouse():wheel() < 0 then
			move = Vec3(0,-0.4,0);
		end
	end
	GameLib.ViewCoordMove( move );
	camera:addLookat( move );
	camera:addPos( move );
	
end
--[[
function CameraMove()
	local camera = CAMERA();
	local vx = -GetMouse():velocityX();
	local vy = - GetMouse():velocityY();
	if GetMouse():isOn( Mouse.BUTTON_LEFT ) then
		if vx or vy then
			local move = Vec3(vx/20,0,vy/20);
			GameLib.ViewCoordMove( move );
			camera:addLookat( move );
			camera:addPos( move );
		end
	end
	if GetMouse():isOn( Mouse.BUTTON_RIGHT ) then
		if vy then
			local move = Vec3(0,vy/20,0);
			GameLib.ViewCoordMove( move );
			camera:addLookat( move );
			camera:addPos( move );
		end
	end
end
--]]
function CameraRotate()
	if GetMouse():isOn( Mouse.BUTTON_RIGHT) then
		local camera = CAMERA();
		local vx = GetMouse():velocityX();
		local vy = - GetMouse():velocityY();
		if vx or vy then
			GameLib.RotateCamera( Vec3( vy/10 , vx/10 , 0) );
		end
	end
end

function MeshMove()
	local LE = GameLib.LevelEditor()
--		GameLib.LevelEditor():selectedMesh():setPosition( Vec3(gCurrentSpinN/4,0,0) );
	local kb = GetKeyboard();
	if kb:isOn( Keyboard.KEY_CONTROL) then
		if IsKeyTriggered( "c" ) then
			if LE:selectedMesh() then
				GameLib.LevelEditor():copySelectedMesh();
			end
		end
	end

	local mouseVx = GetMouse():velocityX();
	local mouseVy = GetMouse():velocityY();
	local mesh = GameLib.LevelEditor():selectedMesh();
	if mesh then
		local move = Vec3(0);
		if GetMouse():isOn( Mouse.BUTTON_LEFT ) then
			if mouseVx or mouseVy then
				 move = Vec3( mouseVx/20 , 0 , -mouseVy/20 );
				
			end
		end
		if GetMouse():isOn( Mouse.BUTTON_RIGHT) then
			if mouseVy then
				move = Vec3( 0 , -mouseVy/20 , 0 );
			end
		end
		ViewCoordTransform( move );	
		mesh:addPos( move );
	end
end

function MeshRotate()
	local mouseVx = GetMouse():velocityX();
	local mouseVy = GetMouse():velocityY();
	local mesh = GameLib.LevelEditor():selectedMesh();
	if mesh then
		if GetMouse():isOn( Mouse.BUTTON_LEFT ) then
			if mouseVx or mouseVy then
				local a = Vec3( 0, mouseVx/20 , 0 );
				mesh:addAngle( a );
			end
		end
		if GetMouse():isOn( Mouse.BUTTON_RIGHT ) then
			if mouseVx or mouseVy then
				local a = Vec3( mouseVx/20 ,0, 0 );
				mesh:addAngle( a );
			end
		end
	end
end

function MeshScale()
	local mouseVx = GetMouse():velocityX();
	local mouseVy = GetMouse():velocityY();
	local mesh = GameLib.LevelEditor():selectedMesh();
	if mesh then
		if GetMouse():isOn( Mouse.BUTTON_LEFT ) then
			if mouseVx or mouseVy then
				local a = Vec3( mouseVx/20 ,mouseVx/20,mouseVx/20);
				mesh:addScale( a );
			end
		end
	end
end

function MeshSelect()
	GameLib.LevelEditor():selectGeometry()
end

function MeshDelete()
end

function ImageMove()
	local sub = GameLib.GetSubtitler();
	local mouseVx = GetMouse():velocityX();
	local mouseVy = GetMouse():velocityY();
	if gDragging then
		local mx = GetMouse():x();
		local my = GetMouse():y();
		local w = gCurrentFocusedImage:width();
		local h = gCurrentFocusedImage:height();
		local dstX = mx - w/2 ;
		local dstY = my - h/2 ;
		if GetMouse():isOn( Mouse.BUTTON_LEFT ) then
			SetPos( gCurrentFocusedImage , dstX ,dstY );
			local str = sub:get( gCurrentCap );
			if str then
				SetPos( str , dstX , dstY );
			end
		elseif GetMouse():isOn( Mouse.BUTTON_RIGHT ) then
			gCurrentFocusedImage:setWidthHeight( w+mouseVx , h+mouseVy  );
		else
			gDragging = false;
		end	
--]]	
	end
end

--function 
--	local mesh = GameLib.LevelEditor():selectedMesh();
function CalcWall()
	GameLib.LevelEditor():calcWall();
end
function CalcFloor()
	GameLib.LevelEditor():calcFloor();
end

function SaveLevel()
--[[	local data={}
	for i=0,GameLib.LevelEditor():meshNum()-1,1 do
		SerializeMeshInfo( data , GameLib.LevelEditor():mesh(i) )
	end
--]]
	gOpenFileName = GameLib.SaveFileControl();
	GameLib.LevelEditor():serialize( "Scene" , gOpenFileName );	
end

function LoadLevel()
	gOpenFileName = GameLib.OpenFileControl();
	GetEventManager():triggerEvent("LoadScript", gOpenFileName );
	GameLib.LevelEditor():deserialize( Level);
end

function SerializeMeshInfo( t , m )
	local pos = m:position();
	local scl = m:scale();
	local angle = m:angle();
	local data={
		File=m:fileName(),
		Pos={ pos.x , pos.y , pos.z },
		Angle={ angle.x , angle.y , angle.z },
		Scale={ scl.x , scl.y , scl.z },
		Type=m:objectType(),
		visible=m:isVisible(),
	}
	t[ m:name() ] = data;
--	table.insert( t , data );
end

function SerializeTileInfo( t , m )
	local pos = m:position();
	local scl = m:scale();
	local angle = m:angle();
	local data={ 
		pos={ pos.x , pos.y , pos.z },
		angle={ angle.x , angle.y , angle.z },
		scale={ scl.x , scl.y , scl.z },
		material=m:materialName(),
	}
	t[ m:name() ] = data;
--	table.insert( t , data );		
end

function GetMaterial( name )
	
end      

function Deserialize(  leveldata )
	if leveldata.Meshes then
		for name,t in pairs( leveldata["Meshes"] ) do			
			local pos = t["Pos"];
			local s = t["Scale"];
			local a = t["Angle"];
--			local view= Native.Methods.CurrentSceneState():sceneView();
			local view = GetViewManager():view( "Editor" );
			if view then
				local nodeType = SceneNode.TYPE_STATIC_OPAQUE;
				if t.isAlpha then
					nodeType = SceneNode.TYPE_STATIC_ALPHA;
				end
				view:attachMesh( 
				name ,
				t["File"] , 
				Vec3( pos[1] , pos[2] , pos[3] ) ,
				Vec3( a[1] , a[2] , a[3] ) ,
				Vec3( s[1] , s[2] , s[3] ) ,
				nodeType ,
				t["Type"]
				);
			end
		end
	end
end
--]]

function DeserializeLevel( viewname , leveldata )
	if leveldata.Meshes then
		for name,t in pairs( leveldata["Meshes"] ) do			
			local pos = t["Pos"];
			local s = t["Scale"];
			local a = t["Angle"];
			local view = GetViewManager():view( viewname );
			if view then
				local nodeType = SceneNode.TYPE_STATIC_OPAQUE;
				if t.isAlpha then
					nodeType = SceneNode.TYPE_STATIC_ALPHA;
				end
				local mesh = view:attachMesh( 
							name ,
							t["File"] , 
							Vec3( pos[1] , pos[2] , pos[3] ) ,
							Vec3( a[1] , a[2] , a[3] ) ,
							Vec3( s[1] , s[2] , s[3] ) ,
							nodeType ,
							t["Type"]
						);	
				if t.visible then
--					mesh:setVisible( t["visible"] );
				end
				mesh:update();
			end
		end
	end
end
--]]
--[[
function DeserializeMesh( t )
	local pos = t["Pos"];
	local s = t["Scale"];
	local a = t["Angle"];
	local m = GameLib.LevelEditor():addMesh( 
		t["File"] , 
		Vec3( pos[1] , pos[2] , pos[3] ) ,
		Vec3( a[1] , a[2] , a[3] ) ,
		Vec3( s[1] , s[2] , s[3] ) );
end	

function DeserializeTile( t )
	local p = t["pos"];
	local s = t["scale"];
	local a = t["angle"];
	local matname = t["material"];
	local pos = Vec3( p[1] , p[2] , p[3] ) ;
	local angle = Vec3( a[1] , a[2] , a[3] );
	local scale= Vec3( s[1] , s[2] , s[3] );
	Native.Editor.addTile(
		pos,
		angle ,
		scale ,
		matname
--		MaterialPallet.get( t["material"] )
	);
--		MaterialDuplicater( data );

end	
--]]	

function AddFloorByClick(p1,p2)
--[[	local rect={
		Bottom = p1.x,
		Top= p1.z,
		Right= p2.x,
		Left= p2.z,
		Height=(p1.y+p2.y)/2
	}	
	GameLib.AddFloor( "Edit" , rect );
--]]
end

function ExitGame()
	QuitGame();
end

function CreateMaterialDialog()
	GameLib.CreateDialog( "MAT_DIALOG" );
end

function CreateObjectDialog()
	GameLib.CreateDialog( "OBJ_DIALOG" );
end

function CreateCommandMenuDialog()
	GameLib.CreateDialog( "DEBUG_MENU" );
end

gMenuID={
	{ 40001, LoadLevel },
	{ 40002, SaveLevel },
	{ 40003, ExitGame },
	{ 40004, LoadAnimation },
	{ 40009, CalcFloor },
	{ 40010, CalcWall },
	{ 40015 , CreateCommandMenuDialog },
	{ 40018 , CreateObjectDialog },
	{ 40017 , ExitGame },
}
function GetVec3Interpreter( interpreter )
	local ret =Vec3(0);
	ret.x = interpreter:getFloat();
	ret.y = interpreter:getFloat();
	ret.z = interpreter:getFloat();
	return ret;
end


function CollectTableKey( collector , t)
	for k,v in pairs( t ) do		
--		collector:collect("aaaa" );
		collector:collect( k );
	end
end

function CollectMatDataKey( collector )
	CollectTableKey( collector , gMaterialDataPallet );
end

function SetEditMaterialName( v )
	gCurrentEditMaterialData[ "name" ]=v;
end

function SetEditMaterialValue( v , id )

end

function SetEditMaterialDecal( v )
	gCurrentEditMaterialData[ "TextureFileName" ]=v;
end

function SaveEditMaterialToPallet()
	
end

function SetEditMaterialToSelected()
	local m = Native.Editor.selectedMesh();
	if m then
		if m:isTile() then
			m:setMaterial(  );
		end
	end
end

function AddGraphNodes( data )
	--Create Graph Nodes
	for name,childrenName in pairs( data ) do
		local node = GetSceneManager():get( name );
		if node then
			local scene = CurrentSceneState();
			if scene then
				scene:graph():createNode( node:position() );
			end
		end
	end
	--Link the Nodes 
	for name,childrenName in pairs( data ) do
		local node = GetSceneManager():get( name );
		if node then
			local scene = CurrentSceneState();
			if scene then
				local gr = scene:graph();
				for i=1,#childrenName,1 do
					gr:linkNodes( name , chidlrenName[i] );
				end
			end
		end
	end
	
end

function FindByKey( tbl , key )
	if IsKeyExist( tbl , key ) then
		return tbl[ key ];
	else
		return nil;
	end	
end

function ShowSelectedMeshName()
	local s = GameLib.LevelEditor():selectedMesh();
	if s then
		Dout( "Current node:"..s:name() );
	end
end

function ExecCommand( line )
	GetEventManager():triggerEvent( "CommandLineExec" , line );
end

function CreateImage2( d )	
	OffsetGUI( d );
	local img = GameLib.CreateImage(
		d["name"] ,
		d["pos"][1] , d["pos"][2] ,
		d["size"][1] , d["size"][2] , 
		d["texture"],
		d["blend"]
	);
	if d.effect then
		GameLib.AttachFlipUVProcess( d.name , d.effect[1] , d.effect[2] );	
--		GameLib.AttachFlipUVProcess( "image_exp" , "ExplodeEffect1" , ParaparaAnimation["ExplodeEffect1"] );
	end
	if d.alpha then
		img:setAlpha( d["alpha"] );
	end
	
	if d.uv then
		local t = d.uv;
		img:setUV( t[1] , t[2] , t[3] , t[4] );
	end
	return img;
	--]]
end

--Iterate the Same Func to a list
function IterateFunc( list , func )
	for i=1,#list,1 do
		func( list[i] );
	end
end

function SerializeCurrSceneParam()
	if IsCurrSceneParamExist() then
		local sceneName = Native.Methods.CurrentSceneName();
		local filename = "Lua/param2/SceneParam_"..sceneName..".lua";
		local out = GetOutput( filename );
		out:write( "SceneParam[\""..sceneName.."\"]=" );
		serialize( SceneParam[ sceneName ] , out );
	end
end

function IsCurrSceneParamExist()
	local sceneName = Native.Methods.CurrentSceneName();
	return IsKeyExist( SceneParam , sceneName );
end

function SetCurrLightOn( index , t )
	assert( index > 0 and index <= 4 );
	local lightParam = GetCurrLightParam();
	if lightParam then
		lightParam[ index ]["isUse"] = t;		
	end
end

function SetCurrLightPos( index , x , y, z  )
	assert( index > 0 and index <= 4 );
	local lightParam = GetCurrLightParam();
	if lightParam then
		lightParam[ index ]["pos"][1] = x;
		lightParam[ index ]["pos"][2] = y;
		lightParam[ index ]["pos"][3] = z;
	end
end

function SetCurrLightCol( index , r , g, b  )
	assert( index > 0 and index <= 4 );
	local sceneName = Native.Methods.CurrentSceneName();
	local lightParam = GetCurrLightParam();
	if lightParam then
		lightParam[ index ]["col"][1] = r;
		lightParam[ index ]["col"][2] = g;
		lightParam[ index ]["col"][3] = b;
	end
end

function SetCurrLightAtten( index , atten )
	assert( index > 0 and index <= 4 );
	local sceneName = Native.Methods.CurrentSceneName();
	local lightParam = GetCurrLightParam();
	if lightParam then
		lightParam[ index ]["atten"] = atten;
	end
end

function GetCurrLightParam()
	local sceneName = Native.Methods.CurrentSceneName();
	if IsCurrSceneParamExist() then
		if SceneParam[ sceneName ].Main_State then
			if SceneParam[ sceneName ]["Main_State"].Update then
				local t = SceneParam[ sceneName ]["Main_State"]["Update"];
				if t.SetLightParam then
					return SceneParam[ sceneName ]["Main_State"]["Update"]["SetLightParam"];
				end
			end
		end
	end
	return nil;
end

function SetCurrLightAmbient( index , r , g , b)
	local lightParam = GetCurrLightParam();
	if lightParam then
		lightParam[ index ]["amb"][1] = r;
		lightParam[ index ]["amb"][2] = g;
		lightParam[ index ]["amb"][3] = b;
	end
end

function VisiblePhysicalView()
	local sceneName = Native.Methods.CurrentSceneName();
	local ph = GetSceneManager():get( sceneName.."_physical");
	if ph then
		if ph:isVisible() then
			ph:setVisible( false );
		else
			ph:setVisible( true );
		end
	end
	local pm = GetPhysicsManager();
	if pm:isShowView() then
		pm:enableShowPhysicalView( false );
	else
		pm:enableShowPhysicalView( true );
	end
end

function ActivateCharaView( t )
	Player_1View:activateAgent( t );
	Player_2View:activateAgent( t );
	AI_1View:activateAgent( t );
	AI_2View:activateAgent( t );
	AI_3View:activateAgent( t );
	AI_4View:activateAgent( t );
	NPCView:activateAgent( t );
end	

function JaggyMoveXY( ampX , ampY , speedX , speedY )
	local t1 = CosWav( ampX , speedX );
	local t2 = SinWav( ampY , speedY );
	local v1 = Vec3( t1 , t2 , 0 );
	local v2= Vec3( t2 , t1 , 0 );
	return v1,v2;
end

function JaggyMove( ampX , ampY , ampZ , speedX , speedY ,speedZ )
	local t1 = CosWav( ampX , speedX );
	local t2 = SinWav( ampY , speedY );
	local t3 = SinWav( ampZ , speedZ );
	local v1 = Vec3( t1 , t2 , t3 );
	return v1;
end

function IsCurrentSceneExist( data )
	if data.activatedSceneName then
		for i=1,#data.activatedSceneName, 1 do
			if ( Native.Methods.CurrentSceneName() == data.activatedSceneName[i] ) then
				return true;
			end	
		end
	end
	return false;
end

function ChangeAnimationParam( setname , name , speed )
	if IsKeyExist( AnimationParam , setname ) then
		if IsKeyExist( AnimationParam[ setname ] , name ) then
			AnimationParam[ setname ][ name ]["Speed"] = speed;		
		end
	end
end


EvtListener={}
EvtListener.create=function( )
	local o={}
	o.exec=function() 
	
	end
	
end
listener={
	handleEvent=function( sender , evtdata)
		
	end,
	log=function()
		
	end
}
--
function CommandExecFromFileListener( data )
	local ip = Interpreter( data );
	local token = ip:getToken();	
	GetEventManager():triggerEvent( token , ip );
end

function CommandLineExecListener( data )
	local ip = Interpreter();
	ip:setData( data );
	local token = ip:getToken();	
	GetEventManager():triggerEvent( token , ip );
end
--[[
function SCRIPT_TokenListener( data )
	local name = ip:getToken();
	EventScriptData[ name ] ={}
	local token = ip:getToken();
	while not( token == "END" ) do
		local curr = ip:currentToken();
		if curr == "WAIT" then
			local milliSec = ip:getInt()
			table.insert( EventScriptData[name] , { "WAIT" , milliSec } );
		else
			local line = ip:getLine();
			table.insert( EventScriptData[name] , { curr , line } );
		end
		token = ip:getToken();
	end
end
--]]
--[[
function AnimInfo_CommandListener( ip )
	while not ip:isEof() do
		local token = ip:getToken();
		if token == "name" then
			gCamDataName = ip:getToken();
			break;
		end
	end
end	
--]]

function IsHaveCamData( camdat )
	if camdat.eyePos then
		return ( #camdat["eyePos"] > 0 );
	else
		return false;
	end
end

function ParseRokCamData( ip , id )
	local token = ip:getToken();
	local idx = id+1;
	CameraData[ idx ] ={}
	CameraData[ idx ][ "eyePos"]={}
	CameraData[ idx ][ "lookAtPos"]={}
	local keyCount = 1;
	while not ( token == "#Camera"..id ) do
		if token == "frameno" then
			table.insert( CameraData[ idx ][ "eyePos"] , {} );
			table.insert( CameraData[ idx ][ "lookAtPos"] , {} );
			local keyEyePos = CameraData[ idx ][ "eyePos"][ keyCount ];		
			local keyLookPos = CameraData[ idx ][ "lookAtPos"][ keyCount ];
			local sec = ip:getFloat()/30;
			keyEyePos["t"] = sec;
			keyLookPos["t"] = sec;
		elseif token == "pos" then
			local key = CameraData[ idx ][ "eyePos"][ keyCount ];
			key["x"] = ip:getFloat()/80;
			key["y"] = ip:getFloat()/80;
			key["z"] = ip:getFloat()/80;
			key["w"]=0;
		elseif token == "target" then
			local key = CameraData[ idx ][ "lookAtPos"][ keyCount ];
			key["x"] = ip:getFloat()/80;
			key["y"] = ip:getFloat()/80;
			key["z"] = ip:getFloat()/80;
			key["w"]=0;
			keyCount = keyCount +1;
		end
		token = ip:getToken();
	end
	ip:getToken();
--]]
end

function Camera0_CommandListener( ip )
	ParseRokCamData( ip , 0 );	
--	if IsHaveCamData( CameraData[1] ) then	
--gCamCurveProcess0:deserialize( CameraData[1] );
--gCamCurveProcess0:changeMode( Process.INITIALIZING );
--	end
end

function Camera1_CommandListener( ip )
	ParseRokCamData( ip , 1 );		
--	if IsHaveCamData( CameraData[2] ) then		
--gCamCurveProcess1:deserialize( CameraData[2] );
--gCamCurveProcess1:changeMode( Process.INITIALIZING );
--	end
end

function Camera2_CommandListener( ip )
	ParseRokCamData( ip , 2 );	
--	if IsHaveCamData( CameraData[3] ) then		
--gCamCurveProcess2:deserialize( CameraData[3] );
--gCamCurveProcess2:changeMode( Process.INITIALIZING );
--	end
end

function SET_CommandListener( ip )
	local com = ip:getToken();	
	local nodename = ip:getToken();
	local node = GetSceneManager():get( nodename );
	if node then
		local v = GetVec3Interpreter( ip );
		if com == "POS" then
			node:setPosition( v );
		elseif com == "ANGLE" then
			node:setAngle( v );
		elseif com == "SCALE" then
			node:setScale( v );
		end
	end
end

function CHANGE_ANIM_CommandListener( ip )
	local role = ip:getToken();
	local animset = ip:getToken();
	local anim = ip:getToken();
	local agent = Character.get( role );
	if not agent then
		return;
	end	
	local t = IsKeyExist( AnimationParam , animset );
	if t then
		t = IsKeyExist( AnimationParam[ animset ] , anim );
		if t then
			ChangeAnim( agent , AnimationParam[ animset][ anim ] );
		end
	end
end

function CAMERA_CommandListener( ip )
	local camState = ip:getToken();
--	Camera.changeState( camState );
	if camState == "CloseUp" then
		gCamId = 0;
	elseif camState == "Parallel" then
		gCamId = 1;
	elseif camState == "2D" then
		gCamId = 2;
	elseif camState == "CameraCourse" then
		local camNum = ip:getInt(); --ԃJH
		local proc=  GetProcessManager():process( "CamCourse"..camNum );
		if proc then
			proc:deserialize( CameraData[ camNum + 1 ] );
			proc:changeMode( Process.INITIALIZING );
		end
		gCamId = 4 + camNum;
	end
end

function CHANGE_CAM_CommandListener( ip )
	local beforeCamState = ip:getToken();
	local afterCamState = ip:getToken();
	local pos = Camera.position();
	local lookpos = Camera.lookAtPos();
	Camera.changeState( afterCamState );
	Camera.setPos( pos );
	Camera.setLookAt( lookpos );
end

--Change Command . Using Like This...
--	CHANGE SCENE Title 0.5 10
--	CHANGE STATE Player Wait_State
--<Grammar>
--	CHANGE SCENE "SceneName" "SceneChangeWaitTime( seconds )" "ChangeSpeed"
--	CHANGE STATE "AgentName" "StateName"
gPrevState="";
function CHANGE_CommandListener( ip )
	local subject = ip:getToken();
	if subject == "STATE" then		
		local role = ip:getToken();
		local a = Character.get( role );
--		local node = GetSceneManager():get( name );
		if a then
			local state =  ip:getToken();
			a:getFSM():changeState( state );
		end

	elseif subject == "SCENE" then
		--get the next scene state name , wait time , 
		local nextSceneName = ip:getToken();
		if gPrevState == nextSceneName then
			return;
		end
		gPrevState = nextSceneName;
		local sceneChangeWaitTime = ip:getFloat();
		local changeSpeed = ip:getFloat();
		local transitData={
			name=nextSceneName,
			wait=sceneChangeWaitTime,
			speed=changeSpeed,
		}
		TransitionEvent.create( transitData );
		local view = GetViewManager():view(  nextSceneName );
		if view then
			GetViewManager():viewController():setCurrentView(  view  );	
		end
Native.Methods.OutputDebugStr( nextSceneName );
	elseif subject == "CAM" then
		local id = ip:getInt();
		gCamId = id;
	elseif subject == "CAMTARGET" then
		local nodename = ip:getToken();
		if nodename == "Player" then
			nodename = Character.getCharacterName( "Player" );
		end
		gRailCameraData["SubjectName"]=nodename
		gCameraCloseUpData["SubjectName"]=nodename;
		local data={
			name=nodename,			
		}
		TriggerEvent( "CamTgt_"..nodename.."_Changed" , data );
	elseif subject == "PARACAMSPEED" then
		local x = ip:getFloat();
		local y = ip:getFloat();
		gRailCameraData["SpeedX"]= x;
		gRailCameraData["SpeedZ"]= y;
	elseif subject == "TEX" then
		local nodename = ip:getToken();
		local texname = ip:getToken();
		local node = GetSceneManager():get( nodename );
		if node then
			node:setTexture( texname );
		end		
	elseif subject == "BEHAVIOR" then
		local role = ip:getToken();
		local behav = ip:getToken();
		local agent = Character.get( role );
		ChangeBehavior( agent , behav );
	end
end

function CHANGE_FOCUS_TEX_CommandListener( ip )
	local guiname = ip:getToken();
	local texname = ip:getToken();
	local gui = GUI_Button.get( guiname );
	if gui then
		gui.changeFocusTex( texname );
	end
end

function ChangeBehavior( agent , name )
	local br = agent:brain();
	if br then
		br:setBehavName( name );
	end
end

function FADE_CommandListener( ip )
	local inout = ip:getToken();
	local data={
		name=ip:getToken(),
		alpha=ip:getFloat(),
		speed=ip:getFloat(),
		threshold=ip:getFloat(),
		mode=Process.INITIALIZING,
	}
	if inout == "IN" then
		Animation2D.fadeIn( data );
	elseif inout == "OUT" then
		Animation2D.fadeOut( data );
	end
	
end

function BLINK_CommandListener( ip )
	local data={
		name=ip:getToken(),
		speed=ip:getFloat(),
		threshold=ip:getFloat(),
		max=ip:getFloat(),
		min=ip:getFloat(),
		mode=Process.INITIALIZING,
		blink=true,
	}
	Animation2D.alphaWave( data );	
end

function BLINK_ALPHA_CommandListener( ip )
	local data={
		name=ip:getToken(),
		speed=ip:getFloat(),
		mode=Process.INITIALIZING,
	}
	Animation2D.alphaWave( data );	
end

function FLY_CommandListener( ip )
	local name = ip:getToken();
	local pos1 = ip:getFloat();
	local pos2 = ip:getFloat();
	local dst1 = ip:getFloat();
	local dst2 = ip:getFloat();
	local tim = ip:getFloat();
	local w,h = GetOffset();
	local data={
		name=name,
		pos={ pos1*w, pos2*h },
		dst={ dst1*w , dst2*h},
		coef=0,
		time=tim,
		mode=Process.INITIALIZING,
	}	
	Animation2D.fly( data );	
end

function FLYGUI_CommandListener( ip )
	local typ = ip:getToken();
	local name = ip:getToken();
	local where = ip:getToken();
	local tim = ip:getFloat();
	local w,h = GetOffset();
	local data={
		name=name,
		pos={ 0,0 },
		dst={ 100,100},
		coef=0,
		time=tim,
		mode=Process.INITIALIZING,
	}	
	local gui = nil;
	if typ == "BUTTON" then
		gui = GUI_Button.get( name );
	elseif typ == "PIC" then
		gui = GUI_Picture.get( name );
	elseif typ == "BAR" then
		gui = GUI_ProgressBar.get( name );
	end
	if gui then
		if where == "LEFT" then
			data["pos"][1] = -100;
			data["pos"][2] = gui.pos[2];
		elseif where == "RIGHT" then 
			data["pos"][1] = FullWidth() + 100;
			data["pos"][2] = gui.pos[2];
		elseif where == "UP" then 
			data["pos"][1] = gui.pos[1];
			data["pos"][2] = -100;
		elseif where == "DOWN" then 
			data["pos"][1] = gui.pos[1];
			data["pos"][2] = FullHeight() + 100;
		end
		data["dst"] = { gui.pos[1]*w , gui.pos[2]*h };
	end
	Animation2D.fly( data );	
--]]
end

function ZOOM_CommandListener( ip )
	local name = ip:getToken();
	local w1 = ip:getFloat();
	local h1 = ip:getFloat();
	local w2= ip:getFloat();
	local h2 = ip:getFloat();
	local tim = ip:getFloat();
	local data={
		name=name,
		size1={w1,h1},
		size2={w2,h2},
		coef=0,
		time=tim,
		mode=Process.INITIALIZING,
	}	
	Animation2D.zoom( data );	
end

function ATTACH_CommandListener( ip )
	local subject=ip:getToken();
	if subject == "SCENE" then
		local nodename = ip:getToken();
		TriggerEvent( "AttachNode" , { name=nodename } );
	elseif subject == "AGENT" then
		local name = ip:getToken();
		local c = Character.getCharacterName( name );
		ip:getToken("VIEW");
		local viewName = ip:getToken();
		local view = GetViewManager():view( viewName );
		local node =GetSceneManager():get( c );
		view:attachAgent( node );
		local data = {
			name= c,
			role=name,
			viewName=viewName,
		}
		TriggerEvent( "AgentViewAttached" , data );
--		view:attachNode( c );
--		CharacterView:attachNode( c );
--		TriggerEvent( "AttachNode" , { name=c } );
	elseif subject == "VIEW" then
		local name = ip:getToken();
		AttachView( name );
	elseif subject == "POS" then
		local objname1 = ip:getToken();
		local objname2 = ip:getToken();
		local ofsx = ip:getFloat();
		local ofsy = ip:getFloat();
		local ofsz = ip:getFloat();
		local SM = GetSceneManager();
		local obj1 = SM:get( objname1 );
		local obj2 = SM:get( objname2 );
		local obj1pos = obj1:position()
		obj2:setPosition( Vec3( obj1pos.x + ofsx , obj1pos.y + ofsy , obj1pos.z + ofsz ) );
	end
end

function REVIVE_CommandListener( ip )
	local name = ip:getToken();
	Revive( name );
end
		
function DISPLAY_CommandListener( ip )
	local subject = ip:getToken();
	if subject == "MSG" then
		local txtId = ip:getToken();
		ip:getToken("IN");
		local txtboxId = ip:getToken();
		local t = GUI_TextBox.get( txtboxId );
		if t then
			t.setTextId( txtId );
		end
	elseif subject == "PICTURE" then
		local picId = ip:getToken();
		GUI_Picture.create( PictureData[ picId ] );	
	elseif subject == "BUTTON" then
		local buttonId = ip:getToken();
		GUI_Button.create( ButtonData[ buttonId ] );		
	end
end

function ENABLE_CommandListener( ip )
	local tk = ip:getToken();
	if tk == "AI" then
		local name = ip:getToken();
		local TorF = ip:getToken();
		local a = Character.get( name );
		if a then
			if TorF == "true" then
				a:enableAI( true ) ;
			else
				a:getFSM():changeState( "Wait_State" );
				a:enableAI( false ) ;				
			end
		end
	end
end

function ACTIVATE_CommandListener( ip )
	local subj = ip:getToken();
	if subj == "TRIGVOL" then
		local name = ip:getToken();
		if IsKeyExist( TriggerVolData , name ) then
			local t = ip:getToken();
			if t == "true" then
				t=true;
			else
				t=false;
			end
			TriggerVolData[ name ]["active"] = t;
		end	
	end
end

function VISIBLE_CommandListener( ip )
	local name = ip:getToken();
--	local node = GetSceneManager():get( name );
--	if node then
		local t = ip:getToken();
		if t == "true" then
Native.Methods.OutputDebugStr( name.." true" );
			Native.Methods.SetVisible( name , true );
--			node:setVisible( true );
		else
Native.Methods.OutputDebugStr( name.." false" );
			Native.Methods.SetVisible( name , false);
--			node:setVisible( false );		
		end
--	end
end

gScrId = 0;
function PLAY_CommandListener( ip )
	local token = ip:getToken();
	if token == "BGM" then
		local bgm = ip:getToken();
		Native.Methods.PlayBgm( bgm );
	elseif  token == "SE" then
	
	elseif  token == "ANIMATION" then
		local charaName = ip:getToken();
		local anim = ip:getToken();
		local chara = Character.get( charaName );
		if chara then
		
		end
	elseif token == "SCRIPT" then
		local scrName = ip:getToken();
		if IsKeyExist( EventScriptData , scrName ) then
			
--			CommandQueue.create( scrName..gScrId, EventScriptData[ scrName ] );
			CommandQueue.create( scrName, EventScriptData[ scrName ] );
			gScrId = gScrId + 1;
		end
	end

end

gCamPosBuff=nil;
gCamLookAtBuff=nil;
function BUF_CAMPOS_CommandListener( ip )
	local id = ip:getInt();
	if not ( gCamPosBuff == nil ) then
		Camera.setPosId( gCamPosBuff , id )
		Camera.setLookAtId( gCamLookAtBuff , id );
		gCamPosBuff = nil;
		gCamLookAtBuff = nil;
	else
		gCamPosBuff = Camera.positionId( id );
		gCamLookAtBuff = Camera.lookAtPosId( id );
	end
end

function DoutListener( data )
	Dout( data );
end

--///////////////////////////////////////////////////////////////////////////////////
--EventListener : Start Loading a Model 
-- data = "ModelName";
function StartLoadingModelListener( data )
	local gm = GetModelLoader();
--	if Framework():isUseArchive() then
	gm:load( data["file"] );
--	end
	if data.frame then
		gm:requestLoad( data["mesh"] , data["frame"] );
	else
		gm:requestLoadMesh( data["mesh"] );
	end
	Native.Methods.OutputDebugStr( data["file"] );
end
--Mesh[ data ] , RootFrames[ data ]
--///////////////////////////////////////////////////////////////////////////////////
--EventListener : Loading Subtitle
--data="Pass";
function LoadSubtitleListener( data )
	local sub = GameLib.GetSubtitler();
	sub:loadFile( data );	
end

--///////////////////////////////////////////////////////////////////////////////////
--EventListener : Attach a Process to Native Defined Process Manager
--data={
--	name=string,
--	state=state_object,
--	data=data
--}
function PreProcessAttachListener( data )
	local p=GameLib.AttachProcess( data["name"] , data["state"] , data["data"] );
	AttachNextProcess( p , data );
end

function AttachNextProcess( parentProcess , data )
	if IsKeyExist( data , "next" ) then
		local t = data["next"];
		local nextProcess = GameLib.CreateProcess( t["name"] , t["state"] , t["data"] );
		parentProcess:setNext( nextProcess );
		AttachNextProcess( nextProcess , t );
	end	
end

--///////////////////////////////////////////////////////////////////////////////////
--EventListener : Parse a File. For example, Animation File , ... AnimationSet Token is Hit , and Loading is Start.
--data="Pass";
function ParseFileListener( data )
	if data["arch"] then
		GetParser():parseRes( data["file"] );
	else
		GetParser():parse( data["file"] );
	end
--]]
--	GetParser():parse( data );
--	end	
Native.Methods.OutputDebugStr( data["file"] );
--	GameLib.ParseFromFile( data );
end

--function CreateSceneStateListener( data )	
--	GameLib.SceneStateManager():create( data["name"] , data["states"] );
--end

function CreateMeshListener( t )
	local pos = Vec3(  t["Pos"][1] , t["Pos"][2] , t["Pos"][3] );
	local angle = Vec3( t["Angle"][1] , t["Angle"][2] , t["Angle"][3] );
	local scale = Vec3( t["Scale"][1] , t["Scale"][2] , t["Scale"][3] );
	GameLib.CreateMesh( t["name"] , t["File"] , pos , angle , scale , SceneNode.TYPE_STATIC_OPAQUE );
end

function CreateBillboardListener( t )
	Native.Billboard.create( t );
end

function CreateImageListener( t )
--	OffsetGUI( t );
	local img = GameLib.CreateImage(
		t["name"],
		t["pos"][1],
		t["pos"][2],
		t["width"],
		t["height"],
		t["tex"],
		t["blend"]
	);
--]]
	if t.alpha then
		img:setAlpha( t["alpha"] );
	end
	if t.effect then
		GameLib.AttachFlipUVProcess( t.name , t.effect[1] , t.effect[2] );	
--		GameLib.AttachFlipUVProcess( "image_exp" , "ExplodeEffect1" , ParaparaAnimation["ExplodeEffect1"] );
	end
	if t.uv then
		local s = t.uv;
		img:setUV( s[1] , s[2] , s[3] , s[4] );
	end
Native.Methods.OutputDebugStr( t["name"] );
end

function CreateAgentListener( data )
	GameLib.CreateAgent( data["name"] , data["param"] );
end

function AttachNodeListener( data )
	local node = GetSceneManager():get( data["name"] )
	if node then
		local s = GameLib.CurrentSceneState();
		if s then
			s:attach( data["name"] )
		end
		if data.visible then
--		if IsKeyExist( data , "visible" ) then
			node:setVisible( data["visible"] );
		end
		if data.rgb then
			node:setColor( rgb[1],rgb[2],rgb[3] );
		end
		if data.alpha then
			node:setAlpha( data.alpha );
		end
Native.Methods.OutputDebugStr( data["name"] );	
--		GetSceneManager():getFSM():currentState():attach( data["name"] )
	end
	
end	

--///////////////////////////////////////////////////////////////////////////////////
--Start Billboarding Animation
--data={
--	position=Vec3(),
--	lifetime=number,
--	width=number,
--	height=number,
--	animationname=string,
--}
function BillEffectListener(data)
	GetBillboardSet():createEffect(
		data["position"] ,
		data["lifetime"] ,
		data["width"] ,
		data["height"] ,
		data["animationname"]
	);
--]]
end

gQueuedEvent={}
function EnemyDeadListener( data )
	
end

function WallCollisionListener(data)
	local agent = data["agent"];
	--移動前のposition
	local PosA = agent:position();
	local MoveA = agent:move();
	--Aの移動量からx成Eだけ引いてぶつかるかテスチE
	local ray = agent:moveRay();
	PosA.x = PosA.x - MoveA.x;
	ray.Dir.x = ray.Dir.x - MoveA.x;
	ray:calcEnd();
	local inter = Vec3();
	if IsIntersectWall( agent , inter ) then
		--x成Eの移動量をEに戻して
		PosA.x = PosA.x + MoveA.x;
		ray.Dir.x = ray.Dir.x + MoveA.x;
		--z成Eで同様Eことを試衁E
		PosA.z = PosA.z - MoveA.z;
		ray.Dir.z = ray.Dir.z - MoveA.z;
		ray:calcEnd();
		if IsIntersectWall( agent , inter ) then
			PosA.x = PosA.x - MoveA.x;
			ray.Dir.x = ray.Dir.x - MoveA.x;
			ray:calcEnd();
		end
	end
	agent:setPosition( PosA );
end

function MsgBoxClickedListener( data )
	GetEventManager():triggerEvent( "PlaySound", "Click" );
	msg = data["message"];
	CurrentModeUpdate = data["functionList"][ msg ];
end


--WaitProcessSampleData={
--	time=2,
--	after=Process.KILLED
--}

WaitProcess_State={}
WaitProcess_State["Initialize"]=function( process , data )
	data["start"]=os.clock();
	process:changeMode( Process.ACTIVATED );
end
WaitProcess_State["Update"]=function( process , data )
	rest = data["time"] - os.difftime( os.clock() , data["start"] );
	Dout("Waiting.. Rest is : " .. rest );
--	Dout( "Time Elapsed : ".. os.difftime( os.clock() , data["Start"] ) );
	if os.difftime( os.clock() , data["start"] ) > data["time"] then
		process:changeMode( data["after"] );
	end		
--]]
end

-- Screen Effect : FadeOut

alphaFadeOut=0;
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--Enemy Appearance Process State

EnemyData={
	name="Zako1",
	
}

function EnemyAppearListener( data )
	
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--Go To Next Level Process : Wait a few minutes and Fade Out and Go Next

GoToNextLevelProcess_State={}
GoToNextLevelProcess_State["Initialize"]=function( process , data )
	local waitdata={
		Start=0,
		WaitTime=data["WaitTime"],
	}
	gEnemyNum = 1;
	wait=GetProcessManager():attachScripted( WaitProcess_State , waitdata );
	wait:setNextScripted(  FadeOutProcess_State , FadeOutParam );
	process:changeMode( Process.ACTIVATED );
end
GoToNextLevelProcess_State["Update"]=function( process , data )
	
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

ProcessMap={
	GoToNextLevel=GoToNextLevelProcess_State,
}
function CreateWaitData( processName , t )
	local o={
		name=processName,
		state=WaitProcess_State,
		data={
			time=t
		}
	}
	gCreatedProcessData[ processName ] = o;
	return o;
end

function CreateFadeInData( processName , imgname , alp , sp , th )
	local o={
		name=processName,
		state=FadeInProcess_State,
		data={
			name=imgname,
			alpha=alp,
			speed=sp,
			threshold=th,
		}
	}
	return o;
end

function CopyProcessData( data )
	local d={}
	for k,v in pairs( data["data"] ) do
		d[ k ] = v;
	end
	local t ={
		name=data["name"],
		state=data["state"],
		data=d
	}
	if IsKeyExist( data , "next" ) then
		t["next"] = CopyProcessData( data["next"] );
	end
	return t;
end

ExeFuncsProcess_State={}
ExeFuncsProcess_State["Update"]=function(process,funcs)
	for i=1,#funcs,1 do
		funcs[i]();
	end
end
EventTriggerProcess_State={}
EventTriggerProcess_State.Initialize=function(process,data)
	if data["activate"]() then
		process:changeMode( Process.ACTIVATED );
	end
end
EventTriggerProcess_State.Update=function(process,data)
	if data["trigger"]() then
		--EventĂΎs
		if data.event then
			data["event"]();
		--ȂʓIȃgK[Cxgςɑ
		else
			TriggerEvent( data.name.."_Triggered" , data );
		end
		process:changeMode( data["changeAfter"] );
	end
	if not data["activate"]() then
		process:changeMode( Process.INITIALIZING );
	end
end

function ActivateGUI( UI_array , t )
	for i=1,#UI_array,1 do
		for k=1,#UI_array[i],1 do
			UI_array[i][k].active = t;
		end
	end
end

function UnFocusButtonArray( buttonlist , data )
	for i=1,#buttonlist,1 do
		for k=1,#buttonlist[i],1 do
			buttonlist[i][k].onFocus = false;
			if buttonlist[i][k]["onMouse"] then
				nX ,nY =  k,i;
				data.onFocusX ,data.onFocusY = k,i;
			end
		end
	end
end
       
CursorMoveProcess_State={}
CursorMoveProcess_State.instance = nil;
CursorMoveProcess_State.Initialize=function( process ,data )
--	if Native.Methods.CurrentSceneName() == data["sceneName"] then
	ActivateGUI( data["array"] , true );
	data.onFocusX = 1;
	data.onFocusY = 1;
	process:changeMode( Process.ACTIVATED );
--	end
end
CursorMoveProcess_State.Update=function( process , data )
--	if not ( Native.Methods.CurrentSceneName() == data["sceneName"] ) then
--		process:changeMode( Process.INITIALIZING );
--	end
	local array = data["array"];
	local lenW = #array[ data["onFocusY"] ];
	data["onFocusX"] ,data["onFocusY"] = CursorMove( data["onFocusX"] , data["onFocusY"] , 1 , lenW , 1 , #array , TriggerDirection );
	local nX = data["onFocusX"];
	local nY = data["onFocusY"];
	UnFocusButtonArray( array , data );
	if #array[ nY ] < nX then
		nX = #array[ nY ];
	end
	if not GUI_Editor["isEdit"] then
		array[ nY ][ nX ].onFocus = true;
		if array[ nY ][ nX ].update then
			array[ nY ][ nX ].update();
		end
	end
end
CursorMoveProcess_State.changeGroup=function( data )
	if CursorMoveProcess_State["instance"] then
		local currdata = CursorMoveProcess_State.instance:data();
		local buttonlist = currdata["buttonList"];
		ActivateGUI( currdata["buttonList"] , false );
		UnFocusButtonArray( buttonlist , currdata );
		CursorMoveProcess_State.prevData = currdata;
		CursorMoveProcess_State.instance:changeMode( Process.INITIALIZING );
		CursorMoveProcess_State.instance:setData( data );
	end
end

CursorMoveProcess_State.addGUI=function( gui , x , y )
	if CursorMoveProcess_State["instance"] then
		local currdata = CursorMoveProcess_State.instance:data();
		local buttonlist = currdata["buttonList"];
		if y <= #buttonlist then
			if x < #buttonlist[ y ] then
				table.insert( buttonlist[ y ] , gui , x )
			end
		end
		ActivateGUI( currdata["buttonList"] , false );
		UnFocusButtonArray( buttonlist , currdata );
	end
end
CursorMoveProcess_State.pushBackGUI=function( gui , y )
	if CursorMoveProcess_State["instance"] then
		local currdata = CursorMoveProcess_State.instance:data();
		local buttonlist = currdata["buttonList"];
		if y <= #buttonlist then
			table.insert( buttonlist[ y ] , gui  )
		end
		ActivateGUI( currdata["buttonList"] , false );
		UnFocusButtonArray( buttonlist , currdata );
	end
end
CursorMoveProcess_State.backToPrevGroup=function()
	local prevData = CursorMoveProcess_State.prevData;
	CursorMoveProcess_State.changeGroup( prevData );
end

ShowLoadingImageProcess={}
ShowLoadingImageProcess.Initialize=function(p,d)
	if GetParser():isParsing() then
--		_("ATTACH SCENE loading");
--		_("ATTACH SCENE loadingStr");
		local t = GetSceneManager():get( "loading" );
		if t then
			t:setVisible( true );
		end
		t = GetSceneManager():get( "loadingStr" );
		if t then
			t:setVisible( true );
		end
		p:changeMode( Process.ACTIVATED ) ;
	end
end
ShowLoadingImageProcess.Update=function(p,d)
	if not GetParser():isParsing() then
		local t = GetSceneManager():get( "loading" );
		if t then
			t:setVisible( false );
		end
		t = GetSceneManager():get( "loadingStr" );
		if t then
			t:setVisible( false );
		end
		p:changeMode( Process.INITIALIZING ) ;
	end
end

gCursorPos=1;
MsgListProcess_State={}
MsgListProcess_State["Initialize"]=function(process,data)
	local dstX=data["MsgList"][1]["DstX"];
	local dstY=data["MsgList"][1]["DstY"];	
	for i=1,#data["MsgList"],1 do
		local t = data["MsgList"][i];
		local strL = t["Caption"]:size()*t["CharW"];	
		CapMsg( t );
		t["Img"]:setPosition( dstX , dstY + ( i -1 )*data["StrideH"] );
		t["Caption"]:setPosition( dstX - strL/2 , dstY + ( i -1 )*data["StrideH"] );
	end
	process:changeMode( Process.ACTIVATED );
end

gAl = 255;
MsgListProcess_State["Update"]=function(process,data)
	for i=1,#data["MsgList"],1 do
		local t = data["MsgList"][i];
		if IsKeyExist( t , "Img" ) then
			gAl = AbsCosWav( 255 , 1 );
			local color = ColorARGB( gAl , t["RGB"][1] , t["RGB"][2] , t["RGB"][3] );
			t["Img"]:setColor(
				color,
				color,
				color,
				color );	
			if gCursorPos == i then
			
			end
		end
	end
end
MsgListProcess_State["Killed"]=function(process,data)

end

Image={}
Image.create=function( data )
end

AlphaWaveProcess_State={}
AlphaWaveProcess_State.Initialize =function(process,data)
	local img = GetSceneManager():get( data["name"] );
	if img then
		data["time"] = os.clock();
		data["img"] = img;
		process:changeMode( Process.ACTIVATED );
	end
end
AlphaWaveProcess_State.Update=function(process,data)
	local img = data["img"];
Dout( "Alpha Wave "..data.name );
	local a = AbsCosWav( 255 , data["speed"] );
--	local a = math.abs( 255 * math.cos( data["speed"] * os.difftime( os.clock() , data["time"] ) ) );
	if data.blink then
		Blinking( img , data["threshold"] , data["speed"] , data["max"] , data["min"] );
	else
		if img then
			img:setAlpha( a );
		end
	end
end

FadeInProcess_State={}
--[[
FadeInProcess_State.Initialize=function( process , data ) 
	_("ATTACH SCENE "..data.name );
	process:changeMode( Process.ACTIVATED );
end
--]]
FadeInProcess_State["Update"]=function( process , data ) 
Dout("Fade IN : ".. data["name"] );	
	local img = GetSceneManager():get( data["name"] )
	if not img then
		return;
	end
	local w = 0xffffff;
--	img:setColor( w,w,w,w );
	data["alpha"] = data["alpha"] + data["speed"];
	local a = data["alpha"];
	img:setAlpha( a );
	if a > data["threshold"] then
		data["alpha"] = data["threshold"];
		a = data["alpha"];
		img:setAlpha( a );
		process:changeMode( Process.KILLED );
	end
end

FadeOutProcess_State={}
FadeOutProcess_State["Update"]=function( process , data ) 
Dout("Fade OUT");	
	local img = GetSceneManager():get( data["name"] )
	if not img then
		return;
	end
	local w = 0xffffff;
--	img:setColor( w,w,w,w );
	data["alpha"] = data["alpha"] - data["speed"];
	local a = data["alpha"];
	img:setAlpha( a );
	if a < data["threshold"] then
		data["alpha"] = data["threshold"] ;
		a = data["alpha"];
		img:setAlpha( a );
		local dat={
			name=process:name(),
			mode=process:mode()
		}
--		GetEventManager():triggerEvent( "ProcessModeChanged" , dat );
		process:changeMode( Process.KILLED );
	end
end

SizeUpProcess_State={}
SizeUpProcess_State.Initialize=function(process,data)
	local img = GetSceneManager():get( data["name"] );	
	img:setWidthHeight( data["size1"][1] , data["size1"][2] );		
	process:changeMode( Process.ACTIVATED );
end
SizeUpProcess_State.Update=function(process,data)
	local img = GetSceneManager():get( data["name"] );
	if img then
		local s1 = data["size1"];
		local s2 = data["size2"];
		local curpos = Vec2( s2[1],s2[2] ) * data["coef"] + 
						Vec2(  s1[1],s1[2] ) * ( 1 - data["coef"] );
		local t = Framework():oneFrameTime();
		data["coef"] = data["coef"] +   t /data["time"];
		if data["coef"] >= 1 then
			process:changeMode( Process.KILLED );
			return;
		end
		img:setWidthHeight( curpos.x , curpos.y );		
	end
end

MoveImgProcess_State={}
MoveImgProcess_State.Initialize=function(process,data)
	local img = GetSceneManager():get( data["name"] );	
	img:setPosition( data["pos"][1], data["pos"][2] );		
	process:changeMode( Process.ACTIVATED );
end
MoveImgProcess_State.Update=function(process,data)
	local img = GetSceneManager():get( data["name"] );
	if img then
		local ratioW,ratioH = GetOffset();
Dout( "RatioW,h:"..ratioW.." "..ratioH );		
		local p1=data["pos"];
		local p2=data["dst"];
		local curpos = Vec2( p2[1],p2[2] ) * data["coef"] + 
						Vec2(  p1[1],p1[2] ) * ( 1 - data["coef"] );
		local t = Framework():oneFrameTime();
		data["coef"] = data["coef"] +   t /data["time"];
		if data["coef"] >= 1 then
			process:changeMode( Process.KILLED );
			return;
		end
		img:setPosition( curpos.x, curpos.y );
	end
end


JagMoverProcess={}
JagMoverProcess.Initialize=function( p , d )
	d["timeElapsed"] = 0;
	local mover = GetSceneManager():get( d["name"] );
	if not mover then
		p:changeMode( Process.WAITING );
		return;
	end
--	d["pos"] = mover:position();
	p:changeMode( Process.ACTIVATED );
	--]]
end
JagMoverProcess.Update=function( p , d )
	local mover = GetSceneManager():get( d["name"] );
	if not mover then
		p:changeMode( Process.WAITING );	
	end
	if d.time then	
		d["timeElapsed"] = d["timeElapsed"] + Framework():oneFrameTime();
		if d["time"] < d["timeElapsed"] then
			if d.pos then
				mover:setPosition( d["pos"] );
			end
			p:changeMode( Process.WAITING );
		else
			local jx =  d["jagX"];
			local jy =  d["jagY"];
			local jz =  d["jagZ"];
			local v1 = JaggyMove(  jx[1] , jy[1] , jz[1] , jx[2] , jy[2] , jz[2] );
			mover:addPos( v1 );
		end		
	end
--]]
end


EditCameraProcess_State={}
EditCameraProcess_State.isEdit = false;
gRecSpeed = 1;
EditCameraProcess_State["Update"]=function( process,data)

	if EditCameraProcess_State["isEdit"] then
Dout( "Edit Camera: R : RESET DATA");
Dout( "Edit Camera: S : REC START & PAUSE");
Dout( "Edit Camera: J : SERIALIZE DATA");

		local ce = GetCameraEditor();
		ce:update();
		if IsKeyTriggered("r") then
			ce:reset();
		end
		if IsKeyTriggered("s") then
			ce:rec();
		end
		if IsKeyTriggered("j") then
			ce:serialize( "Lua/EditCameraData.lua" );
		end

		if IsKeyTriggered("l") then	
			gRecSpeed = gRecSpeed + 0.1;
		elseif IsKeyTriggered("k") then	
			gRecSpeed = gRecSpeed - 0.1;
		end
		ce:setRecSpeed( gRecSpeed );
		CameraMove();
		CameraRotate();	
	end
end

CombCameraProcess_State={}
CombCameraProcess_State["Update"]=function( process,data)
	local camera1 = GetSceneManager():camera( CAMMODE_CloseUp );
	local camera2 = GetSceneManager():camera( CAMMODE_Parallel );
	local camera3 = GetSceneManager():camera( CAMMODE_Comb );
	
	local pos = ( camera1:position() + camera2:position() )/2;
	local look = ( camera1:lookAt() + camera2:lookAt() ) /2;
	
	camera3:setPosition( pos );
	camera3:setLookatPt( look );
end

CameraChangeProcess_State={}
CameraChangeProcess_State["Initialize"]=function( process,data)
	GetSceneManager():setCameraId( 3 );
	local prevPos = GetSceneManager():camera( gPrevCameraId ):position();
	local prevLook = GetSceneManager():camera( gPrevCameraId ):lookAt();
	GetSceneManager():camera( 3 ):setPosition( prevPos );
	GetSceneManager():camera( 3 ):setLookatPt( prevLook );	
	process:changeMode( Process.ACTIVATED );
end
CameraChangeProcess_State["Update"]=function( process,data)
	local prevPos = GetSceneManager():camera( gPrevCameraId ):position();
	local prevLook = GetSceneManager():camera( gPrevCameraId ):lookAt();
	local curPos = GetSceneManager():camera( gCurrentCameraId ):position();
	local curLook = GetSceneManager():camera( gCurrentCameraId ):lookAt();	
	local sub=Vec3();
	sub:setSub( curPos , prevPos);
	if sub:length() > 0 then
		sub:normalize();
		sub = sub*0.5;
		GetSceneManager():camera( 3 ):addPos( sub );		
		GetSceneManager():camera( 3 ):addLookat( sub );		
	else
		process:changeMode( Process.WAITING );
	end
--]]
end

EventMoveData={
	charaName="Player",
	dest=Vec3(0),
	appDistance=1,
	afterState="Wait_State",
}

EventMoveProcess_State={}
EventMoveProcess_State["Update"] = function( process , param )
	--AからBへの差ベクタ
	local dif = Vec3(1);
	local desired = 0;
	local agent = Character.get( param["charaName"] );
	local path = agent:pathPlanner();
	local heading = param["dest"];
	dif , desired = LookAtPos(  heading , agent:position() );	
	local dif2 = Vec2( dif.x , dif.z );
	if CheckVec2Zero( dif2 ) then
		return;
	end
	--プレイヤーとの距離遠ければ近寁E
	
	local th=0.5;
	local isApp = true;
	isApp = ( dif2:length() > param["appDistance"] );
	if isApp then
		dif2:normalize();
		InputDir( agent , th , dif2 );
	else
		agent:getFSM():changeState( param["afterState"] );
		process:changeMode( Process.KILLED );
	end
		
end

MoveProcess={}
MoveProcess.Update=function( process , data )
	local m = GetSceneManager():get( data["name"] );
	if m then
		local p1=data["pos1"];
		local p2=data["pos2"];
		local curpos = p2 * data["coef"] + p1 * ( 1 - data["coef"] );
		local t = Framework():oneFrameTime();
		local done = false;
		if data.dir == 1 then
			data["coef"] = data["coef"] +   t /data["time"];
			done = ( data["coef"] >= 1 );
		else
			data["coef"] = data["coef"] -   t /data["time"];
			done = ( data["coef"] <= 0 );
		end
		if done then
			if data.dir == 1 then
				TriggerEvent( data.name.."_Moved", data["name"] );
			end
			process:changeMode( Process.WAITING );
			return;
		end
		m:setPosition( curpos );
	end
--]]	
end

SlerpProcess={}
SlerpProcess.Update=function( process , data )
	local m = GetSceneManager():get( data["name"] );
	if m then
		local qua =  Quaternion();
		local qua1 = Quaternion();
		local qua2 = Quaternion();
		local axa1 = data["axisAngle1"];
		local axa2 = data["axisAngle2"];
		local ax1 = Vec3( axa1[1] , axa1[2] , axa1[3]  );
		local ax2 = Vec3( axa2[1] , axa2[2] , axa2[3]  );
		qua1:setAxisAngle( ax1 , math.rad( axa1[4] ) );
		qua2:setAxisAngle( ax2 , math.rad( axa2[4] ) );
		qua1:normalize();
		qua2:normalize();
		qua:slerp( qua1 , qua2 , data["coef"] );
		local t = Framework():oneFrameTime();
		local done = false;
		if data.dir == 1 then
			data["coef"] = data["coef"] +   t /data["time"];
			done = ( data["coef"] >= 1 );
		else
			data["coef"] = data["coef"] -   t /data["time"];
			done = ( data["coef"] <= 0 );
		end
		if done then
			if data.dir == 1 then
				TriggerEvent( data.name.."_Slerped", data["name"] );
			end
			process:changeMode( Process.WAITING );
			return;
		end
		local axis = Vec3();
		local radian ;
		qua:getAxisAngle( axis , radian );
		local dg = math.deg( radian );
--[[		
		local mat = Mat4x4();
		qua:getMatrix( mat );
		local angle = Vec3();
		angle = mat:transform( angle );
		angle.x = math.deg( angle.x );
		angle.y = math.deg( angle.y );
		angle.z = math.deg( angle.z );
--		local angle = Vec3();
--		angle.y = dg;
		m:setAngle( angle );
--]]
	end
end

--hAJ߃vZX
OpenCloseDoorProcess={}
OpenCloseDoorProcess.Initialize=function( proc ,data )
--	data.addedTick=0;
--	data.state = "open";
	local door = GetSceneManager():get( data["name"] );
	if door then
		local t = data["initAngle"];
		door:setAngle( Vec3( t[1] , t[2] , t[3] ) );
		door:update();
		proc:changeMode( Process.ACTIVATED );
	end	
	
end
OpenCloseDoorProcess.Update=function( proc ,data )
	local door = GetSceneManager():get( data["name"] );
	if door then
		door:update();
		local tick = 0;
		local th = data["threshold"];
		if data["state"] == "open" then
			tick = data["angleTickOpen"] ;
		elseif data["state"] == "close" then
			tick = data["angleTickClose"] ;
		elseif data["state"] == "wait" then
			return;
		end
		data["addedTick"] = data["addedTick"] + tick;
		data["currTick"] = data["currTick"] + tick;
		local isAdd = false;
		--Ăl臒l𒴂ԕω
		if th < math.abs( data["addedTick"] ) then
			data["addedTick"] = 0;
			if data["state"] == "open" then
				TriggerEvent( data["name"].."Opened" , data );
				data["state"] = "close";
			elseif	data["state"] == "close" then
				if data.closeSound then
					Native.Methods.PlaySe( data["closeSound"] );
				end
				TriggerEvent( data["name"].."Closed" , data );
				data["state"] = "wait";
				proc:changeMode( Process.WAITING );
			end
		else
			isAdd = true;
		end		
--		if isAdd then
			door:setAngle( Vec3( 0,data["currTick"],0 ) );			
--		end
		
	end	
end

CamTgtChangeProcess={}
CamTgtChangeProcess.Update=function( proc , dat )
	local rol = dat["role"];
	local objName = dat["obj"];
	local subj1 = Character.get( rol );
	local subj2 = GetSceneManager():get( objName );
	if dat["lock"] then
		return;
	end
	if subj1 and subj2 then
		local dif = Vec3();
		dif:setSub( subj1:position() , subj2:position() );
		--x̍̒臒l艺΋߂ÂCxgM
		if math.abs( dif.x ) < dat["threshold"] then
			local obj = GetSceneManager():get( objName );
			local p = obj:position();
--			local mX = p.x + dat["movableX"][1];
--			local pX = p.x + dat["movableX"][2];
			local mX = p.x + gMovableXData[ objName ][1];
			local pX = p.x + gMovableXData[ objName ][2];
			_("LOCK_MOVE true "..mX.." "..pX );
			--1f[^𑗐M烍bNB
			dat["lock"] = true;
			_("CHANGE CAMTARGET "..objName );
--			TriggerEvent( rol.."_"..objName.."Closed" , dat );
		end
	end
end


CameraFight2DProcess_State={}
CameraFight2DProcess_State.target1 = "Player";
CameraFight2DProcess_State.target2 = "Zako1";
CameraFight2DProcess_State.Initialize=function(process,data)
--	local child = GameLib.AttachProcess( "CloseUpImpl" , CameraCloseUpProcess_State , gCloseUpData );
	--waiting while this fight2D camera process is 
--	child:changeMode( Process.WAITING );
--	process:setChild( child );	
	process:changeMode( Process.ACTIVATED );
end
CameraFight2DProcess_State.Update=function(process,data)
	local SM = GetSceneManager();
	local t1 = CameraFight2DProcess_State.target1;
	local t2 = CameraFight2DProcess_State.target2;
	local s1 = Character.get( t1 )--SM:get( "Player" );
	local s2 =  Character.get( t2 )--SM:get( "Zako1" );

	local camera = SM:camera( data["cameraId"] );
	if s1 then
		if s2 then
--			local camToTarget2 = Vec3();
--			camToTarget2:setSub( s2:position() , camera:position()  );
			--the Middle Point between Chara1 and Chara2
--			camToTarget2 = camToTarget2 * 0.1;
			local m = ( s1:position() + s2:position() ) /2;
--			local m = ( s1:position() + camToTarget2 ) /2;
			m.y = m.y + 1;
			camera:setLookatPt( m  );
	--		m.y = 3;
			local dif = Vec3(0);
			dif:setSub( s1:position() , s2:position() );
			local dist = 1;
			local t = dif:length()*1.5;
			if  t < 7 then
				dist = 7;
			--if the distance is over 15 , then seek other agent and close up to the middle point
			--between player and the closer
--			elseif dif:length()*2 > 15 then
--				local p = process:child("CloseUpImpl");
--				p:changeMode( Process.INITIALIZING );
			
--				dist = 15;
--[[			elseif t > 15 then
				local dat={
					SubjectName="Player",
					ProcessKilledDistance=9,
					ApproachSpeed = 0.1,
					LookAtOffset=Vec3(0,1,0),
					EyeOffset=Vec3(0,4,0),
					cameraId=CAMMODE_Fight2D
				}
				CameraCloseUpProcess_State.Update( process , dat );
--]]
			else
				dist = dif:length()*1.5;
			end
			local n = Vec3( -dif.z , 3 , dif.x );
			n.x = n.x*3
			n.z = n.z*3;
			local pos = m +Vec3( 0,4, -dist );--Vec3( -dif.z*2, 3 , dif.x*2 )--
	--		pos.y = s1:position().y + 1;
			camera:setPosition( pos );
	--		m.y = m.y + 1;
		end
	end
	
end
--]]

CameraCloseUpProcess_State={}
CameraCloseUpProcess_State["Update"]=function( process,data)
	local camera = GetSceneManager():camera( data["cameraId"] );
	local t = nil;
	if data.SubjectName then
--		t = Character.get( data["SubjectName"] );
		t = GetSceneManager():get( data["SubjectName"] );
	end
	if not t then
		return;
	end
	local pos=Vec3();
	if data.SubjectName then
		pos= t:position();
		pos.y = pos.y;
	elseif data.dst then
		pos = data.dst;
	end
	 pos = pos + data["LookAtOffset"];
	camera:setLookatPt( pos );
	local sub = Vec3();
	sub:setSub( pos , camera:position() );
	sub = sub + data["EyeOffset"];
--	Dout("Subject to Camera Distance : "..sub:length() );
	local slen = sub:length();
	local minLen = 6;
	if ( minLen < slen ) and ( slen < data["ProcessKilledDistance"] ) then
--		process:changeMode( Process.KILLED );
		return;
	elseif ( slen < minLen ) then
		sub:normalize();
		sub = sub*(-data["ApproachSpeed"] );
		if sub.y < 0 then
			sub.y = - sub.y;
		end
		camera:addPos( sub );		
	else
		sub:normalize();
		sub = sub*(data["ApproachSpeed"] );
		camera:addPos( sub );		
--[[		local lenX = math.abs( sub.x * sub.x );
		local lenY = math.abs( sub.y * sub.y );
		local lenZ = math.abs( sub.z * sub.z );
		local pow = Vec3( lenX , lenY , lenZ );
		sub = pow * data["ApproachSpeed"] * -0.01;
		camera:addPos( sub );
--]]
	end
--[[	local campos = camera:position();
	local lookpos = camera:lookAt();	
	if data.minY then
		if campos.y < data["minY"] then
			campos.y = data["minY"];
		end
		if lookpos.y < data["minY"] then
			lookpos.y = data["minY"];
		end
	end
	camera:setPosition( campos );
	camera:setLookatPt( lookpos );	
--]]
end

CameraCloseUpProcess_State2={}
CameraCloseUpProcess_State2["Update"]=function( process,data)
	local camera = GetSceneManager():camera( data["cameraId"] );
	local t = nil;
	if data.SubjectName then
--		t = Character.get( data["SubjectName"] );
		t = GetSceneManager():get( data["SubjectName"] );
	end
	if not t then
		return;
	end
	local pos=Vec3();
	if data.SubjectName then
		pos= t:position();
		pos.y = pos.y;
	elseif data.dst then
		pos = data.dst;
	end
	local campos = camera:position();
	local camlookpos = camera:lookAt();
	pos = pos + data["LookAtOffset"];
--	camera:setLookatPt( pos );
	local sub = Vec3();
	sub:setSub( pos , camlookpos );
	
	sub = sub + data["EyeOffset"];
--	Dout("Subject to Camera Distance : "..sub:length() );
	local slen = sub:length();
	local minLen = 6;
	if ( minLen < slen ) and ( slen < data["ProcessKilledDistance"] ) then
--		process:changeMode( Process.KILLED );
		return;
	elseif ( slen < minLen ) then
		sub:normalize();
		sub = sub*(-data["ApproachSpeed"] );
		if sub.y < 0 then
			sub.y = - sub.y;
		end
		camera:addPos( sub );		
	else
		sub:normalize();
		sub = sub*(data["ApproachSpeed"] );
		camera:addPos( sub );		
--[[		local lenX = math.abs( sub.x * sub.x );
		local lenY = math.abs( sub.y * sub.y );
		local lenZ = math.abs( sub.z * sub.z );
		local pow = Vec3( lenX , lenY , lenZ );
		sub = pow * data["ApproachSpeed"] * -0.01;
		camera:addPos( sub );
--]]
	end
--[[	local campos = camera:position();
	local lookpos = camera:lookAt();	
	if data.minY then
		if campos.y < data["minY"] then
			campos.y = data["minY"];
		end
		if lookpos.y < data["minY"] then
			lookpos.y = data["minY"];
		end
	end
	camera:setPosition( campos );
	camera:setLookatPt( lookpos );	
--]]
end

RailCameraProcess_State={}
RailCameraProcess_State["Initialize"]=function( process,data)
	local t = GetSceneManager():get( data["SubjectName"] );
	local camera = GetSceneManager():camera( data["cameraId"] );
	if t then
		data["Subject"] = t;
		local pos = t:position();
		camera:setLookatPt( pos );
		local ofs = Vec3( data["InitialPos"][1] , data["InitialPos"][2] , data["InitialPos"][3] );
		local pos = pos + ofs;
		camera:setPosition( pos );
		process:changeMode( Process.ACTIVATED );	
	end
end
RailCameraProcess_State["Update"]=function( process,data)
	Dout("Rail Camera Process ..");
	local camera = GetSceneManager():camera( data["cameraId"] );
	local sub = data["Subject"];
	local current = sub:getFSM():currentStateName();
	if ( current == "Walk_State" )
			or
	( current == "Run_State" )
			or
	( current == "JumpUp_State" ) 
			or
	( current == "Fall_State" )
			or
	( current == "Ladder_State" )	then	
--[[		local subpos = sub:position();
		local diff = Vec3();
		diff:setSub( subpos , camera:position() );
		local difflen = diff:length();
		Dout(  "Diff Length".. difflen );
		if difflen > data["MaxDist"] and difflen < 12 then
			local move = sub:move();
			camera:addLookat( Vec3( move.x,0,0) );
			camera:addPos( Vec3( move.x,0,0) );
	--		process:changeMode( Process.KILLED );
		end
--]]
		local subpos = sub:position();
		local campos = camera:position();
		local len = math.abs( campos.x - subpos.x ) ;
		if len < data["MaxDistance"] and len > data["MinDistance"] then
			local move = sub:move();
			camera:addLookat( move );--Vec3( move.x,move.y,0) );
			camera:addPos( move );--Vec3( move.x,move.y,0) );
	--		process:changeMode( Process.KILLED );
		end		
	end
--]]
end
--[[
ParallelCameraProcess_State={}
ParallelCameraProcess_State["Initialize"]=function( process,data)
--	local t = Character.get( data["SubjectName"] );
	local t = GetSceneManager():get( data["SubjectName"] );
	local camera = GetSceneManager():camera( data["cameraId"] );
	if t then
--		data["Subject"] = t;
		local pos = t:position();
		local ofs = data["offset"];
		local look = pos + Vec3( ofs[1] , ofs[2] , ofs[3] );
		camera:setLookatPt( look );
		local ofs = Vec3( data["InitialPos"][1] , data["InitialPos"][2] , data["InitialPos"][3] );
		local pos = pos + ofs;
		camera:setPosition( pos );
		process:changeMode( Process.ACTIVATED );	
	end
end
ParallelCameraProcess_State["Update"]=function( process,data)
	local sub = GetSceneManager():get( data["SubjectName"] );
	if not sub then
--		process:changeMode( Process.WAITING );
		return;
	end
	local camera = GetSceneManager():camera( data["cameraId"] );
	local subpos = sub:position();
	local campos = camera:position();
	local lookpos = camera:lookAt();
	local diff = subpos - campos;
	local v = Vec3(0);
	local lenX = math.abs( diff.x*diff.x );
	local lenZ = math.abs( diff.z*diff.z );
	local spX = data["nearSpeedX"];
	local spZ = data["speedZ"];
	if diff.x > data["nearDist"] then
		spX = data["farSpeedX"];
	end

	if ( diff.x < - data["threashold"][1] ) then
		v.x = - lenX * spX---0.1+0.8*difMove.x;
	elseif ( diff.x > data["threashold"][1] ) then
		v.x = lenX * spX---0.1+0.8*difMove.x;
	end		
	local zOffs = math.abs( data["InitialPos"][3] );
	if ( diff.z < - data["threashold"][2] + zOffs ) then
		v.z = -spZ---lenZ * 0.012--+0.5*move.z;
	elseif ( diff.z > data["threashold"][2] + zOffs ) then
		v.z = spZ--lenZ * 0.012--+0.5*move.x;
	end
	--ꂷĂȒl̂h~
	if math.abs( v.x ) > 1 then
		if v.x > 0 then
			v.x = 1
		elseif v.x < 0 then
			v.x = -1;
		end
	end
	
--	campos.x = subpos.x + data["InitialPos"][1];
	campos.y = subpos.y + data["InitialPos"][2];
--	campos.z = subpos.z + data["InitialPos"][3];
	
	local ofs = data["offset"];
--	lookpos.x = subpos.x + ofs[1];
	lookpos.y = subpos.y + ofs[2];
--	lookpos.z = lookpos.z + ofs[3];
	if data.minY then
		if campos.y < data["minY"] then
			campos.y = data["minY"];
		end
		if lookpos.y < data["minY"] then
			lookpos.y = data["minY"];
		end
	end
	if data.maxY then
		if campos.y > data["maxY"] then
			campos.y = data["maxY"];
		end
		if lookpos.y > data["maxY"] then
			lookpos.y = data["maxY"];
		end
	end
	camera:setPosition( campos );
	camera:setLookatPt( lookpos );
	
	camera:addLookat( v );--Vec3( move.x,move.y,0) );
	camera:addPos( v );--Vec3( move.x,move.y,0) );	
end
--]]
ParallelCameraProcess_State={}
ParallelCameraProcess_State["Initialize"]=function( process,data)
--	local t = Character.get( data["SubjectName"] );
	local t = GetSceneManager():get( data["SubjectName"] );
	local camera = GetSceneManager():camera( data["cameraId"] );
	if t then
--		data["Subject"] = t;
		local pos = t:position();
		local ofs = data["offset"];
		local look = pos + Vec3( ofs[1] , ofs[2] , ofs[3] );
		camera:setLookatPt( look );
		local ofs = Vec3( data["InitialPos"][1] , data["InitialPos"][2] , data["InitialPos"][3] );
		local pos = pos + ofs;
		camera:setPosition( pos );
		process:changeMode( Process.ACTIVATED );	
	end
end
ParallelCameraProcess_State["Update"]=function( process,data)
	local sub = GetSceneManager():get( data["SubjectName"] );
	if not sub then
--		process:changeMode( Process.WAITING );
		return;
	end
	local camera = GetSceneManager():camera( data["cameraId"] );
	local subpos = sub:position();
	local campos = camera:position();
	local lookpos = camera:lookAt();
	local diff = subpos - campos;
ViewCoordTransform( diff );
	local v = Vec3(0);
	local lenX = math.abs( diff.x*diff.x );
	local lenZ = math.abs( diff.z*diff.z );
	local spX = data["nearSpeedX"];
	local spZ = data["speedZ"];
	if diff.x > data["nearDist"] then
		spX = data["farSpeedX"];
	end

	if ( diff.x < - data["threashold"][1] ) then
		v.x = - lenX * spX---0.1+0.8*difMove.x;
	elseif ( diff.x > data["threashold"][1] ) then
		v.x = lenX * spX---0.1+0.8*difMove.x;
	end		
	local zOffs = math.abs( data["InitialPos"][3] -2 ); --TODO : 1
	if ( diff.z < - data["threashold"][2] + zOffs ) then
		v.z = -spZ---lenZ * 0.012--+0.5*move.z;
	elseif ( diff.z > data["threashold"][2] + zOffs ) then
		v.z = spZ--lenZ * 0.012--+0.5*move.x;
	end
	--ꂷĂȒl̂h~
	local isFar = false;
	if math.abs( v.x ) > 1 then
		isFar = true;
		if v.x > 0 then
			v.x = 1
		elseif v.x < 0 then
			v.x = -1;
		end
	end
	
--	campos.x = subpos.x + data["InitialPos"][1];
	campos.y = subpos.y + data["InitialPos"][2];
--	campos.z = subpos.z + data["InitialPos"][3];
	
	local ofs = data["offset"];
--	lookpos.x = subpos.x + ofs[1];
	lookpos = subpos;
	lookpos.y = subpos.y + ofs[2] ; --TODO 2
--	lookpos.z = lookpos.z + ofs[3];
	if data.minY then
		if campos.y < data["minY"] then
			campos.y = data["minY"];
		end
		if lookpos.y < data["minY"] then
			lookpos.y = data["minY"];
		end
	end
	if data.maxY then
		if campos.y > data["maxY"] then
			campos.y = data["maxY"];
		end
		if lookpos.y > data["maxY"] then
			lookpos.y = data["maxY"];
		end
	end
	camera:setPosition( campos );
--	local lookdif = ( subpos - lookpos ) /10;
--	if isFar then
		camera:setLookatPt( lookpos ) --lookdif );-- lookpos );
--	else
--		camera:setLookatPt( lookpos ) --lookdif );--  );	
--	end
	camera:addLookat( v );--Vec3( move.x,move.y,0) );
	camera:addPos( v );--Vec3( move.x,move.y,0) );	
end

LerpCameraProcess_State={}
LerpCameraProcess_State["Update"]=function( process,data)
	local posA = Camera.positionId( data["IdA"] );
	local posB = Camera.positionId( data["IdB"] );
	local lookposA = Camera.lookAtPosId( data["IdA"] );
	local lookposB = Camera.lookAtPosId( data["IdB"] );
Dout( "ID A: "..data["IdA"] );
Dout( "ID B: "..data["IdB"] );
Dout( "Coef: "..data["coef"] );
	local t = data["coef"];
	if t < 0 then
		t = 0;
		data["coef"] = 0;
	elseif t > 1 then
		t = 1;
		data["coef"] = 1;
	end	
--	local combpos = posA * t + posB * ( 1 - t );
	local combpos = posA * t + posB * ( 1 - t );
--	local b = posA.y * t + posB.y * ( 1 - t );
--	local c = posA.z * t + posB.z * ( 1 - t );
--	local v = Vec3( a , b , c );
	local comblookpos = lookposA * t + lookposB * ( 1 - t );
	
Dout( "Combpos.x : "..combpos.x );	
	Camera.setPos( combpos );
--	Camera.setPosId( combpos , data["setId"] );
	Camera.setLookAt( comblookpos );
--	Camera.setPosId( v , data["setId"] );
--	Camera.setLookAtId( comblookpos , data["setId"] );
--]]
end

CamJagProcess_State={}
CamJagProcess_State.Initialize=function( p , d )
	d["timer"]:start(0);
	d["pos"] = Vec3();
	d["lookPos"] = Vec3();
	p:changeMode( Process.ACTIVATED );
end
CamJagProcess_State.Update=function( p , d )
	if d.time then
		if d["time"] < d["timer"]:milliSec( 0 ) then
			d["pos"] =d["pos"] * (-1) ;
			d["lookPos"] = d["lookPos"]  * (-1) ;
			Camera.addPos( d["pos"] );
			Camera.addLookAt( d["lookPos"] );
			p:changeMode( Process.WAITING );
		else
			local v1,v2 = JaggyMoveXY( 0.1 , 0.2 , 100 , 100 );
			Camera.addPos( v1 );
			Camera.addLookAt( v2 );
			d["pos"] = d["pos"] + v1;
			d["lookPos"] = d["lookPos"] + v2;
		end		
	end
end

--ۓIȃLN^[NXB
--ƃL̖OʂB
--Character.get( "Player" ) ƂƍvC[̃LgetłB

Character={}
Character.property={}
Character.collection={}
Character.nameMap={}
Character.rollMap={}
Character.create=function( data )
	--CreateCharacterImplQ[ƂɎ邱
	return CreateCharacterImpl( data );
end
Character.getProperty=function( name )
	if IsKeyExist( Character.property , name ) then
		return Character.property[ name ];
	else
		return nil;
	end
end
Character.getCharacterName=function( role )
	if IsKeyExist( Character.nameMap , role ) then
		return Character.nameMap[ role ];
	else
		return "";
	end
end
Character.setNameMap=function( roll , name )
	Character.nameMap[ roll ] = name;
	Character.rollMap[ name ] = roll;
end
Character.getRollType=function( charaName )
	if IsKeyExist( Character.rollMap , charaName ) then
		return Character.rollMap[ charaName ];
	else
		return nil;
	end	
end
Character.get=function( name )
	local ret = nil;
	local t = Character.getCharacterName( name );
	if IsKeyExist( Character.collection , t ) then
		ret = Character.collection[ t ]["instance"];
	end
	return ret;
end
Character.getData=function( name )
	local ret = nil;
--	local t = Character.getCharacterName( name );
	if IsKeyExist( Character.collection , name ) then
		ret = Character.collection[ name ]["data"];
	end
	return ret;
end
--Cancel the AI system , and set player character 
Character.setPlayer=function( name )
	local p = Character.get( name );
	if p then
		local ai = p:getProcessor():process("AI");
--		p:controller():setJoystickId( Native.CharaID.P1 );
--		if ai then
--			ai:changeMode( Process.WAITING );
--		end
	end
end
function DecorateAgent( agent, data )
	--DecorateAgentImplQ[ƂɎ邱
	DecorateAgentImpl( agent , data );
end

gGridData={
	Interval = 0.5,
	Length=10,
	Color1=0xffffffff,
	Color2=0xffffffff,
}
--Process Mode from Native C++
PROC_WAIT = Process.WAITING;
PROC_INIT = Process.INITIALIZING;
PROC_ACTIVATE = Process.ACTIVATED;

--Common Global Variables
MeshHair={}
RootFrames={}
Mesh={}
AnimationSet={}
AnimationNameList={}
AnimationParam ={}
FlipAnimationData={}
AttackHitProcessData={}
BasicCommandData={}
AttackCommandData={}
SpecialCommandData={}
AgentParam ={}
CollisionMol ={}
MaterialData={}
FuzzySet={}
CameraData={}
SceneParam={}
ViewProp={}
ParticleData={}
HitObjectData={}
CharaData={}
GameMissionParam={}
TriggerVolData={}
AI_FightInputParamMap={}
AI_StateData={}
AI_FightInputData={}
BehavScorePtMap={}
BehavCostMap={}
EventScriptData={}
--Listener Tables
GUI_EvtListener={}
SceneInit={}

--GUI Grobals
GroupBoxData={}
ButtonData={}
TextBoxData={}
PictureData={}
ProgressBarData={}
UpDownBarData={}

gSoundVol =0;
gCamId=0;
gCamNum=10;

gTextBoxTitleMenu=0;
gTB_Tech=0;
gIsDrag = false;

--Game Controller Buttons
Right=PSController.PS_RIGHT
Left=PSController.PS_LEFT
Up=PSController.PS_UP
Down=PSController.PS_DOWN
AnaRight=PSController.PS_ANALOG_RIGHT
AnaLeft=PSController.PS_ANALOG_LEFT
AnaUp=PSController.PS_ANALOG_UP
AnaDown=PSController.PS_ANALOG_DOWN
Dir=PSController.PS_DIR
A=PSController.PS_CIRCLE
B=PSController.PS_CROSS
J=PSController.PS_SQUARE
T=PSController.PS_TRIANGLE
None=PSController.PS_NONE
R1=PSController.PS_R1
L1=PSController.PS_L1



GUI_Common={}
GUI_Common.collection={}
GUI_Common.get=function( gui , key )
	if IsKeyExist( gui.collection , key ) then
		return gui.collection[ key ];	
	else
		return nil;
	end
end
--]]
function VisibleGUI( gui , t )
	if gui.BGImage then
		gui.BGImage:setVisible( t );
	end
	if gui.focusImage then
		gui.focusImage:setVisible( t );
	end

end

GUI_Common.activate=function( data )
	if data.activatedAllScene then
		if data["activatedAllScene"] then
			VisibleGUI( data , true );
			return true;
		else
			VisibleGUI( data , false );
			return false;
		end
	elseif IsCurrentSceneExist( data ) then
		VisibleGUI( data , true );
		return true;
	end	
	if data.view then
		if data.view == GetViewManager():currentViewName() then
			VisibleGUI( data , true );
			return true;			
		end		
	end
	VisibleGUI( data , false );	
	return false;	
end
AttachText=function( gui )
	if not ( gui.view and gui.text ) then
		return;
	end
	local view = GetViewManager():view( gui["view"] );
--		if view then
--	if gui.text then
		for i=1,#gui.text,1 do
			local text = gui.text[i];
			local textid = text["id"];
			local sub = GameLib.GetSubtitler();
			local t = sub:get( textid ) ;
			if t then	
				view:label(textid );
				t:setOriginalScale( text.scale[1] , text.scale[2] );
				t:setOriginalPos( text.pos[1] , text.pos[2] );
				t:setScale( text.scale[1] , text.scale[2] );
				t:setPosition( text.pos[1] , text.pos[2] );
				if gui.textColor then
					t:setColor( gui["textColor"] );			
				else
					t:setColor( 0xffffff );			
				end
			end
		end
--	end
--	end
end
AttachGUItoView=function( data )
	local attach=function( data , viewname)
		local view = GetViewManager():view( viewname );
		if view then
			view:attachNode( data.name ) --setChild( btn.BGImage );
			if data.focustex then
				view:attachNode( "focus"..data.name )  --setChild( btn.focusImage );
			end		
		end
	end
	if data.view then
		attach( data , data.view );
	elseif data.views then
		for i=1,#data.views, 1 do
			attach( data , data.views[i] );
		end
	else	
		local e = GetEventManager();
		e:triggerEvent( "AttachNode" , data );
		if data.focustex then
			e:triggerEvent( "AttachNode" , focusData );
		end
	end
end

GUI_Common.attachProcess=function( gui , gui_type )
	local processName = gui_type..gui["name"];
	if gui.view then
		local view = GetViewManager():view( gui.view );
		if view then
			view:attachProcess( processName , EventTriggerProcess_State , gui );
		end
	else
		GameLib.AttachProcess( processName , EventTriggerProcess_State , gui );	
	end
end

GUI_Button={}
GUI_Button.collection={}
GUI_Button.name="Button";
GUI_Button.mouseClick = true;
GUI_Button.mouseOnly = true;
GUI_Button.get=function(key)
	return GUI_Common.get( GUI_Button , key );
--	return GUI_Button.collector.get( key );
end
 GUI_Button.create=function( data )
	local btn=data;
--	local btn = GUI_Common.create( data );
	OffsetGUI( data );
	btn.focusAlpha = 0;
	btn.entered = false;
	btn.isFirst = true;
	btn.onFocus = false;
	btn.onMouse= false;
	btn.copiedData=CopyData( data );
	btn.active= false;
	btn.serialize=function( button )
		button.copiedData["width"] = button.BGImage:width();
		button.copiedData["height"] = button.BGImage:height();
		button.copiedData.pos[1] = button.BGImage:dstX();
		button.copiedData.pos[2] = button.BGImage:dstY();
		if button.text then
			for i=1,#button.text,1 do
				local sub = GameLib.GetSubtitler();
				local billstr = sub:get( button.text[i]["id"] ) ;
				if billstr then
					button.copiedData.text[i]["pos"][1] = billstr:dstX();
					button.copiedData.text[i]["pos"][2] = billstr:dstY();
					button.copiedData.text[i]["scale"][1] = billstr:scaleX();
					button.copiedData.text[i]["scale"][2] = billstr:scaleY();
				end
			end
		end
		local out=io.open("lua/gui/button/"..button.name..".lua" , "w");
		out:write("ButtonData[\""..button.name.."\"]=" );
		serialize( button["copiedData"] , out );
		out:close();
	end	
	btn.activate=function()
		return GUI_Common.activate( btn );
	end
	btn.changeFocusTex=function( name )
		if data.focustex then
			if data.focustex then
				btn.focusImage = GetSceneManager():get( "focus"..data.name );
				btn.focusImage:setTexture( name );
			end
		end
	end
	btn.attachScene = function( data )
		local e = GetEventManager();
		if btn["isFirst"] then
			btn.isFirst = false;
			if data.focustex then
				local focusData={ 
					name="focus"..data.name,
					pos={0,0},
					width=1,
					height=1,
					tex=data["focustex"],
					blend=Graphics.BLEND_LINEAR ,
					alpha=255
				}
				e:triggerEvent( "CreateImage" , focusData );
			end
			e:triggerEvent( "CreateImage", data );
		end
		btn.BGImage = GetSceneManager():get( data.name );
		if data.focustex then
			btn.focusImage = GetSceneManager():get( "focus"..data.name );
		end
		AttachGUItoView( btn );
	
		AttachText( btn );
--]]
	end
	btn.onEditMode=function()
		GUI_Editor.editImageAndText( btn );
	end
	btn.zoomImage=function( sx , sy )
		local bgW = btn.width;
		local bgH = btn.height;
--		if btn.focusSize then
--			OffsetSize( btn , bgW*btn.focusSize[1] , bgH*btn.focusSize[2] );
--			btn.BGImage:setWidthHeight( btn.focusSize[1] , btn.focusSize[2] );
--		else
--			OffsetSize( btn , bgW*sx , bgH*sy );
			local w,h = GetOffset();
			btn.BGImage:setWidthHeight( bgW*sx*w , bgH*sy*h );
--		end
		if btn.focusImage then
			local focus = btn.focusImage;
			focus:setPosition( btn.BGImage:dstX() , btn.BGImage:dstY() );
			focus:setWidthHeight( bgW*sx , bgH*sy );	
		end
	end
	btn.changeAlpha=function( speed )
		if btn.focusImage then
			local focus = btn.focusImage;
			if btn.focusAlphaWave then
				local a = AbsCosWav( 255 , speed );
			--	local a = math.abs( 255 * math.cos( data["speed"] * os.difftime( os.clock() , data["time"] ) ) );
				focus:setAlpha( a );
			else
				data.focusAlpha = 200;
				focus:setAlpha( data.focusAlpha );			
			end		
		end
	end
	btn.onFocused=function()
		if btn["entered"] then
			TriggerEvent( "Button_"..data["name"].."_Enter" , data );	
--			GetSoundManager():playSe( "Cursor" ) ;
			btn.entered = false;
		end
		if btn.zoomScl then
			btn.zoomImage( btn["zoomScl"][1] , btn["zoomScl"][2] );		
		else
			btn.zoomImage( 1.25 , 1.25 );
		end
		if btn.focusAlphaWave then
			btn.changeAlpha( btn.focusAlphaWave["speed"] );
		else
			btn.changeAlpha( 2 );
		end
		if btn.focusImage then
			local focus = btn.focusImage;
			
			if btn.rgb then
				focus:setColor( btn["rgb"][1] , btn["rgb"][2] ,btn["rgb"][3] );
			else
				--defaulting  color
				focus:setColor( 255,255,0);
			end
		end
		if GetMouse():isTriggered( Mouse.BUTTON_LEFT ) then
			if btn.attachedContainer then
				btn.attachedContainer.receiveClickedWidget( btn );
			end
			return true;
		end
		return false;
	end
	btn.unFocused=function()
		btn.entered = true;
		local ratioW,ratioH = GetOffset();
		local isW = btn.BGImage:width() > btn.width*ratioW;
		local isH = btn.BGImage:height() > btn.height*ratioH;
		local focus = btn.focusImage;
		if  isW and isH then
			btn.BGImage:setWidthHeight( btn.BGImage:width() -1 , btn.BGImage:height() - 1 );
--			OffsetSize( btn , btn.BGImage:width() -3 , btn.BGImage:height() - 5 );	
			if btn.focusImage then
				focus:setWidthHeight( btn.BGImage:width() -1 , btn.BGImage:height() - 1 );
			end
		else
			btn.BGImage:setWidthHeight( btn.width*ratioW-5 , btn.height*ratioH-5 );
--			OffsetSize( btn , btn.width , btn.height );	
			if btn.focusImage then
				focus:setWidthHeight( btn.BGImage:width() -1 , btn.BGImage:height() - 1 );
--				focus:setWidthHeight( btn.width , btn.height );
			end
		end
		--if "isChecked" Key is not exist, reducing the alpha value
		if btn.focusImage then
			if not data.isChecked then
				focus:setAlpha( data.focusAlpha );
		--			focus:setColor( 255,255,255 );
				data.focusAlpha = data.focusAlpha - 3;
				if data.focusAlpha <= 0 then
					data.focusAlpha = 0;
				end
			else
				data.focusAlpha = 0;
				focus:setAlpha( data.focusAlpha );
			end	
		end
	end
	btn.trigger=function()
		local sub = GameLib.GetSubtitler();
		local name=data.name;
		local w=0x00ffffff;
		local g=0x0000ff00;
		btn.BGImage:setColor( w,w,w,g);
		btn.BGImage:setAlpha( 255,255,255,255);
		if btn.BGImage:isVisible() then
			if GUI_Button["mouseClick"] then
				if HitTest1( btn.BGImage ) then
					btn["onFocus"] = true;
					btn["onMouse"] = true;
					if GUI_Editor["isEdit"] then
						GUI_Editor.register( btn );
					end
				else
					if GUI_Button["mouseOnly"] then--btn.mouseOnly and btn["mouseOnly"] then--
						btn["onFocus"] = false;

					end
					if btn.mouseOnly and btn["mouseOnly"] then--
						btn["onFocus"] = false;
					end
					
					if btn.holdFocus and btn["holdFocus"] then
					
					else
--						if GUI_Button["mouseOnly"] then--btn.mouseOnly and btn["mouseOnly"] then--
--							btn["onFocus"] = false;
--						end
					end
					btn["onMouse"] = false;
				end
			end
			if GUI_Editor["isEdit"] then
				return false;
			end
			if btn["onFocus"] then
				local vc = GetViewManager():viewController();
				local cont = vc:controller();
				--local cont = Player_1View:controller();
				local isStart = cont:isTriggered( PSController.PS_START );
				local isCircle = cont:isTriggered( PSController.PS_CIRCLE );
				local isEnter = IsKeyTriggeredFromCode( 128 );
				if btn.onFocused() then
					return true;
				elseif isStart or isCircle or isEnter then --Enter( se )
					return true;
				end
			else
				btn.unFocused();
			end
		end
--]]	
		return false;
	end
	btn.event=function()
		local se = "";
		if btn.clickedSound then
			se = btn["clickedSound"];
			GetSoundManager():playSe( se ) ;
		else
			se = SeMap.enter;
		end
		--TODO:{^tH[JXĂȂ̂ɃNbNĉȂƂ
		TriggerEvent( "Button_"..data["name"].."_Clicked" , data );	
		btn.zoomImage( 1.5 , 1.5 );
--		btn.changeAlpha( 5 );		
	end
	GUI_Button.collection[ data.name ] = btn;
	
	btn.changeAfter=Process.INITIALIZING;
	btn.attachScene( data );
	GUI_Common.attachProcess( btn , "Button" );
--	GameLib.AttachProcess( "Temp"..data["name"], EventTriggerProcess_State , btn );
	return btn;
 end

GUI_Editor={}
GUI_Editor.isEdit=false;
GUI_Editor.currentWidget=nil;
GUI_Editor.currentTextPos = 1;
GUI_Editor.editMode="Img";
--Widget Must have these BGImage , name.
GUI_Editor.editImageAndText=function( widget )
	if widget.isDrag then
		if gEditMode == "Img" then
			DragPosImage( widget.BGImage );
			DragSizeImage( widget.BGImage );
		elseif gEditMode == "Cap" then
			if widget.text then
				if #widget.text < GUI_Editor.currentTextPos then
					GUI_Editor.currentTextPos = #widget.text;					
				elseif GUI_Editor.currentTextPos < 1 then
					GUI_Editor.currentTextPos = 1;
				end
				local sub = GameLib.GetSubtitler();
				local billstr = sub:get( widget.text[ GUI_Editor.currentTextPos ][ "id" ] ) ;
				DragPosImage( billstr );
				DragSizeImage( billstr );					
			end
		end				
	end
end
GUI_Editor.attachProcessManager=function()
	local process={}
	process.Update=function(process,dummydata)
		GUI_Editor.edit();
	end
	GameLib.AttachProcess("GUI_Edit",process,"dummy" );
end
GUI_Editor.register=function( widget )
	GUI_Editor.currentWidget = widget;	
end
GUI_Editor.edit=function()
	Dout(" Key i : EDIT Image " );
	Dout(" Key o : EDIT Cap" );
	if IsKeyTriggered("i") then
		gEditMode = "Img";
	elseif IsKeyTriggered("o") then
		gEditMode = "Cap";
	end	
	if IsKeyTriggered("+") then
		GUI_Editor.currentTextPos = GUI_Editor.currentTextPos + 1
	elseif  IsKeyTriggered("-") then
		GUI_Editor.currentTextPos = GUI_Editor.currentTextPos - 1
	end
	
	Dout( "GUI In Edit Mode: e");
	Dout( "GUI Leave Edit Mode : r");
	if IsKeyTriggered("e") then					
		GUI_Editor.isEdit=true;
	elseif IsKeyTriggered("r") then					
		GUI_Editor.isEdit=false;
--	elseif IsKeyTriggered("c") then					
--		GameLib.LevelEditor():calcWallAndFloor();
	elseif IsKeyTriggered("c") then					
		if GUI_Editor.currentWidget then
			GUI_Editor.currentWidget.serialize( GUI_Editor.currentWidget );
		end			
	end
	if GUI_Editor["isEdit"] then
		if GUI_Editor.currentWidget then
Dout( "Current Edit Widget:"..GUI_Editor.currentWidget.name );
			GUI_Editor.currentWidget.onEditMode();
		end	
	else
		GUI_Editor.currentWidget = nil;
	end
end
gEditMode= "Img"

GUI_GroupBox={}
GUI_GroupBox.name="GroupBox";
GUI_GroupBox.collection={}
GUI_GroupBox.get=function(key)
	return GUI_Common.get( GUI_GroupBox , key );
end
GUI_GroupBox.create=function(data)
	local gb=data;
	--collect the creating Widget to get by key
	GUI_GroupBox.collection[ data.name ] = gb;
	gb.collection={}
--	gb.currentFocusWidget=0;
	gb.isFirst = true;
	gb.data=CopyData( data );
	gb.activate=function()
		for i=1,#data.activatedSceneName, 1 do
			if ( GameLib.CurrentSceneState():name() == data.activatedSceneName[i] ) then
				return true;
			end
		end
		return false;
	end
	gb.collect=function( widget )
		local this = GetSceneManager():get( data.name );
		local ofs = { 
			this:dstX() - widget.BGImage:dstX(),
			this:dstY() - widget.BGImage:dstY()
		}
		--Insert widget and offset coord pair to Table  
		table.insert( data.collection , { widget , ofs } );
		widget.attachedContainer = gb;
	end
	gb.attachScene= function( data )
		local e = GetEventManager();
		if data["isFirst"] then
			data.isFirst = false;
			e:triggerEvent( "CreateImage", data );
		end
		e:triggerEvent( "AttachNode" , data );
	end
	gb.trigger=function()
		return false;
	end
	gb.event=function()
--		GetEventManager():triggerEvent( "Button_"..data["name"].."_Clicked" , data );	
	end
	gb.changeAfter=Process.INITIALIZING;
	gb.attachScene( data );
	GameLib.AttachProcess( "GroupBox"..data.name, EventTriggerProcess_State , gb );
	return gb;
end

GUI_Picture={}
GUI_Picture.name="Picture";
GUI_Picture.collection={}
GUI_Picture.get=function(key)
	return GUI_Common.get( GUI_Picture , key );
end
GUI_Picture.addSize=function( pic , data )
	local lessW = pic.BGImage:width() < data.maxW;
	local lessH = pic.BGImage:height() < data.maxH;
	if lessW then
		pic.currentData.width = pic.currentData.width + data.speedW;
	end
	if lessH then
		pic.currentData.height = pic.currentData.height + data.speedH;
	end
	pic.BGImage:setWidthHeight( pic.currentData.width , pic.currentData.height );
	if not ( lessW and lessH ) then
		return true;
	end
	return false;
end	
GUI_Picture.move=function( pic , data )
	pic.BGImage:setPosition( pic.currentData.pos[1] , pic.currentData.pos[2] );
	pic.currentData.pos[1] = pic.currentData.pos[1] + data.dir[1] * data.speed[1];
	pic.currentData.pos[2] = pic.currentData.pos[2] + data.dir[2] * data.speed[2];
	local difX = math.abs( pic.currentData.pos[1] - data.dst[1] )
	local difY = math.abs( pic.currentData.pos[2] - data.dst[2] )
	if ( difX < data.err ) and ( difY < data.err ) then
		return true;
	end
	return false;
end
 GUI_Picture.create=function( data )
	local pic=data;
	OffsetGUI( data );
	pic.focusAlpha = 0;
	pic.entered = false;
	pic.isFirst = true;
	pic.onFocus = false;
	pic.onMouse= false;
	pic.onEdit = false;
	pic.copiedData=CopyData( data );
	pic.currentData=CopyData( data );
	pic.activate=function()
		return GUI_Common.activate( pic );
	end
	pic.serialize=function( pict )
		pict.copiedData["width"] = pict.BGImage:width();
		pict.copiedData["height"] = pict.BGImage:height();
		pict.copiedData.pos[1] = pict.BGImage:dstX();
		pict.copiedData.pos[2] = pict.BGImage:dstY();
		if pict.text then
			for i=1,#pict.text,1 do
				local sub = GameLib.GetSubtitler();
				local billstr = sub:get( pict.text[i]["id"] ) ;
				if billstr then
					pict.copiedData.text[i]["pos"][1] = billstr:dstX();
					pict.copiedData.text[i]["pos"][2] = billstr:dstY();
					pict.copiedData.text[i]["scale"][1] = billstr:scaleX();
					pict.copiedData.text[i]["scale"][2] = billstr:scaleY();
				end
			end
		end
		local out=io.open("lua/gui/picture/"..pict.name..".lua" , "w");
		out:write("PictureData[\""..pict.name.."\"]=" );
		serialize( pict["copiedData"] , out );
		out:close();
	end		
	pic.setTextId=function( textid )
--[[		local sub = GameLib.GetSubtitler();
		local t = sub:get( textid ) ;
		if t then
			GameLib.CurrentSceneState():attachSubtitle( textid );
			t:setVisible( true );
			if data.gradual then
				t:enableGradual( data["gradual"] );
			end
			t:setScale( data.capscale[1] , data.capscale[2] );
			SetPos( t , data["cappos"][1] , data["cappos"][2] );
			t:setColor( 0xffffff );			
		end		
--]]
	end
	pic.attachScene = function( data )
		local e = GetEventManager();
		if pic["isFirst"] then
			pic.isFirst = false;
			e:triggerEvent( "CreateImage", data );
		end
--		e:triggerEvent( "AttachNode" , data );
		AttachGUItoView( pic );
		AttachText( pic );
		pic.BGImage = GetSceneManager():get( data.name );
		pic.BGImage:setPosition( data["pos"][1] , data["pos"][2] );
		pic.BGImage:setWidthHeight( data["width"] , data["height"] );
		
		if pic.processes then
--			pic.processQueue = Queue.create();
--			for i=1,#pic.processes,1 do
--				pic.processQueue.push_back( pic.processes[i] );
--			end
			for i=1,#pic.processes,1 do
				TriggerEvent( "PreProcessAttach" , pic.processes[i] );
			end
			
--			Native.Methods.AttachProcess( pic.front()["name"] ,  );
		end
		if pic.update then
			pic.currentUpdatePos = 1;
		end
	end
	pic.onEditMode=function()
		local sub = GameLib.GetSubtitler();
		if pic.textid then
			local t = sub:get( pic.textid ) ;
			GUI_Editor.editImageAndText( pic , t );
		else
			GUI_Editor.editImageAndText( pic , nil );
		end
	end
	pic.trigger=function()
		local sub = GameLib.GetSubtitler();
		local name=data.name;
		local w=0x00ffffff;
		local g=0x0000ff00;
		pic.BGImage:setColor( w,w,w,g);
		pic.BGImage:setAlpha( 255,255,255,255);
		if HitTest1( pic.BGImage ) then
			if GUI_Editor["isEdit"] then
				GUI_Editor.register( pic );
				
			end
			pic["onFocus"] = true;
			pic["onMouse"] = true;
		else
			pic["onMouse"] = false;
		end
		if pic.process then
			
		end
		if pic.update then
			local t = pic.update[ pic.currentUpdatePos ];
			if t["func"]( pic , t["data"] ) then
				pic.currentUpdatePos = pic.currentUpdatePos + 1;
				if pic.currentUpdatePos > #pic["update"] then
					return true;
				end
			end
		end
		return false;
	end
	pic.event=function()
		GetEventManager():triggerEvent( "Picture_"..data["name"].."_Triggered" , data );	
	end
	GUI_Picture.collection[ data.name ] = pic;
	if data.textid then
		pic.setTextId( data.textid );
	end
--	pic.changeAfter=Process.INITIALIZING;
	pic.changeAfter=Process.WAITING;
	pic.attachScene( data );
	GUI_Common.attachProcess( pic , "Picture" );
	
--	local pro = GameLib.AttachProcess( "Picture"..data["name"], EventTriggerProcess_State , pic );
--	pic.process=pro;
--]]
	return pic;
 end

 GUI_ProgressBar={}
 GUI_ProgressBar.name="ProgressBar";
 GUI_ProgressBar.collection={}
 GUI_ProgressBar.get=function(key)
	return GUI_Common.get( GUI_ProgressBar , key );
 end
 GUI_ProgressBar.create=function( data )
 	local pb=data;
	OffsetGUI( data );
	pb.entered = false;
	pb.isFirst = true;
	pb.onMouse = false;
	pb.data=CopyData( data );
	if not pb.currentW then
		pb.currentW= data["width"];
	end
	if not pb.currentH then
		pb.currentH=data["height"];
	end
	pb.frameW = data["width"];
	pb.frameH = data["height"];
--	pb.increment = 
	 pb.serialize=function( progbar )
		progbar.data["width"] = progbar.FrameImage:width();
		progbar.data["height"] = progbar.FrameImage:height();
		progbar.data.pos[1] = progbar.FrameImage:dstX();
		progbar.data.pos[2] = progbar.FrameImage:dstY();
		progbar.data.barpos[1] = progbar.BarImage:dstX();
		progbar.data.barpos[2] = progbar.BarImage:dstY();
		local out=io.open("lua/gui/progressBar/"..progbar.name..".lua" , "w");
		out:write("ProgressBarData[\""..progbar.data.name.."\"]=" );
		serialize( progbar.data , out ); 
		out:close();		
	 end
	pb.activate=function()
		return GUI_Common.activate( pb );
	end
	pb.onEditMode=function()
	end
	pb.attachScene = function( data )
		local e = GetEventManager();
		local barData={ 
			name="bar"..data.name,
			pos={ data.pos[1] - data.width/2 ,data.pos[2] - data.height/2   },
			width=pb.currentW,
			height=pb.currentH,
			tex=data["bartex"],
			blend=Graphics.BLEND_LINEAR ,
			alpha=255
		}
		if pb["isFirst"] then
			pb.isFirst = false;
			e:triggerEvent( "CreateImage", data );
			e:triggerEvent( "CreateImage" , barData );
		end
		pb["FrameImage"] = GetSceneManager():get( data.name );
		pb["BarImage"] = GetSceneManager():get( barData.name );
		--TODO : Image.RM_RECT is invalid !! why??
		pb["BarImage"]:setRenderMode( 1 )--Image.RM_RECT );
		if data.view then
--			GetViewManager():view( data.view ):setChild( pb.FrameImage );
--			GetViewManager():view( data.view ):setChild( pb.BarImage );
			GetViewManager():view( data.view ):attachNode( data.name );
			GetViewManager():view( data.view ):attachNode( barData.name );
		else			
			e:triggerEvent( "AttachNode" , barData );
			e:triggerEvent( "AttachNode" , data );
		end
--]]
	end
	pb.setWidthPercent=function( perc )
		local h = pb.BarImage:height();
		--t[Ɉpercent
		local w = pb.FrameImage:width() * perc;
		pb.BarImage:setWidthHeight( w , h );
	end
	pb.addWidth=function( d )
		local incre = d*pb.increment;	
		incre = RatioOffsetX( incre );
		if pb.incrementType == "size" then
			pb.currentW = pb.currentW + incre;
			if pb.currentW > pb.width then 
				pb.currentW = pb.width;
			end
			pb.BarImage:setWidthHeight( pb.currentW , pb.currentH );
		elseif pb.incrementType == "uv" then
			local r = pb.BarImage:uvRight() + incre/pb.FrameImage:width();
			if r > 1 then
				r = 1;
			end
			pb.BarImage:setUV( 0 ,0 , r , 1 );		
		end
	end
	pb.trigger=function()
		local name=data.name;
		local w=0x00ffffff;
		local g=0x0000ff00;
		pb.FrameImage:setColor( w,w,w,g);
		pb.FrameImage:setAlpha( 255,255,255,255);
		local barX = pb.FrameImage:dstX() - pb.FrameImage:width()/2;
		local barY = pb.FrameImage:dstY() - pb.FrameImage:height()/2;
		pb.BarImage:setPosition( barX , barY );
		if IsKeyTriggered("x") then				
--			SerializeProgressBar( pb );
		end
		if pb.onFocus then
			if pb["onFocus"] then
				if pb.updateWidget then
					pb.updateWidget();
				end
			end
		end
		if HitTest1( pb.FrameImage ) then
			if GUI_Editor["isEdit"] then
				GUI_Editor.register( pb );
			end	
			if data.isDrag then
				DragPosImage( pb.FrameImage );
				DragSizeImage( pb.FrameImage );
				DragPosImage( pb.BarImage );
				DragSizeImage( pb.BarImage );
			end
--			gEditMode = "Img";
		end
		return false;
	end
	pb.event=function()
		GetEventManager():triggerEvent( "Button_"..data["name"].."_Clicked" , data );	
	end
	GUI_ProgressBar.collection[ data.name ] = pb;

	pb.changeAfter=Process.INITIALIZING;
	pb.attachScene( data );
	GUI_Common.attachProcess( pb , "ProgressBar" );	
	return pb;
 end

GUI_TextBox={}
GUI_TextBox.name="TextBox";
GUI_TextBox.collection={}
GUI_TextBox.get=function(key)
	return GUI_Common.get( GUI_TextBox , key );
end
 GUI_TextBox.create=function( data )
	local txtbox=data;
	OffsetGUI( data );
	txtbox.focusAlpha = 0;
	txtbox.entered = false;
	txtbox.isFirst = true;
	txtbox.onFocus = false;
	txtbox.onMouse= false;
	txtbox.onEdit = false;
	txtbox.active= false;
	
	txtbox.currLine = 1;
	txtbox.labelLines={}
	txtbox.copiedData=CopyData( data );
	txtbox.activate=function()
		return GUI_Common.activate( txtbox );
	end
	txtbox.setTextId=function( textid )
		local sub = GameLib.GetSubtitler();
--[[		if txtbox.textid then
			if txtbox["textid"] == textid then
				return;
			end
		end
--]]		local t = sub:get( textid ) ;
		if t then
			txtbox.clearText( );
			txtbox.textid = textid;
			if txtbox.view then
				local v = GetViewManager():view( txtbox.view );
				v:label( textid );
			end
			t:setVisible( true );
			if data.gradual then
				t:enableGradual( data["gradual"] );
			end
			t:setScale( data.capscale[1] , data.capscale[2] );
			local dstX = txtbox.BGImage:dstX();
			local dstY = txtbox.BGImage:dstY();
			local w = txtbox.BGImage:width();
			local h = txtbox.BGImage:height();
			local px = dstX - w/2 + data["cappos"][1];
			local py = dstY - h/2 + data["cappos"][2];
			t:setPosition( px , py );
			t:setColor( 0xffffff );			
			if data.showLimiteSec then
				if t:size() < 20 then
					txtbox["txtShowLimiteSec"] = 4;
				else
					txtbox["txtShowLimiteSec"] =  6;
				end
				txtbox["time"]=os.clock();
			end	
		end		
--]]
	end
	txtbox.attachScene = function( data )
		local e = GetEventManager();
		if txtbox["isFirst"] then
			txtbox.isFirst = false;
			e:triggerEvent( "CreateImage", data );
		end
		txtbox.BGImage = GetSceneManager():get( data.name );
		if txtbox.view then
			local v = GetViewManager():view( txtbox.view );
			v:attachNode( data.name );
--			v:setChild( txtbox.BGImage );
		end
--		e:triggerEvent( "AttachNode" , data );
		AttachText( txtbox );
	end
	txtbox.onEditMode=function()
		local sub = GameLib.GetSubtitler();
		if txtbox.textid then
			local txt = sub:get( txtbox["textid"] );
			GUI_Editor.editImageAndText( txtbox , txt );
		else
			GUI_Editor.editImageAndText( txtbox , nil );
		end
	end
	txtbox.clearText=function()
		if txtbox.textid then
			local sub = GameLib.GetSubtitler();
			local t = sub:get( txtbox["textid"] ) ;
			if t then
				txtbox.textid = nil;
				t:setVisible( false );
			end
		end
	end
	txtbox.trigger=function()
		local sub = GameLib.GetSubtitler();
		local name=data.name;
		local w=0x00ffffff;
		local g=0x0000ff00;
		txtbox.BGImage:setColor( w,w,w,g);
		txtbox.BGImage:setAlpha( 255,255,255,255);
--		local billstr = sub:get( name );
--		if billstr then
--			billstr:setColor( 0xffffff );
--		end
--[[
		if IsKeyTriggered("q") then					
			local sub = GameLib.GetSubtitler();
			if txtbox.textid then
				local t = sub:get( txtbox.textid ) ;
				SerializeTextBox( txtbox , t );
			else
				SerializeTextBox( txtbox , nil );
			end
		end		
--]]
		if txtbox.time then
			if txtbox.textid then
				if os.difftime( os.clock() , txtbox["time"] ) > txtbox["txtShowLimiteSec"] then
					local t = sub:get( txtbox["textid"] ) ;
					if t then
						txtbox.textid = nil;
						t:setVisible( false );
					end
				else
					
				end
			end
		end
		
		if HitTest1( txtbox.BGImage ) then
			if GUI_Editor["isEdit"] then
				GUI_Editor.register( txtbox );
				
			end
			txtbox["onFocus"] = true;
			txtbox["onMouse"] = true;
		else
			txtbox["onMouse"] = false;
		end
		return false;
	end
	txtbox.event=function()
		GetEventManager():triggerEvent( "TextBox_"..data["name"].."_Clicked" , data );	
	end
	GUI_TextBox.collection[ data.name ] = txtbox;
	
	txtbox.changeAfter=Process.INITIALIZING;
	txtbox.attachScene( data );
	GameLib.AttachProcess( "TextBox"..data["name"], EventTriggerProcess_State , txtbox );
	return txtbox;
 end

 GUI_UpDownBar={}
 GUI_UpDownBar.create=function( pbdata )
	local ud = GUI_ProgressBar.create( pbdata );
	ud.value = pbdata["initialValue"];
	ud.updateWidget=function()
Dout("Updating UpDown Bar");
		local dx=0;
		local dy=0;
		dx ,dy = CursorMove( dx , dy , -1 , 1 , -1 , 1 , OnDirection );
		Dout( "Cursor DX:"..dx );
		if dx ==1 then
			ud.addWidth(5);
		elseif dx ==-1 then
			ud.addWidth(-5);
		end
	end
	return ud;
 end
 gFocusAlpha=128;

function SetOffsetPos( gb , widget )
	for i=1,#gb.collection,1 do
		
	end
end

GUI_UpDownControl={}

GUI_Numeric={}
GUI_Numeric.name="Numeric";
GUI_Numeric.collection={}
GUI_Numeric.get=function(key)
	return GUI_Common.get( GUI_Numeric , key );
end
 GUI_Numeric.create=function( data )	
	local o={}
	local digitW = data["digitSize"][1];
	local digitH = data["digitSize"][2];
	o.isFirst = true;
	o.imageCollection=CollectionClass.create();
	o.createNumericImages=function( )
		for i=1,data.digitNum,1 do
			local x = data.pos[1] - (i-1) * digitW + 10 ;
			for k=0,9,1 do
				local left = ( data["numberTexPixelWidth"] * k ) / data["numberTexPixelWidthMax"];
				local right = left;
				right = right + data["numberTexPixelWidth"] / data["numberTexPixelWidthMax"];
				local digitData={ 
					name = data.name..i.."num"..k,
					pos={ x , data.pos[2] } , size={digitW , digitH } , texture=data.numberTex ,
					uv={ left , 0 , right , 1 } , blend=Graphics.BLEND_LINEAR, };
				local img = CreateImage2( digitData );
				img:setVisible( false );
				o.imageCollection.collect( digitData.name , img );
			end
		end		
	end
	o.attachScene = function( data )	
		if o["isFirst"] then
			o.isFirst = false;
			o.createNumericImages();
		end
		if data.view then
			local v= GetViewManager():view( data.view );
			if v then
				for i=1,data.digitNum,1 do
					for k=0,9,1 do
						v:attachNode( data.name..i.."num"..k );
					end
				end
			end
		else
			for i=1,data.digitNum,1 do
				for k=0,9,1 do
					_("ATTACH SCENE "..data.name..i.."num"..k );
				end
			end
		end
		if data.upDownControl then
			local upButton = {
				pos = { 167, 465, } ,
				  blend = 0,
				  name = data.name.."UDUp",
				  tex = "FaceGra1.bmp",
			  }
			GUI_Button.create( upButton );
		end
	end
	o.setNumber=function( n )
		o.number = n;
--		if n > o["showThreshold"] then
			o.reset();
			if n < 10 then
				o.imageCollection.get( data.name.."1".."num"..n ):setVisible( true );
			elseif (10 <= n ) and ( n < 100) then
				local t = math.floor( n /10 );
				local img = o.imageCollection.get( data.name.."2".."num"..t );
				if img then
					img:setVisible( true );
				end
				t = n - t * 10;
				img = o.imageCollection.get( data.name.."1".."num"..t )
				if img then
					img:setVisible( true );		
				end
			end
--		end
	end
	o.reset=function()
		for i=1,data.digitNum,1 do
			for k=0,9,1 do
				local t = o.imageCollection.get( data.name..i.."num"..k );
				if t then
					t:setVisible( false );
				end
			end
		end
	end
	GUI_Numeric.collection[ data.name ] = o;
	
	o.attachScene( data );
	
	return o;
 end
	
GUI={}
GUI.collection={}
GUI.get=function( key )
	if IsKeyExist( GUI.collection , key ) then
		return GUI.collection[ key ];	
	else
		return nil;
	end
end

SelectorButtonSampleData={
	name="StageSelector",
	leftTex="LeftArrow.bmp",
	rightTex="RightArrow.bmp",
	handleOffset=300,
	  activatedSceneName = {
		"StageSelect",
		"CharaSelect",
	}
	,
	  pos = {
	167,
	299,
	}
	,
	buttons={
		{
		  focustex = "OnFocus3.bmp",
		  focusAlpha = 0,
		  alpha = 255,
		  width = 100,
		  tex = "nightStreet.bmp",
		  blend = 0,
		  height = 100,
		  name = "Stage1",
		},
		{
		  focustex = "OnFocus3.bmp",
		  focusAlpha = 0,
		  alpha = 255,
		  width = 100,
		  tex = "Stage08_Select.bmp",
		  blend = 0,
		  height = 100,
		  name = "Stage2",
		},
		
	},
}
GUI_Selector={}
GUI_Selector.name="Selector";
GUI_Selector.collection={}
GUI_Selector.get=function(key)
	return GUI_Common.get( GUI_Selector , key );
end
 GUI_Selector.create=function( data )	
	local o = {}
	o.currPos=1;
	o.buttonCollection = {}
	local leftHandleButtonData={
	  focustex = "OnFocus3.bmp",
	  focusAlpha = 0,
	  alpha = 255,
	  width = 100,
	  tex = data["leftTex"],
	  blend = 0,
	  height = 100,
	  name = data["name"].."LeftHandle",
	  pos={ data["pos"][1] , data["pos"][2] },
	}
	leftHandleButtonData["activatedSceneName"] = data["activatedSceneName"];
	leftHandleButtonData["pos"][1] = leftHandleButtonData["pos"][1] - data["handleOffset"]/2;
	local rightHandleButtonData={
	  focustex = "OnFocus3.bmp",
	  focusAlpha = 0,
	  alpha = 255,
	  width = 100,
	  tex = data["rightTex"],
	  blend = 0,
	  height = 100,
	  name = data["name"].."RightHandle",
	  pos={ data["pos"][1] , data["pos"][2] },
	}
	rightHandleButtonData["activatedSceneName"] = data["activatedSceneName"];
	rightHandleButtonData["pos"][1] = rightHandleButtonData["pos"][1] + data["handleOffset"]/2;
	
	for i=1,#data["buttons"],1 do
		data["buttons"][i]["pos"] = data["pos"];
		data["buttons"][i]["activatedSceneName"] = data["activatedSceneName"];
		local b = GUI_Button.create( data["buttons"][i] );
		table.insert( o.buttonCollection , b );
	end

	for i=1,#o.buttonCollection,1 do
		o.buttonCollection[i].BGImage:setVisible( false );
		o.buttonCollection[i].focusImage:setVisible( false );
	end
	o.buttonCollection[ o.currPos ].BGImage:setVisible( true );
	o.buttonCollection[ o.currPos ].focusImage:setVisible( true );
	
	leftHandleClickedListener=function( data )
		o.currPos = o.currPos - 1;
		if o.currPos <= 0 then
			o.currPos = 1;
		end
	end
	rightHandleClickedListener=function( data )
		o.currPos = o.currPos + 1;
		if o.currPos > #o.buttonCollection then
			o.currPos = #o.buttonCollection;
		end	
	end
	local e = GetEventManager();
	e:addScriptedListener( "Button_"..data["name"].."LeftHandle".."_Clicked", leftHandleClickedListener );
	e:addScriptedListener( "Button_"..data["name"].."RightHandle".."_Clicked", rightHandleClickedListener );
	

	GUI_Button.create( rightHandleButtonData );
	GUI_Selector.collection[ data.name ] = o;
	o.crsData={
		sceneName="CharaSelect",
		buttonList={
			{ GUI_Button.create( leftHandleButtonData ) ,
			 o.buttonCollection[ o.currPos ] ,
			 GUI_Button.create( rightHandleButtonData ) }	
		}
	}	

	GameLib.AttachProcess( "CursorMove" , CursorMoveProcess_State , o.crsData );	
	
--	GameLib.AttachProcess( "Button"..data["name"], EventTriggerProcess_State , btn );	
	
--]]
	return o;
 end
 
function DragPosImage( img )
	local mX = GetMouse():x();
	local mY = GetMouse():y();
	local vX = GetMouse():velocityX();
	local vY = GetMouse():velocityY() 
	if GetMouse():isOn( Mouse.BUTTON_LEFT ) then
		if gEditMode == "Img" then 
			local dstX = mX - img:width()/2;
			local dstY = mY - img:height()/2 
			img:setPosition( mX , mY );
		elseif gEditMode == "Cap" then					
			img:setPosition( mX , mY );
		end
	end
end
function DragSizeImage( img )
	local mX = GetMouse():x();
	local mY = GetMouse():y();
	local vX = GetMouse():velocityX();
	local vY = GetMouse():velocityY() 
	if GetMouse():isOn( Mouse.BUTTON_RIGHT ) then
		if gEditMode == "Img" then 
			img:setWidthHeight( img:width() + vX , img:height()+vY );
		elseif gEditMode == "Cap" then
			img:setScale( img:scaleX() + vX/100 ,img:scaleY() +  vY/100 );
		end
	end
end

SerializePicture=function( pic , billstr )
	pic.copiedData["width"] = pic.BGImage:width();
	pic.copiedData["height"] = pic.BGImage:height();
	pic.copiedData.pos[1] = pic.BGImage:dstX();
	pic.copiedData.pos[2] = pic.BGImage:dstY();
	if billstr then
		pic.copiedData.cappos[1] = billstr:dstX();
		pic.copiedData.cappos[2] = billstr:dstY();
		pic.copiedData.capscale[1] = billstr:scaleX();
		pic.copiedData.capscale[2] = billstr:scaleY();
	end
	local out=io.open("lua/gui_parts/"..pic.name..".lua" , "w");
	out:write("PictureData[\""..pic.name.."\"]=" );
	serialize( pic["copiedData"] , out );
	out:close();
end	


 function SerializeProgressBar( pb )
	pb.data["width"] = pb.FrameImage:width();
	pb.data["height"] = pb.FrameImage:height();
	pb.data.pos[1] = pb.FrameImage:dstX();
	pb.data.pos[2] = pb.FrameImage:dstY();
	pb.data.barpos[1] = pb.BarImage:dstX();
	pb.data.barpos[2] = pb.BarImage:dstY();
	local out=GetOutput("lua/gui/progressBar/"..pb.data.name..".lua" );
	out:write("ProgressBarData[\""..pb.data.name.."\"]=" );
	serialize( pb.data , out ); 
	out:close();
 end

function SerializeTextBox( textbox , billstr )
	local bg =textbox.BGImage;
	textbox.copiedData["width"] = bg:width();
	textbox.copiedData["height"] = bg:height();
	textbox.copiedData.pos[1] = bg:dstX();
	textbox.copiedData.pos[2] = bg:dstY();
	if billstr then
		textbox.copiedData.cappos[1] = billstr:dstX() - bg:dstX() - bg:width()/2 ;
		textbox.copiedData.cappos[2] = billstr:dstY() - bg:dstY() - bg:height()/2 ;
		textbox.copiedData.capscale[1] = billstr:scaleX();
		textbox.copiedData.capscale[2] = billstr:scaleY();
	end
	local out=io.open("lua/gui/textBox/"..textbox.name..".lua" , "w");
	out:write("TextBoxData[\""..textbox.name.."\"]=" );
	serialize( textbox["copiedData"] , out );
	out:close();
end	

function OffsetSize( gui , w , h )
	local ratioW,ratioH = GetOffset();
	if gui.BGImage then
		gui.BGImage:setWidthHeight( w * ratioW , h * ratioH );
	end
end

function GetOffset()
 	local ratioW = Native.Methods.windowWidth() / 840
	local ratioH = Native.Methods.windowHeight() / 680
	return ratioW,ratioH;
end

function OffsetGUI( t ) 
 	local ratioW = Native.Methods.windowWidth() / 840
	local ratioH = Native.Methods.windowHeight() / 680
	t["pos"][1] = t["pos"][1] * ratioW;
	t["pos"][2] = t["pos"][2] * ratioH;
	if t.width then
		t["width"] = t["width"] * ratioW;
		t["height"] = t["height"] * ratioH;
	end
	if t.size then
		t["size"][1] = t["size"][1] * ratioW;
		t["size"][2] = t["size"][2] * ratioH;	
	end
--[[	if t.focusSize then
		t["focusSize"][1] = t["focusSize"][1]*ratioW;
		t["focusSize"][2] = t["focusSize"][2]*ratioH;
	end
--]]
	if t.text then
		for i=1,#t.text,1 do
			local sub = GameLib.GetSubtitler();
			local txt = t.text[i];
			local billstr = sub:get( txt["id"] ) ;
			if billstr then
				txt["scale"][1] = txt["scale"][1] * ratioW;
				txt["scale"][2] = txt["scale"][2] * ratioH;
			end
		end
	end
end

Native={}
Native.Graphics={}
Native.Graphics.enableLight=function(  t , index )
	GetGraphicsManager():enableLight( t , index );
end
Native.Graphics.enableAttenuate=function(  t , index )
	GetGraphicsManager():enableAttenuate( t , index );
end
Native.Graphics.setLightPos=function(  p , index )
	GetGraphicsManager():setLightPos( p , index );
end
Native.Graphics.setLightColor=function(  c , index )
	GetGraphicsManager():setLightColor( c , index );
end
Native.Graphics.setAttenuate=function(  a , index )
	GetGraphicsManager():setAttenuate( a , index );
end
Native.Graphics.setAmbient=function(  a  )
	GetGraphicsManager():setAmbient( a );
end

--Native Editor Class Wrapper
Native.Editor={}
Native.Editor.get=function()
	return GameLib.LevelEditor();
end
Native.Editor.serialize=function( lvname , filename )				
	Native.Editor.get():serialize( lvname , filename );
end
Native.Editor.deserialize=function( o )				
	Native.Editor.get():deserialize( o );
end
Native.Editor.addMesh=function( name , file )
	return Native.Editor.get():addMesh( name , file );
end
Native.Editor.addTile=function( name , pos,angle,scale,materialname )
	return Native.Editor.get():addTile( name , pos,angle,scale,materialname );
end
Native.Editor.copySelectedMesh=function()
	return Native.Editor.get():copySelectedMesh();
end
Native.Editor.eraseSelectedMesh=function()
	Native.Editor.get():eraseSelectedMesh();
end
Native.Editor.selectedMesh=function()
	return Native.Editor.get():selectedMesh();
end
Native.CharaID={
	P1=GameLib.JoystickID.PLAYER_1,
	P2=GameLib.JoystickID.PLAYER_2,
	AI=GameLib.JoystickID.AI,
}

Native.CollisionType={
	Sphere=CollisionAtom.COLLISION_SPHERE,
	Cylinder=CollisionAtom.COLLISION_CYLINDER,
}

Native.Keyboard={
	NUM0=Keyboard.KEY_NUM0,
	NUM1=Keyboard.KEY_NUM1,
	NUM2=Keyboard.KEY_NUM2,
	NUM3=Keyboard.KEY_NUM3,
	NUM4=Keyboard.KEY_NUM4,
	NUM5=Keyboard.KEY_NUM5,
	NUM6=Keyboard.KEY_NUM6,
	NUM7=Keyboard.KEY_NUM7,
	NUM8=Keyboard.KEY_NUM8,
	NUM9=Keyboard.KEY_NUM9,	
}
Native.Methods={}
Native.Methods.OutputDebugStr=function( str )
	GameLib.OutputDebugStr( str );
end
Native.Methods.windowWidth=function()
	return GetWindowWidth();
end
Native.Methods.windowHeight=function()
	return GetWindowHeight();
end
Native.Methods.toggleWindowMode=function()
	local frm = Framework();
	if frm:isFullScreen() then
		frm:enableFullScreen( false );
	else
		frm:enableFullScreen( true );
	end
end
Native.Methods.addListener=function( name , lis )
	local e = GetEventManager();
	e:addScriptedListener( name , lis );	
end
Native.Methods.RequestEnd=function()
	GameLib.RequestEnd();
end		
Native.Methods.PlayBgm=function( key )
--	GetSoundManager():stopBgm();
	if IsKeyExist( SoundMap , key ) then
--		GetSoundManager():playBgm( SoundMap[ key ] );
		local t = SoundMap[ key ];
		GetSoundManager():playStreamSound( t["name"]..".wav" , t["loop"] );
	end
end
Native.Methods.PlaySe=function( name )
	GetSoundManager():playSe( name );
end
Native.Methods.SetBgmVol=function( v )
	GetSoundManager():setStreamSoundVolume( v );
end
Native.Methods.SetSeVol=function( v )
GetSoundManager():setSeVolume( v );
end
Native.Methods.AttachProcess=function( name , processstate , data )
	return GameLib.AttachProcess( name , processstate , data );
end
Native.Methods.CreateAgent=function( name , id , param )
	 local a = CreateAgent( name , id , param );
	 return a;
end
Native.Methods.CreateFighter=function( name , id , param )
	 local a = CreateFighter( name , id , param );
	 return a;
end
Native.Methods.MessageBox=function( title , str )
	GameLib.MessageBox( title , str );
end
Native.Methods.SetVisible=function( name , t )
	SetVisible( name , t );
end
Native.Methods.ConvertXFile=function( file )
	GameLib.ConvertXFile( file );
end
Native.Methods.CurrentSceneName=function()
	return GameLib.CurrentSceneState():name();
end
Native.Methods.CurrentSceneState=function( )
	return GameLib.CurrentSceneState();
end
Native.Methods.IsKeyTriggered=function( i )
	return IsKeyTriggeredFromCode( i );
end

--Native Subtitler Class Wrapper
Native.Subtitler={}
Native.Subtitler.get=function()
	return GameLib.GetSubtitler();
end
Native.Subtitler.getSub=function( name )
	return Native.Subtitler.get():get( name );
end

--Native Billboard Class Wrapper
Native.Billboard={}
Native.Billboard.create=function( t )
	local rect = RectUV()
	rect.mLeft = t["uv"][1];
	rect.mTop = t["uv"][2];
	rect.mRight = t["uv"][3];
	rect.mBottom = t["uv"][4];
	local bill = GameLib.CreateBillboard(
		t["name"],
		Vec3( t["pos"][1] , t["pos"][2] , t["pos"][3] ),
		t["width"],
		t["height"],
		rect,
		t["texture"],
		t["nodeType"],
		t["blendMode"]
	);
	if t.angle then
		bill:enableBillboarding( false );
		local ang = Vec3( t["angle"][1] , t["angle"][2] , t["angle"][3] );
		bill:setAngle( ang );
	end
	if t.effect then
		GameLib.AttachFlipUVProcess( t.name , t.effect[1] , t.effect[2] );	
--		GameLib.AttachFlipUVProcess( "image_exp" , "ExplodeEffect1" , ParaparaAnimation["ExplodeEffect1"] );
	end
	return bill;
end

Native.PhysicsManager=function()
	return GetPhysicsManager();
end

CurrentSceneStateParam=nil;
--XNvgꂽXe[g
Scene_State={}
Scene_State["Enter"]=function(scene, data)
	CurrentSceneStateParam = data;
	QueueEvent( "Scene"..scene:name().."_Enter" , data );
	if data.Enter then
		FindFuncAndExecute( scene , data["Enter"] , SceneStateFunctions );
	end
end
Scene_State["Update"]=function(scene,data)
	if data.Update then
		FindFuncAndExecute( scene , data["Update"] , SceneStateFunctions );
	end
end
Scene_State["Exit"]=function(scene,data)
	TriggerEvent( "Scene"..scene:name().."_Exit" , data );
	if data.Exit then
		FindFuncAndExecute( scene , data["Exit"] , SceneStateFunctions );
	end
end

gSerialMeshID=0;
gSerialImageID=0;
TransitionByInput=function( scene , args )
	if scene:command():isPushed( args["Button"] ) then
		scene:getFSM():changeState( args["NextState"] );
	end
end
IsProcessMode=function( scene , args )
	local ret = false;
	local process = scene:getProcessor():process( args["ProcessName"] );
	if process then
		ret = ( process:mode() == args["ProcessMode"]);
	end
	return ret;
end
ChangeProcessModeByInput=function( scene , args )
	if scene:command():isPushed( args["Button"] ) then
		scene:getProcessor():changeProcessMode( args["ProcessName"] , args["ProcessMode"] );
	end
end
ChangeProcessMode=function( scene , args )
	scene:getProcessor():changeProcessMode( args["ProcessName"] , args["ProcessMode"] );
end
IsProcessModeThen=function( scene , args )
	local process = scene:getProcessor():process( args["ProcessName"] )
	if process then
		if process:mode() == args["ProcessMode"]  then
			scene:getFSM():changeState( args["NextState"] );
		end
	end
end
IsPrevStateThen=function( scene , args )
	for k=1,#args["PrevState"],1 do
		if scene:getFSM():prevStateName() == args["PrevState"][k] then
			FindFuncAndExecute( scene , args , StateFunctions );
		end
	end
end
AttachProcess=function( scene , args )
	scene:getProcessor():attachScripted( args["name"] , args["state"] , args["data"] );
end
AttachNode=function( scene , args )
	GetEventManager():triggerEvent("AttachNode" , args );
end
AttachSub=function( scene , args )
	scene:attachSubtitle( args["sub"] );
end
Exec=function( scene , args )
	args[1]( args[2] );
end
ExecList=function( scene , args )
	for i=1,#args , 1 do
		args[i]();
	end
end

--Change Scene State
ChangeSceneState=function( scene, args )
	scene:getFSM():changeState( args["state"] );
end

--Transit Another StateMachine
ChangeScene=function( name )
	GetSceneStateManager():getFSM():changeState( name );
end

--	if args["term"]() then
TriggerVolumeIn=function( scene , args )
	local node = GetSceneManager():get( args["name"] );
	if node then
		local r = args["volumeRadious"];
		local dif = Vec3(0);
		local vpos = args["volpos"];
		dif:setSub( node:position() , vpos );
		if dif:length() < r then
			args["event"]( args["evtData"] );
		end
	end
end
CreateMesh=function( scene , data )
	data["name"] = "image_"..gSerialMeshID;
	GetEventManager():triggerEvent( "CreateMesh" , data );		
	gSerialMeshID = gSerialMeshID + 1;
end
CreateImage=function( scene , data )
	data["name"] = "image_"..gSerialImageID;
	GetEventManager():triggerEvent( "CreateImage" , data );
	gSerialImageID = gSerialImageID + 1;
end
LoadLevel=function( scene , t )
	GetEventManager():triggerEvent("LoadScript", t["levelfile"] );
	GameLib.LevelEditor():deserialize( Level );
	
end

SceneStateFunctions={
	PlaySound=function( scene , args )
		PlaySound( args["name"] );
	end,
	TransitionByInput=TransitionByInput,
	IsProcessMode=IsProcessMode,
	ChangeProcessModeByInput=ChangeProcessModeByInput,
	ChangeProcessMode=ChangeProcessMode,
	IsProcessModeThen=IsProcessModeThen,
	IsPrevStateThen=function( scene , args )
		for k=1,#args["PrevState"],1 do
			if scene:getFSM():prevStateName() == args["PrevState"][k] then
				FindFuncAndExecute( scene , args , StateFunctions );
			end
		end
	end,
	AttachProcess=function( scene , args )
		scene:getProcessor():attachScripted( args["name"] , args["state"] , args["data"] );
	end,
	AttachNode=AttachNode,
	AttachSub=function( scene , args )
		scene:attachSubtitle( args["sub"] );
	end,
	AddButtons=function( scene , args )
		AddButtonList( scene , args["buttons"] , args["data"] );
	end,
	NotifyButtonTriggered=function( scene , args )
		NotifyButtonTriggered( args["buttons"] , args["data"] );
	end,
	Exec=function( scene , args )
		args[1]( args[2] );
	end,
	ExecList=function( scene , args )
		for i=1,#args , 1 do
			args[i]();
		end
	end,
	--Change Scene State
	ChangeSceneState=function( scene, args )
		scene:getFSM():changeState( args["state"] );
	end,
	--Transit Another StateMachine
	ChangeScene=function( scene, args )
		if IsKeyTriggered( " " ) then
			GetSceneStateManager():getFSM():changeState( args["sceneName"] );
		end
	end,
	TriggerVolumeIn=TriggerVolumeIn,
	CreateMesh=function( scene , data )
		data["name"] = "image_"..gSerialMeshID;
		GetEventManager():triggerEvent( "CreateMesh" , data );		
		gSerialMeshID = gSerialMeshID + 1;
	end,
	CreateImage=function( scene , data )
		data["name"] = "image_"..gSerialImageID;
		GetEventManager():triggerEvent( "CreateImage" , data );
		gSerialImageID = gSerialImageID + 1;
	end,
	--V[̓ǂݍ݁Bxt@C(.lua)ǂށB
	LoadScene=function( scene , t ) 
		local f = Framework();	
		--A[JCuǂ?
		if f:isUseArchive() then
			f:loadLuaFromArchive( t["sceneFile"] );
		else
			local path = f:dataPath().."/level/"..t["sceneFile"]; 
			GetEventManager():triggerEvent("LoadScript", path );
		end
		DeserializeLevel( t["name"] , Scene );
		local s = GetPhysicsManager():createPhysicalSceneState( t[ "name" ] , t["name"] );
		GetPhysicsManager():getFSM():initState( t["name"]);
		if t.minHeight then
			s:setMinHeight( t["minHeight"] );
		end
		TriggerEvent( "Scene"..t["name"].."_Loaded" , "data");
--		local rec = t["movableRect"];
--		s:setMovableRect( rec[1] , rec[2] , rec[3] , rec[4] );
--]]
	end,
	SetPhysicalParam=function( scene , t )
		local s = GetPhysicsManager():currentPhysicalSceneState();
		if t.minHeight then
			s:setMinHeight( t["minHeight"] );
		end	
	end,
	QueueEnemy=function( scene , t )
		EnemyQueue.push_back( t );
	end,
	AttachCharacter=function( scene , t )
		local s = GetSceneManager():get( t["name"] );
		_("ATTACH AGENT "..t["name"] );
		local chara = Character.get( t["name"] );
		if t["name"] == "Player" then
			chara:setVisible( true );
		else
--			chara:setVisible( false );
		end
		if t.pos then
			local name = Character.getCharacterName( t["name"] );
			_("SET POS "..name.." "..t["pos"][1].." "..t["pos"][2].." "..t["pos"][3]);
		end
	end,
	TriggerEvents=function( scene , t )
		
	end,
	ClearCharacters=function( scene , t )
		local chara = GetViewManager():view("Character");
		if chara then
			chara:clearNodes();
		end
	end,
	SetCameraPos=function( scene , t )
		local camera = GetSceneManager():camera( t["id"] );
		local look = t["lookAt"];
		local pos = t["pos"];
		camera:setLookatPt( Vec3( look[1], look[2] , look[3] ));
		camera:setPosition( Vec3( pos[1] , pos[2] , pos[3]  ) );
	end,
	AttachView=function( scene , t )
		local v = GetViewManager():view( t );
		GetViewManager():viewController():setCurrentView(  v );	
	end,
	EnterToChangeState=function( scene , t )
		if Enter( "") then
			_("CHANGE SCENE "..t.." 0.2 10" );
		end
	end,
	SetLightPos=function( scene , t )
		gLightDir:set( t[1] , t[2] , t[3] );
	end,
	Ambient=function( scene ,t )
		gAmb:set( t[1] , t[2] , t[3] );
	end,
	SetLightParam=function( scene , t )
		if t["isUse"] then
			local idx =t["index"] ;
			local pos = Vec3( t["pos"][1] , t["pos"][2] , t["pos"][3] );
			local col = Vec3( t["col"][1] , t["col"][2] , t["col"][3] );
			local amb = Vec3( t["amb"][1] , t["amb"][2] , t["amb"][3] );
			local atten = t["atten"];
			if t.wav then
				if t["wav"].R then
					local amp = AbsCosWav( t["wav"]["R"]["amp"] , t["wav"]["R"]["speed"] );
					col.x = amp;
				end
				if t["wav"].G then
					local amp = AbsCosWav( t["wav"]["G"]["amp"] , t["wav"]["G"]["speed"] );
					col.y = amp;
				end
			end
			Native.Graphics.enableLight( true , idx );
			Native.Graphics.enableAttenuate( true , idx );
--[[			local pl = Character.get( "Player");
			if idx == 2 then
				if pl then
--					if pl:animationControl():currentAnimeName() == "ZenchuUp" then
--					if pl:getFSM():currentStateName() == "Guard_State" then
					pos = pl:position();
					pos.y = -1;
					Native.Graphics.setLightPos( pos , idx );
					col = Vec3( 1,0,0 );
					Native.Graphics.setLightColor( col , idx );
				end
			else
				Native.Graphics.setLightPos( pos , idx );
				Native.Graphics.setLightColor( col , idx );
			end
			Native.Graphics.setAttenuate( atten , idx );
			Native.Graphics.setAmbient( amb );			
		else
			local idx =t["index"] ;
--]]
			Native.Graphics.setAmbient( amb );			
			Native.Graphics.setAttenuate( atten , idx );
			Native.Graphics.setLightPos( pos , idx );
			Native.Graphics.setLightColor( col , idx );
			Native.Graphics.enableLight( false , idx );
			Native.Graphics.enableAttenuate( false, idx );			
		end
	end,
	IsLoadTrue=function( scene, t )
		SceneParam["Loading"].isLoad=true;
	end,
	ChangeSceneWhenLoadFinish=function( scene , t )
		if SceneParam["Loading"]["isLoad"] then
			if not GetParser():isParsing() then
				_("CHANGE SCENE "..t["name"].." 0.2 10");
				SceneParam["Loading"].isLoad=false;
			end
		end
	end,
	ChangeSceneLoadFinishAndEnterTriggered=function( scene , t )
--		if SceneParam["Loading"]["isLoad"] then
			if not GetParser():isParsing() then
				if Enter( "" ) then
					_("CHANGE SCENE "..t["name"].." 0.2 10");
--					SceneParam["Loading"].isLoad=false;
				end
			end
--		end		
	end,
	CreateGUIArray=function( scene , t )
		
	end
}



AnimationProcess_State={}
AnimationProcess_State["Initialize"]=function( process , data )
	local agent = process:owner();
process:getAny()["animTime"] = os.clock();
	
	local animCont = agent:animationControl();
	animCont:stopWatch():start(0)	
--	process:setTime(  );
	local smoothWeight = 0.5;
	local smoothSpeed=  0.1;
	local prevanimname = animCont:currentAnimeName();
	
	local atkp = agent:getProcessor():process("AttackHit");
	if atkp then
		atkp:changeMode( Process.INITIALIZING )
	end
--]]
--[[	if IsKeyExist( t , prevanimname ) then--data["animname"]
		t = AnimationParam[ agent:modelName() ][ prevanimname ];
		if IsKeyExist( t , "Smoothing" ) then
			smoothWeight = t[ "Smoothing" ][ "Weight" ];
			smoothSpeed = t[ "Smoothing" ][ "Speed" ];
		end
	end
--]]
--data["Type"]
	if data then
		if data.Type then
			animCont:setAnimation( data["Type"] , data["Name"] , smoothWeight , smoothSpeed );
		--	animCont:setAnimation( "Ryu" , data["Name"] , smoothWeight , smoothSpeed );
			animCont:changeAnimationSpeed( data["Speed"] );
			animCont:setTime( data["Initial"] );
			process:changeMode( Process.ACTIVATED );
		--]]
			--何回アニメーションループしたか
			data["Times"] = 0;
		end
	end
end

function TransFrameMove( v )
	local ret = v * Framework():oneFrameTime() * 60/1000;
	return ret;
end

AnimationProcess_State["Update"]=function( process , data )
	local agent = process:owner();
	local proc = agent:getProcessor();
	local animCont = agent:animationControl();
	local currAnimName = animCont:currentAnimeName();

	--X^~iĂAjXs[h_E
	local prop = Character.getProperty( agent:name() );
	if prop then
		local state = agent:getFSM():currentStateName();
		if ( state == "Attack_State")  and ( 10 > prop["physical"] ) then
			local speed = data["Speed"] * ( prop["physical"] + 50 )/100;
			animCont:changeAnimationSpeed( speed );		
		end
		
	end
	
	if data.process then
		for i=1,#data.process,1 do
			StateFunctions["ChangeProcessMode"]( agent , data.process[ i ] );
		end
	end
	--AjɈړ𔺂
	if data.addDir then
		local dir = Vec3(0,0,1);
		agent:getDirection( dir );
		local t = dir * data["addDir"] ;
		t = TransFrameMove( t );
		agent:addPos( t );
	end
	if data.addNegDir then
		local dir = Vec3(0,0,1);
		agent:getDirection( dir );
		dir:setNeg( dir );
		local t = dir * data["addNegDir"];
		t = TransFrameMove( t );
		agent:addPos(  t );
	end
	if data.SoundKey then
		local skey = data[ "SoundKey" ];
		for i=1,#skey,1 do
			if IsErrorTolerant( animCont:Time() , skey[i][1] , 1 ) then
				GetSoundManager():playSe( skey[i][2] );
			end
		end
	end
	local chdata = Character.getData( agent:name() );
--[[	if chdata.voice then
		if FindByKey( chdata , currAnimName ) then
			GetSoundManager():playSe( ch[ currAnimName ] );
		end
	end
--]]

	if data.Event then
		local evts = data[ "Event" ];
		for i=1,#evts,1 do
			local evt = evts[i];
			if IsErrorTolerant( animCont:Time() , evt["time"] , 3 ) then
				evt["data"]["name"]= agent:name();
				TriggerEvent( "AnimationTime" , evt["data"] );
			end
		end		
	end
	local isR = agent:command():isOn( PSController.PS_RIGHT )
	
	local isPlayAnim = true
	if data.playWhileInputOn then
		isPlayAnim = false;
		for i=1,#data.playWhileInputOn,1 do
			if agent:command():isOn( data.playWhileInputOn[i] ) then
				isPlayAnim = true;
			end
		end
	end
	local any = process:getAny();
	if isPlayAnim then
		--フレーム変換行Eの更新
		animCont:playAnimation();
		if any.animTime then
			local at = any["animTime"];		
			local t = os.difftime( os.clock() , at );
			any["animTime"] = os.clock();
--			animCont:advanceTime( animCont:stopWatch():sec(0) );
			animCont:advanceTime( Framework():oneFrameTime()/1000 );
			animCont:stopWatch():start(0)	
			--時	刻を進める
			animCont:smootherAnimation();
		else	
			return;
		end
	end
	
--	end
	local tp = type( data["Mode"] );
	if tp == "string" then
		if data["Mode"] == "Once" then
			if IsAnimationFinished( agent ) then
				if data.AfterState then
					agent:getFSM():changeState( data["AfterState"] );
				end
				process:changeMode( Process.WAITING );
			end
		elseif data["Mode"] == "Next" then
			local isFin = false;
			if data.End then
				if animCont:Time() >= data["End"] then
					isFin = true;
				end
			elseif IsAnimationFinished( agent ) then
				isFin = true;
			end
			if isFin then
				process:setData( data["next"] );
				process:changeMode( Process.INITIALIZING );
			end
		end
	elseif tp == "number" then
		if IsAnimationFinished( agent ) then
			animCont:advanceTime( 0 );
			data["Times"] = data["Times"] + 1;
			if data["Times"] > data["Mode"] then
				process:changeMode( Process.WAITING );
			end
		end
	end
	if IsKeyExist( data , "particle" ) then
		local eft = data["particle"];
		for i=1,#eft,1 do
			local frmpos = agent:model():findFrame( eft[i]["Position"] ):position();
			local particleData={
				setname=eft[i]["name"],
				pos={frmpos.x , frmpos.y,frmpos.z}
			}
			Particle.trigger( particleData );
			
--[[			local eftDat = {
				position=frmpos,
				lifetime=eft[i]["LifeTime"] ,
				width=eft[i]["Width"] ,
				height=eft[i]["Height"],
				animationname=eft[i]["AnimationName"],
			}
			GetEventManager():triggerEvent( "BillEffect",eftDat );		
--]]
		end
	end	
	
	if IsKeyExist( data , "PosOffset" ) then
		local frmpos = agent:model():findFrame( data["PosOffset"] ):position();
		agent:setPosition( frmpos );
	end
end

--働きっぱなしEプロセスでスチEEトE変わり目を見つけたらアニメーションを変えるかたずねめE
FlipAnimationProcess_State={}
FlipAnimationProcess_State["Update"]=function(process,data)
	local agent=process:owner();
	local currentStateName = agent:getFSM():currentStateName();
	local prevStateName = agent:getFSM():oneFramePrevStateName();
	if not( currentStateName == prevStateName ) then
		if IsKeyExist( data , currentStateName ) then
--					agent:getProcessor():process( "Animation" ):setData( afterList[i]["Animation"] );
			agent:getProcessor():process( "Animation" ):setData( data[ currentStateName ] );
			local arg = {
				ProcessName="Animation" ,
				ProcessMode=Process.INITIALIZING
			}
			StateFunctions["ChangeProcessMode"]( agent , arg );
--						process:changeMode( Process.INITIALIZING );
		end
	end
	agent:getFSM():setOneFramePrevStateName( currentStateName );
end

AgentDyingProcess_State={}
AgentDyingProcess_State["Initialize"]=function( process ,data)
	local agent = process:owner();
	data["Alpha"] = 255;
	local stat = agent:getFSM():currentStateName();
	local canDead = ( stat == "Down_State" ) or ( stat == "FaceDownLand_State" );
	if( agent:hitpoint() <= 0 and  canDead ) then
		agent:getFSM():changeState( "Dead_State" );
		data["Time"] = os.clock();
		process:changeMode( Process.ACTIVATED );
	end
end
AgentDyingProcess_State["Update"]=function( process ,data)
	local agent = process:owner();
	
	AgentDie( agent , data["Alpha"] );
	data["Alpha"] = data["Alpha"] - 2;
	if data["Alpha"] < 0 then
		data["Alpha"] = 0;
	end
--	agent:model():setAlpha( AbsCosWav(255,3)/255 );
--	Blinking( agent:model() , 128 , 10 , 255 , 0 );
	if os.difftime( os.clock() , data["Time"] ) > data["disappearTime"] then
		agent:activate( false );
		_("VISIBLE "..agent:name().." false");
--		agent:setVisible( false );
--		AgentDie( agent , 0 );
--		agent:getFSM():changeState("Wait_State");
		local agentStateData={
			name=agent:name(),
		}
		local role = Character.getRollType( agent:name() );
		if ( role == "Player" ) or ( role == "Player2" ) then
			TriggerEvent("PlayerDead",agentStateData );
		else
			TriggerEvent("EnemyDead",agentStateData );
		end
		process:changeMode( Process.INITIALIZING );
	end
end

AttackHitProcess_State={}
AttackHitProcess_State["Initialize"] = function( process , data )
	local agent = process:owner();
	local col = Native.PhysicsManager():collision( agent:name() );
	Native.PhysicsManager():setContactDelayTick( 5 );
	if col then
		process:getAny()["collision"] = col;
		col:enableDetect( false );
	end
	local animname = agent:animationControl():currentAnimeName();
	if IsKeyExist( data , animname ) then
		Native.PhysicsManager():enableDetectAllPair( true );
		process:changeMode( Process.ACTIVATED );
	end	
end
AttackHitProcess_State["Update"] = function( process , data )
	local col = nil;
	if process:getAny().collision then
		col = process:getAny()["collision"];
	else
		process:changeMode( Process.INITIALIZING );
		return;
	end
	local agent = process:owner();
	local animname = agent:animationControl():currentAnimeName();
	local modelname=agent:modelName();
	if not IsKeyExist( data , animname ) then
		process:changeMode( Process.INITIALIZING );
		return;
	end
	local aData = data[ animname ];
	local hitframename = aData[ "HitFrameName" ];
	local tm =agent:animationControl():Time();
	if aData[ "BeginTime" ] <  tm then
		--Now Start Detecting the Hit Frame Part
--		Native.PhysicsManager():enableDetectAllPair( true );
		col:enableDetect( hitframename , true );
	elseif aData[ "EndTime" ] < tm then
		col:enableDetect( false );
		process:changeMode( Process.WAITING );		
	end
	local animCont = agent:animationControl();
	if data.HitRevivalTime then
		local t =  data["HitRevivalTime"];
		local col = Native.PhysicsManager():collision( agent:name() );
		if col then
			for i=1,#t,1 do
				if IsErrorTolerant( animCont:Time() , t[i] , 1 ) then
--				if math.floor(animCont:Time()) == t[i] then
--[[					local atkp = agent:getProcessor():process("AttackHit");
					if atkp then
						atkp:changeMode( Process.INITIALIZING )
					end
--]]					--process:changeMode( Process.INITIALIZING );
					Native.PhysicsManager():enableDetectAllPair( true );
					col:enableDetect( true );
					col:enableDetect( hitframename , true );	

					break;
				end
			end
		end
	end
--]]
end

ItemGetProcess_State={}
ItemGetProcess_State.Update=function( p , d )
	local agent = p:owner();
	local name = agent:name();
	local prop = Character.getProperty( name );
	if prop.ItemGettable then
		if prop.ItemAttach then
			if prop["ItemGettable"] then
				if agent:command():isTriggered( A ) then
--					agent:getFSM():changeState( "GetItem_State" );
				end
			elseif prop["ItemAttach"] then
				if agent:command():isTriggered( B ) then
--					agent:getFSM():changeState( "ThrowItem_State" );
				end
			end	
		end
	end
end

CommandProcess_State={}
CommandProcess_State["Initialize"]=function(process,data)
	process:setTime( os.clock() )
	local o= process:getAny();
	
	o["pos"] = 1;
	o["isFinish"] = false;
--	data["Time"] = os.clock();
--	data["Pos"]=1;
	local agent = process:owner();
	local prop = Character.getProperty( agent:name() );
	if data.Before then
		for i=1,#data["Before"],1 do
			local t = data["Before"][i];
			if agent:getFSM():currentStateName() == data["Before"][i] then
				process:changeMode( Process.ACTIVATED );
				break;
			end
			if IsKeyExist( prop , t ) then
				if prop[ t ] then
					process:changeMode( Process.ACTIVATED );
					break;
				end
			end			
		end
	else
		process:changeMode( Process.ACTIVATED );		
	end
	--]]
end

gThrowData1={

}
gThrowData2={

}

CommandProcess_State["Update"]=function(process,data)
--Dout("Command Process Running" );
	local agent = process:owner();
	local cont = agent:command();
	if data.LimiteSec then
		if os.clock() -process:timeStamp() > data["LimiteSec"] then	
--		if os.clock() - data["Time"] > data["LimiteSec"] then
			SetPrevCommandData( process , data );
			process:changeMode( Process.INITIALIZING );
			return;
		end
	end
	local HaveBeforeState=false;
	local prop = Character.getProperty( agent:name() );
	if data.Before then
		for i=1,#data["Before"],1 do
			local t = data["Before"][i];
			if agent:getFSM():currentStateName() == t then
				HaveBeforeState = true;			
				break;
			end
			if not HaveBeforeState then
				if IsKeyExist( prop , t ) then
					if prop[ t ] then
						HaveBeforeState = true;			
						break;
					end
				end
				
			end
		end
	end
	if not HaveBeforeState then
		process:changeMode( Process.INITIALIZING );
		return;
	end
	local o = process:getAny();
	local isTrigger =  ( o["pos"] <= #data["Command"] )
	if data.trigger then
		isTrigger = not ( o["isFinish"] );
	end
	if isTrigger then
--		local com = data["Command"][ o["pos"] ];
--		if ConvertCommand( agent , com[1] , com[2] ) then
		if data.CommandType then
			if data["CommandType"] == "isOn" then
				if agent:command():isOn( data["Command"][ o["pos"] ] )  then
					o["pos"] = o["pos"] +1
				end
			end
		else
			local bt = data["Command"][ o["pos"] ];
			if cont:isTriggered( bt )  then
				if data.InnerPro then
					if bt == PSController.PS_DIR then
						local left = cont:isTriggered( PSController.PS_LEFT );
						local right = cont:isTriggered( PSController.PS_RIGHT );
						local up = cont:isTriggered( PSController.PS_UP );
						local down = cont:isTriggered( PSController.PS_DOWN );
						local vec1 = Vec3( -1,0,0);
						local vec2 = Vec3(0);
						agent:getDirection( vec2 );
						vec2:normalize();
						if left then
							vec1= Vec3( -1,0,0);
						elseif right then
							vec1= Vec3( 1,0,0);
						elseif up then
							vec1= Vec3( 0,0,1);
						elseif down then
							vec1= Vec3( 0,0,-1);
						end						
						local ip = vec1:dot( vec2 );
						if not ( ( data["InnerPro"][1] <= ip ) and ( ip <= data["InnerPro"][2] ) ) then
							return;
						end
					end
				end
				o["pos"] = o["pos"] +1
			end
		end
	else
		o["isFinish"] = false;
		if data.AnimationData then
			ChangeAnim( agent , data["AnimationData"] );
		end
		if data.type then
			if data["type"] == "throw" then
				local t1=GetProcessManager():process("throw1");
				local t2=GetProcessManager():process("throw2");
				local throwData={
					throwerName= agent:name(),
					param=data,
				}
				if t1:getAny()["isReady"] then
					t1:changeMode( Process.INITIALIZING );
					t1:setData( throwData );
				elseif t2:getAny()["isReady"] then
					t2:changeMode( Process.INITIALIZING );
					t2:setData( throwData );					
				end
			end
		end
		if data.After then
			agent:getFSM():changeState( data["After"] );
		end
		--͂ł鑊肪ꍇɁÃvZXZ̃R}hł
		--𓊂ԁA𓊂ԂɁB
		if data.GrappledAfter then
			if prop.grappleTarget then
				local grappled = GetSceneManager():get(  prop["grappleTarget"] );
				if grappled then
					grappled:getFSM():changeState( data["GrappledAfter"] );					
					ChangeAnim( grappled , data["GrappledAnimationData"] );
				end
			end
		end
		SetNextOrPrevCommandData( process , data );
		process:changeMode( Process.INITIALIZING );	
	end	

--]]
end

function SetPrevCommandData( process , data )
	if data.prev then
		process:setData( data["prev"] );
	end
end

function SetNextOrPrevCommandData( process , data )
	if data.next then
		process:setData( data["next"] );
	else
		if data.prev then
			process:setData( data["prev"] );
		end
	end
end

gGrapplePairs={}
gCharaNames={
	"Player",
	"Player2",
	"Player3",
	"Zako1",
	"Zako2",	
	"Zako3",
	"Zako4",
	"Zako5",
	"Zako6",
	"Boss1",
	"Boss2",
	"Boss3",
	"Boss4",
}

function IsEnemyEachOther( a , b )
	if not string.find( a:name() , "Player" ) then
		if not string.find( b:name() , "Player" ) then
			return true;
		end
	end
	return false;
end

GrapplerProcess_State={}
GrapplerProcess_State["Update"]=function(process,data)
	local grappler=process:owner();
	local grappled = nil;
	local grapplerName = grappler:name();
	local currentStateName = grappler:getFSM():currentStateName();
	local SM = GetSceneManager();
--	local grapplerProp = Character.getProperty( grappler:name() );
	local prop = Character.getProperty( grappler:name() );
	if currentStateName == "Walk_State" or currentStateName == "Run_State" or 
	currentStateName == "Wait_State" then
		for i=1,#gCharaNames,1 do
			grappled = Character.get( gCharaNames[i]);
			if grappled then
				if not ( grappler:name() == grappled:name() ) then
					if grappled:getFSM():currentStateName() == "MiddleDamaged_State"
									or
					grappled:getFSM():currentStateName() == "Grappled_State" then
						local sub = Vec3();
						sub:setSub( grappler:position() , grappled:position() );
						local len = sub:length();
						if 1 <= len and len < 2 then
--							grapplerProp["close"] = true;
							if grappler:command():isTriggered( A ) then--IsKeyTriggered("m") then --PSController.PS_CIRCLE
								local p = grappler:getProcessor():process( "Animation" );
								p:setData( AnimationParam["Ninja"]["JumpRollingKick"] );
								local arg = {
									ProcessName="Animation" ,
									ProcessMode=Process.INITIALIZING
								}
								StateFunctions["ChangeProcessMode"]( grappler , arg );			
								grappler:getFSM():changeState( "Attack_State" );
							end
--							grappler:getProcessor():process( grappler:name().."finish1Command" ):getAny()["isFinish"] = true;
--]]
						elseif len < 1 then
							GetSoundManager():playSe( "Tsukami" );
							grappler:getFSM():changeState( "Grappling_State" );
							grappled:getFSM():changeState( "Grappled_State" );
							grappled:setAngle( grappler:angle() );
							local grpName = grappled:name();
							gGrapplePairs[ grappler:name() ] = grpName;
							gGrapplePairs[ grappled:name() ] = "none";
							prop["grappleTarget"] = grpName;	
							break;
						else
--							grapplerProp["close"] = false;
						end
					end
				end
			end
		end
	end
	if currentStateName == "Throw_State" then
		grappled = SM:get( prop["grappleTarget"] );
		if grappled then
--		if prop.grappleTarget then
			local v = grappler:angle() ;
--			v.y = v.y + 180;
--grappled:enableAI( false );
			grappled:setAngle( v );
		end
	else
		
	end
end

GrappledProcess_State={}
GrappledProcess_State["Initialize"]=function(process,data)
	local grappled=process:owner();
	local currentStateName = grappled:getFSM():currentStateName();
	if currentStateName == "Grappled_State" then
		process:changeMode( Process.ACTIVATED );
	end
end
GrappledProcess_State["Update"]=function(process,data)
	local grappled=process:owner();
	local currentStateName = grappled:getFSM():currentStateName();
	if currentStateName == "Grappled_State" then 
		
	else
		process:changeMode( Process.INITIALIZING );
		
	end
end

gThrowTechList={
--	BackDrop=,
--	SakasaOtoshi=,
	
}

ThrowProcess_State={}
ThrowProcess_State["Initialize"]=function(process,data)
	if data.throwerName then
		local throwerName = data["throwerName"];
		local thrower= GetSceneManager():get( throwerName );
		if IsKeyExist( gGrapplePairs , throwerName ) then
			local thrown= GetSceneManager():get( gGrapplePairs[ throwerName ] );
			if thrown and thrower then
--				thrown:getFSM():changeState( "Thrown_State" );--data["param"]["thrownChangedState"] );
				thrown:getFSM():changeState( data["param"]["thrownChangedState"]  );
				StateFunctions["SetAnimationData"]( thrown , data["param"]["damagedAnimationData"] )
--[[				if data["param"].processOn then
					local p = thrower:getProcessor():process( data["param"]["processOn"] );
					p:changeMode( Process.INITIALIZING );
				end
				if data["param"].damagedProcessOn then
					local p = thrown:getProcessor():process( data["param"]["damagedProcessOn"] );
					p:changeMode( Process.INITIALIZING );
				end
--]]
				process:getAny()["isReady"] = false;
				process:changeMode( Process.ACTIVATED );
			else
				process:getAny()["isReady"] = true;
				process:changeMode( Process.WAITING );
			end
		end
	else
		process:getAny()["isReady"] = true;
		process:changeMode( Process.WAITING );
	end
end
ThrowProcess_State["Update"]=function(process,data)
	local throwerName = data["throwerName"];
	local thrower= GetSceneManager():get( throwerName );	
	if IsKeyExist( gGrapplePairs , throwerName ) then
		local thrown= GetSceneManager():get( gGrapplePairs[ throwerName ] );
		local t = thrower:animationControl():Time();
		if data["param"]["damageTime"] <= t then
			thrown:damage( data["param"]["damagePoint"] );
			thrown:getFSM():changeState( "BlewUp_State" );--data["param"]["thrownAfterState"] );
--			thrown:getFSM():changeState( "Down_State" );--data["param"]["thrownAfterState"] );
			process:getAny()["isReady"] = true;
			data = {};
			gGrapplePairs[ throwerName ] = "none";
			process:changeMode( Process.WAITING );
		else
			if data.attachPos then
				local pos = thrower:model():findFrame( data["param"]["attachPos"] ):position();
				thrown:setPosition( pos );
			end
		end	
	else
		process:getAny()["isReady"] = true;
		process:changeMode( Process.WAITING );	
	end
end


TranslateProcess_State={}
--TranslateProcess_State["Initialize"]=function( process,data )
--end
TranslateProcess_State["Update"]=function( process,data )
	local agent = process:owner();
	local isExec = false;
	local currentStateName = agent:getFSM():currentStateName() ;
	if data.ActivateState then 
		for i=1,#data["ActivateState"],1 do
			if data["ActivateState"][i] == currentStateName then
	--			local dir = Vec3();
	--			agent:getDirection( dir );
	--			dir:setNeg( dir );
				isExec = true;
			end
		end
	end
	local currentAnimName = agent:animationControl():currentAnimeName();
	if data.Animation then 
		for i=1,#data["Animation"],1 do
			if data["Animation"][i] == currentAnimName then
				isExec = true;
			end
		end
	end
	--]]
	if isExec then
		if data["Type"] == "Add" then
			local move= data["Dir"] * data["Speed"];
			agent:addPos( move );
		elseif  data["Type"] == "Set" then
			agent:setPosition( data["Dir"] * data["Speed"] );
		else end
	end
--	if Native.Methods.CurrentSceneState():physicalScene():hitTestWall( agent ) then
--[[	local wallHit = GetPhysicsManager():currentPhysicalSceneState():hitTestWall( agent );
	if wallHit then
		if currentStateName == "BlewUp_State" 
							or 
			currentStateName == "BlewDown_State" then
				agent:getFSM():changeState( "BoundDown_State" );
			end
	end
--]]
--	local v = agent:prevMove();
--	v.y = 0;
--	agent:addPos( v/2 );
--]]
end

InertiaProcess_State={}
InertiaProcess_State["Initialize"]=function( process,data )
	local agent = process:owner();
	local prev = agent:prevMove();
	process:getAny()["time"] =  os.clock();
	process:getAny()["dir"] = prev;
	process:getAny()["length"] = prev:length();
	if agent:getFSM():prevStateName() == "Run_State" then
		if agent:getFSM():currentStateName() == "Wait_State" then
			if  ( data["inertiaThreashold"][1] < math.abs( prev.x )  )
						or
				( data["inertiaThreashold"][2] < math.abs( prev.z ) ) then
					process:getAny()["dir"]:normalize();
					process:changeMode( Process.ACTIVATED );
			end
		end
	end
end
InertiaProcess_State["Update"]=function( process,data )
	local agent = process:owner();
Dout2(500,100,"Inertia!!!"..agent:name() ,0xffff0000 );
--	process:getAny()["time"]
	local any = process:getAny();
	any["length"] = any["length"] * 0.01;
	local mov = any["dir"];
	mov.x = mov.x * any["length"]
	mov.z = mov.z * any["length"]
Dout2(500,120,"Inertia!!!"..mov.x ,0xffff0000 );
	
--	if agent:getFSM():currentStateName() == "Wait_State" then
		agent:addPos( mov );
--	end
	if  ( data["inertiaThreashold"][1] > math.abs( mov.x )  )
				and
		( data["inertiaThreashold"][2] > math.abs( mov.z ) ) then
			process:changeMode( Process.WAITING );
	end		
end

RotateProcess_State={}
RotateProcess_State["Update"]=function( process,data )
	local agent = process:owner();
	local isExec = false;
	local currentStateName = agent:getFSM():currentStateName() ;
	if IsKeyExist( data , "ActivateState" ) then 
		for i=1,#data["ActivateState"],1 do
			if data["ActivateState"][i] == currentStateName then
	--			local dir = Vec3();
	--			agent:getDirection( dir );
	--			dir:setNeg( dir );
				isExec = true;
			end
		end
	end
	local currentAnimName = agent:animationControl():currentAnimeName();
	if IsKeyExist( data , "Animation" ) then 
		for i=1,#data["Animation"],1 do
			if data["Animation"][i] == currentAnimName then
				isExec = true;
			end
		end
	end
	if isExec then
		if data["Type"] == "Add" then
			agent:addAngle( data["Angle"] );	
		elseif  data["Type"] == "Set" then
			agent:setAngle( data["Angle"] );	
		else end
	end
	--]]
end
	
gCnt = 0	
gTimeSum = 0;
gTime=0;
MoveProcess_State={}
MoveProcess_State["Initialize"]=function( process  ,data )
	local agent = process:owner();
	local data={
		name=agent:name(),
	}
--	GetEventManager():queueEvent( "AgentMoved" , data );
	process:getAny()["timer"] = StopWatch();
	process:getAny()["timer"]:start(0);
	process:changeMode( Process.ACTIVATED );
end
MoveProcess_State["Update"]=function( process  ,data )
	local agent = process:owner();
	local timer = process:getAny()["timer"];	
	local move = Vec3(0);
	local Speed = 0;
	local CurrentStateName = agent:getFSM():currentStateName();
	local prevStateName = agent:getFSM():prevStateName();
	local command = agent:command();
	local isPlayer = not ( command:id() == Native.CharaID["AI"] )--string.find( agent:name() , "Player" );	
	
	if CurrentStateName == "Walk_State" or 
		CurrentStateName == "Land_State"	then
		Speed = data[ "WalkSpeed" ];
	elseif CurrentStateName == "Run_State" then
		Speed = data[ "RunSpeed" ];
--		if not command:isPushed( Pad.BUTTON_R1 )  then
--			agent:getFSM():changeState("Walk_State" );
--		end
	elseif CurrentStateName == "JumpUp_State" then
		if prevStateName == "Walk_State" then
			Speed = data[ "MoveSpeedWhileJumpUpFromWalk" ];
		elseif prevStateName == "Run_State" then
			Speed = data[ "MoveSpeedWhileJumpUpFromRun" ];
		elseif prevStateName == "Wait_State" then
			Speed = data[ "MoveSpeedWhileJumpUpFromWait" ];
		end
	elseif CurrentStateName == "Fall_State" then
		Speed = data[ "MoveSpeedWhileFall" ];
	else
	end
	
	local isUp = command:isOn( PSController.PS_UP );
	local isDown = command:isOn( PSController.PS_DOWN )
	local isLeft = command:isOn( PSController.PS_LEFT )
	local isRight = command:isOn( PSController.PS_RIGHT )
--[[	if MoveAnalog then
		isUp =  command:isOn( PSController.PS_ANALOG_UP );
		isDown = command:isOn( PSController.PS_ANALOG_DOWN ) 
		isLeft = command:isOn( PSController.PS_ANALOG_LEFT ) 
		isRight = command:isOn( PSController.PS_ANALOG_RIGHT ) 
	end
--]]
	if isLeft then
		move.x = - Speed;
	elseif isRight then
		move.x = Speed;
	else end
	if isUp then
		move.z = Speed;
	elseif isDown then
		move.z = -Speed;
	else end
--	local msec = timer:milliSec(0)
--	timer:start(0);
	local msec = Framework():oneFrameTime();
Dout( "msec ."..msec );	
	move.x = move.x * msec * 60/1000;
	move.z = move.z * msec * 60/1000;
	
	if CurrentStateName == "Ladder_State" then
		local Speed = 0.1;
		if isUp then
			move.y = Speed;
		elseif isDown then
			move.y = -Speed;
		end		
	end
--]]
	if isPlayer then
		ViewCoordTransform( move );
--		agent:viewCoordMove( move );
	end
--]]	
	if not ( move.x == 0 and move.y==0 and move.z==0 ) then
		local agent = process:owner();
		local m = agent:move();
		local data={
			name=agent:name(),
			move={ m.x ,m.y,m.z },
		}
--		GetEventManager():queueEvent( "AgentMoved" , data );
		local radY = math.atan2( move.x , move.z ) - math.rad(180);
		local angle = Vec3( 0,math.deg(radY),0);
--[[		if move.x > 0 then
			local angle = Vec3( 0,-90,0);
			agent:setAngle( angle );
		elseif move.x < 0 then
			local angle = Vec3( 0,90,0);
			agent:setAngle( angle );
		end
--]]
		if CurrentStateName == "Ladder_State" then
			move.x =0;
			move.z = 0;
		else
			if isPlayer then			
				agent:setAngle( angle );
			end
--]]
		end
		agent:addPos( move );
	end
end

JumpUpProcess_State={}
JumpUpProcess_State["Initialize"]=function( process , data )
	local jumper = process:owner();
	local dir = Vec3(0,0,1);
	jumper:getDirection( dir );
	process:getAny()["dir"] = dir;
	process:setTime( os.clock() )
	process:changeMode( Process.ACTIVATED );
end
JumpUpProcess_State["Update"]=function( process , data )
	local dir = process:getAny()["dir"];
	local jumper = process:owner();
	local t = os.clock() - process:timeStamp();
	local current = jumper:getFSM():currentStateName();
	local upper = 0;
	if current == "JumpUp_State" then
		upper = 2 * data["JumpSpeed"] * math.sqrt( data["JumpHeight"] * t );
		dir.x = 0;
		dir.z=0;
	elseif current == "BlewUp_State" then
		upper = 2 * data["BlewUpSpeed"] * math.sqrt( data["BlewUpHeight"] * t );
		dir.x = -dir.x;
		dir.z = -dir.z;
	elseif current == "BlewUpDown_State" then
		upper = 2 * data["BlewUpSpeed"] * math.sqrt( data["BlewUpHeight"] * t );
		dir.x = -dir.x;
		dir.z = -dir.z;
	end
	local pos = jumper:position();
	local dy = upper - t * t;
	local move = Vec3( dir.x*0.1 , dy , dir.z*0.1 );
	jumper:addPos( move );
	if dy < 0 then
		process:changeMode( Process.WAITING );
	end
	--]]
end

GravityProcess_State={}
GravityProcess_State["Initialize"]=function( process,data)
	process:setTime( os.clock() )
	local level = GetLevelManager():getFSM():currentState();
	local fallling = process:owner();
	pos = Vec3( falling:position() );
	if not level:isOnFloor( falling ) then
		process:changeMode( Process.ACTIVATED );
	end
	--]]
end
GravityProcess_State["Update"]=function( process,data)
	local level = GetLevelManager():getFSM():currentState();
	local fallling = process:owner();
	local t = os.clock() - process:timeStamp();
	local dy = - t * t;
	local move = Vec3( 0 , dy , 0 );
	falling:addPos( move );
	local pos = Vec3( falling:position() );
	if level:isOnFloor( falling ) then
--		falling:setPosition( pos ); 
		process:changeMode( Process.INITIALIZING );
	end
--]]
end		

LadderProcess_State={}
LadderProcess_State["Initialize"]=function( process  ,data )
	local agent = process:owner();
	local name = agent:name();
	local prop = Character.getProperty( name );
	if prop then
		if prop.hitWallMesh then
			if agent:getFSM():currentStateName() == "Ladder_State" then
				process:changeMode( Process.ACTIVATED );			
			end
		end
	end
end
LadderProcess_State["Update"]=function( process  ,data )
	local agent = process:owner();
	local prop = Character.getProperty( name );
	if not agent:getFSM():currentStateName() == "Ladder_State" then
		process:changeMode( Process.INITIALIZING );
		return;
	end
	if prop then
		if prop.hitWallMesh then
			local dir = Vec3();
			agent:getDirection( dir );
			local ray = Ray();
			ray = agent:position() + dir * 5;
			local mesh = GetSceneManager():get( prop["hitWallMesh"] );
			local inters =Vec3();
			local isInter = mesh:isRayIntersect( ray , inters );
		end
	end
--[[	local move = Vec3(0);	
	local command = agent:command();
	local isUp = command:isOn( PSController.PS_UP )
	local isDown = command:isOn( PSController.PS_DOWN )
	
	agent:addPos( move );
--]]
end


function CreateCharacterImpl( data )
	local rotateData={
		Angle=Vec3( 0, 0 , 0  ),
		ActivateState={
			"BlewUp_State","BlewDown_State"
		},
	--[[	Animation={
			"MartialWait"
		},
	--]]	Type="Add",
	}
	local grappleMode = Process.WAITING;
	if data.grappler then
		grappleMode = Process.ACTIVATED;
	end
	local jagData={
		name=data["name"],
		time = 200,
		jagX ={ 0.13 , 100 },
		jagY ={ 0.02 , 100 },
		jagZ ={ 0.13 , 100 },
	}
	local physData={ 
		name=data["name"] ,
		fatigability=data["fatigability"] ,
		elapsedMilli = 0,
		prevState = "",
	}
	data["process"] = {
--		FlipAnimationCommon={ state=FlipAnimationProcess_State , data=FlipAnimationData[ "Common" ] ,  mode=Process.ACTIVATED} , 
		FlipAnimation={ state=FlipAnimationProcess_State , data=FlipAnimationData[ data["battleStyle"] ] ,  mode=Process.ACTIVATED} , 
		BlewUpTranslate={ state=TranslateProcess_State , data=GetTable() ,  mode=Process.ACTIVATED },
		Rotate={ state=RotateProcess_State , data=rotateData ,  mode=Process.ACTIVATED },
		JumpUp={ state=JumpUpProcess_State , data=data["moverData"] ,  mode=Process.WAITING },
		Move={ state=MoveProcess_State , data=data["moverData"] ,  mode=Process.WAITING },
--		Inertia={ state=InertiaProcess_State , data=data["moverData"] ,  mode=Process.INITIALIZING },
		MiddleDamagedWait={ state=WaitProcess_State , data={ time=1 ,after=Process.WAITING } ,  mode=Process.WAITING },
		Animation={ state=AnimationProcess_State , data={} ,  mode=Process.WAITING },
		Grappler={ state=GrapplerProcess_State , data=GetTable() ,  mode=grappleMode };
		Grappled={ state=GrappledProcess_State , data=GetTable() ,  mode=Process.INITIALIZING },
--		AttackHit={ state=AttackHitProcess_State , data=AttackHitProcessData[ data["battleStyle"] ] ,  mode=Process.INITIALIZING },
--		Health={ state=HealthProcess_State , data=data ,  mode=Process.INITIALIZING },		
		Dying={ state=AgentDyingProcess_State , data={ disappearTime=2 } ,  mode=Process.INITIALIZING },		
--		ItemGet={ state=ItemGetProcess_State , data={} ,  mode=Process.INITIALIZING },
		AttackHit={ state=AttackHitProcess_State , data=AttackHitProcessData ,  mode=Process.INITIALIZING },
		JagMoved={ state=JagMoverProcess , data=jagData , mode=Process.WAITING } ,
--		Damage={ state=DamageProcess , data={} , mode=Process.INITIALIZING } ,
		Physical={ state=AgentPhysicalProcess ,  data=physData , mode=Process.ACTIVATED } ,
--]]
	}
	--iX^Cɋʂ̃tbvAj[VZbg
	for k,v in pairs( FlipAnimationData[ "Common" ] ) do
		--łɃZbgĂ΂ȂɂȂ
		if not IsKeyExist( FlipAnimationData[ data["battleStyle"] ] , k ) then
			FlipAnimationData[ data["battleStyle"] ][ k ] = v;
		end
	end
	data["stateList"]=Agent_StateMap;	
	if data.isDestroyObject then
		data["stateList"]=DestroyObject_StateMap;	
	end
	
	data["command"]={}
	if data.specialCommand then
		if IsKeyExist( SpecialCommandData , data["specialCommand"] ) then
			table.insert( data["command"] , SpecialCommandData[ data["specialCommand"] ] );
		end	
	end
	table.insert( data["command"] , BasicCommandData[ data["battleStyle"] ] );
	table.insert( data["command"] , AttackCommandData[ data["battleStyle"] ] );
	
	local agent = Native.Methods.CreateFighter( data["name"] , GameLib.JoystickID.AI , data );	
	Character.collection[ data["name"] ] = { 
		instance = agent,
		data=data,
	}
	Character.property[ data["name"] ] = {};
	Character.property[ data["name"] ]["accumDamage"] = 0;
	Character.property[ data["name"] ]["blowUp"] = false;
	Character.property[ data["name"] ]["physical"] = 100;
	return agent;
end


function DecorateAgentImpl( agent , data )	
	if IsKeyExist( data , "mesh" ) then
		for i=1,#data["mesh"],1 do
			local t = data["mesh"][i];
			GameLib.AddParts( agent , t );
		end
	end
	if IsKeyExist( data , "head" ) then
		GameLib.AddParts( agent , data["head"] );
	end
	if data.material then
		for i=1,#data["material"],1 do
			local t = data["material"][i];
			agent:model():changeMaterial( t[1] , t[2] , t[3] );
		end
	end
	if IsKeyExist( data , "process" ) then
		AddProcessList( agent,data["process"] );
	end
--[[	if IsKeyExist( data , "AI_process" ) then
		Character.property[ data["name"] ]["AI_ProcessMap"] = {};
		local procTbl = Character.property[ data["name"] ]["AI_ProcessMap"];
		for k,v in pairs( data["AI_process"] ) do
			local proc = GameLib.AddAI_ProcessToAgent( agent , k ,v["state"],v["data"] );
			proc:changeMode( v["mode"] );
			procTbl[ k ] = proc;
		end
	end
--]]	if IsKeyExist( data , "command" ) then
		for i=1,#data["command"] ,1 do
			for k,v in pairs(data["command"][i] ) do
				GameLib.AddProcessToAgent( agent , agent:name()..k.."Command" , CommandProcess_State , v );
			end
		end
	end
	if IsKeyExist( data , "InitialAnimation" ) then
		agent:getProcessor():process( "Animation" ):setData( data["InitialAnimation"] );
	end
	for i=1,#gJoystickButtonMap,1 do
		agent:command():setJoystickButtonToCommand( gJoystickButtonMap[i][1] , gJoystickButtonMap[i][2] );
	end
	for i=1,#gKeyMap,1 do
		agent:command():setKeyboardToCommand( CharToNum( gKeyMap[i][1] ) , gKeyMap[i][2] );
	end
	--Register to Collision 
	if IsKeyExist( CollisionMol , data["collision"] ) then
		GetPhysicsManager():createCollision( data["name"] , agent:model() , CollisionMol[ data["collision"] ] );
	end
	
end

function CreateTechParam( param)
	local ret = CopyData( param["param"] );
	ret.Mode="Next";
	if param.initial then
		ret.Initial = param["initial"];
	end
	if param.speed then
		ret.Speed = param["speed"];
	end
	if param.End then
		ret.End = param["End"];
	end
	if param.addDir then
		ret.addDir = param["addDir"];
	end
	return ret;
end

Tech={}
Tech.list={}
Tech.create=function( techparamlist )
	local t={}
	local technum = #techparamlist;
	for i=1,technum,1 do
		table.insert( t , CreateTechParam( techparamlist[i] ) );
	end
	for i=1,#t-1,1 do
		t[i].Mode= "Next";
		t[i].next= t[i+1];
	end
	t[ #t ].Mode=techparamlist[ technum ]["param"]["Mode"];
	return t[1];
end

AnimationParam["FightClubScene"]={}
AnimationParam["FightClubScene"]["Player"]={
	Type="FightClubScene",
	Name="Player",
	Speed = 0.5,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["FightClubScene"]["Enemy"]={
	Type="FightClubScene",
	Name="Enemy",
	Speed = 0.5,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["FightClubScene"]["MachoPause"]={
	Type="FightClubScene",
	Name="MachoPause",
	Speed = 0.6,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Boxing"]={}
AnimationParam["Boxing"]["Wait"] ={
	Type="Boxing",
	Name="Wait",
	Speed = 0.5,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Boxing"]["Run"] ={
	Type="Boxing",
	Name="Run",
	Speed = 1,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Boxing"]["Walk"] ={
	Type="Boxing",
	Name="Walk",
	Speed = 1,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Boxing"]["HookL"] ={
	Type="Boxing",
	Name="HookL",
	Speed = 2.5,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 10 , "swing03" }
	},
	particle={
		{ name="particleYellow" , Position="HandL_Joint"  }
	},
}
AnimationParam["Boxing"]["HookR"] ={
	Type="Boxing",
	Name="HookR",
	Speed = 2.5,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 10 , "swing03" }
	},
	particle={
		{ name="particleYellow" , Position="HandR_Joint"  }
	},
}
AnimationParam["Boxing"]["MiddleHookL"] ={
	Type="Boxing",
	Name="MiddleHookL",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 10 , "swing03" }
	},
}
AnimationParam["Boxing"]["StraightPunch"] ={
	Type="Boxing",
	Name="StraightPunch",
	Speed = 1.5,
	Initial = 0,
	Mode="Once",
--	addDir=0.1,
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 10 , "tm2_swing000" }
	},
}
AnimationParam["Boxing"]["UpperCut"] ={
	Type="Boxing",
	Name="UpperCut",
	Speed = 1.4,
	Initial = 0,
	addDir=0.01,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "tm2_swing000" }
	},
	particle={
		{ name="particleBlue" , Position="HandR_Joint"  }
	},
	
}
AnimationParam["Common"]={}
AnimationParam["Common"]["KubikariNageThrown"] ={
	Type="Common",
	Name="KubikariNageThrown",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	addDir=0.03,
	Smoothing={
		Weight=0,
		Speed=0
	},
	Event={ 
		{ time=45 , data={ type="BackDropped"} },	
	},
}
AnimationParam["Common"]["SuperBackDropped"] ={
	Type="Common",
	Name="SuperBackDropped",
	Speed = 0.7,
	Initial = 0,
	Mode="Once",
	addDir=-0.05,
	SoundKey={
		{ 36 , "hit57" },
	},
	Event={ 
		{ time=45 , data={ type="BackDropped"} },	
	},
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Common"]["Dogeza"] ={
	Type="Common",
	Name="Dogeza",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Common"]["BatanPikuPiku"] ={
	Type="Common",
	Name="BatanPikuPiku",
	Speed = 0.7,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Common"]["Kawashi"] ={
	Type="Common",
	Name="Kawashi",
	Speed = 2,
	Initial = 0,
	Mode="Once",
	addDir=-0.035,
	SoundKey={
		{ 20 , "swing05" },
	},
	Smoothing={
		Weight=0,
		Speed=0
	},
}

AnimationParam["Common"]["RelaxingWaitLean"] ={
	Type="Common",
	Name="RelaxingWaitLean",
	Speed = 0.2,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Common"]["YankeeSit"] ={
	Type="Common",
	Name="YankeeSit",
	Speed = 0.2,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Common"]["BarrelWait"] ={
	Type="Common",
	Name="BarrelWait",
	Speed = 1,
	Initial = 0,
	addDir=0.1,
	Mode="Loop",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Common"]["BarrelPaka"] ={
	Type="Common",
	Name="BarrelPaka",
	Speed = 1,
	Initial = 0,
	addDir=0.1,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}

AnimationParam["Common"]["ZenchuUp"] ={
	Type="Common",
	Name="ZenchuUp",
	Speed = 0.8,
	Initial = 0,
	addDir=0.22,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing06_e" }
	},
}

AnimationParam["Common"]["ThrowItem"] ={
	Type="Common",
	Name="ThrowItem",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing01" }
	},
	Event={ 
		{ time=29 , data={ type="ItemThrowed"} },
	},
}
AnimationParam["Common"]["PickUp"] ={
	Type="Common",
	Name="PickUp",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	Event={ 
		{ time=27 , data={ type="ItemGet", } },
	},
}
AnimationParam["Common"]["Squat"] ={
	Type="Common",
	Name="Squat",
	Speed = 1.2,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Common"]["ResistGrappled"] ={
	Type="Common",
	Name="ResistGrappled",
	Speed = 1.2,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Common"]["JumpRoll"] ={
	Type="Common",
	Name="JumpRoll",
	addDir=0.2,
	Speed = 1.5,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey ={
		{ 5,"swing03" }
	},	
}
AnimationParam["Common"]["Radar"] ={
	Type="Common",
	Name="Radar",
	Speed = 1,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=1,
		Speed=0
	},
	playWhileInputOn={
		Up,Down
	}
}
AnimationParam["Common"]["StandUp"] ={
	Type="Common",
	Name="StandUp",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=1,
		Speed=0
	},
}
AnimationParam["Common"]["Land"] ={
	Type="Common",
	Name="Land",
	Speed = 3,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=1,
		Speed=0
	},
}
AnimationParam["Common"]["Guard"] ={
	Type="Common",
	Name="Guard",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=1,
		Speed=0
	},
}
AnimationParam["Common"]["JumpKick"] ={
	Type="Common",
	Name="JumpKick",
	Speed = 1.5,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Common"]["Jump"] ={
	Type="Common",
	Name="Jump",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey ={
		{ 3,"Jump" }
	},	
	Control={
		{ Time=0 , ProcessName="JumpUp" , ProcessMode=Process.INITIALIZING },
		{ Time=22 , Mode= "Stop" , IFCurrentStateIs= ""   },
	}
}
AnimationParam["Common"]["Grappled"] ={
	Type="Common",
	Name="Grappled",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=1,
		Speed=0
	},
}
AnimationParam["Common"]["Grappling"] ={
	Type="Common",
	Name="Grappling",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=1,
		Speed=0
	},
}
AnimationParam["Common"]["GrapplingAttackedKick"] ={
	Type="Common",
	Name="GrapplingAttackedKick",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Common"]["GrapplingAttackedElbow"] ={
	Type="Common",
	Name="GrapplingAttackedElbow",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Common"]["GrapplingElbow"] ={
	Type="Common",
	Name="GrapplingElbow",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Common"]["GrapplingKneeKick"] ={
	Type="Common",
	Name="GrapplingKneeKick",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Common"]["SmallDamaged1"] ={
	Type="Common",
	Name="SmallDamaged1",
	Speed = 1,
	Initial = 0,
	addDir=-0.02,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Common"]["MiddleDamaged"] ={
	Type="Common",
	Name="MiddleDamaged",
	Speed = 1.3,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Common"]["BlewUp2"] ={
	Type="Common",
	Name="BlewUp2",
	Speed = 1,
	Initial = 0,
--	addDir=-0.2,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
--	PosOffset="RootRoot_Joint"
}
AnimationParam["Common"]["BlewUpDown"] ={
	Type="Common",
	Name="BlewUpDown",
	Speed = 1.4,
	Initial = 0,
--	addDir=-0.05,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey ={
		{ 65,"bosu35", }
	},	

--	PosOffset="RootRoot_Joint"
}
AnimationParam["Common"]["BoundDown"]={
	Type="Common",
	Name="BoundDown",
	Speed=1.2,
	Initial=0,
	Mode="Once",
}
AnimationParam["Common"]["Down"]={
	Type="Common",
	Name="Down",
	Speed=0,
	Initial=0,
	Mode="Once",
}
AnimationParam["Common"]["BeatFallDown"]={
	Type="Common",
	Name="BeatFallDown",
	Speed=1,
	Initial=0,
--	addDir=-0.2,
	Mode="Once",
}
AnimationParam["Common"]["FallDown"] ={
	Type="Common",
	Name="FallDown",
	Speed = 1,
	Initial = 0,
	Mode="Once",
}
AnimationParam["Common"]["BoundWall"] ={
	Type="Common",
	Name="BoundWall",
	Speed = 1.5,
	Initial = 0,
	Mode="Once",
}
AnimationParam["Common"]["FrontFallDown"] ={
	Type="Common",
	Name="FrontFallDown",
	Speed = 1.5,
	Initial = 0,
	Mode="Once",
}
AnimationParam["Common"]["FaceDownLand"] ={
	Type="Common",
	Name="FaceDownLand",
	Speed = 1,
	Initial = 0,
	Mode="Once",
}
AnimationParam["Common"]["BackDropped"] ={
	Type="Common",
	Name="BackDropped",
	Speed = 0.8,
	Initial = 0,
	Mode="Once",
}
AnimationParam["Common"]["PileDrivered"] ={
	Type="Common",
	Name="PileDrivered",
	Speed = 0.8,
	Initial = 0,
	Mode="Once",
}

AnimationParam["Karate"]={}
AnimationParam["Karate"]["Wait"] ={
	Type="Karate",
	Name="Wait",
	Speed = 0.5,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Karate"]["Run"] ={
	Type="Karate",
	Name="Run",
	Speed = 1.5,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Karate"]["Walk"] ={
	Type="Karate",
	Name="Walk",
	Speed = 1,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Karate"]["BackKick"] ={
	Type="Karate",
	Name="BackKick",
	Speed = 1.3,
	Initial = 0,
	addDir=-0.015,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 25 , "swing05" },
--		{ 9 , "voice_ha" },
	},
}
AnimationParam["Karate"]["PunchA"] ={
	Type="Karate",
	Name="PunchA",
	Speed = 2,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 10 , "swing03" }
	},
}
AnimationParam["Karate"]["ShitaZukiL"] ={
	Type="Karate",
	Name="ShitaZukiL",
	Speed = 3,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	particle={
		{ name="particleYellow" , Position="HandL_Joint"  }
	},
	SoundKey={
		{ 10 , "swing03" }
	},
}
AnimationParam["Karate"]["ShitaZukiR"] ={
	Type="Karate",
	Name="ShitaZukiR",
	Speed = 3,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	particle={
		{ name="particleYellow" , Position="HandR_Joint"  }
	},
	SoundKey={
		{ 10 , "swing03" }
	},
}
AnimationParam["Karate"]["StraightPunch"] ={
	Type="Karate",
	Name="StraightPunch",
	Speed = 2,
	Initial = 0,
	Mode="Once",
	addDir=0.02,
	Smoothing={
		Weight=0,
		Speed=0
	},
	particle={
		{ name="particleYellow" , Position="HandR_Joint"  }
	},
	SoundKey={
		{ 10 , "swing03" }
	},
}
AnimationParam["Karate"]["UpperCut"] ={
	Type="Karate",
	Name="UpperCut",
	Speed = 1,
	Initial = 0,
	addDir=0.02,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing03" }
	},
}
AnimationParam["Karate"]["MiddlePunch"] ={
	Type="Karate",
	Name="MiddlePunch",
	Speed = 1.3,
	Initial = 0,
	addDir=0.01,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing03" }
	},
}
AnimationParam["Karate"]["TornadoUpper"] ={
	Type="Karate",
	Name="TornadoUpper",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "Special02" }
	},
--	Effect={
--		{ Position="HandR_Joint" , LifeTime=50 , Width=0.25 , Height=0.25 , AnimationName="FireEffect1" },
--	},	
}
AnimationParam["Karate"]["JumpKneeKick"] ={
	Type="Karate",
	Name="JumpKneeKick",
	Speed = 1.8,
	Initial = 0,
	addDir=0.13,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
--		{ 5 , "Special02" }
		{ 5 , "Sliding" }
	},
	process={
		{ ProcessName="Gravity" , ProcessMode=Process.INITIALIZING }
	},	
	AfterState="Land_State",
--	Effect={
--		{ Position="FootR_Joint" , LifeTime=50 , Width=0.25 , Height=0.25 , AnimationName="FireEffect1" },
--	},	
}
AnimationParam["Karate"]["FrontKick"] ={
	Type="Karate",
	Name="FrontKick",
	Speed = 1.5,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing03" }
	},
}
AnimationParam["Karate"]["RoundHouseKick"] ={
	Type="Karate",
	Name="RoundHouseKick",
	Speed = 1.5,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing03" }
	},
}
AnimationParam["Karate"]["RoundHouseMiddleKick"] ={
	Type="Karate",
	Name="RoundHouseMiddleKick",
	Speed = 1.5,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing03" }
	},
}
AnimationParam["Karate"]["WhirlwindKick1"] ={
	Type="Karate",
	Name="WhirlwindKick1",
	Speed = 1.2,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=1,
		Speed=0
	},
	addDir=0.02,
	SoundKey={
--		{ 10 , "Special01" }
		{ 25 , "swing05" },
		{ 53 , "swing05" },
		{ 80 , "swing05" },
	},
	particle={
		{ name="particleYellow" , Position="FootR_Joint"  }
	},
	
--	Effect={
--		{ Position="FootR_Joint" , LifeTime=50 , Width=0.25 , Height=0.25 , AnimationName="ExplodeEffect1" },
--	},
}
AnimationParam["Karate"]["SakasaOtoshi"] ={
	Type="Karate",
	Name="SakasaOtoshi",
	Speed = 0.8,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey ={
		{ 25,"Special04" },
		{ 91,"Hit03" }
	},
--	PosOffset="RootRoot_Joint"
}
AnimationParam["Karate"]["DoubleLariat"] ={
	Type="Karate",
	Name="DoubleLariat",
	Speed = 0.5,
	Initial = 0,
	addDir=0.2,
	Mode=10,
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey ={
		{ 0,"Special08" },
	},
--	PosOffset="RootRoot_Joint"
}
AnimationParam["Karate"]["BackDrop"] ={
	Type="Karate",
	Name="BackDrop",
	Speed = 0.8,
	Initial = 0,
	Mode="Once",
	
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey ={
		{ 41,"Hit02" },
	},
--	PosOffset="RootRoot_Joint"
}
AnimationParam["Karate"]["PileDriver"] ={
	Type="Karate",
	Name="PileDriver",
	Speed = 0.8,
	Initial = 0,
	Mode="Once",
	
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey ={
		{ 41,"Hit02" },
	},
--	PosOffset="RootRoot_Joint"
}

AnimationParam["Kungfu"]={}
AnimationParam["Kungfu"]["ZenchuKakato"] ={
	Type="Kungfu",
	Name="ZenchuKakato",
	Speed = 1,
	Initial = 0,
	addDir=0.04,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "Jump" },
		{ 40 , "Special01"},
	},
	AfterState="Land_State",
	particle={
		{ name="particleYellow" , Position="FootR_Joint"  }
	},
}

AnimationParam["Kungfu"]["ShorinTsukiR"] ={
	Type="Kungfu",
	Name="ShorinTsukiR",
	Speed = 1.2,
	Initial= 0,
	addDir=0.01,
	Mode="Once",
	SoundKey = {
		{ 0,"swing03" }
	},
	CostTime=300, --millisec
}

AnimationParam["Kungfu"]["GazzelUpper"] ={
	Type="Kungfu",
	Name="GazzelUpper",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=1,
		Speed=0
	},
	addDir=0.04,
	SoundKey={
		{ 10 , "Special01" }
	},
	particle={
--		{ name="particleYellow" , Position="HandR_Joint"  },
		{ name="hitEffect" , Position="HandR_Joint"  }
	},	
}
AnimationParam["Kungfu"]["WhirlWindKick2"] ={
	Type="Kungfu",
	Name="WhirlWindKick2",
	Speed = 1.5,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=1,
		Speed=0
	},
--	addDir=0.04,
	SoundKey={
		{ 10 , "Special01" }
	},
--	particle={
--		{ name="particleYellow" , Position="FootR_Joint"  }
--	},
	
--	Effect={
--		{ Position="FootR_Joint" , LifeTime=50 , Width=0.25 , Height=0.25 , AnimationName="ExplodeEffect1" },
--	},
}

AnimationParam["Kungfu"]["Wait"] ={
	Type="Kungfu",
	Name="Wait",
	Speed = 0.5,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Kungfu"]["JumpKick2"] ={
	Type="Kungfu",
	Name="JumpKick2",
	Speed = 1.4,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Kungfu"]["JumpKick3"] ={
	Type="Kungfu",
	Name="JumpKick3",
	Speed = 1.4,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Kungfu"]["RoundHouseLowerKick"] ={
	Type="Kungfu",
	Name="RoundHouseLowerKick",
	Speed = 1.5,
	Initial = 0,
	addDir=0.01,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing03" }
	},
}
AnimationParam["Kungfu"]["RollingKick2"] ={
	Type="Kungfu",
	Name="RollingKick2",
	Speed = 1.2,
	Initial = 0,
	addDir=0.01,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing05" },
--		{ 9 , "voice_ha" },
	},
}
AnimationParam["Kungfu"]["SideKickStart"] ={
	Type="Kungfu",
	Name="SideKickStart",
	Speed = 1.4,
	Initial = 0,
	addDir=0.01,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing03" },
	},
}
AnimationParam["Kungfu"]["SideKickFinish"] ={
	Type="Kungfu",
	Name="SideKickFinish",
	Speed = 1.3,
	Initial = 0,
	addDir=0.06,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing03" },
--		{ 9 , "voice_ha" },
	},
}
AnimationParam["Kungfu"]["SummersaultKick"] ={
	Type="Kungfu",
	Name="SummersaultKick",
	Speed = 1,
	Initial = 0,
	addDir=0.01,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing05" }
	},
	particle={
		{ name="particleYellow" , Position="FootR_Joint"  }
	},	
}
AnimationParam["Kungfu"]["HighSpinKick"] ={
	Type="Kungfu",
	Name="HighSpinKick",
	Speed = 0.8,
	Initial = 0,
	addDir=0.1,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing03" }
	},
}
AnimationParam["Kungfu"]["FinishKick"] ={
	Type="Kungfu",
	Name="FinishKick",
	Speed = 1.5,
	Initial = 0,
	Mode="Once",
	addDir=0.05,
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "Hit03" }
	},
}
--[[
AnimationParam["Kungfu"]["Run"] ={
	Type="Kungfu",
	Name="Run",
	Speed = 1.5,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Kungfu"]["Walk"] ={
	Type="Kungfu",
	Name="Walk",
	Speed = 1,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Kungfu"]["PunchA"] ={
	Type="Kungfu",
	Name="PunchA",
	Speed = 2,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 10 , "swing03" }
	},
}
AnimationParam["Kungfu"]["StraightPunch"] ={
	Type="Kungfu",
	Name="StraightPunch",
	Speed = 2,
	Initial = 0,
	Mode="Once",
--	addDir=0.1,
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 10 , "swing03" }
	},
}
AnimationParam["Kungfu"]["UpperCut"] ={
	Type="Kungfu",
	Name="UpperCut",
	Speed = 1,
	Initial = 0,
	addDir=0.05,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing03" }
	},
}
AnimationParam["Kungfu"]["MiddlePunch"] ={
	Type="Kungfu",
	Name="MiddlePunch",
	Speed = 1.3,
	Initial = 0,
	addDir=0.01,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing03" }
	},
}
AnimationParam["Kungfu"]["TornadoUpper"] ={
	Type="Kungfu",
	Name="TornadoUpper",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "Special02" }
	},
--	Effect={
--		{ Position="HandR_Joint" , LifeTime=50 , Width=0.25 , Height=0.25 , AnimationName="FireEffect1" },
--	},	
}
AnimationParam["Kungfu"]["JumpKneeKick"] ={
	Type="Kungfu",
	Name="JumpKneeKick",
	Speed = 1.5,
	Initial = 0,
	addDir=0.1,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "Special02" }
	},
--	Effect={
--		{ Position="FootR_Joint" , LifeTime=50 , Width=0.25 , Height=0.25 , AnimationName="FireEffect1" },
--	},	
}

AnimationParam["Kungfu"]["FrontKick"] ={
	Type="Kungfu",
	Name="FrontKick",
	Speed = 1.5,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing03" }
	},
}
AnimationParam["Kungfu"]["RoundHouseKick"] ={
	Type="Kungfu",
	Name="RoundHouseKick",
	Speed = 1.5,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing03" }
	},
}

AnimationParam["Kungfu"]["WhirlwindKick1"] ={
	Type="Kungfu",
	Name="WhirlwindKick1",
	Speed = 1.5,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=1,
		Speed=0
	},
	addDir=0.04,
	SoundKey={
		{ 10 , "Special01" }
	},
	particle={
		{ name="particleYellow" , Position="FootR_Joint"  }
	},
	
--	Effect={
--		{ Position="FootR_Joint" , LifeTime=50 , Width=0.25 , Height=0.25 , AnimationName="ExplodeEffect1" },
--	},
}
AnimationParam["Kungfu"]["SakasaOtoshi"] ={
	Type="Kungfu",
	Name="SakasaOtoshi",
	Speed = 0.8,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey ={
		{ 25,"Special04" },
		{ 91,"Hit03" }
	},
--	PosOffset="RootRoot_Joint"
}
AnimationParam["Kungfu"]["DoubleLariat"] ={
	Type="Kungfu",
	Name="DoubleLariat",
	Speed = 3.5,
	Initial = 0,
	addDir=0.2,
	Mode=10,
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey ={
		{ 0,"Special08" },
	},
--	PosOffset="RootRoot_Joint"
}
AnimationParam["Kungfu"]["BackDrop"] ={
	Type="Kungfu",
	Name="BackDrop",
	Speed = 0.8,
	Initial = 0,
	Mode="Once",
	
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey ={
		{ 41,"Hit02" },
	},
--	PosOffset="RootRoot_Joint"
}
AnimationParam["Kungfu"]["PileDriver"] ={
	Type="Kungfu",
	Name="PileDriver",
	Speed = 0.8,
	Initial = 0,
	Mode="Once",
	
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey ={
		{ 41,"Hit02" },
	},
--	PosOffset="RootRoot_Joint"
}
--]]


AnimationParam["Mino"]={}
AnimationParam["Mino"]["Wait"] ={
	Name="Wait",
	Speed = 0.5,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Ninja2"] = {}
AnimationParam["Ninja2"]["Wait"] ={
	Type="Ninja2",
	Name="Wait",
	Speed = 1,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=1,
		Speed=0
	},
}
AnimationParam["Ninja2"]["Walk"] ={
	Type="Ninja2",
	Name="Walk",
	Speed = 1,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=1,
		Speed=0
	},
}
AnimationParam["Ninja2"]["Run"]={
	Type="Ninja2",
	Name="Run",
	Speed=1.5,
	Initial=0,
	Mode="Loop",
}
AnimationParam["Ninja2"]["StickAttack"] ={
	Type="Ninja2",
	Name="StickAttack",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 17 , "tm2_swing000" },
		{ 42 , "tm2_swing000" }
	},
}
AnimationParam["Ninja2"]["SpinKick"] ={
	Type="Ninja2",
	Name="SpinKick",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	addDir=0.03,
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "tm2_swing000" },
		{ 40 , "tm2_swing000" },
	},
}
AnimationParam["Ninja2"]["KuutenKick"] ={
	Type="Ninja2",
	Name="KuutenKick",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	addDir=0.01,
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "Jump" },
	},
}
AnimationParam["Ninja2"]["KunaiSlashL"] ={
	Type="Ninja2",
	Name="KunaiSlashL",
	Speed = 2,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 10 , "tm2_swing000" }
	},
}
AnimationParam["Ninja2"]["Swan"]={
	Type="Ninja2",
	Name="Swan",
	Speed=1.5,
	Initial=0,
	addDir=-0.15,
	Mode="Once",
	SoundKey={
		{ 5 , "Jump" }
	},
}
AnimationParam["Ninja2"]["SummersaultKick"] ={
	Type="Ninja2",
	Name="SummersaultKick",
	Speed = 1,
	Initial = 0,
	addDir=0.01,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "swing05" }
	},
	particle={
		{ name="particleYellow" , Position="FootR_Joint"  }
	},
	
}
AnimationParam["Ninja"] = {}
AnimationParam["Ninja"]["Wait"] ={
	Type="Ninja",
	Name="Wait",
	Speed = 1,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=1,
		Speed=0
	},
}
AnimationParam["Ninja"]["SuperBackDrop"] ={
	Type="Ninja",
	Name="SuperBackDrop",
	Speed = 0.7,
	Initial = 0,
	Mode="Once",
	addDir=-0.01,
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Ninja"]["KubikariNage"] ={
	Type="Ninja",
	Name="KubikariNage",
	Speed = 0.9,
	Initial = 0,
	Mode="Once",
	addDir=0.03,
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Ninja"]["RanzoWait"] ={
	Type="Ninja",
	Name="RanzoWait",
	Speed = 0,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=1,
		Speed=0
	},
}
AnimationParam["Ninja"]["NitoryuWait"] ={
	Type="Ninja",
	Name="NitoryuWait",
	Speed = 0.02,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=1,
		Speed=0
	},
}
AnimationParam["Ninja"]["Walk"] ={
	Type="Ninja",
	Name="Walk",
	Speed = 1,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=1,
		Speed=0
	},
}
AnimationParam["Ninja"]["Run"]={
	Type="Ninja",
	Name="Run",
	Speed=1.5,
	Initial=0,
	Mode="Loop",
}
AnimationParam["Ninja"]["JumpUp"] ={
	Type="Ninja",
	Name="JumpUp",
	Speed = 1,
	Initial = 0,
	SoundKey ={
		{ 5,"Jump" }
	},
}
AnimationParam["Ninja"]["CutDown"] ={
	Type="Ninja",
	Name="CutDown",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 10 , "tm2_swing000" }
	},
}
AnimationParam["Ninja"]["CutDownBladeR"] ={
	Type="Ninja",
	Name="CutDownBladeR",
	Speed = 1.5,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 10 , "swing06_e" }
	},
}
AnimationParam["Ninja"]["CutUpBladeR"] ={
	Type="Ninja",
	Name="CutUpBladeR",
	Speed = 1.2,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 10 , "swing06_e" }
	},
}
AnimationParam["Ninja"]["FinishCutDownBladeR"] ={
	Type="Ninja",
	Name="FinishCutDownBladeR",
	Speed = 1.5,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 10 , "swing05" }
	},
}
AnimationParam["Ninja"]["Rolling"]={
	Type="Ninja",
	Name="Rolling",
	Speed=1,
	Initial=0,
	Mode="Loop",
}
AnimationParam["Ninja"]["Swan"]={
	Type="Ninja",
	Name="Swan",
	Speed=1.5,
	Initial=0,
	Mode="Once",
}
AnimationParam["Ninja"]["BackhandBlow"] ={
	Type="Ninja",
	Name="BackhandBlow",
	Speed = 1.8,
	Initial= 0,
--	addDir=0.005,
	Mode="Once",
	SoundKey = {
		{ 0,"swing03" }
	},
	CostTime=300, --millisec
}
AnimationParam["Ninja"]["RollingKick"] ={
	Type="Ninja",
	Name="RollingKick",
	Speed = 1.5,
	Initial = 0,
	addDir=0.03,
	Mode="Once",
	SoundKey = {
		{ 0,"swing05" }
	},
	CostTime=500,
}
AnimationParam["Ninja"]["JumpRollingKick"] ={
	Type="Ninja",
	Name="JumpRollingKick",
	Speed = 1,
	Initial = 0,
	addDir=0.03,
	Mode="Once",
	SoundKey = {
		{ 5,"swing05" }
	},
}
AnimationParam["Ninja"]["RoundhouseUpperKick"] ={
	Speed = 1.5,
	Initial = 0,
	HitFrameName = "FootR_Joint",
	HitSoundName = "Hit03",
	SoundKey = {
		{ 0,"tm2_swing000" }
	},
	DamageBeginTime = 10,
	DamageEndTime = 30,
	DamagePoint=3,
	ChangeState = "State_MiddleDamaged"
}
AnimationParam["Ninja"]["Backflip"]={
	Type="Ninja",
	SoundKey = {
		{ 5,"swing03" }
	},
	Smoothing = {
		Weight= 0 ,
		Speed = 0
	},
	addDir=-0.2,
	IsSavePositionWhenAnimDone= "RootRoot_Joint",
	Name="Backflip",
	Speed = 2,
	Initial = 0,
	Mode="Once",
}

AnimationParam["Surge"]={}
AnimationParam["Surge"]["SurgeWait"] ={
	Type="Surge",
	Name="SurgeWait",
	Speed = 0.5,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Surge"]["SurgeWalk"] ={
	Type="Surge",
	Name="SurgeWalk",
	Speed = 0.8,
	Initial = 0,
	Mode="Loop",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Surge"]["PreAttack"] ={
	Type="Surge",
	Name="PreAttack",
	Speed = 1,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Surge"]["SurgePunchR"] ={
	Type="Surge",
	Name="SurgePunchR",
	Speed = 0.7,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
}
AnimationParam["Surge"]["SurgePunchL"] ={
	Type="Surge",
	Name="SurgePunchL",
	Speed = 1.8,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey = {
		{ 8,"swing05" }
	},
	
}
AnimationParam["Surge"]["JumonjiKick"] ={
	Type="Surge",
	Name="JumonjiKick",
	Speed = 1.5,
	Initial = 0,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey = {
		{ 8,"swing05" }
	},	
}
AnimationParam["Surge"]["Tackle"] ={
	Type="Surge",
	Name="Tackle",
	Speed = 1,
	Initial = 0,
	addDir=0.02,
	Mode="Once",
	Smoothing={
		Weight=0,
		Speed=0
	},
	SoundKey={
		{ 5 , "tm2_swing000" }
	},
}

MaterialData[ "BlackMan" ]={
  Diffuse = {
0.1,
0.1,
0.1,
1,
}
,
  Emissive = {
0.011,
0.011,
0.011,
0.001,
}
,
  name = "BlackMan",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Ash02" ]={
  Diffuse = {
0.2,
0.2,
0.2,
1,
}
,
  Emissive = {
0.011,
0.011,
0.011,
0.001,
}
,
  name = "Ash02",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Ash05" ]={
  Diffuse = {
0.5,
0.5,
0.5,
1,
}
,
  Emissive = {
0.011,
0.011,
0.011,
0.001,
}
,
  name = "Ash05",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Green2" ]={
  Diffuse = {
0,
1,
0,
1,
}
,
  Emissive = {
0.011,
0.011,
0.011,
0.001,
}
,
  name = "Green2",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Red2" ]={
  Diffuse = {
1,
0,
0,
1,
}
,
  Emissive = {
0.01,
0.01,
0.01,
0.01,
}
,
  name = "Red2",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Skin" ]={
 Diffuse = {
1,
0.69,
0.63,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "Skin",
  Power = 50,
  Specular = {
0.05,
0.05,
0.05,
0.5,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Blue2" ]={
 Diffuse = {
0.1,
0.1,
0.9,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "Blue2",
  Power = 50,
  Specular = {
0.05,
0.05,
0.05,
0.5,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "CobaltBlue" ]={
 Diffuse = {
0.1,
0,
1,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "CobaltBlue",
  Power = 50,
  Specular = {
0.5,
0.5,
0.5,
0.5,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Black" ]={
 Diffuse = {
0.1,
0.1,
0.1,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "Black",
  Power = 50,
  Specular = {
0.5,
0.5,
0.5,
0.5,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "White" ]={
 Diffuse = {
0.8,
0.8,
0.8,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "White",
  Power = 50,
  Specular = {
0.01,
0.01,
0.01,
0.01,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Aqua" ]={
 Diffuse = {
0,
0.82,
0.9,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "Aqua",
  Power = 50,
  Specular = {
0.01,
0.01,
0.01,
0.01,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Brown" ]={
 Diffuse = {
0.6666,
0.184,
0,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "Brown",
  Power = 50,
  Specular = {
0.01,
0.01,
0.01,
0.01,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Door" ]={
 TextureFileName = "door.bmp",
 Diffuse = {
1,
1,
1,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "Door",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Fence" ]={
 TextureFileName = "fence.bmp",
 Diffuse = {
1,
1,
1,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "fence",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}

MaterialData[ "BrickOld" ]={
 TextureFileName = "brickOld.bmp",
 Diffuse = {
1,
1,
1,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "brickOld",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "BenchWood" ]={
 TextureFileName = "benchWood.bmp",
 Diffuse = {
1,
1,
1,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "benchWood",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
--[[
MaterialData[ "Concrete2" ]={
 --TextureFileName = "wall.dds",
 TextureFileName = "building.bmp",
 Diffuse = {
1,
1,
1,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "Concrete2",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
--]]
MaterialData[ "BoxWood" ]={
 TextureFileName = "box_wood.png",
 Diffuse = {
1,
1,
1,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "BoxWood",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}

MaterialData[ "NewYork" ]={
 TextureFileName = "NewYork2.dds",
 Diffuse = {
1,
1,
1,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "NewYork",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Grass" ]={
  Diffuse = {
1,
1,
1,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "Grass",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Blue" ]={
  Diffuse = {
0,
0,
1,
0.6,
}
,
  Emissive = {
0.01,
0.01,
0.01,
0.01,
}
,
  name = "Blue",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Marker" ]={
  TextureFileName = "Node.bmp",
  Diffuse = {
1,
1,
1,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "Marker",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "road" ]={
  TextureFileName = "RoadWay.bmp",
  name = "road",
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  Diffuse = {
1,
1,
1,
1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Power = 1,
}
MaterialData[ "Building" ]={
  TextureFileName = "building.bmp",
  Diffuse = {
1,
1,
1,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "Building",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Purple" ]={
  Diffuse = {
0,
1,
1,
0.9,
}
,
  Emissive = {
0.011,
0.011,
0.011,
0.001,
}
,
  name = "Purple",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Sprite" ]={
  TextureFileName = "Sprite.jpg",
  Diffuse = {
1,
1,
1,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "Sprite",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Green" ]={
  Diffuse = {
0,
1,
0,
0.5,
}
,
  Emissive = {
0.011,
0.011,
0.011,
0.001,
}
,
  name = "Green",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Concrete" ]={
  TextureFileName = "concrete.dds",
  Diffuse = {
1,
1,
1,
1,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "Concrete",
  Power = 30,
  Specular = {
0.01,
0.01,
0.01,
0.01,
}
,
  Ambient = {
0.1,
0.1,
0.1,
0.1,
}
,
}
MaterialData[ "Yellow" ]={
  Diffuse = {
1,
1,
0,
0.5,
}
,
  Emissive = {
0.011,
0.011,
0.011,
0.001,
}
,
  name = "Yellow",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialData[ "Red" ]={
  Diffuse = {
1,
0,
0,
0.5,
}
,
  Emissive = {
0.001,
0.001,
0.001,
0.001,
}
,
  name = "Red",
  Power = 50,
  Specular = {
0.1,
0.1,
0.1,
0.1,
}
,
  Ambient = {
0.5,
0.5,
0.5,
0.5,
}
,
}
MaterialList={
--	Concrete = Material( MaterialData["Concrete"] ),
--	Grass=Material( MaterialData["Grass"] ),
}

Mat_Blue = Material( MaterialData["Blue"] );
Mat_Blue2 = Material( MaterialData["Blue2"] );
Mat_Red = Material( MaterialData["Red"] );
Mat_Red2 = Material( MaterialData["Red2"] );
Mat_Yellow = Material( MaterialData["Yellow"] );
Mat_Green = Material( MaterialData["Green"] );
Mat_Green2 = Material( MaterialData["Green2"] );
Mat_Purple = Material( MaterialData["Purple"] );
--[[
Mat_Concrete = Material( MaterialData["Concrete"] );
Mat_Grass = Material( MaterialData["Grass"] );
--]]
Mat_Sprite = Material( MaterialData["Sprite"] );
Mat_Marker = Material( MaterialData["Marker"] );
Mat_Brown = Material( MaterialData["Brown"] );
Mat_Aqua = Material( MaterialData["Aqua"] );
Mat_White = Material( MaterialData["White"] );
Mat_CobBlue = Material( MaterialData["CobaltBlue"] );
Mat_Skin = Material( MaterialData["Skin"] );
Mat_Ash05 = Material( MaterialData["Ash05"] );
Mat_Ash02 = Material( MaterialData["Ash02"] );
Mat_BlackMan = Material( MaterialData["BlackMan"] );

gMaterialPallet={}
gMaterialDataPallet={}
gCurrentEditMaterialData={
	name="edit_1",
	Diffuse = {1,1,1,1},
	Ambient ={0.5,0.5,0.5,0.5},
	Specular = {0.1,0.1,0.1,0.1},
	Emissive = {0.001,0.001,0.001,0.001},
	Power = 1,
}


ParaparaAnimation={}
ParaparaAnimation["HitEffect1"]={
	Texturename="hitEffect.bmp",
	TextureWidth = 1024,
	TextureHeight = 128,
	Key = { 
		{ 0,0,0,128,128 }, -- Time , U,V,W,H
		{ 15,128,0,128,128 },
		{ 30,128*2,0,128,128 },
		{ 45,128*3,0,128,128 },
		{ 60,128*4,0,128,128 },
		{ 75,128*5,0,128,128 },
--		{ 90,128*6,0,128,128 },
--		{ 105,128*7,0,128,128 },
	}
}
ParaparaAnimation["HitEffect2"]={
	Texturename="s_delete01.png",
	TextureWidth = 960,
	TextureHeight = 192,
	Key = { 
		{ 0,0,0,192,192 }, -- Time , U,V,W,H
		{ 5,192,0,192,192 },
		{ 10,192*2,0,192,192 },
		{ 15,192*3,0,192,192 },
		{ 20,192*4,0,192,192 }
	}
}
ParaparaAnimation["FireEffect1"]={
	Texturename="efe_fire03.png",
	TextureWidth = 1024,
	TextureHeight = 128,
	Key = { 
		{ 0,0,0,128,128 }, -- Time , U,V,W,H
		{ 5,128,0,128,128 },
		{ 10,128*2,0,128,128 },
		{ 15,128*3,0,128,128 },
		{ 20,128*4,0,128,128 },
		{ 25,128*5,0,128,128 },
		{ 30,128*6,0,128,128 }
	}
}
ParaparaAnimation["ThunderEffect1"]={
	Texturename="efe_than.png",
	TextureWidth = 512,
	TextureHeight = 240,
	Key = { 
		{ 0,0,0,64,240 }, -- Time , U,V,W,H
		{ 5,64,0,64,240 },
		{ 10,64*2,0,64,240 },
		{ 15,64*3,0,64,240 },
		{ 20,64*4,0,64,240 },
		{ 25,64*5,0,64,240 },
		{ 30,64*6,0,64,240 },
		{ 35,64*7,0,64,240 }
	}
}
ParaparaAnimation["ExplodeEffect1"]={
--	Texturename="explode.png",
	Texturename="particle.bmp",
	TextureWidth = 256,
	TextureHeight = 256,
	Key = { 
		{ 0,0,0,64,64 }, -- Time , U,V,W,H
		{ 5,64,0,64,64 },
		{ 10,64*2,0,64,64 },
		{ 15,64*3,0,64,64 },
		
		{ 20,0,64,64,64 },
		{ 25,64,64,64,64 },
		{ 30,64*2,64,64,64 },
		{ 35,64*3,64,64,64 },
		
		{ 40,0,64*2,64,64 },
		{ 45,64,64*2,64,64 },
		{ 50,64*2,64*2,64,64 },
		{ 55,64*3,64*2,64,64 },
		
		{ 60,0,64*3,64,64 },
		{ 65,64,64*3,64,64 },
		{ 70,64*2,64*3,64,64 },
		{ 75,64*3,64*3,64,64 }
		
		
	}
}

ParaparaAnimation["NovaEffect"]={
	Texturename="nova.bmp",
	TextureWidth = 256*5,
	TextureHeight = 256,
	Key = { 
		{ 0,0,0,256,256 }, -- Time , U,V,W,H
		{ 5,256,0,256,256 }, 
		{ 10,256*2,0,256,256 }, 
		{ 15,256*3,0,256,256 }, 
		{ 20,256*4,0,256,256 }, 
				
		
	}
}

ParaparaAnimation["NowLoading"]={
--	Texturename="loading.dds",
	TextureWidth = 256,
	TextureHeight = 128,
	Key = { 
		{ 0,0,0,64,64 }, -- Time , U,V,W,H
		{ 15,64,0,64,64 },
		{ 30,64*2,0,64,64 },
		{ 45,64*3,0,64,64 },
		
		{ 60,0,64,64,64 },
		{ 75,64,64,64,64 },
		{ 90,64*2,64,64,64 },
		{ 105,64*3,64,64,64 },
--[[		
		{ 0,0,0,64,64 }, -- Time , U,V,W,H
		{ 5,64,0,64,64 },
		{ 10,64*2,0,64,64 },
		{ 15,64*3,0,64,64 },
		
		{ 20,0,64,64,64 },
		{ 25,64,64,64,64 },
		{ 30,64*2,64,64,64 },
		{ 35,64*3,64,64,64 },
--]]			
	}
}


FlipAnimationData["Boxing"]={
	Wait_State=AnimationParam["Boxing"]["Wait"],
	Walk_State=AnimationParam["Boxing"]["Walk"],
	Run_State=AnimationParam["Karate"]["Run"],
--	Fall_State=AnimationParam["Common"]["FallDown"],
	JumpUp_State=AnimationParam["Common"]["Jump"],
	Relaxing_State=AnimationParam["Common"]["YankeeSit"],
	Dead_State=AnimationParam["Common"]["Dogeza"],
}
BasicCommandData["Boxing"]={
	b1={
		Before={ "Walk_State","Run_State" },
		Command={ None },
		After="Wait_State",		
		CommandType="isOn",

	},
	b2={
		Before={ "Wait_State" },
		Command={ Dir },
		After="Walk_State",
		CommandType="isOn",
	},
	b3={
		Before={ "Wait_State","Walk_State","Run_State" ,"Grappling_State","Ladder_State" },
		Command={ J },
		After="JumpUp_State",
	},
	b4={
		Before={ "Down_State" , "FaceDownLand_State" },
		Command={ Dir },
		After="StandUp_State",
		CommandType="isOn",
	},
	b5={
		LimiteSec=0.5,
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={ None, Dir , None , Dir },
		After="Run_State",
		CommandType="isOn",
	},
	b6={
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={ PSController.PS_R1 },
		After="Guard_State",
		
	},
	b7={
		LimiteSec=1,
		Before={ "Grappled_State"},
		Command={ A , None , A },
		After="Attack_State",
		AnimationData=AnimationParam["Common"]["ResistGrappled"]
	},
}

Command_Boxing_HookL={
	Before={ "Wait_State","Walk_State" },
	Command={ A },
	After="Attack_State",
	AnimationData=AnimationParam["Boxing"]["HookL"]
}
Command_Boxing_HookR={
	Before={ "Wait_State","Walk_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Boxing"]["HookR"]
}
Command_Boxing_MiddleHookL={
	Before={ "Wait_State","Walk_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Boxing"]["MiddleHookL"]
}
Command_Boxing_MiddlePunch={
	Before={ "Wait_State","Walk_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Karate"]["MiddlePunch"]
}
Command_Boxing_StraightPunch={
	Before={ "Wait_State","Walk_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Boxing"]["StraightPunch"]
}
Command_Boxing_Combo1_0=Command_Boxing_HookL
Command_Boxing_Combo1_1={
	prev=Command_Boxing_Combo1_0,
	LimiteSec=0.3,
	Before={ "Wait_State","Walk_State" , "Attack_State" },
--	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
--	AnimationData=AnimationParam["Karate"]["PunchA"],
	AnimationData=AnimationParam["Boxing"]["HookR"],
}
Command_Boxing_Combo1_2={
	prev=Command_Boxing_Combo1_0,
	LimiteSec=0.3,
	Before={ "Wait_State","Walk_State" },
--	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
--	AnimationData=AnimationParam["Karate"]["PunchA"],
	AnimationData=AnimationParam["Boxing"]["UpperCut"],
}
Command_Boxing_Combo1_3={
	prev=Command_Boxing_Combo1_0,
	LimiteSec=0.3,
	Before={ "Wait_State","Walk_State" },
--	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
	AnimationData=AnimationParam["Boxing"]["UpperCut"],
}

Command_Boxing_Combo1_0["next"] = Command_Boxing_Combo1_1;
Command_Boxing_Combo1_1["next"] = Command_Boxing_Combo1_2;
--Command_Boxing_Combo1_2["next"] = Command_Boxing_Combo1_3;

DempseyRoll={
	{
		param=AnimationParam["Boxing"]["HookL"],
		speed=2,	
		addDir=0.02,
	},
	{
		param=AnimationParam["Boxing"]["HookR"],
		speed=2,	
		addDir=0.02,
	},
	{
		param=AnimationParam["Boxing"]["MiddleHookL"],
		speed=2,	
		addDir=0.02,
	},
	{
		param=AnimationParam["Boxing"]["UpperCut"],
		speed=2,	
		addDir=0.02,
	},
	
}
AttackCommandData["Boxing"]={
--	a1=Command_Boxing_HookL,
--	a2=Command_Boxing_HookR,
--[[	{
		Before={ "Wait_State","Walk_State" },
		Command={ B },
		After="Attack_State",
		AnimationData=AnimationParam["Ninja2"]["StickAttack"]
	},
--]]
	a3=Command_Boxing_Combo1_0,
	a2=Command_Boxing_MiddlePunch,
--	a2=Command_Boxing_StraightPunch,
}

SpecialCommandData["Boxing"]={
	s6={
		LimiteSec=0.5,
		Before={ "Wait_State","Walk_State" },
		Command={ Down , Right , A },
		After="Attack_State",
		AnimationData=Tech.create( DempseyRoll ),
--		AnimationData=AnimationParam["Boxing"]["UpperCut"]
	},
--]]
}



FlipAnimationData["Karate"]={
	Wait_State=AnimationParam["Karate"]["Wait"],
	Walk_State=AnimationParam["Karate"]["Walk"],
	Run_State=AnimationParam["Karate"]["Run"],
	Fall_State=AnimationParam["Common"]["FallDown"],
	JumpUp_State=AnimationParam["Common"]["Jump"],
	Relaxing_State=AnimationParam["Common"]["RelaxingWaitLean"],
	Dead_State=AnimationParam["Common"]["BatanPikuPiku"],
}

BasicCommandData["Karate"]={
--[[	b9={
		LimiteSec=1,
		Before={ "ItemGettable"},
		Command={ A  },
		After="GetItem_State",
		AnimationData=AnimationParam["Common"]["PickUp"]
	},
	throw={
		Before={ "ItemAttach"},
		Command={ A },		
		After="ThrowItem_State",
		AnimationData=AnimationParam["Common"]["ThrowItem"]
	},
--]]
	b1={
		Before={ "Walk_State","Run_State" },
		Command={ None },
		After="Wait_State",
		CommandType="isOn",
	},
	b2={
		Before={ "Wait_State" },
		Command={ Dir },
		After="Walk_State",
		CommandType="isOn",
	},
	b3={
		Before={ "Wait_State","Walk_State","Run_State" ,"Grappling_State","Ladder_State","ItemGettable_State" },
		Command={ J },
		After="JumpUp_State",
	},
	b4={
		Before={ "Down_State" , "FaceDownLand_State" },
		Command={ Dir },
		After="StandUp_State",
		CommandType="isOn",
	},
	b8={
--		LimiteSec=0.5,
--		Before={ "Guard_State"},
		Before={ "Wait_State","Walk_State"},
		Command={ None, Dir , None , Dir },
--		Command={ R1 , Dir },
--		After="Attack_State",
		After="Run_State",
		CommandType="isOn",
--		AnimationData=AnimationParam["Common"]["JumpRoll"]
	},
--[[	kawashi={
		LimiteSec=0.5,
--		Before={ "Guard_State"},
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={ A },
--		Command={ PSController.PS_TRIANGLE },
		After="Kawashi_State",
		AnimationData=AnimationParam["Common"]["Kawashi"],
	},
--]]
--[[	b5={
		LimiteSec=0.5,
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={ None, Dir , None , Dir },
		After="Attack_State",
		After="Run_State",
		CommandType="isOn",
--		AnimationData=AnimationParam["Common"]["JumpRoll"]
	},
--]]
	b6={
		Before={ "Wait_State","Walk_State","Run_State","ItemGettable_State"},
		Command={ PSController.PS_R1 },
		After="Guard_State",
		CommandType="isOn",
		
	},
	b7={
		LimiteSec=1,
		Before={ "Grappled_State"},
		Command={ A , None , A },
		After="Attack_State",
		AnimationData=AnimationParam["Common"]["ResistGrappled"]
	},

--[[
	b8={
		LimiteSec=1,
		Before={ "Wait_State"},
		Command={ A  },
		After="Attack_State",
		AnimationData=AnimationParam["Common"]["PickUp"]
	},
--]]
}

Command_Karate_PunchA={
	Before={ "Wait_State","Walk_State" },
	Command={ A },
	After="Attack_State",
	AnimationData=AnimationParam["Karate"]["PunchA"],
--	AnimationData=AnimationParam["Ninja"]["BackhandBlow"],
}
Command_Karate_FrontKick={
	Before={ "Wait_State","Walk_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Karate"]["FrontKick"]
--	AnimationData=AnimationParam["Common"]["ThrowItem"]
}
Command_Karate_RoundHouseMiddleKick={
	Before={ "Wait_State","Walk_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Karate"]["RoundHouseMiddleKick"],
--	AnimationData=AnimationParam["Common"]["ThrowItem"]
}

Command_Karate_Combo1_0=Command_Karate_PunchA
Command_Karate_Combo1_1={
--[[	prev=Command_Karate_Combo1_0,
	LimiteSec=0.5,
	Before={ "Wait_State","Walk_State" ,"Attack_State","ItemGettable_State" },
--	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
	
	AnimationData=AnimationParam["Karate"]["PunchA"],
--	AnimationData=AnimationParam["Karate"]["StraightPunch"],
--	AnimationData=AnimationParam["Ninja"]["BackhandBlow"],
--]]
	prev=Command_Karate_Combo1_0,
	LimiteSec=0.5,
--		Before={ "Guard_State"},
	Before={ "Wait_State","Walk_State","Run_State"},
	Command={ A },
--		Command={ PSController.PS_TRIANGLE },
	After="Kawashi_State",
	AnimationData=AnimationParam["Common"]["Kawashi"],
}
Command_Karate_Combo1_2={
	prev=Command_Karate_Combo1_0,
	LimiteSec=0.3,
	Before={ "Wait_State","Walk_State","Attack_State","ItemGettable_State" },
--	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
	AnimationData=AnimationParam["Karate"]["StraightPunch"],
}
Command_Karate_Combo1_3={
	prev=Command_Karate_Combo1_0,
	LimiteSec=0.3,
	Before={ "Wait_State","Walk_State","ItemGettable_State" },
--	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
	
--	AnimationData=AnimationParam["Kungfu"]["RollingKick2"],
	AnimationData=AnimationParam["Karate"]["UpperCut"]	,
--	AnimationData=AnimationParam["Karate"]["FinishKick"],
--	AnimationData=AnimationParam["Karate"]["MiddlePunch"],	
}

Command_Karate_Combo1_0["next"] = Command_Karate_Combo1_1;
Command_Karate_Combo1_1["next"] = Command_Karate_Combo1_2;
--Command_Karate_Combo1_2["next"] = Command_Karate_Combo1_3;
--]]
--[[
Command_Karate_Combo1_0=Command_Karate_PunchA
Command_Karate_Combo1_1={
	prev=Command_Karate_Combo1_0,
	LimiteSec=0.5,
	Before={ "Wait_State","Walk_State" ,"Attack_State","ItemGettable_State" },
--	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
	AnimationData=AnimationParam["Karate"]["PunchA"],
--	AnimationData=AnimationParam["Ninja"]["BackhandBlow"],
}
Command_Karate_Combo1_2={
	prev=Command_Karate_Combo1_0,
	LimiteSec=0.3,
	Before={ "Wait_State","Walk_State","Attack_State","ItemGettable_State" },
--	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
--	AnimationData=AnimationParam["Karate"]["StraightPunch"],
	AnimationData=AnimationParam["Ninja"]["BackhandBlow"],
}
Command_Karate_Combo1_3={
	prev=Command_Karate_Combo1_0,
	LimiteSec=0.5,
	Before={ "Wait_State","Walk_State" ,"Attack_State","ItemGettable_State" },
--	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
--	AnimationData=AnimationParam["Karate"]["PunchA"],
	AnimationData=AnimationParam["Ninja"]["BackhandBlow"],
}
Command_Karate_Combo1_4={
	prev=Command_Karate_Combo1_0,
	LimiteSec=0.5,
	Before={ "Wait_State","Walk_State" ,"Attack_State","ItemGettable_State" },
--	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
	AnimationData=AnimationParam["Karate"]["PunchA"],
--	AnimationData=AnimationParam["Ninja"]["BackhandBlow"],
}
Command_Karate_Combo1_5={
	prev=Command_Karate_Combo1_0,
	LimiteSec=0.3,
	Before={ "Wait_State","Walk_State","Attack_State","ItemGettable_State" },
--	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
	AnimationData=AnimationParam["Karate"]["StraightPunch"],
--	AnimationData=AnimationParam["Karate"]["MiddlePunch"],	
}
Command_Karate_Combo1_6={
	prev=Command_Karate_Combo1_0,
	LimiteSec=0.3,
	Before={ "Wait_State","Walk_State","ItemGettable_State" },
--	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
	
--	AnimationData=AnimationParam["Kungfu"]["RollingKick2"],
--	AnimationData=AnimationParam["Karate"]["UpperCut"]	,
	AnimationData=AnimationParam["Kungfu"]["SideKickFinish"],
--	AnimationData=AnimationParam["Karate"]["FinishKick"],
--	AnimationData=AnimationParam["Karate"]["MiddlePunch"],	
}

Command_Karate_Combo1_0["next"] = Command_Karate_Combo1_1;
Command_Karate_Combo1_1["next"] = Command_Karate_Combo1_2;
Command_Karate_Combo1_2["next"] = Command_Karate_Combo1_3;
Command_Karate_Combo1_3["next"] = Command_Karate_Combo1_4;
Command_Karate_Combo1_4["next"] = Command_Karate_Combo1_5;
Command_Karate_Combo1_5["next"] = Command_Karate_Combo1_6;
--]]
Command_Karate_ComboKick1_0=Command_Karate_FrontKick;
Command_Karate_ComboKick1_1={
	prev=Command_Karate_ComboKick1_0,
	LimiteSec=0.4,
	Before={ "Wait_State","Walk_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Ninja"]["JumpRollingKick"]	
--	AnimationData=AnimationParam["Karate"]["RoundHouseMiddleKick"],
--	AnimationData=AnimationParam["Kungfu"]["SideKickFinish"],
}
Command_Karate_ComboKick1_0["next"] = Command_Karate_ComboKick1_1;

Command_Karate_MiddlePunch={
	Before={ "Wait_State","Walk_State","ItemGettable_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Karate"]["MiddlePunch"]
}
Command_Karate_RoundHouseKick={
	Before={ "Wait_State","Walk_State","ItemGettable_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Karate"]["RoundHouseKick"]
}
Command_Karate_RoundHouseLowerKick={
	Before={ "Guard_State", "Land_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Karate"]["RoundHouseLowerKick"]
}
Command_Karate_JumpKneeKick={
	Before={ "Run_State" },
	Command={ T },
	After="Attack_State",
	AnimationData=AnimationParam["Karate"]["JumpKneeKick"]
}
Command_Karate_GrapplingElbow={
	Before={ "Grappling_State" },
	Command={ A },
--	After="Grappling_State",
	After="Throw_State",
	GrappledAfter="Thrown_State",
--	Times=3,
--	AnimationData=AnimationParam["Common"]["GrapplingElbow"]
	AnimationData=AnimationParam["Ninja"]["SuperBackDrop"],
	GrappledAnimationData=AnimationParam["Common"]["SuperBackDropped"]
--	AnimationData=AnimationParam["Ninja"]["KubikariNage"],
--	GrappledAnimationData=AnimationParam["Common"]["KubikariNageThrown"]
	
}
Command_Karate_GrapplingKneeKick={
	Before={ "Grappling_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Common"]["GrapplingKneeKick"]
}
Command_Common_JumpRoll={
	Before={ "Run_State" },
	Command={ T },
	After="Attack_State",
	AnimationData=AnimationParam["Common"]["JumpRoll"]
}
Command_Karate_WhirlwindKick1={
	Before={ "Run_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Karate"]["WhirlwindKick1"]
}
Command_Karate_SideKick={
	Before={ "Run_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Kungfu"]["SideKickFinish"],
--		AnimationData=AnimationParam["Karate"]["WhirlwindKick1"]	
}

AttackCommandData["Karate"]={
	a9=Command_Karate_Combo1_0,
	a10=Command_Karate_ComboKick1_0,
	sideKick=Command_Karate_SideKick,
--	a2=Command_Karate_FrontKick,
--	a2=Command_Karate_RoundHouseKick,
--	a2=Command_Karate_MiddlePunch,
--	a3= Command_Karate_ComboJumpKick0,--Command_Karate_JumpKick,
	a4=Command_Karate_GrapplingElbow,
	a5=Command_Karate_GrapplingKneeKick,
--	a1=Command_Karate_JumpKneeKick,
}

TurboPunch={
	{
		param=AnimationParam["Karate"]["PunchA"],
		speed=2,
	},
	{
		param=AnimationParam["Karate"]["PunchA"],
		speed=2,	
	},
	{
		param=AnimationParam["Karate"]["PunchA"],
		speed=2,	
	},
}

SpecialCommandData["Kunio"]={
	s3={
		LimiteSec=0.3,
--		Before={ "JumpUp_State"},
		Before={ "Wait_State","Walk_State","Run_State"},
--		Command={ None , Down , Right , B },
		Command={ B },
		After="Attack_State",
--		AnimationData=Tech.create( TurboPunch ),
		AnimationData=AnimationParam["Kungfu"]["WhirlWindKick2"]
	},
--]]
}

ZenchuKakatoOtoshi={
	{
		param=AnimationParam["Kungfu"]["ZenchuKakato"],
		speed=0.9,	
		addDir=0.02,
	},
	{
		param=AnimationParam["Common"]["Land"],
		speed=3,
--		addDir=0.03,
	},
}


FlipAnimationData["Kungfu"]={
	Wait_State=AnimationParam["Kungfu"]["Wait"],
	Walk_State=AnimationParam["Ninja2"]["Walk"],
--	Run_State=AnimationParam["Karate"]["Run"],
	Run_State=AnimationParam["Ninja2"]["Run"],	
	Fall_State=AnimationParam["Common"]["Rolling"],
--	JumpUp_State=AnimationParam["Common"]["Jump"],
	GetItem_State=AnimationParam["Common"]["PickUp"],
	ThrowItem_State=AnimationParam["Common"]["ThrowItem"],
	Dead_State=AnimationParam["Common"]["BatanPikuPiku"],
	
}

BasicCommandData["Kungfu"] = {
--[[	b9={
		LimiteSec=1,
		Before={ "ItemGettable"},
		Command={ A  },		
		After="GetItem_State",
		AnimationData=AnimationParam["Common"]["PickUp"]
	},
--]]	b1={
		Before={ "Walk_State","Run_State" },
		Command={ None },
		After="Wait_State",
		CommandType="isOn",
	},
--[[	b2={
		Before={ "Wait_State" },
		Command={ Dir },
		After="Walk_State",
		CommandType="isOn",
	},
--]]
	b3={
		Before={ "Wait_State","Walk_State","Run_State" ,"Grappling_State","Ladder_State","ItemGettable_State" },
		Command={ J },
		After="JumpUp_State",
		AnimationData=AnimationParam["Common"]["ZenchuUp"],	
--		AnimationData=AnimationParam["Ninja"]["Rolling"]--{ Name="Rolling2", Speed=1,Initial=0,Mode="Loop" },
		
	
	},
--]]
	b4={
		Before={ "Down_State" , "FaceDownLand_State" },
		Command={ Dir },
		After="StandUp_State",
		CommandType="isOn",
	},
	b5={
		LimiteSec=0.5,
		Before={ "Wait_State","Walk_State"},
--		Command={ None, Dir , None , Dir },
		Command={ Dir },
		After="Run_State",
		CommandType="isOn",
	},
	b6={
		Before={ "Wait_State","Walk_State","Run_State","ItemGettable_State"},
		Command={ PSController.PS_R1 },
--		Command={ PSController.PS_TRIANGLE },
		After="Guard_State",
		CommandType="isOn",
		
	},
	b7={
		LimiteSec=1,
		Before={ "Grappled_State"},
		Command={ A , None , A },
		After="Attack_State",
		AnimationData=AnimationParam["Common"]["ResistGrappled"]
	},
--[[
	b8={
		LimiteSec=1,
		Before={ "Wait_State"},
		Command={ A  },
		After="Attack_State",
		AnimationData=AnimationParam["Common"]["PickUp"]
	},
--]]
}


Command_Kungfu_PunchA={
	Before={ "Wait_State","Walk_State" },
	Command={ A },
	After="Attack_State",
--	AnimationData=AnimationParam["Karate"]["PunchA"],
	AnimationData=AnimationParam["Ninja"]["BackhandBlow"],
}
Command_Kungfu_Combo1_0=Command_Kungfu_PunchA
Command_Kungfu_Combo1_1={
	prev=Command_Kungfu_Combo1_0,
	LimiteSec=0.5,
	Before={ "Wait_State","Walk_State" ,"Attack_State","ItemGettable_State" },
--	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
--	AnimationData=AnimationParam["Karate"]["PunchA"],
	AnimationData=AnimationParam["Ninja"]["BackhandBlow"],
}
Command_Kungfu_Combo1_2={
	prev=Command_Kungfu_Combo1_0,
	LimiteSec=0.3,
	Before={ "Wait_State","Walk_State","ItemGettable_State" },
--	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
--	AnimationData=AnimationParam["Kungfu"]["ShorinTsukiR"],
	AnimationData=AnimationParam["Karate"]["StraightPunch"],
--	AnimationData=AnimationParam["Kungfu"]["RoundHouseLowerKick"],
}
Command_Kungfu_Combo1_3={
	prev=Command_Kungfu_Combo1_0,
	LimiteSec=0.3,
	Before={ "Wait_State","Walk_State","ItemGettable_State" },
--	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
--	AnimationData=AnimationParam["Kungfu"]["GazzelUpper"],	
--	AnimationData=AnimationParam["Kungfu"]["FinishKick"],
	AnimationData=AnimationParam["Kungfu"]["RollingKick2"],
--	AnimationData=AnimationParam["Ninja"]["RollingKick"],
--	AnimationData=AnimationParam["Kungfu"]["SummersaultKick"],
}

Command_Kungfu_Combo1_0["next"] = Command_Kungfu_Combo1_1;
Command_Kungfu_Combo1_1["next"] = Command_Kungfu_Combo1_2;
--Command_Kungfu_Combo1_2["next"] = Command_Kungfu_Combo1_3;
--Command_Kungfu_Combo1_3["next"] = Command_Kungfu_Combo1_2;
--Command_Kungfu_Combo1_4["next"] = Command_Kungfu_Combo1_5;
--Command_Kungfu_Combo1_5["next"] = Command_Kungfu_Combo1_6;
--Command_Kungfu_Combo1_6["next"] = Command_Kungfu_Combo1_7;

Command_Kungfu_RoundHouseLowerKick={
--	Before={ "Guard_State", "Land_State" },
	Before={ "Wait_State","Walk_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Kungfu"]["RoundHouseLowerKick"]
}
Command_Kungfu_JumpKick={
	Before={ "JumpUp_State","Fall_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Kungfu"]["JumpKick2"]
}
Command_Kungfu_JumpKick3={
	Before={ "JumpUp_State","Fall_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Kungfu"]["JumpKick3"]
}


Command_Kungfu_ComboJumpKick0=Command_Kungfu_JumpKick3
Command_Kungfu_ComboJumpKick1={
	prev=Command_Kungfu_ComboJumpKick0,
	LimiteSec=0.3,	
	Before={ "JumpUp_State","Fall_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Kungfu"]["JumpKick2"],
}
Command_Kungfu_ComboJumpKick0["next"] = Command_Kungfu_ComboJumpKick1;



Command_Kungfu_ComboKick0=Command_Kungfu_RoundHouseLowerKick--Command_Karate_RoundHouseMiddleKick;--
--[[	Before={ "Wait_State","Walk_State"},
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Kungfu"]["SideKickStart"],	
}
--]]--[[
Command_Kungfu_ComboKick1={
	prev=Command_Kungfu_ComboKick0,
--	Before={ "Run_State" },
	LimiteSec=0.5,
	Before={ "Wait_State","Walk_State" },
	Command={ B },
	After="Attack_State",
--	AnimationData=AnimationParam["Kungfu"]["SideKickFinish"],
	AnimationData=AnimationParam["Kungfu"]["RoundHouseLowerKick"],
}
--]]
--[[
Command_Kungfu_ComboKick2={
	prev=Command_Kungfu_ComboKick0,
--	Before={ "Run_State" },
	LimiteSec=0.2,
	Before={ "Wait_State","Walk_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Ninja"]["JumpRollingKick"]	,
--	AnimationData=AnimationParam["Kungfu"]["RollingKick2"],
}
Command_Kungfu_ComboKick0["next"] = Command_Kungfu_ComboKick1;
Command_Kungfu_ComboKick1["next"] = Command_Kungfu_ComboKick2;
--]]
Command_Kungfu_ComboKick1={
	prev=Command_Kungfu_ComboKick0,
--	Before={ "Run_State" },
	LimiteSec=0.5,
	Before={ "Wait_State","Walk_State" },
	Command={ B },
	After="Attack_State",
--	AnimationData=AnimationParam["Kungfu"]["SideKickFinish"],
--	AnimationData=AnimationParam["Ninja"]["JumpRollingKick"]	,
	AnimationData=AnimationParam["Karate"]["RoundHouseMiddleKick"],
}
Command_Kungfu_ComboKick0["next"] = Command_Kungfu_ComboKick1;
--Command_Kungfu_ComboKick1["next"] = Command_Kungfu_ComboKick2;
--[[
Command_Kungfu_ComboKick0=Command_Kungfu_
Command_Kungfu_ComboKick1={
	prev=Command_Kungfu_ComboKick0,
	LimiteSec=0.3,
	Before={ "Wait_State","Walk_State","ItemGettable_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Kungfu"]["RoundHouseLowerKick"]
}
Command_Kungfu_ComboKick2={
	prev=Command_Kungfu_ComboKick0,
	LimiteSec=0.3,
	Before={ "Wait_State","Walk_State","ItemGettable_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Kungfu"]["JumpKick3"],	
--	After="JumpUp_State",
--	AnimationData=AnimationParam["Karate"]["JumpUp"]
}
Command_Kungfu_ComboKick3={
	prev=Command_Kungfu_ComboKick0,
	LimiteSec=0.3,
	Before={ "Wait_State","Walk_State","ItemGettable_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Kungfu"]["JumpKick2"],	
--	After="JumpUp_State",
--	AnimationData=AnimationParam["Kungfu"]["JumpUp"]
}
Command_Kungfu_ComboKick0["next"] = Command_Kungfu_ComboKick1;
Command_Kungfu_ComboKick1["next"] = Command_Kungfu_ComboKick2;
Command_Kungfu_ComboKick2["next"] = Command_Kungfu_ComboKick3;
--]]

Command_Kungfu_RunningSummersault={
	Before={ "Run_State" },
--	Before={ "Attack_State" },
	Command={ B },
	After="Attack_State",
--	AnimationData=AnimationParam["Kungfu"]["FinishKick"],
--	AnimationData=AnimationParam["Ninja"]["RollingKick"],
	AnimationData=AnimationParam["Kungfu"]["SummersaultKick"],
}
Command_Kungfu_SideKick={
	LimiteSec=0.5,
	Before={ "Wait_State","Walk_State" , "Run_State" },
--	Command={ Dir , None , Dir , B },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Kungfu"]["SideKickFinish"],
}
Com_KungfuJumpKickCombo={
	{
		param=AnimationParam["Kungfu"]["JumpKick3"],
		speed=2,
	},
	{
		param=AnimationParam["Kungfu"]["JumpKick2"],
		speed=2,	
	},
}

AttackCommandData["Kungfu"]={
	JK={
		LimiteSec=0.4,
		Before={ "JumpUp_State"},
--		Before={ "Wait_State","Walk_State","Run_State"},
--		Command={ None,Down , Right , B },
		Command={ B },
		After="Attack_State",
--		AnimationData=Tech.create( TurboPunch ),
		AnimationData=AnimationParam["Ninja"]["JumpRollingKick"]	,
--		AnimationData=AnimationParam["Karate"]["WhirlwindKick1"],
--		AnimationData=AnimationParam["Kungfu"]["WhirlWindKick2"]
	},

	a9=Command_Kungfu_Combo1_0,
--[[	knee={
		LimiteSec=0.3,
		Before={ "Land_State"},
		Command={ B },
		After="Attack_State",
		AnimationData=AnimationParam["Karate"]["JumpKneeKick"],
	},
--]]	
--	a8=Command_Kungfu_PunchA,
	a2= Command_Kungfu_ComboKick0,--Command_Karate_FrontKick,
--	a2=Command_Karate_RoundHouseKick,
--[[	JK={
		Before={ "Wait_State","Walk_State" , "Run_State" },
--		Before={ "JumpUp_State" },
		Command={ B },
		After="Attack_State",
		AnimationData=Tech.create(  Com_KungfuJumpKickCombo ),
	},
--]]
--[[	a8={
	--	Before={ "Guard_State", "Land_State" },
		Before={ "Wait_State","Walk_State","ItemGettable_State" },
--		Command={ Down , Left , Up , Right , B },
		Command={ B },
		After="Attack_State",
--		AnimationData=AnimationParam["Ninja"]["JumpRollingKick"]	
--		AnimationData=AnimationParam["Karate"]["BackKick"]	
--		AnimationData=AnimationParam["Ninja"]["JumpRollingKick"]	
		AnimationData=AnimationParam["Kungfu"]["RoundHouseLowerKick"]
	},
--]]
--	a2=Command_Karate_MiddlePunch,
--	a3= Command_Kungfu_ComboJumpKick0,--Command_Karate_JumpKick,
	
	a4=Command_Karate_GrapplingElbow,
	a5=Command_Karate_GrapplingKneeKick,
--	a1=Command_Karate_JumpKneeKick,
--	a7=Command_Common_JumpRoll,
	sideKick=Command_Karate_SideKick,
--	a10=Command_Kungfu_RunningSummersault,
--	a11=Command_Kungfu_ComboKick0,--Command_Karate_JumpKick,
--	a11=Command_Kungfu_SideKick,	
}

Com_KungfuSuperCombo={
	{
		param=AnimationParam["Ninja"]["BackhandBlow"],
		speed=3,
	},
	{
		param=AnimationParam["Karate"]["StraightPunch"],
		speed=3,	
	},
	{
		param=AnimationParam["Karate"]["PunchA"],
		speed=3,
	},
	{
		param=AnimationParam["Karate"]["ShitaZukiR"] ,
		speed=3,	
	},
	{

		param=AnimationParam["Kungfu"]["SummersaultKick"],
		speed=1.5,	
	},
}
Com_KungfuSuperCombo2={
	{
		param=AnimationParam["Karate"]["ShitaZukiR"] ,
		speed=4,
	},
	{
		param=AnimationParam["Karate"]["ShitaZukiL"] ,
		speed=4,	
	},
	{
		param=AnimationParam["Karate"]["ShitaZukiR"] ,
		speed=4,
	},
	{
		param=AnimationParam["Karate"]["ShitaZukiL"] ,
		speed=4,	
	},
	{
--		param=AnimationParam["Kungfu"]["RollingKick2"],
		param=AnimationParam["Kungfu"]["SideKickFinish"],
		speed=2,	
	},
}
Com_KungfuSuperCombo3={
	{
		param=AnimationParam["Kungfu"]["RoundHouseLowerKick"],
		speed=3,
	},
	{
		param=AnimationParam["Kungfu"]["RoundHouseLowerKick"],
		speed=3,	
	},
	{
		param=AnimationParam["Kungfu"]["RoundHouseLowerKick"],
		speed=3,
	},
	{
		param=AnimationParam["Kungfu"]["RoundHouseLowerKick"],
		speed=3,	
	},
	{
		param=AnimationParam["Kungfu"]["SummersaultKick"],
		speed=1.5,	
	},
}

SpecialCommandData["Kungfu"]={
	s3={
		LimiteSec=0.8,
--		Before={ "JumpUp_State"},
		Before={ "Wait_State","Walk_State","Run_State"},
--		Command={  Down , Right , B },
		Command={ B },
		After="Attack_State",
		AnimationData=Tech.create( Com_KungfuSuperCombo ),
--		AnimationData=AnimationParam["Kungfu"]["WhirlWindKick2"]
	},
	s4={
		LimiteSec=0.5,
--		Before={ "JumpUp_State"},
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={  Down , Right , B },
--		Command={ A},
		After="Attack_State",
		AnimationData=Tech.create( Com_KungfuSuperCombo2 ),
	},

	s1={
--		Before={ "JumpUp_State" },
		Before={ "Land_State" },
		Command={ A },
		After="Attack_State",
--		After= "JumpUp_State",
--		AnimationData=AnimationParam["Kungfu"]["HighSpinKick"],
		AnimationData=AnimationParam["Common"]["ZenchuUp"],
	},
	
	
	a6={
		Before={ "Grappling_State" },
		Command={ T},
		type="throw",
		After="GrapplingJumpUp_State",
		thrownChangedState="GrappledJumpUp_State",		
		damagePoint=5,
		damageTime=41,
--		attachPos=,		
--		AnimationData=AnimationParam["Karate"]["SakasaOtoshi"]
--		AnimationData=AnimationParam["Karate"]["BackDrop"],
		AnimationData=AnimationParam["Karate"]["PileDriver"],
		damagedAnimationData=AnimationParam["Common"]["PileDrivered"],
--		processOn="JumpUp",
--		damagedProcessOn="JumpUp",
--		damagedAnimationData=AnimationParam["Common"]["BackDropped"]
	},
}

FlipAnimationData["Ninja"]={
	Wait_State=AnimationParam["Ninja"]["RanzoWait"],
	Walk_State=AnimationParam["Ninja2"]["Walk"],
	Run_State=AnimationParam["Ninja2"]["Run"],	
	Fall_State=AnimationParam["Common"]["Rolling"],
	Dead_State=AnimationParam["Common"]["BatanPikuPiku"],
--	JumpUp_State=AnimationParam["Common"]["Jump"],
}

BasicCommandData["Ninja"]={
	None={
		Before={ "Walk_State","Run_State" },
		Command={ None },
		After="Wait_State",		
		CommandType="isOn",
	},
--]]
	Walk={
		Before={ "Wait_State" },
		Command={ Dir },
		After="Walk_State",
		CommandType="isOn",
	},
	Jump={
		Before={ "Wait_State","Walk_State","Run_State" ,"Grappling_State","Ladder_State"},
		Command={ J },
		After="JumpUp_State",
		AnimationData=AnimationParam["Ninja"]["Rolling"]--{ Name="Rolling2", Speed=1,Initial=0,Mode="Loop" },
	},
	StandUp={
		Before={ "Down_State" },
		Command={ Dir },
		After="StandUp_State",
		CommandType="isOn",
	},
	Guard={
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={ PSController.PS_R1 },
		After="Guard_State",
--		AnimationData=AnimationParam["Common"]["Guard"]
	},
	Run={
		LimiteSec=0.5,
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={ None, Dir , None , Dir },
		After="Run_State",
		CommandType="isOn",
--		AnimationData=AnimationParam["Ninja"]["Run"]
	},
	
	--]]
}

Command_Ninja_ComboSlash_0={
	Before={ "Wait_State","Walk_State","Run_State" },
	Command={ A },
	After="Attack_State",
	AnimationData=AnimationParam["Ninja"]["CutDownBladeR"]
}
Command_Ninja_ComboSlash_1={
	prev=Command_Ninja_ComboSlash_0,
	LimiteSec=0.5,
	Before={ "Wait_State","Walk_State" },
	Command={ A },
	After="Attack_State",
	AnimationData=AnimationParam["Ninja"]["CutUpBladeR"]
--	AnimationData=AnimationParam["Kungfu"]["RollingKick2"]
--	AnimationData=AnimationParam["Ninja2"]["SummersaultKick"]
}
Command_Ninja_ComboSlash_2={
	prev=Command_Ninja_ComboSlash_0,
	LimiteSec=0.5,
	Before={ "Wait_State","Walk_State" },
	Command={ A },
	After="Attack_State",
--	AnimationData=AnimationParam["Ninja"]["FinishCutDownBladeR"]
	AnimationData=AnimationParam["Kungfu"]["RollingKick2"]
--	AnimationData=AnimationParam["Ninja2"]["SummersaultKick"]
}

Command_Ninja_ComboSlash_0["next"] = Command_Ninja_ComboSlash_1;
Command_Ninja_ComboSlash_1["next"] = Command_Ninja_ComboSlash_2;

Command_Ninja_Combo1_0={
	Before={ "Wait_State","Walk_State","Run_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Kungfu"]["RoundHouseLowerKick"]
}
Command_Ninja_Combo1_1={
	prev=Command_Ninja_Combo1_0,
--	LimiteSec=0.5,
	Before={ "Wait_State","Walk_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Kungfu"]["RollingKick2"]
}

Command_Ninja_Combo1_0["next"] = Command_Ninja_Combo1_1;

Com_NinjaCombo={
	{
		param=AnimationParam["Ninja"]["CutDownBladeR"],
		speed=2.5,
	},
	{
		param=AnimationParam["Ninja"]["CutUpBladeR"],
		speed=2.5,	
	},
	{
		param=AnimationParam["Ninja"]["FinishCutDownBladeR"],
		speed=2,	
	},
	
}
AttackCommandData["Ninja"]={
--	A=Command_Ninja_ComboSlash_0,
	A={
--		Before={ "JumpUp_State"},
		Before={ "Wait_State","Walk_State","Run_State"},
--		Command={  Down , Right , B },
		Command={ A },
		After="Attack_State",
		AnimationData=Tech.create( Com_NinjaCombo ),
--		AnimationData=AnimationParam["Ninja"]["CutDownBladeR"],
	},
--]]
	B={
--		Before={ "JumpUp_State"},
		Before={ "Wait_State","Walk_State","Run_State"},
--		Command={  Down , Right , B },
		Command={ B },
		After="Attack_State",
		AnimationData=AnimationParam["Ninja"]["JumpRollingKick"]	
	},
--	Strong=Command_Ninja_Combo1_0,
--[[	JumpAttack={
		Before={ "JumpUp_State","Fall_State" },
		Command={ B },
--		After="Attack_State",
		AnimationData=AnimationParam["Common"]["JumpKick"]
	},
--]]
}

SpecialCommandData["Ninja"]={
	Special1={
		LimiteSec=0.6,
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={Down , Right , J },
		After="JumpUp_State",
		AnimationData=AnimationParam["Ninja"]["Swan"]
	},
	Special2={
		LimiteSec=0.6,
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={Down , Left , J },
		After="Attack_State",
		AnimationData=AnimationParam["Ninja"]["Backflip"]
	},
}

--]]
FlipAnimationData["Ninja2"]={
	Wait_State=AnimationParam["Ninja2"]["Wait"],
	Walk_State=AnimationParam["Ninja2"]["Walk"],
	Run_State=AnimationParam["Ninja2"]["Run"],	
	Fall_State=AnimationParam["Common"]["Rolling"],
}

BasicCommandData["Ninja2"]={
	None={
		Before={ "Walk_State","Run_State" },
		Command={ None },
		After="Wait_State",		
		CommandType="isOn",
	},
--]]
	Walk={
		Before={ "Wait_State" },
		Command={ Dir },
		After="Walk_State",
		CommandType="isOn",
	},
	Jump={
		Before={ "Wait_State","Walk_State","Run_State" ,"Grappling_State","Ladder_State","ItemGettable_State" },
		Command={ J },
		After="JumpUp_State",
		AnimationData=AnimationParam["Common"]["ZenchuUp"],	
--		AnimationData=AnimationParam["Ninja"]["Rolling"]--{ Name="Rolling2", Speed=1,Initial=0,Mode="Loop" },
	},
	StandUp={
		Before={ "Down_State" },
		Command={ Dir },
		After="StandUp_State",
		CommandType="isOn",
	},
	Guard={
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={ PSController.PS_R1 },
		After="Guard_State",
--		AnimationData=AnimationParam["Common"]["Guard"]
	},
	Run={
		LimiteSec=0.5,
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={ None, Dir , None , Dir },
		After="Run_State",
		CommandType="isOn",
--		AnimationData=AnimationParam["Ninja"]["Run"]
	},
	
	--]]
}

Command_Ninja2_Combo1_0={
	Before={ "Wait_State","Walk_State","Run_State" },
	Command={ A },
	After="Attack_State",
	AnimationData=AnimationParam["Ninja2"]["KunaiSlashL"]
}
Command_Ninja2_Combo1_1={
	prev=Command_Ninja2_Combo1_0,
	LimiteSec=0.5,
	Before={ "Wait_State","Walk_State" },
	Command={ A },
	After="Attack_State",
	AnimationData=AnimationParam["Kungfu"]["RollingKick2"]
--	AnimationData=AnimationParam["Ninja2"]["SummersaultKick"]
}
Command_Ninja2_Combo1_0["next"] = Command_Ninja2_Combo1_1;

Command_Ninja2_ComboKick1_0={
	Before={ "Wait_State","Walk_State","Run_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Kungfu"]["RoundHouseLowerKick"]
}
Command_Ninja2_ComboKick1_1={
	prev=Command_Ninja2_ComboKick1_0,
	LimiteSec=0.5,
	Before={ "Wait_State","Walk_State" },
	Command={ B },
	After="Attack_State",
--	AnimationData=AnimationParam["Kungfu"]["RollingKick2"]
	AnimationData=AnimationParam["Ninja2"]["SummersaultKick"]
}

Command_Ninja2_ComboKick1_0["next"] = Command_Ninja2_ComboKick1_1;

AttackCommandData["Ninja2"]={
	Weak=Command_Ninja2_Combo1_0,
	JK={
		Before={ "JumpUp_State"},
--		Before={ "Wait_State","Walk_State","Run_State"},
--		Command={ None,Down , Right , B },
		Command={ B },
		After="Attack_State",
--		AnimationData=Tech.create( TurboPunch ),
		AnimationData=AnimationParam["Ninja"]["JumpRollingKick"]	,
--		AnimationData=AnimationParam["Karate"]["WhirlwindKick1"],
--		AnimationData=AnimationParam["Kungfu"]["WhirlWindKick2"]
	},

--	Strong=Command_Ninja2_ComboKick1_0,
--[[	jump={
		Before={ "Wait_State","Walk_State" ,"Grappling_State","Ladder_State"},
		Command={ B },
		After="JumpUp_State",
		AnimationData=AnimationParam["Ninja2"]["Swan"]--{ Name="Rolling2", Speed=1,Initial=0,Mode="Loop" },
	},
--]]
--[[	JumpAttack={
		Before={ "JumpUp_State","Fall_State" },
		Command={ B },
--		After="Attack_State",
		AnimationData=AnimationParam["Common"]["JumpKick"]
	},
--]]
}

SpecialCommandData["Ninja2"]={
	Special1={
		LimiteSec=0.6,
		Before={ "Run_State"},
--		Command={Down , Right , J },
		Command={ J },
		After="JumpUp_State",
--		After="Attack_State",
		AnimationData=AnimationParam["Ninja2"]["Swan"]
	},
}

--]]
FlipAnimationData["KickBoxer"]={
	Wait_State=AnimationParam["Karate"]["Wait"],
	Walk_State=AnimationParam["Karate"]["Walk"],
	Run_State=AnimationParam["Karate"]["Run"],
	Fall_State=AnimationParam["Common"]["FallDown"],
	JumpUp_State=AnimationParam["Common"]["Jump"],
--	Guard_State=AnimationParam["Common"]["Squat"],	
	
}

BasicCommandData["KickBoxer"]={
	None={
		Before={ "Walk_State","Run_State" },
		Command={ None },
		After="Wait_State",		
		CommandType="isOn",
	},
--]]
	Walk={
		Before={ "Wait_State" },
		Command={ Dir },
		After="Walk_State",
		CommandType="isOn",
	},
	Jump={
		Before={ "Wait_State","Walk_State" ,"Grappling_State","Ladder_State"},
		Command={ J },
		After="JumpUp_State",
--		AnimationData=AnimationParam["Ninja"]["Rolling"]--{ Name="Rolling2", Speed=1,Initial=0,Mode="Loop" },
	},
	StandUp={
		Before={ "Down_State" },
		Command={ Dir },
		After="StandUp_State",
		CommandType="isOn",
	},
	Guard={
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={ PSController.PS_R1 },
		After="Guard_State",
--		AnimationData=AnimationParam["Common"]["Guard"]
	},
--]]
	Run={
		LimiteSec=0.5,
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={ None, Dir , None , Dir },
		After="Run_State",
		CommandType="isOn",
--		AnimationData=AnimationParam["Ninja"]["Run"]
	},
	
	--]]
}

BurningUpper={
	LimiteSec=0.7,
--	Before={ "Guard_State" },
	Before={ "Wait_State","Walk_State","Run_State"},
	Command={ None,Down , Right , A },
	After="Attack_State",
	AnimationData=AnimationParam["Kungfu"]["GazzelUpper"],
--	AnimationData=AnimationParam["Karate"]["PunchA"],
--	AnimationData=AnimationParam["Ninja"]["BackhandBlow"],
}

Command_KB_Combo1_0={
	Before={ "Wait_State","Walk_State","Run_State"},
	Command={ PSController.PS_R1 },
	After="Attack_State",
--	After="Guard_State",
	CommandType="isOn",
	AnimationData=AnimationParam["Common"]["Squat"],	
}
Command_KB_Combo1_1={
	prev=Command_KB_Combo1_0,
	LimiteSec=0.6,
--	Before={ "Guard_State" },
	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
	AnimationData=AnimationParam["Kungfu"]["GazzelUpper"],
--	AnimationData=AnimationParam["Karate"]["PunchA"],
--	AnimationData=AnimationParam["Ninja"]["BackhandBlow"],
}
Command_KB_Combo1_0["next"] = Command_KB_Combo1_1;

AttackCommandData["KickBoxer"]={
	A=Command_Boxing_Combo1_0,
--[[	{
--		Before={ "Wait_State","Walk_State" },
		Before={ "Guard_State" },
		Command={ A },
		After="Attack_State",
		
	--	AnimationData=AnimationParam["Kungfu"]["RollingKick2"]
		AnimationData=AnimationParam["Kungfu"]["GazzelUpper"],
		--AnimationParam["Karate"]["MiddlePunch"],
	},
--]]
	
--	Combo=Command_KB_Combo1_0,
	B={
		Before={ "Wait_State","Walk_State" },
		Command={ B },
		After="Attack_State",
	--	AnimationData=AnimationParam["Kungfu"]["RollingKick2"]
		AnimationData=AnimationParam["Karate"]["RoundHouseMiddleKick"],
	},
--	Strong=Command_Ninja2_ComboKick1_0,
--[[	jump={
		Before={ "Wait_State","Walk_State" ,"Grappling_State","Ladder_State"},
		Command={ B },
		After="JumpUp_State",
		AnimationData=AnimationParam["Ninja2"]["Swan"]--{ Name="Rolling2", Speed=1,Initial=0,Mode="Loop" },
	},
--]]
--[[	JumpAttack={
		Before={ "JumpUp_State","Fall_State" },
		Command={ B },
--		After="Attack_State",
		AnimationData=AnimationParam["Common"]["JumpKick"]
	},
--]]
}
SpecialCommandData["KickBoxer"]={
	Upper=BurningUpper,
}
FlipAnimationData["Surge"]={
	Wait_State=AnimationParam["Surge"]["SurgeWait"],
	Walk_State=AnimationParam["Surge"]["SurgeWalk"],
	Run_State=AnimationParam["Surge"]["SurgeWalk"],
	Fall_State=AnimationParam["Common"]["Rolling"],
	JumpUp_State=AnimationParam["Common"]["Jump"],
	Guard_State=AnimationParam["Common"]["Guard"],	
}

BasicCommandData["Surge"] = {
	b9={
		LimiteSec=1,
		Before={ "ItemGettable_State"},
		Command={ A  },
		After="GetItem_State",
		AnimationData=AnimationParam["Common"]["PickUp"]
	},
	b1={
		Before={ "Walk_State","Run_State" },
		Command={ None },
		After="Wait_State",
		CommandType="isOn",
	},
	b2={
		Before={ "Wait_State" },
		Command={ Dir },
		After="Walk_State",
		CommandType="isOn",
	},
	b3={
		Before={ "Wait_State","Walk_State","Run_State" ,"Grappling_State","Ladder_State","ItemGettable_State" },
		Command={ J },
		After="JumpUp_State",	
	},
	b4={
		Before={ "Down_State" , "FaceDownLand_State" },
		Command={ Dir },
		After="StandUp_State",
		CommandType="isOn",
	},
	b5={
		LimiteSec=0.5,
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={ None, Dir , None , Dir },
		After="Run_State",
		CommandType="isOn",
	},
	b6={
		Before={ "Wait_State","Walk_State","Run_State","ItemGettable_State"},
		Command={ PSController.PS_R1 },
		After="Guard_State",
		CommandType="isOn",
		
	},
	b7={
		LimiteSec=1,
		Before={ "Grappled_State"},
		Command={ A , None , A },
		After="Attack_State",
		AnimationData=AnimationParam["Common"]["ResistGrappled"]
	},
--[[
	b8={
		LimiteSec=1,
		Before={ "Wait_State"},
		Command={ A  },
		After="Attack_State",
		AnimationData=AnimationParam["Common"]["PickUp"]
	},
--]]
}

Command_Surge_Tackle={
	Before={ "Wait_State","Walk_State" },
	Command={ A },
	After="Attack_State",
	AnimationData=AnimationParam["Surge"]["Tackle"],
}
Command_Surge_Punch={
	Before={ "Wait_State","Walk_State" },
	Command={ A },
	After="Attack_State",
	AnimationData=AnimationParam["Surge"]["SurgePunchL"],
}
Command_Surge_Kick={
	Before={ "Wait_State","Walk_State" },
	Command={ B },
	After="Attack_State",
	AnimationData=AnimationParam["Surge"]["JumonjiKick"],
}
Command_Surge_Combo1_0={
	Before={ "Wait_State","Walk_State" },
	Command={ A },
	After="Attack_State",
	AnimationData=AnimationParam["Karate"]["MiddlePunch"]
--	AnimationData=AnimationParam["Surge"]["PreAttack"],
}
Command_Surge_Combo1_1={
	prev=Command_Surge_Combo1_0,
	LimiteSec=0.8,
	Before={ "Wait_State","Walk_State","ItemGettable_State" },
--	Before={ "Attack_State" },
	Command={ A },
	After="Attack_State",
--	AnimationData=AnimationParam["Surge"]["SurgePunchR"],
	AnimationData=AnimationParam["Surge"]["SurgePunchL"],
	
}
--[[
Command_Surge_Combo1_2={
	prev=Command_Surge_Combo1_0,
--	LimiteSec=0.3,
	Before={ "Wait_State","Walk_State","Attack_State","ItemGettable_State" },
	Command={ A },
	After="Attack_State",
	AnimationData=AnimationParam["Surge"]["SurgePunchL"],
}
--]]
Command_Surge_Combo1_0["next"] = Command_Surge_Combo1_1;
--Command_Surge_Combo1_1["next"] = Command_Surge_Combo1_2;

Command_Surge_RunningSummersault={
	Before={ "Run_State" },
--	Before={ "Attack_State" },
	Command={ B },
	After="Attack_State",
--	AnimationData=AnimationParam["Surge"]["FinishKick"],
--	AnimationData=AnimationParam["Ninja"]["RollingKick"],
	AnimationData=AnimationParam["Kungfu"]["SummersaultKick"],
}

AttackCommandData["Surge"]={
	A=Command_Surge_Combo1_0,
--	a10=Command_Surge_RunningSummersault,
--	A=Command_Surge_Punch,
	B=Command_Surge_Kick,
--	a2=Command_Surge_Tackle,
--[[	A={
		Before={ "Wait_State","Walk_State","Run_State" },
		Command={ A },
		After="Attack_State",
		AnimationData=AnimationParam["Karate"]["DoubleLariat"],
	}
--]]	
}

SpecialCommandData["Surge"]={
	s1={
--		Before={ "JumpUp_State" },
		Before={ "Run_State" },
		Command={ A },
		After="Attack_State",
--		AnimationData=AnimationParam["Surge"]["HighSpinKick"],
		AnimationData=AnimationParam["Surge"]["Tackle"],
	},
	a6={
		Before={ "Grappling_State" },
		Command={ T},
		type="throw",
		After="GrapplingJumpUp_State",
		thrownChangedState="GrappledJumpUp_State",		
		damagePoint=5,
		damageTime=41,
--		attachPos=,		
--		AnimationData=AnimationParam["Karate"]["SakasaOtoshi"]
--		AnimationData=AnimationParam["Karate"]["BackDrop"],
		AnimationData=AnimationParam["Karate"]["PileDriver"],
		damagedAnimationData=AnimationParam["Common"]["PileDrivered"],
--		processOn="JumpUp",
--		damagedProcessOn="JumpUp",
--		damagedAnimationData=AnimationParam["Common"]["BackDropped"]
	},
}

SpecialCommandData["Billy"]={
	rashR={
		LimiteSec=0.5,
--		Before={ "JumpUp_State"},
		Before={ "Wait_State","Walk_State","Run_State"},
--		Before={ "Run_State"},
		Command={  Down , Right , A },
--		Command={ A},
		After="Attack_State",
		AnimationData=Tech.create( Com_KungfuSuperCombo ),
	},
	rashL={
		LimiteSec=0.5,
--		Before={ "JumpUp_State"},
		Before={ "Wait_State","Walk_State","Run_State"},
--		Before={ "Run_State"},
		Command={  Down , Left , A },
--		Command={ A},
		After="Attack_State",
		AnimationData=Tech.create( Com_KungfuSuperCombo ),
	},
	kawashi={
		LimiteSec=0.5,
		Before={ "Guard_State"},
--		Before={ "Wait_State","Walk_State","Run_State"},
		Command={ A },
--		Command={ PSController.PS_TRIANGLE },
		After="Kawashi_State",
		AnimationData=AnimationParam["Common"]["Kawashi"],
	},	
	b8={
		LimiteSec=0.5,
		Before={ "Guard_State"},
--		Command={ None,Dir,None,Dir },
		Command={ None,Dir,},
		After="Attack_State",
		InnerPro={ 0,1 },
		AnimationData=AnimationParam["Common"]["JumpRoll"],
	},	
	back={
		LimiteSec=0.5,
		Before={ "Guard_State"},
--		Command={ None,Dir,None,Dir },
		Command={ None,Dir,},
		After="Attack_State",
		InnerPro={ -1,-0.5, },
		AnimationData=AnimationParam["Ninja"]["Backflip"],
	},	

--[[	super={
		LimiteSec=0.8,
--		Before={ "JumpUp_State"},
		Before={ "Wait_State","Walk_State","Run_State"},
--		Command={  Down , Right , B },
		Command={ B },
		After="Attack_State",
		AnimationData=Tech.create( Com_KungfuSuperCombo ),
--		AnimationData=AnimationParam["Kungfu"]["WhirlWindKick2"]
	},
--]]
	s1={
--		Before={ "JumpUp_State" },
		Before={ "Land_State" },
		Command={ A },
		After="Attack_State",
--		After= "JumpUp_State",
--		AnimationData=AnimationParam["Kungfu"]["HighSpinKick"],
		AnimationData=Tech.create(  ZenchuKakatoOtoshi ),--AnimationParam["Common"]["ZenchuUp"],
	},
--]]

	b9={
--		LimiteSec=1,
		Before={ "ItemGettable"},
		Command={ A  },		
		After="GetItem_State",
		AnimationData=AnimationParam["Common"]["PickUp"]
	},
--[[	throw={
		Before={ "ItemAttach"},
		Command={ B  },		
		After="ThrowItem_State",
		AnimationData=AnimationParam["Common"]["ThrowItem"]
	},
--]]
	whirlR={
		LimiteSec=0.4,
--		Before={ "JumpUp_State"},
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={ None,Down , Right , B },
--		Command={ B },
		After="Attack_State",
--		AnimationData=Tech.create( TurboPunch ),
		AnimationData=AnimationParam["Karate"]["WhirlwindKick1"],
--		AnimationData=AnimationParam["Kungfu"]["WhirlWindKick2"]
	},
	whirlL={
		LimiteSec=0.4,
--		Before={ "JumpUp_State"},
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={ None,Down , Left , B },
--		Command={ B },
		After="Attack_State",
--		AnimationData=Tech.create( TurboPunch ),
		AnimationData=AnimationParam["Karate"]["WhirlwindKick1"],
--		AnimationData=AnimationParam["Kungfu"]["WhirlWindKick2"]
	},	
--]]
--[[	knee={
		LimiteSec=0.3,
--		Before={ "Land_State"},
--		Before={ "JumpUp_State"},
		Before={ "Run_State"},
		Command={ B },
		After="Attack_State",
		AnimationData=AnimationParam["Karate"]["JumpKneeKick"],
	},
	a6={
		Before={ "Grappling_State" },
		Command={ T},
		type="throw",
		After="GrapplingJumpUp_State",
		thrownChangedState="GrappledJumpUp_State",		
		damagePoint=5,
		damageTime=41,
--		attachPos=,		
--		AnimationData=AnimationParam["Karate"]["SakasaOtoshi"]
--		AnimationData=AnimationParam["Karate"]["BackDrop"],
		AnimationData=AnimationParam["Karate"]["PileDriver"],
		damagedAnimationData=AnimationParam["Common"]["PileDrivered"],
--		processOn="JumpUp",
--		damagedProcessOn="JumpUp",
--		damagedAnimationData=AnimationParam["Common"]["BackDropped"]
	},	
--]]
	
}
SpecialCommandData["Todo"]={
	s3={
		LimiteSec=0.7,
--		Before={ "JumpUp_State"},
		Before={ "Wait_State","Walk_State","Run_State"},
		Command={ B },
--		Command={ B },
		After="Attack_State",
--		AnimationData=Tech.create( TurboPunch ),
--		AnimationData=AnimationParam["Karate"]["WhirlwindKick1"],
		AnimationData=AnimationParam["Kungfu"]["WhirlWindKick2"]
	},
}
SpecialCommandData["Karate"]={

--[[	s4={
		LimiteSec=0.5,
		Before={ "Fall_State"},
--		Before={ "JumpUp_State"},
--		Before={ "Wait_State","Walk_State","Run_State"},
--		Command={ None , Down , Left , B },
		Command={ B },
		After="Attack_State",
--		AnimationData=Tech.create( SerialKick ),
--		AnimationData=Tech.create( MachineGunPunch ),
		AnimationData=AnimationParam["Karate"]["WhirlwindKick1"]
	},
--]]	
--[[
	s2={
		LimiteSec=0.5,
--		Before={ "JumpUp_State"},
		Before={ "Run_State"},
		Command={ B },
		After="Attack_State",
--		AnimationData=AnimationParam["Karate"]["UpperCut"]
		AnimationData=AnimationParam["Karate"]["DoubleLariat"]
	},
--]]
--[[
	s5={
		Before={ "Land_State" },
		Command={ B },
		After="Attack_State",
		AnimationData=AnimationParam["Karate"]["JumpKneeKick"]
	},
	s6={
		Before={ "Land_State" },
		Command={ A },
		After="Attack_State",
		AnimationData=AnimationParam["Karate"]["TornadoUpper"]
	},
--]]
}

FlipAnimationData["Common"]={
	Grappling_State=AnimationParam["Common"]["Grappling"],
	Grappled_State=AnimationParam["Common"]["Grappled"],
	Land_State=AnimationParam["Common"]["Land"],
	Ladder_State=AnimationParam["Common"]["Radar"],
	SmallDamaged_State=AnimationParam["Common"]["SmallDamaged1"],
	MiddleDamaged_State=AnimationParam["Common"]["MiddleDamaged"],
	BlewUp_State=AnimationParam["Common"]["BlewUp2"],
	BlewUpDown_State=AnimationParam["Common"]["BlewUpDown"],
--	BlewDown_State=AnimationParam["Common"]["BeatFallDown"],	
	Down_State=AnimationParam["Common"]["Down"],
	GrappledDamaged_State=AnimationParam["Common"]["GrapplingAttackedKick"],
	StandUp_State=AnimationParam["Common"]["StandUp"],	
	Guard_State=AnimationParam["Common"]["Guard"],
	BoundWall_State=AnimationParam["Common"]["BoundWall"],
	BoundDown_State=AnimationParam["Common"]["BoundDown"],
	FrontFallDown_State=AnimationParam["Common"]["FrontFallDown"],
	FaceDownLand_State=AnimationParam["Common"]["FaceDownLand"],
--	ItemGettable_State=AnimationParam["Common"]["PickUp"],
}


AnimationParam["Kungfu"]["SideKickFinish"]["SoundKey"]={
	{ 5 , "Karaburi" },
	{ 9 , "voice_ha" },
}
AnimationParam["Kungfu"]["RollingKick2"]["SoundKey"]={
	{ 5 , "Karaburi" },
	{ 9 , "voice_ha" },
}

AI_StateData["Base_Normal"]={
	AppRun={ 
		distanceThreshold=2,
		inputThreshold=0.5,
		toTarget=true,
	},
	AppWalk={
		distanceThreshold=2,
		inputThreshold=0.5,
		toTarget=true,
	},
	AwayWalk={
		distanceThreshold=10,
		inputThreshold=0.5,
		toTarget=true,
	},
	AwayRun={
		distanceThreshold=10,
		inputThreshold=0.5,
		toTarget=true,
	},
	ThinkNN={
		waitMilliSec=500,--1000,	
	},

	Wait={
		toTarget=true,	
	},
	Fight={
		waitMilliSec=220,
		toTarget=true,	
	},
	RandMove={
		waitMilliSec=500,
		waitMilliLower=100,
		waitMilliUpper=1000,
		awayDistanceThreshold=10,
		appDistanceThreshold=2,
		inputThreshold=0.5,
	},	

}
AI_FightInputData["Karate_Fight_Easy"]={ A,A,B };
AI_FightInputData["Karate_Fight_Normal"]={ A,A,A,A,B,B };
--AI_FightInputData["Karate_Fight_Normal"]={ B,B,B,None,None,A,A,B,B };
AI_FightInputData["Karate_Fight_Hard"]={ A,A,B,A,B,A,B,A,B };
AI_FightInputData["KickBoxer_Fight_Easy"]={ B,None,A,A,None,None,None,None,B,B };
AI_FightInputData["KickBoxer_Fight_Normal"]={ A,A,A,A,None,None,B,B,None,None,A,A,None,B};
AI_FightInputData["KickBoxer_Fight_Hard"]={ A,A,A,A,B,B,B,B};
AI_FightInputData["Boxing_Fight_Easy"]={ A,A,A,B,None,None,None,A,A,B };
AI_FightInputData["Boxing_Fight_Normal"]={ A,A,A,B,None,None,None,A,A,B };
AI_FightInputData["Boxing_Fight_Hard"]={ A,A,A,B,None,None,None,A,A,B };
AI_FightInputData["Kungfu_Fight_Easy"]={ A,A,A,B,None,None,None,A,A,B };
AI_FightInputData["Kungfu_Fight_Normal"]={ A,A,A,B,None,None,None,A,A,B };
AI_FightInputData["Kungfu_Fight_Hard"]={ A,A,A,B,A,A,B,A,A,B };

AI_FightInputData["Ninja2_Fight_Easy"]={ B,None,A,A,None,None,J,J,None,None,B,B };
AI_FightInputData["Ninja2_Fight_Normal"]={ J,J,None,B,B,None,None,B,A,B,};
AI_FightInputData["Ninja2_Fight_Hard"]={ A,A,A,A,B,B,B,B,J,J,};

AI_FightInputData["Surge_Fight_Easy"]={ A,None,None,None,B,B,B, };
AI_FightInputData["Surge_Fight_Normal"]={ A,A,A,B,A,None,None,B, };
AI_FightInputData["Surge_Fight_Hard"]={ A,A,B, };

BehavCostMap["Easy"]={
	Aggressive=-5,
	Defensive=-3,
	GoStraight=-1,
	Hover=3,
	Away=-3,
	Cunning=0,
}
BehavCostMap["Normal"]={
	Aggressive=-3,
	Defensive=-3,
	GoStraight=-1,
	Hover=2,
	Away=-1,
	Cunning=0,
}
BehavCostMap["Hard"]={
	Aggressive=-2,
	Defensive=-1,
	GoStraight=-1,
	Hover=1,
	Away=-1,
	Cunning=0,
}

BehavScorePtMap["Zako"]={
--_[W𕉂킳ꂽ
	smallPained={ behav="Aggressive" , score=2 },
	middlePained={ behav="Defensive" , score=3 },
	mostPained={ behav="Defensive" , score=3 },
--_[W𕉂킵	
--[[	smallPain={ behav="Aggressive" , score=2 },
	middlePain={ behav="Defensive" , score=3 },
	mostPain={ behav="Hover" , score=3 },
--]]
}
BehavScorePtMap["Boss"]={
--_[W𕉂킳ꂽ
	smallPained={ behav="Aggressive" , score=10 },
	middlePained={ behav="Defensive" , score=4 },
	mostPained={ behav="Defensive" , score=3 },
--_[W𕉂킵	
	smallPain={ behav="Defensive" , score=10 }, --_[W𕉂킷Ɩh䂵
	middlePain={ behav="Defensive" , score=3 }, --_[W𕉂킷Ƃ
	mostPain={ behav="Hover" , score=3 },--_[W𕉂킷Ƒӂ
}

FuzzySet["distance"]={
	name="distance",
	borderThreshold=4,
	borderExpression="distant",
	fuzzyVals={
		distant={
			denom=2,
			nume=1,
			shift=6,		
		},
		near={
			denom=2,
			nume=1,
			shift=4,		
		},
		reach={
			denom=2,
			nume=1,
			shift=0,		
		},	
	}
}

FuzzySet["pain"]={
	name="pain",
	borderThreshold=4,
	borderExpression="mostPain",
	fuzzyVals={
		mostPain={
			denom=2,
			nume=1,
			shift=4,		
		},
		middlePain={
			denom=2,
			nume=1,
			shift=2,		
		},
		smallPain={
			denom=2,
			nume=1,
			shift=0,		
		},	
	}
}



AttackHitProcessData={  ShitaZukiR = {  HitSoundName = "tm2_hit004",  EndTime = 14,  BeginTime = 5,  DamagePoint = 1,  HitFrameName = "HandR_Joint",}
,  ZenchuKakato = {  HitSoundName = "tm2_hit005",  EndTime = 70,  BeginTime = 50,  DamagePoint = 5,  HitFrameName = "FootR_Joint",}
,  BackhandBlow = {  HitSoundName = "tm2_hit004",  EndTime = 12,  BeginTime = 9,  DamagePoint = 1,  HitFrameName = "HandL_Joint",}
,  HookR = {  HitSoundName = "tm2_hit004",  combo = true,  EndTime = 12,  BeginTime = 9,  DamagePoint = 1,  HitFrameName = "HandR_Joint",}
,  FrontKick = {  HitSoundName = "tm2_hit004",  EndTime = 30,  BeginTime = 20,  DamagePoint = 2,  HitFrameName = "FootR_Joint",}
,  Tackle = {  HitSoundName = "tm2_hit005",  combo = true,  EndTime = 35,  BeginTime = 10,  DamagePoint = 5,  HitFrameName = "ShoulderL_Joint",}
,  GrapplingKneeKick = {  HitSoundName = "tm2_hit004",  EndTime = 15,  BeginTime = 12,  DamagePoint = 3,  HitFrameName = "KneeR_Joint",}
,  ResistGrappled = {  HitSoundName = "tm2_hit005",  EndTime = 20,  BeginTime = 10,  DamagePoint = 1,  HitFrameName = "ElbowL_Joint",}
,  JumpRoll = {  HitSoundName = "tm2_hit004",  EndTime = 20,  BeginTime = 0,  DamagePoint = 1,  HitFrameName = "ElbowL_Joint",}
,  TornadoUpper = {  HitSoundName = "Explosion02",  EndTime = 35,  BeginTime = 16,  DamagePoint = 4,  HitFrameName = "HandR_Joint",}
,  GrapplingElbow = {  HitSoundName = "tm2_hit004",  EndTime = 12,  BeginTime = 5,  DamagePoint = 1,  HitFrameName = "ElbowL_Joint",}
,  StraightPunch = {  HitSoundName = "hit_p01_c",  EndTime = 12,  BeginTime = 9,  DamagePoint = 1,  HitFrameName = "HandR_Joint",}
,  UpperCut = {  HitSoundName = "tm2_hit005",  EndTime = 20,  BeginTime = 13,  DamagePoint = 4,  HitFrameName = "HandR_Joint",}
,  JumpKick = {  HitSoundName = "tm2_hit004",  EndTime = 20,  BeginTime = 5,  DamagePoint = 3,  HitFrameName = "FootL_Joint",}
,  MiddleHookL = {  HitSoundName = "tm2_hit004",  combo = true,  EndTime = 12,  BeginTime = 9,  DamagePoint = 2,  HitFrameName = "HandL_Joint",}
,  SideKickFinish = {  HitSoundName = "tm2_hit005",  EndTime = 32,  BeginTime = 28,  DamagePoint = 5,  HitFrameName = "FootL_Joint",}
,  SideKickStart = {  HitSoundName = "tm2_hit004",  EndTime = 32,  BeginTime = 28,  DamagePoint = 2,  HitFrameName = "FootL_Joint",}
,  BackKick = {  HitSoundName = "tm2_hit005",  EndTime = 32,  BeginTime = 28,  DamagePoint = 3,  HitFrameName = "FootR_Joint",}
,  HookL = {  HitSoundName = "tm2_hit004",  combo = true,  EndTime = 12,  BeginTime = 9,  DamagePoint = 1,  HitFrameName = "HandL_Joint",}
,  KunaiSlashL = {  HitSoundName = "tm2_slash003",  EndTime = 12,  BeginTime = 9,  DamagePoint = 3,  HitFrameName = "HandL_Joint",}
,  JumpRollingKick = {  HitSoundName = "hit57",  EndTime = 25,  BeginTime = 16,  DamagePoint = 5,  HitFrameName = "FootR_Joint",}
,  RoundHouseMiddleKick = {  HitSoundName = "tm2_hit004",  EndTime = 30,  BeginTime = 23,  DamagePoint = 5,  HitFrameName = "FootR_Joint",}
,  FinishCutDownBladeR = {  HitSoundName = "tm2_slash003",  EndTime = 40,  BeginTime = 30,  DamagePoint = 3,  HitFrameName = "BladeR_Joint",}
,  CutUpBladeR = {  HitSoundName = "slash",  EndTime = 23,  BeginTime = 15,  DamagePoint = 2,  HitFrameName = "BladeR_Joint",}
,  CutDownBladeR = {  HitSoundName = "slash",  EndTime = 30,  BeginTime = 20,  DamagePoint = 5,  HitFrameName = "BladeR_Joint",}
,  JumpKick3 = {  HitSoundName = "tm2_hit004",  EndTime = 25,  BeginTime = 15,  DamagePoint = 2,  HitFrameName = "FootL_Joint",}
,  CutDown = {  HitSoundName = "tm2_slash003",  EndTime = 40,  BeginTime = 30,  DamagePoint = 5,  HitFrameName = "BladeR_Joint",}
,  SummersaultKick = {  HitSoundName = "hit57",  EndTime = 35,  BeginTime = 24,  DamagePoint = 5,  HitFrameName = "FootR_Joint",}
,  WhirlwindKick1 = {  HitRevivalTime={ 10,20,30,40,50,60,70,80,90},HitSoundName = "hit57",  EndTime = 110,  BeginTime = 0,  DamagePoint = 5,  HitFrameName = "BodyCenter_Joint",}
,  JumpKneeKick = {  HitSoundName = "hit57",  EndTime = 30,  BeginTime = 0,  DamagePoint = 3,  HitFrameName = "KneeR_Joint",}
,  ShitaZukiL = {  HitSoundName = "tm2_hit004",  EndTime = 20,  BeginTime = 5,  DamagePoint = 1,  HitFrameName = "HandL_Joint",}
,  GazzelUpper = {  HitSoundName = "hit57",  EndTime = 20,  BeginTime = 13,  DamagePoint = 4,  HitFrameName = "HandR_Joint",}
,  ShorinTsukiR = {  HitSoundName = "tm2_hit004",  EndTime = 15,  BeginTime = 11,  DamagePoint = 2,  HitFrameName = "HandR_Joint",}
,  ZenchuUp = {  HitSoundName = "tm2_hit005",  EndTime = 20,  BeginTime = 0,  DamagePoint = 3,  HitFrameName = "BodyCenter_Joint",}
, KuutenKick = {  HitSoundName = "tm2_hit005",  EndTime = 55,  BeginTime = 43,  DamagePoint = 5,  HitFrameName = "FootR_Joint",}
,  JumonjiKick = {  HitSoundName = "hit57",  combo = true,  EndTime = 35,  BeginTime = 30,  DamagePoint = 4,  HitFrameName = "FootR_Joint",}
, DoubleLariat = {  HitSoundName = "hit57",  combo = true,  EndTime = 30,  BeginTime = 20,  DamagePoint = 6,  HitFrameName = "BodyCenter_Joint",}
,  RollingKick2 = {  HitSoundName = "hit57",  EndTime = 21,  BeginTime = 16,  DamagePoint = 3,  HitFrameName = "FootR_Joint",}
,  PunchA = {  HitSoundName = "tm2_hit004",  combo = true,  EndTime = 12,  BeginTime = 3,  DamagePoint = 1,  HitFrameName = "HandL_Joint",}
,  SurgePunchL = {  HitSoundName = "tm2_hit004",  combo = true,  EndTime = 32,  BeginTime = 26,  DamagePoint = 5,  HitFrameName = "HandL_Joint",}
,  JumpKick2 = {  HitSoundName = "tm2_hit004",  EndTime = 25,  BeginTime = 15,  DamagePoint = 3,  HitFrameName = "FootR_Joint",}
,  SurgePunchR = {  HitSoundName = "tm2_hit005",  combo = true,  EndTime = 32,  BeginTime = 23,  DamagePoint = 3,  HitFrameName = "HandR_Joint",}
,  RoundHouseKick = {  HitSoundName = "hit57",  EndTime = 30,  BeginTime = 20,  DamagePoint = 3,  HitFrameName = "FootR_Joint",}
,  FinishKick = {  HitSoundName = "hit57",  EndTime = 30,  BeginTime = 5,  DamagePoint = 3,  HitFrameName = "FootR_Joint",}
,  RoundHouseLowerKick = {  HitSoundName = "tm2_hit005",  EndTime = 40,  BeginTime = 30,  DamagePoint = 2,  HitFrameName = "FootR_Joint",}
,  MiddlePunch = {  HitSoundName = "tm2_hit004",  EndTime = 20,  BeginTime = 13,  DamagePoint = 3 , HitFrameName = "HandR_Joint",}
,  RollingKick = {  HitSoundName = "hit57",  EndTime = 30,  BeginTime = 20,  DamagePoint = 3,  HitFrameName = "FootR_Joint",}
,  HighSpinKick = {  HitSoundName = "tm2_hit005",  EndTime = 50,  BeginTime = 33,  DamagePoint = 5,  HitFrameName = "FootL_Joint",}
,  WhirlWindKick2 = {  HitSoundName = "tm2_hit005",  EndTime = 70,  BeginTime = 16,  DamagePoint = 4,  HitFrameName = "KneeR_Joint",}
,  StickAttack = {  HitSoundName = "tm2_hit004",  EndTime = 20,  BeginTime = 15,  DamagePoint = 1,  HitFrameName = "HandR_Joint",}
,SpinKick = {  HitSoundName = "tm2_hit005",  EndTime = 60,  BeginTime = 37,  DamagePoint = 4,  HitFrameName = "FootR_Joint",}
,}

--[[
CameraData["stage1_1Entered"]={  eyePos = {{  y = 6,  x = 12.349926948547,  z = -10.750000953674,  t = 0,  w = 0,}
,{  y = 6,  x = 12.419921875,  z = -10.750000953674,  t = 0.3,  w = 0,}
,{  y = 6,  x = 12.219917297363,  z = -10.750000953674,  t = 0.6,  w = 0,}
,{  y = 6,  x = 11.669911384583,  z = -10.750000953674,  t = 0.9,  w = 0,}
,{  y = 6,  x = 10.369903564453,  z = -10.750000953674,  t = 1.2,  w = 0,}
,{  y = 6,  x = 5.619900226593,  z = -10.950001716614,  t = 1.5,  w = 0,}
,{  y = 6,  x = -3.500100851059,  z = -10.750000953674,  t = 1.8,  w = 0,}
,{  y = 6,  x = -9.2000961303711,  z = -10.550000190735,  t = 2.1,  w = 0,}
,{  y = 6,  x = -10.700094223022,  z = -10.5,  t = 2.4,  w = 0,}
,{  y = 6,  x = -11.250092506409,  z = -10.449999809265,  t = 2.7,  w = 0,}
,{  y = 6,  x = -11.150088310242,  z = -10.449999809265,  t = 3,  w = 0,}
,}
,  lookAtPos = {{  y = 1,  x = 12.349926948547,  z = -0.75000005960464,  t = 0,  w = 0,}
,{  y = 1,  x = 12.419921875,  z = -0.75000005960464,  t = 0.3,  w = 0,}
,{  y = 1,  x = 12.219917297363,  z = -0.75000005960464,  t = 0.6,  w = 0,}
,{  y = 1,  x = 11.669911384583,  z = -0.75000005960464,  t = 0.9,  w = 0,}
,{  y = 1,  x = 10.369903564453,  z = -0.75000005960464,  t = 1.2,  w = 0,}
,{  y = 1,  x = 5.619900226593,  z = -0.95000010728836,  t = 1.5,  w = 0,}
,{  y = 1,  x = -3.500100851059,  z = -0.75000005960464,  t = 1.8,  w = 0,}
,{  y = 1,  x = -9.2000961303711,  z = -0.55000001192093,  t = 2.1,  w = 0,}
,{  y = 1,  x = -10.700094223022,  z = -0.5,  t = 2.4,  w = 0,}
,{  y = 1,  x = -11.250092506409,  z = -0.44999998807907,  t = 2.7,  w = 0,}
,{  y = 1,  x = -11.150088310242,  z = -0.44999998807907,  t = 3,  w = 0,}
,}
,}


CameraData["stage1_1Entered"]={  eyePos = {{  y = 0.56304520368576,  x = 14.217234611511,  z = 0.22717845439911,  t = 0,  w = 0,}
,{  y = 0.92762327194214,  x = 12.251921653748,  z = 0.15907776355743,  t = 0.3,  w = 0,}
,{  y = 1.2922011613846,  x = 10.286608695984,  z = 0.090977139770985,  t = 0.6,  w = 0,}
,{  y = 1.6532351970673,  x = 8.7949352264404,  z = -1.880420088768,  t = 0.9,  w = 0,}
,{  y = 2.0017976760864,  x = 7.4078521728516,  z = -3.9440987110138,  t = 1.2,  w = 0,}
,{  y = 2.3354659080505,  x = 5.5187950134277,  z = -5.2595796585083,  t = 1.5,  w = 0,}
,{  y = 2.6629509925842,  x = 2.7225518226624,  z = -7.6109752655029,  t = 1.8,  w = 0,}
,{  y = 2.9767549037933,  x = -1.4178550243378,  z = -10.805234909058,  t = 2.1,  w = 0,}
,{  y = 3.2722091674805,  x = -6.8552026748657,  z = -11.987894058228,  t = 2.4,  w = 0,}
,{  y = 3.5649638175964,  x = -10.148572921753,  z = -10.136339187622,  t = 2.7,  w = 0,}
,{  y = 3.6545438766479,  x = -11.108916282654,  z = -9.1433591842651,  t = 3,  w = 0,}
,{  y = 3.6545438766479,  x = -11.108916282654,  z = -9.1433591842651,  t = 3.3,  w = 0,}
,}
,  lookAtPos = {{  y = 1,  x = -9.7007913589478,  z = -0.60161274671555,  t = 0,  w = 0,}
,{  y = 1,  x = -9.7007913589478,  z = -0.60161274671555,  t = 0.3,  w = 0,}
,{  y = 1,  x = -9.7007913589478,  z = -0.60161274671555,  t = 0.6,  w = 0,}
,{  y = 1,  x = -9.7007913589478,  z = -0.60161274671555,  t = 0.9,  w = 0,}
,{  y = 1,  x = -9.7007913589478,  z = -0.60161274671555,  t = 1.2,  w = 0,}
,{  y = 1,  x = -9.7007913589478,  z = -0.60161274671555,  t = 1.5,  w = 0,}
,{  y = 1,  x = -9.7007913589478,  z = -0.60161274671555,  t = 1.8,  w = 0,}
,{  y = 1,  x = -9.7007913589478,  z = -0.60161274671555,  t = 2.1,  w = 0,}
,{  y = 1,  x = -9.7007913589478,  z = -0.60161274671555,  t = 2.4,  w = 0,}
,{  y = 1,  x = -9.7007913589478,  z = -0.60161274671555,  t = 2.7,  w = 0,}
,{  y = 1,  x = -9.7007913589478,  z = -0.60161274671555,  t = 3,  w = 0,}
,{  y = 1,  x = -9.7007913589478,  z = -0.60161274671555,  t = 3.3,  w = 0,}
,}
,}
CameraData["stage1_2Enter"]={
eyePos={
	{ t=0, x=-0.31977898, y=2.49942276, z=-4.14292603 ,w=0,},
	{ t=2, x=-4.11833069, y=2.49942261, z=-4.03510834 ,w=0,},
},
lookAtPos={	
	{ t=0,x=-0.19579309, y=1.98673065, z=0.22529156,w=0, },
	{ t=2,x=-3.99426270, y=1.98673065, z=0.33310558 ,w=0,},
},
}
--]]
CharaData["Gody"]={
	name="Gody",
	hitPoint=25,
	personal={
		lookAtMe={ "Aggressive" , 2 },
		doNotLookAtMe={ "Defensive" , 2 },		
	},
	middleDamageTh=4,
--	baseModel="BaseBody",
	head="GodyHead",
	baseModel="Guy",
	battleStyle="Kungfu",
	scale=0.012,
	collision="Body1",
	grappler=true,
	specialCommand="Billy",
	guard=1,
	fatigability="Normal",
--[[
	material={ 
		{ 1, Mat_White, 0 } ,
	},
--]]	
	material={ 
		{ 0, Mat_Red2, 0 } ,
--[[		{ 1, Mat_Blue2, 0 } ,
		{ 2, Mat_Blue2, 0 } ,
		{ 3, Mat_Blue2, 0 } ,
--]]
--		{ 0, Mat_Red2, 0 } ,
--		{ 1, Mat_Red2, 0 } ,
	},
	moverData={
		WalkSpeed=0.06,
--		RunSpeed=0.14,
		RunSpeed=0.2,
		MoveSpeedWhileJumpUpFromWait = 0.1,
		MoveSpeedWhileJumpUpFromWalk = 0.1,
		MoveSpeedWhileJumpUpFromRun = 0.14,
		MoveSpeedWhileFall = 0.1,
--		JumpSpeed=0.2,
--		JumpHeight=0.2,
--		JumpSpeed=0.4,
--		JumpHeight=0.35,
		JumpSpeed=0.3,
		JumpHeight=0.25,

		BlewUpSpeed=0.25,
		BlewUpHeight=0.3,
		inertiaThreashold={ 0.01 , 0.01 }
	},
	enableAI=true,
}
CharaData["Jet"]={
	name="Jet",
	hitPoint=25,
	personal={
		lookAtMe={ "Aggressive" , 2 },
		doNotLookAtMe={ "Defensive" , 2 },		
	},
	middleDamageTh=4,
	baseModel="BaseBody",
	head="GodyHead",
--	baseModel="Guy",
	battleStyle="Karate",
	scale=0.012,
	collision="Body1",
	grappler=true,
	specialCommand="Billy",
	guard=1,
	fatigability="Normal",
	
--[[
	material={ 
		{ 1, Mat_White, 0 } ,
	},
--]]	
	material={ 
--		{ 0, Mat_Red2, 0 } ,
--[[		{ 1, Mat_Blue2, 0 } ,
		{ 2, Mat_Blue2, 0 } ,
		{ 3, Mat_Blue2, 0 } ,
--]]
--		{ 0, Mat_Red2, 0 } ,
--		{ 1, Mat_Red2, 0 } ,
	},
	moverData={
		WalkSpeed=0.06,
		RunSpeed=0.14,
		MoveSpeedWhileJumpUpFromWait = 0.1,
		MoveSpeedWhileJumpUpFromWalk = 0.1,
		MoveSpeedWhileJumpUpFromRun = 0.14,
		MoveSpeedWhileFall = 0.1,
--		JumpSpeed=0.2,
--		JumpHeight=0.2,
		JumpSpeed=0.4,
		JumpHeight=0.35,
		BlewUpSpeed=0.25,
		BlewUpHeight=0.3,
		inertiaThreashold={ 0.01 , 0.01 }
	},
	enableAI=true,
}
CharaData["Shinobi"]={
	name="Shinobi",
	hitPoint=25,
	personal={
		lookAtMe={ "Aggressive" , 2 },
		doNotLookAtMe={ "Defensive" , 2 },		
	},
	fatigability="Normal",
	middleDamageTh=4,
	head="BossNinjaHead",
	baseModel="BossNinja",
--	baseModel="Ranzo",
--	battleStyle="Kungfu",
	battleStyle="Ninja2",
--	scale=0.012,
	scale=0.013,
	collision="Body1",
	grappler=true,
--	specialCommand="Billy",
	guard=1,
--[[
	material={ 
		{ 1, Mat_White, 0 } ,
	},
--]]	
	material={ 
--[[		{ 0 , Mat_BlackMan  , 0 },
		{ 1 , Mat_BlackMan  , 0 },
		{ 2 , Mat_BlackMan  , 0 },
		{ 3 , Mat_BlackMan  , 0 },
		{ 4 , Mat_BlackMan  , 0 },
		{ 5, Mat_Red2, 0 } ,
		{ 9 , Mat_BlackMan  , 0 },
--]]		
--		{ 0, Mat_Red2, 0 } ,
--[[		{ 1, Mat_Blue2, 0 } ,
		{ 2, Mat_Blue2, 0 } ,
		{ 3, Mat_Blue2, 0 } ,
--]]
--		{ 0, Mat_Red2, 0 } ,
--		{ 1, Mat_Red2, 0 } ,
	},
	moverData={
		WalkSpeed=0.1,
		RunSpeed=0.25,
		MoveSpeedWhileJumpUpFromWait = 0.1,
		MoveSpeedWhileJumpUpFromWalk = 0.1,
		MoveSpeedWhileJumpUpFromRun = 0.14,
		MoveSpeedWhileFall = 0.1,
--		JumpSpeed=0.2,
--		JumpHeight=0.2,
		JumpSpeed=0.3,
		JumpHeight=0.3,
		BlewUpSpeed=0.25,
		BlewUpHeight=0.3,
		inertiaThreashold={ 0.01 , 0.01 }
	},
	enableAI=true,
}

CharaData["Zeed"]={
	name="Zeed",
--	head="head4",
--	baseModel="Body1",	
--	baseModel="sordman",	
--	behavior="Cunning",
	middleDamageTh=2,
	personal={
		lookAtMe={ "Defensive" , 2 },		
		doNotLookAtMe={ "Aggressive" , 2 },
	},
	fatigability="Easily",
	behavior="Straight",
--	battleStyle="Boxing",
	head="SkinHead",
	baseModel="BaseBody",
	battleStyle="Boxing",
--	specialCommand="Kungfu",	
	scale=0.012,
	hitPoint=1,
	guard=1,

	material={ 
		{ 0, Mat_Skin , 0 } ,
--		{ 2, Mat_White , 0 } ,
	},
	moverData={
		WalkSpeed=0.03,
		RunSpeed=0.05,
		MoveSpeedWhileJumpUpFromWait = 0.1,
		MoveSpeedWhileJumpUpFromWalk = 0.1,
		MoveSpeedWhileJumpUpFromRun = 0.14,
		MoveSpeedWhileFall = 0.1,
		JumpSpeed=0.35,
		JumpHeight=0.25,
		BlewUpSpeed=0.25,
		BlewUpHeight=0.3,
		inertiaThreashold={ 0.01 , 0.01 }
	},
	collision="Enemy",
	enableAI=true,
}


CharaData["Roper"]={
	name="Roper",
--	head="head4",
--	baseModel="Body1",	
--	baseModel="sordman",	
	behavior="Cunning",
	fatigability="Easily",
	personal={
		doNotLookAtMe={ "Defensive" , 2 },		
		lookAtMe={ "Aggressive" , 10 },
	},
	middleDamageTh=8,	
	battleStyle="Boxing",
	head="SkinHead",
	baseModel="BaseBody",
--	battleStyle="Karate",
--	specialCommand="Kungfu",	
	scale=0.015,
	hitPoint=28,
	guard=1,
	mesh={
		"ShoulderSpike" ,"Bandana"
	},
	material={ 
		{ 0, Mat_BlackMan , 0 } ,
--		{ 1, Mat_Green2 , 0 } ,
--		{ 2, Mat_Green2 , 0 } ,
--		{ 3, Mat_Green2 , 0 } ,
--		{ 2, Mat_White , 0 } ,
	},
	moverData={
		WalkSpeed=0.03,
		RunSpeed=0.1,
		MoveSpeedWhileJumpUpFromWait = 0.1,
		MoveSpeedWhileJumpUpFromWalk = 0.1,
		MoveSpeedWhileJumpUpFromRun = 0.14,
		MoveSpeedWhileFall = 0.1,
		JumpSpeed=0.35,
		JumpHeight=0.25,
		BlewUpSpeed=0.25,
		BlewUpHeight=0.3,
		inertiaThreashold={ 0.01 , 0.01 }
	},
	collision="Enemy",
	enableAI=true,
}

CharaData["John"]={
	name="John",
--	head="JohnHead",
	head="SkinHead",
--	head="BillyHead",
	baseModel="BaseBody",
--	baseModel="Body1",	
	behavior="Straight",
	middleDamageTh=3,
	fatigability="Easily",
	personal={
		doNotLookAtMe={ "Hover" , 1 },		
		lookAtMe={ "Aggressive" , 5 },
	},
	battleStyle="Karate",
--	battleStyle="Boxing",
	scale=0.012,
	hitPoint=14,
	guard=1,
	mesh={
		"LongHair",
	},	
	moverData={
		WalkSpeed=0.04,
		RunSpeed=0.065,
		MoveSpeedWhileJumpUpFromWait = 0.1,		
		MoveSpeedWhileJumpUpFromWalk = 0.1,
		MoveSpeedWhileJumpUpFromRun = 0.14,
		MoveSpeedWhileFall = 0.1,
		JumpSpeed=0.35,
		JumpHeight=0.25,
		BlewUpSpeed=0.25,
		BlewUpHeight=0.3,
		inertiaThreashold={ 0.01 , 0.01 }
	},
	collision="Enemy",	
	enableAI=true,
}

CharaData["HighKicker"]={
	name="HighKicker",
	baseModel="HighKicker",
	battleStyle="KickBoxer",
	behavior="Straight",
	personal={
		doNotLookAtMe={ "Defensive" , 2 },		
		lookAtMe={ "Aggressive" , 10 },
	},
	fatigability="Normal",
	middleDamageTh=7,
	scale=0.015,
	hitPoint=20,
	guard=1,
	moverData={
		WalkSpeed=0.06,
		RunSpeed=0.1,
		MoveSpeedWhileJumpUpFromWalk = 0.1,
		MoveSpeedWhileJumpUpFromRun = 0.14,
		MoveSpeedWhileFall = 0.1,
		JumpSpeed=0.35,
		JumpHeight=0.25,
		BlewUpSpeed=0.25,
		BlewUpHeight=0.2,
		inertiaThreashold={ 0.01 , 0.01 }
	},
	collision="Body1",	
	enableAI=true,
}
--[[
CharaData["Assassin"]={
	name="Assassin",
	head="BossNinjaHead",
	baseModel="BossNinja",
	battleStyle="Ninja2",
	behavior="Straight",
	personal={
		doNotLookAtMe={ "Defensive" , 2 },		
		lookAtMe={ "Aggressive" , 10 },
	},
	specialCommand="Ninja2",
	middleDamageTh=7,
	scale=0.013,
	hitPoint=20,
	guard=1,
	moverData={
		WalkSpeed=0.06,
		RunSpeed=0.1,
		MoveSpeedWhileJumpUpFromWalk = 0.1,
		MoveSpeedWhileJumpUpFromRun = 0.14,
		MoveSpeedWhileFall = 0.1,
		JumpSpeed=0.35,
		JumpHeight=0.25,
		BlewUpSpeed=0.25,
		BlewUpHeight=0.2,
		inertiaThreashold={ 0.01 , 0.01 }
	},
	collision="Body1",	
	enableAI=true,
}
--]]
CharaData["Macho"]={
	name="Macho",
	behavior="BossMove",
	personal={
		doNotLookAtMe={ "Away" , 8 },		
		lookAtMe={ "Aggressive" , 5 },
	},
	middleDamageTh=12,
	head="MachoHead",
	baseModel="MachoBody",	
	battleStyle="Surge",
	scale=0.0105,
	guard=1.5,
	fatigability="Easily",
--	head="head_ninja",
--	head="BossNinjaHead",
--	baseModel="body_ninja",
--	baseModel="BossNinja",
--	battleStyle="Ninja",
--	scale=0.01,
	hitPoint=35,
	voice={
		BlewUpDown="voice_gu_law",
	},	
	moverData={
--		WalkSpeed=0.04,
		WalkSpeed=0.04,
		RunSpeed=0.05,
		MoveSpeedWhileJumpUpFromWait = 0.04,
		MoveSpeedWhileJumpUpFromWalk = 0.06,
		MoveSpeedWhileJumpUpFromRun = 0.05,
		MoveSpeedWhileFall = 0.04,
		JumpSpeed=0.2,
		JumpHeight=0.2,
		BlewUpSpeed=0.25,
		BlewUpHeight=0.25,
		inertiaThreashold={ 0.01 , 0.01 }
	},
	collision="Big",
	enableAI=true,
}
CharaData["MaskMan"]={
	name="MaskMan",
	behavior="BossMove",
	personal={
		doNotLookAtMe={ "Away" , 8 },		
		lookAtMe={ "Aggressive" , 5 },
	},
	middleDamageTh=12,
	head="FabMask",
--	head="JamesHead",
	baseModel="MachoBody",	
	battleStyle="Surge",
	scale=0.0105,
	fatigability="Hard",
	guard=1.5,
	hitPoint=50,
	voice={
		BlewUpDown="voice_gu_law",
	},	
	moverData={
--		WalkSpeed=0.04,
		WalkSpeed=0.06,
		RunSpeed=0.08,
		MoveSpeedWhileJumpUpFromWait = 0.04,
		MoveSpeedWhileJumpUpFromWalk = 0.06,
		MoveSpeedWhileJumpUpFromRun = 0.05,
		MoveSpeedWhileFall = 0.04,
		JumpSpeed=0.2,
		JumpHeight=0.2,
		BlewUpSpeed=0.25,
		BlewUpHeight=0.25,
		inertiaThreashold={ 0.01 , 0.01 }
	},
	collision="Big",
	enableAI=true,
}
CharaData["James"]={
	name="James",
	behavior="BossMove",
	personal={
		doNotLookAtMe={ "Away" , 8 },		
		lookAtMe={ "Aggressive" , 5 },
	},
	middleDamageTh=12,
--	head="FabMask",
	fatigability="Easily",
	head="JamesHead",
	baseModel="MachoBody",	
	battleStyle="Surge",
	scale=0.0105,
	guard=1.5,
	hitPoint=35,
	voice={
		BlewUpDown="voice_gu_law",
	},	
	moverData={
--		WalkSpeed=0.04,
		WalkSpeed=0.06,
		RunSpeed=0.08,
		MoveSpeedWhileJumpUpFromWait = 0.04,
		MoveSpeedWhileJumpUpFromWalk = 0.06,
		MoveSpeedWhileJumpUpFromRun = 0.05,
		MoveSpeedWhileFall = 0.04,
		JumpSpeed=0.2,
		JumpHeight=0.2,
		BlewUpSpeed=0.25,
		BlewUpHeight=0.25,
		inertiaThreashold={ 0.01 , 0.01 }
	},
	collision="Big",
	enableAI=true,
}

--]]


CharaNameMap={
	Player=  "Gody" ,
	Player2=  "Jet" ,
--	Player2=  "Shinobi" ,
--	Player=  "Shinobi" ,
--	Player2=  "Gody" ,
	Player3=  "Ryu" ,
	Zako1= "ZeedA",
	Zako2= "ZeedB",
	Zako3= "JohnA",
	Zako4= "JohnB",
	Zako5= "HighKickerB",
	Zako6= "HighKickerC",
	
	Boss1= "MaskMan",
	Boss2= "Macho",
	Boss3= "James",
	
}


SPR = Native.CollisionType.Sphere;
CYL =  Native.CollisionType.Cylinder;

CollisionMol["Body1"]={
	isVisible=false,
	Data={ 
		{ tp=SPR ,frame="BodyCenter_Joint" ,radious=1.3,stacks=10,slices=10,material="Red" },
		{ tp=SPR , frame="KneeR_Joint", radious=0.24 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR , frame="KneeL_Joint", radious=0.24 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="FootR_Joint", radious=0.34 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="FootL_Joint", radious=0.34 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="BodyCenter_Joint", radious=0.24 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="ElbowR_Joint", radious=0.24 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="ElbowL_Joint", radious=0.24 , stacks=10 , slices=10 , material="Blue" },	
		{ tp=SPR ,frame="HandR_Joint", radious=0.34 , stacks=10 , slices=10 , material="Blue" },	
		{ tp=SPR ,frame="BladeR_Joint", radious=0.24 , stacks=10 , slices=10 , material="Blue" },	
		{ tp=SPR ,frame="HandL_Joint", radious=0.34 , stacks=10 , slices=10 , material="Blue" },	
		{ tp=SPR ,frame="Head_Joint", radious=0.24 , stacks=10 , slices=10 , material="Blue" }
	}
}

CollisionMol["Enemy"]={
	isVisible=false,
	Data={ 
		{ tp=SPR ,frame="BodyCenter_Joint" ,radious=1.3,stacks=10,slices=10,material="Red" },
		{ tp=SPR , frame="KneeR_Joint", radious=0.2 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR , frame="KneeL_Joint", radious=0.2 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="FootR_Joint", radious=0.3 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="FootL_Joint", radious=0.3 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="BodyCenter_Joint", radious=0.2 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="ElbowR_Joint", radious=0.2 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="ElbowL_Joint", radious=0.2 , stacks=10 , slices=10 , material="Blue" },	
		{ tp=SPR ,frame="HandR_Joint", radious=0.3 , stacks=10 , slices=10 , material="Blue" },	
		{ tp=SPR ,frame="BladeR_Joint", radious=0.2 , stacks=10 , slices=10 , material="Blue" },	
		{ tp=SPR ,frame="HandL_Joint", radious=0.3 , stacks=10 , slices=10 , material="Blue" },	
		{ tp=SPR ,frame="Head_Joint", radious=0.2 , stacks=10 , slices=10 , material="Blue" }
	}
}
CollisionMol["Big"]={
	isVisible=false,
	Data={ 
		{ tp=SPR ,frame="BodyCenter_Joint" ,radious=1.4,stacks=10,slices=10,material="Red" },
		{ tp=SPR , frame="KneeR_Joint", radious=0.2 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR , frame="KneeL_Joint", radious=0.2 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="FootR_Joint", radious=0.35 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="FootL_Joint", radious=0.35 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="BodyCenter_Joint", radious=0.2 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="ElbowR_Joint", radious=0.2 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="ElbowL_Joint", radious=0.2 , stacks=10 , slices=10 , material="Blue" },	
		{ tp=SPR ,frame="HandR_Joint", radious=0.35 , stacks=10 , slices=10 , material="Blue" },	
		{ tp=SPR ,frame="BladeR_Joint", radious=0.2 , stacks=10 , slices=10 , material="Blue" },	
		{ tp=SPR ,frame="HandL_Joint", radious=0.35 , stacks=10 , slices=10 , material="Blue" },	
		{ tp=SPR ,frame="Head_Joint", radious=0.2 , stacks=10 , slices=10 , material="Blue" }
	}
}
CollisionMol["body_ninja"]={
	isVisible=false,
	Data={ 
		{ tp=SPR ,frame="BodyCenter_Joint" ,radious=1,stacks=10,slices=10,material="Red" },
		{ tp=SPR , frame="KneeR_Joint", radious=0.25 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR , frame="KneeL_Joint", radious=0.25 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="FootR_Joint", radious=0.5 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="FootL_Joint", radious=0.5 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="BodyCenter_Joint", radious=0.25 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="ElbowR_Joint", radious=0.25 , stacks=10 , slices=10 , material="Blue" },
		{ tp=SPR ,frame="ElbowL_Joint", radious=0.25 , stacks=10 , slices=10 , material="Blue" },	
		{ tp=SPR ,frame="HandR_Joint", radious=0.25 , stacks=10 , slices=10 , material="Blue" },	
		{ tp=SPR ,frame="BladeR_Joint", radious=0.25 , stacks=10 , slices=10 , material="Blue" },	
		{ tp=SPR ,frame="HandL_Joint", radious=0.25 , stacks=10 , slices=10 , material="Blue" },	
		{ tp=SPR ,frame="Head_Joint", radious=0.25 , stacks=10 , slices=10 , material="Blue" }
	},
}

CollisionMol["Juice"]={
	isVisible=false,
	Data={ 
		{ tp=SPR ,radious=1,stacks=10,slices=10,material="Green" },
	}
}

CollisionMol["Burger"]={
	isVisible=false,
	Data={ 
		{ tp=SPR ,radious=0.6,stacks=10,slices=10,material="Green" },
	}
}

CollisionMol["sord"]={
	isVisible=false,
	Data={ 
		{ tp=SPR ,radious=1,stacks=10,slices=10,material="Green" },
	}
}

CollisionMol["yoroi"]={
	isVisible=false,
	Data={ 
		{ tp=SPR ,radious=1,stacks=10,slices=10,material="Green" },
	}
}

CollisionMol["Barrel"]={
	isVisible=false,
	Data={ 
		{ tp=SPR ,frame="RootRoot_Joint" ,radious=1,stacks=10,slices=10,material="Red" },
	}
}


EventScriptData={}
EventScriptData["title"]={
	 "WAIT 1000 ",
	 "FADE IN TitleLogo1 0,2,255" ,
	 "WAIT 1000" ,
	 "FADE IN TitleLogo2 0,2,255" ,
	 "WAIT 2000" ,	
	"CHANGE SCENE TitleMenu 0.2 10" ,
}
EventScriptData["PreTitleMenuEnter"]={
	"ATTACH SCENE title",
	"ATTACH SCENE TitleLogo1",
	"ATTACH SCENE TitleLogo2",
--	"FADE IN TitleLogo1 0,2,255" ,
--	"WAIT 1000",
--	"FADE IN TitleLogo2 0,2,255" ,
--	"FADE IN GameStart 0,4,250" ,
--	"WAIT 100",
--	"FADE IN GameExit 0,4,250" ,
}
--[[	"WAIT 100",
	"FADE IN SurvivalMode 0,4,250" ,
	"WAIT 100",
	"FADE IN TrainingMode 0,4,250" ,
--]]
EventScriptData["PreStageEnter"]={
	"ATTACH SCENE mission",
	"ATTACH SCENE loading",
	"ATTACH SCENE loadingStr",
	"FADE IN mission 20 5 150",
	"WAIT 1000",
	"CHANGE SCENE stage1_1 0.2 10" ,
}
EventScriptData["PreStage1_Enter"]={
	"ATTACH SCENE mission1",
	"ATTACH SCENE loading",
	"ATTACH SCENE loadingStr",
	"FADE IN mission1 20 5 150",
	"WAIT 1000",
	"CHANGE SCENE stage1_1 0.2 10" ,
}
EventScriptData["PreStage1_2_Enter"]={
	"ATTACH SCENE Skysc",
	"ATTACH SCENE loading",
	"ATTACH SCENE loadingStr",
	"FADE IN Skysc 20 5 150",
	"WAIT 1000",
	"CHANGE SCENE stage1_2 0.2 10" ,
}
EventScriptData["PreStage2_1_Enter"]={
	"ATTACH SCENE mission2",
	"ATTACH SCENE loading",
	"ATTACH SCENE loadingStr",
	"FADE IN mission2 20 5 150",
	"WAIT 2000",
	"FADE OUT mission2 150 5 0",
	"WAIT 200",	
	"CHANGE SCENE stage2_1 0.2 10" ,
}
EventScriptData["StageSelectEnter"]={
	"WAIT 500",
	"FLY stageselect -1000,340,420,340 500" ,
	"ATTACH VIEW StageSelect",
	"CHANGE TEX CharaInScript PlayerChara3.bmp" ,
	"CHANGE TEX transition1 WallPaint.bmp" ,
	"FLY CharaInScript -200,590,66,590 500" ,
	"WAIT 500",
	"DISPLAY MSG MissionScript IN GameScript" ,
	"WAIT 2000",
	"DISPLAY MSG PleaseSelect IN GameScript" ,
}
EventScriptData["StageSelectFirstEnter"]={
	"WAIT 500",
	"CHANGE TEX CharaInScript PlayerChara3.bmp" ,
	"FLY CharaInScript -200,590,66,590 500" ,
	"WAIT 500",
	"FLY stageselect -1000,340,420,340 500" ,
	"ATTACH VIEW StageSelect",
	"DISPLAY MSG BeginningScript1 IN GameScript" ,
	"WAIT 2500",
	"DISPLAY MSG BeginningScript2 IN GameScript" ,
	"WAIT 2500",
	"DISPLAY MSG PleaseSelect IN GameScript" ,
}

EventScriptData["stage1_1Enter"]={
	"CHANGE TEX transition1 StageResident.bmp" ,
	"SET ANGLE Gody 0, -90,0",
	"ATTACH AGENT Player VIEW Player_1" ,
	"CHANGE CAMTARGET Player" ,
	"FADE IN UpperBlack 20 3 255",
	"FADE IN GameScript 20 3 255",
	"CHANGE STATE Player Run_State",
--	"CHANGE STATE Boss1 EventAct_State",
--	"CHANGE_ANIM  Player FightClubScene Player",
	"CHANGE_ANIM  Player Common ZenchuUp",
--	"CHANGE_ANIM  Boss1 FightClubScene MachoPause",
--	"CAMERA CameraCourse 2" ,	
	"CAMERA CameraCourse 1" ,	
	"CAMERA CameraCourse 0" ,	
--	"WAIT 2000",
	"CHANGE STATE Player EventAct_State",
	"CHANGE_ANIM  Player Common RelaxingWaitLean",
	"CHANGE CAM 4",
	"WAIT 4000",
	"CHANGE CAM 5",
	"WAIT 4000",
	"CHANGE STATE Player Wait_State",
--	"CHANGE STATE Boss1 Wait_State",
	"WAIT 1200",
--	"FADE OUT UpperBlack 255 3 0",
--	"FADE OUT GameScript 255 3 50",
	"CHANGE CAM 1",	
	
--	"CAMERA CameraCourse stage1_1Entered" ,

--	"FLYGUI PIC CharaInScript LEFT 500",	
--]]
}
EventScriptData["CamTgt_townBox2_Changed"]={
	"FADE OUT UpperBlack 255 3 0",
	"FADE OUT GameScript 255 3 50",
	"OPEN_DOOR townDoor3 open door01",
	"WAIT 1000",
	"OPEN_DOOR townDoor4 open door01",
}
EventScriptData["stage1_1EnemyDefeated1Times"]={
	"LOCK_MOVE false" ,
	"ATTACH POS toStage1_3 ZeedA 0,0,-1",
	"ATTACH POS toStage1_3 ZeedB -2,0,-2",
	"ATTACH POS toStage1_3 JohnA 2,0,-1",
	"CHANGE CAMTARGET Player" ,
	"WAIT  1000",
	"FADE IN UpperBlack 20 3 255",
	"FADE IN GameScript 20 3 255",
	"WAIT  1000",
	"ACTIVATE TRIGVOL toStage1_3 true" ,
	"CHANGE CAMTARGET toStage1_3" ,
	"REVIVE Zako1",
	"REVIVE Zako2",
	"REVIVE Zako3",
	"ATTACH AGENT Zako1 VIEW AI_1" ,	
	"ATTACH AGENT Zako2 VIEW AI_2" ,	
	"ATTACH AGENT Zako3 VIEW AI_3" ,	
	"WAIT  1000",
	"GOSIGN " ,
--	"BUF_CAMPOS 0" ,
--	"FADE OUT UpperBlack 255 3 0",
--	"FADE OUT GameScript 255 3 50",
	"CHANGE CAMTARGET Player" ,
}
EventScriptData["stage1_1EnemyDefeated2Times"]={
	"CHANGE CAMTARGET Player" ,
	"WAIT  1000",
	"FADE IN UpperBlack 20 3 255",
	"FADE IN GameScript 20 3 255",
	"WAIT  1000",
	"CHANGE CAMTARGET toStage1_3" ,
	"WAIT  1000",
	"ACTIVATE TRIGVOL toStage1_3 true" ,
	"KILL_ENEMIES " ,
	"WAIT  1000",
	"GOSIGN " ,
--	"BUF_CAMPOS 0" ,
	"CHANGE CAMTARGET Player" ,
	"LOCK_MOVE false" ,
}
EventScriptData["stage1_2Enter"]={
	"CHANGE TEX transition1 StageResident.bmp" ,
	"SET ANGLE Gody 0, -90,0",
	"ATTACH AGENT Player VIEW Player_1" ,
	"CHANGE CAMTARGET Player" ,
	"FADE IN UpperBlack 20 3 255",
	"FADE IN GameScript 20 3 255",
	"WAIT 1000",
	"GOSIGN",
--	"CAMERA CameraCourse stage1_1Entered" ,

--	"FLYGUI PIC CharaInScript LEFT 500",	
}
EventScriptData["stage1_3Enter"]={
	"ATTACH AGENT Player VIEW Player_1" ,
	"LOCK_MOVE false" ,
	"ATTACH POS toStage1_4 ZeedA -2,0,-4",
	"ATTACH POS toStage1_4 JohnA -1.5,0,-3",
	"ATTACH POS toStage1_4 HighKickerB -1,0,-1",
	"CHANGE CAMTARGET Player" ,
	"WAIT  1000",
	"FADE IN UpperBlack 20 3 255",
	"FADE IN GameScript 20 3 255",
	"WAIT  1000",
--	"ACTIVATE TRIGVOL toStage1_3 true" ,
	"CHANGE CAMTARGET toStage1_4" ,
	"REVIVE Zako1",
	"REVIVE Zako2",
	"REVIVE Zako3",
	"ATTACH AGENT Zako1 VIEW AI_1" ,	
	"ATTACH AGENT Zako3 VIEW AI_2" ,	
	"ATTACH AGENT Zako5 VIEW AI_3" ,	
	"WAIT  1000",
--	"GOSIGN " ,
--	"BUF_CAMPOS 0" ,
	"FADE OUT UpperBlack 255 3 0",
	"FADE OUT GameScript 255 3 50",
	"CHANGE CAMTARGET Player" ,
}
EventScriptData["stage1_3EnemyDefeated1Times"]={
	"GOSIGN " ,
	"ACTIVATE TRIGVOL toStage1_4 true" ,
}
--[[	"WAIT  2000",	
	"ATTACH AGENT Zako1 VIEW AI_2" ,
	"WAIT  200",	
--	"ATTACH AGENT Zako2 VIEW AI_3" ,
	"WAIT  200",	
	"ATTACH AGENT Zako3 VIEW AI_3" ,
--]]
--[[
EventScriptData["stage1_4Enter"]={
	"FADE IN UpperBlack 20 3 255",
	"FADE IN GameScript 20 3 255",
--	"CAMERA CameraCourse stage1_1Entered" } ,
	"ATTACH AGENT Player VIEW Player_1" ,
--	"WAIT  1000",
--	"PLAY BGM Boss",
	"ATTACH AGENT Boss1 VIEW AI_1" ,
	"CHANGE STATE Player Run_State",
	"CHANGE STATE Boss1 EventAct_State",
--	"CHANGE_ANIM  Player FightClubScene Player",
	"CHANGE_ANIM  Player Common ZenchuUp",
	"CHANGE_ANIM  Boss1 FightClubScene MachoPause",
	
	"CAMERA CameraCourse 2" ,	
	"CAMERA CameraCourse 1" ,
	"CAMERA CameraCourse 0" ,
	"WAIT 2000",
	"CHANGE STATE Player EventAct_State",
	"CHANGE_ANIM  Player Kungfu Wait",
	"CHANGE CAM 5",
	"WAIT 4200",
	"CHANGE CAM 6",
	"WAIT 1000",
	"CHANGE STATE Player Wait_State",
	"CHANGE STATE Boss1 Wait_State",
	"WAIT 1200",
	"FADE OUT UpperBlack 255 3 0",
	"FADE OUT GameScript 255 3 50",
	"CHANGE CAM 1",
}
--]]
EventScriptData["stage1_4Enter"]={
	"FADE IN UpperBlack 20 3 255",
	"FADE IN GameScript 20 3 255",
	
	"ATTACH AGENT Player VIEW Player_1" ,
--	"ATTACH AGENT Zako1 VIEW AI_1" ,
	"ATTACH AGENT Boss1 VIEW AI_1" ,
--	"ATTACH AGENT Boss3 VIEW AI_3" ,
	
--	"ATTACH AGENT Zako2 VIEW AI_2" ,
--	"ATTACH AGENT Zako3 VIEW AI_3" ,
--	"ATTACH AGENT Zako4 VIEW AI_4" ,
	
	"CHANGE STATE Player Run_State",
--	"CHANGE STATE Zako1 EventAct_State",
	"CHANGE STATE Boss1 EventAct_State",	
--	"CHANGE STATE Boss3 EventAct_State",	
--	"CHANGE STATE Zako2 EventAct_State",
--	"CHANGE STATE Zako3 EventAct_State",
--	"CHANGE STATE Zako4 EventAct_State",
	"CHANGE_ANIM  Player Common ZenchuUp",
--	"CHANGE_ANIM  Zako1 Boxing Wait",
--	"CHANGE_ANIM  Zako2 Boxing Wait",
--	"CHANGE_ANIM  Zako3 Karate Wait",
--	"CHANGE_ANIM  Zako4 Karate Wait",
	"CHANGE_ANIM  Boss1 FightClubScene MachoPause",
	"WAIT 500",
--	"CHANGE_ANIM  Boss3 FightClubScene MachoPause",
	
	"CAMERA CameraCourse 2" ,	
	"CAMERA CameraCourse 1" ,
	"CAMERA CameraCourse 0" ,
	"WAIT 2000",
	"CHANGE STATE Player EventAct_State",
	"CHANGE_ANIM  Player Kungfu Wait",
	"CHANGE CAM 5",
--	"SET POS ZeedA 5,10,-2",
	"WAIT 4200",
	"CHANGE CAM 6",
	"WAIT 1000",
	"CHANGE STATE Player Wait_State",
--	"CHANGE STATE Zako1 Wait_State",
--	"CHANGE STATE Zako2 Wait_State",
--	"CHANGE STATE Zako3 Wait_State",
--	"CHANGE STATE Zako4 Wait_State",
	"CHANGE STATE Boss1 Wait_State",
--	"CHANGE STATE Boss3 Wait_State",
	"WAIT 1200",
	"ATTACH AGENT Zako1 VIEW AI_2" ,
	"WAIT 1000",
	"ATTACH AGENT Zako3 VIEW AI_3" ,
	"FADE OUT UpperBlack 255 3 0",
	"FADE OUT GameScript 255 3 50",
	"CHANGE CAM 1",
}
--]]
--[[
EventScriptData["stage1_2EnemyDefeated"]={
	"WAIT  1000",
	"SET POS NinjaA 12,5,1" ,
	"SET POS NinjaB 15,5,1" ,	
	"PLAY BGM Boss",
	"ATTACH AGENT Boss2 VIEW AI_1" ,	
--	"WAIT  1000",
--	"ATTACH AGENT Boss3 VIEW AI_2" ,	
}
--]]
EventScriptData["stage2_1Enter"]={
	"CHANGE TEX transition1 StagePrePlatform.bmp" ,
--	"CAMERA CameraCourse stage1_1Entered" } ,
	"ATTACH AGENT Player VIEW Player_1" ,
	"WAIT  200",	
--	"ATTACH AGENT Player2 VIEW NPC" ,
	"WAIT  20",
	"ATTACH AGENT Zako1 VIEW AI_1" ,
--	"WAIT  20",	
	"ATTACH AGENT Zako3 VIEW AI_2" ,
	"WAIT  100",
	"ENABLE AI Zako1 false" ,
	"ENABLE AI Zako3 false" ,
	"SET ANGLE ZeedA 0,0,0" ,
	"SET ANGLE JohnA 0,0,0" ,
	"CHANGE STATE Zako1 Relaxing_State" ,
	"CHANGE STATE Zako3 Relaxing_State" ,
	"FADE IN UpperBlack 20 3 255",
	"FADE IN GameScript 20 3 255",
--	"WAIT  200",	
--	"ATTACH AGENT Zako3 VIEW AI_3" ,
--	"ATTACH AGENT Zako4 VIEW AI_4" ,
--	"ATTACH AGENT Boss2" ,
--	"CHANGE_CAM CameraCourse CameraCloseUp" ,
}
EventScriptData["stage2_2_EnemyDefeated1Times"]={
	"WAIT  1000",
	"FADE IN UpperBlack 20 3 255",
	"FADE IN GameScript 20 3 255",
	"WAIT  1000",
	"PLAY BGM Boss",
--	"SET POS Macho 25,0.1,1" ,
	"BUF_CAMPOS 0" ,
	"CHANGE CAMTARGET Macho" ,
	"WAIT  1000",
	"ATTACH AGENT Boss2 VIEW AI_1" ,		
	"WAIT  1000",
	"FADE OUT UpperBlack 255 3 0",
	"FADE OUT GameScript 255 3 50",
	"BUF_CAMPOS 0" ,
	"CHANGE CAMTARGET Player" ,
}
--]]
EventScriptData["stage2_1EnemyDefeated1Times"]={
	"WAIT 1000",
	"REVIVE Zako1" ,
	"REVIVE Zako3" ,
	"FADE IN UpperBlack 20 3 255",
	"FADE IN GameScript 20 3 255",
	"ATTACH AGENT Zako1 VIEW AI_1" ,
	"ATTACH AGENT Zako2 VIEW AI_2" ,
	"ATTACH AGENT Zako3 VIEW AI_3" ,
	"ENABLE AI Zako1 false" ,
	"ENABLE AI Zako2 false" ,
	"ENABLE AI Zako3 false" ,
	"SET ANGLE ZeedA 0,0,0" ,
	"SET ANGLE ZeedB 0,90,0" ,
	"SET ANGLE JohnA 0,0,0" ,
	"CHANGE STATE Zako1 Relaxing_State" ,
	"CHANGE STATE Zako2 Relaxing_State" ,
	"CHANGE STATE Zako3 Relaxing_State" ,
}
EventScriptData["CamTgt_stage2_1Fence3Changed"]={
	"WAIT 1000",
	"SET POS ZeedA 28.17,0.1,3" ,
	"SET POS JohnA 28.2,0.1,-3" ,
--	"SET POS Macho 29,0.1,0" ,
	"SET POS RoperA 29,0.1,0" ,
	"REVIVE Zako1" ,
	"WAIT 2000",
	"REVIVE Zako3" ,
--	"ATTACH AGENT Zako4 VIEW AI_1" ,
--	"ATTACH AGENT Zako3 VIEW AI_2" ,
}
--[[
EventScriptData["stage2_1EnemyDefeated3Times"]={
--	"WAIT 10000",
	"ATTACH AGENT Boss1 VIEW AI_2" ,
}
--]]
EventScriptData["stage2_1Boss1Dead"]={
	"CAMERA Parallel" ,
	"CHANGE CAMTARGET Player" ,
	"WAIT  1000",
	"FADE IN UpperBlack 20 3 255",
	"FADE IN GameScript 20 3 255",
	"WAIT  1000",
	"CHANGE CAMTARGET toStage2_2" ,
	"WAIT  1000",
	"ACTIVATE TRIGVOL toStage2_2 true" ,
	"KILL_ENEMIES " ,
	"WAIT  1000",
	"GOSIGN " ,
--	"BUF_CAMPOS 0" ,
	"CHANGE CAMTARGET Player" ,
	"LOCK_MOVE false" ,
}
EventScriptData["stage2_2Enter"]={
	"FADE OUT UpperBlack 255 3 0",
	"FADE OUT GameScript 255 3 50",
	"CHANGE TEX transition1 StagePlatform.bmp" ,
	"ATTACH AGENT Player VIEW Player_1" ,
	"WAIT  1000",	
--	"ATTACH AGENT Zako1 VIEW AI_1" ,
--	"ATTACH AGENT Boss1 VIEW AI_1" ,
	"WAIT  1000",
--	"ATTACH AGENT Boss3 VIEW AI_1" ,
	"WAIT  1000",
	"ATTACH AGENT Zako1 VIEW AI_1" ,
	"WAIT  1000",
	"ATTACH AGENT Zako2 VIEW AI_2" ,
	"WAIT  1000",
	"ATTACH AGENT Zako3 VIEW AI_3" ,
	"WAIT  1000",
	"ATTACH AGENT Zako4 VIEW AI_4" ,
}

EventScriptData["stage2_2EnemyDefeated"]={
	"WAIT  1000",
	"SET POS Macho 3,6,-1" ,
	"PLAY BGM Boss",
--	"CHANGE BEHAVIOR Boss1 BossMove" ,
	"ATTACH AGENT Boss3 VIEW AI_1" ,	
}
--[[
EventScriptData["stage2_2Enter"]={
	"SET POS Gody 0,2,0" ,
	"SET POS Riki 0,2,0" ,
	"SET POS John 5,10,2" ,
	"SET POS Shin 7,10,-2" ,
--	"CAMERA CameraCourse stage1_1Entered" } ,
	"ATTACH AGENT Player VIEW Player_1" ,
	"SET POS NinjaDD3_A -1,15,0" ,
	"SET POS NinjaDD3_B 4,15,-1" ,
	"ATTACH AGENT ZakoNinja1 VIEW AI_1" ,
--	"SET POS Ryuji 0,5,-2" ,
	"ATTACH AGENT ZakoNinja2 VIEW AI_2" ,
	"REVIVE ZakoNinja1" ,
	"REVIVE ZakoNinja2" ,
}
--]]
EventScriptData["stage3_1Enter"]={
	"SET POS Gody -2,0.1,-2" ,
	"SET POS Riki -2,0.1,-4" ,
	"SET POS JohnA 10,0.1,-2" ,
	"SET POS HighKickerB 12,0.1,-5" ,
	"SET POS JohnB -4,0.1,-5" ,
	"SET POS HighKickerC -4,0.1,0" ,
	"ATTACH AGENT Player VIEW Player_1" ,
	"WAIT  1000",
	"ATTACH AGENT Zako3 VIEW AI_1" ,
	"WAIT  1000",
	"ATTACH AGENT Zako4 VIEW AI_2" ,
	"WAIT  1000",
	"ATTACH AGENT Zako5 VIEW AI_3" ,
--	"ATTACH AGENT Zako6 VIEW AI_4" ,
}
EventScriptData["stage3_1EnemyDefeated"]={
	"WAIT  1000",
	"FADE IN UpperBlack 20 3 255",
	"FADE IN GameScript 20 3 255",
	"WAIT  1000",
	"CHANGE CAMTARGET toStage3_2" ,
	"WAIT  1000",
	"ACTIVATE TRIGVOL toStage3_2 true" ,
	"KILL_ENEMIES " ,
	"WAIT  1000",
	"GOSIGN " ,
	"FADE OUT UpperBlack 255 3 0",
	"FADE OUT GameScript 255 3 50",
--	"BUF_CAMPOS 0" ,
	"CHANGE CAMTARGET Player" ,
}
EventScriptData["stage3_2Enter"]={
	"SET POS Gody -19,0.1,2.5" ,
	"SET POS Riki -18,0.1,2" ,
	"SET POS Macho 10,0.1,2.5" ,
	"SET POS RoperA 10,0.1,2.5" ,
	"SET POS HighKickerA 9,0.1,1" ,
	"SET POS HighKickerB 10,0.1,1" ,
	"SET POS HighKickerC 10,0.1,0" ,
	"ATTACH AGENT Player VIEW Player_1" ,
	"WAIT  1000",
--	"ATTACH AGENT Boss3 VIEW AI_1" ,
--	"WAIT  1000",
--	"ATTACH AGENT Boss2 VIEW AI_2" ,
--	"WAIT  10000",
	"ATTACH AGENT Boss1 VIEW AI_1" ,
--]]
}
EventScriptData["stage3_3Enter"]={
--[[	"SET POS Gody -2,0.1,0" ,
	"SET ANGLE Gody 0,90,0" ,
	"SET POS Riki -2,0.1,-3" ,
	"SET POS Todo 4,0.1,0" ,
	"SET ANGLE Todo 0,270,0" ,
	"ATTACH AGENT Player VIEW Player_1" ,
	"WAIT  1000",
	"ATTACH AGENT Boss3 VIEW AI_1" ,
	"WAIT", 1000",
	"FADE IN UpperBlack 20 3 255",
	"FADE IN GameScript 20 3 255",
	"WAIT 2000",
	"FADE OUT UpperBlack 255 3 0",
	"FADE OUT GameScript 255 3 50",
	"PLAY BGM LastBoss",
--	"CHANGE BEHAVIOR Boss1 BossMove" ,
--]]

	"SET POS Gody -2,0.1,0" ,
	"ATTACH AGENT Player VIEW Player_1" ,
	"SET ANGLE Gody 0,90,0" ,
	"SET POS Riki -2,0.1,-3" ,
	"SET ANGLE Todo 0,270,0" ,
	"WAIT  1000",
	"FADE IN UpperBlack 20 3 255",
	"FADE IN GameScript 20 3 255",
	"WAIT  1000",
	"SET POS Todo 4,0.1,0" ,
	"SET POS HighKickerA -2,5,1" ,
	"SET POS HighKickerB 2,5,1" ,
	"SET POS HighKickerC 2,5,-1" ,
	"SET POS Macho 0,5,0" ,
	"SET POS RoperA 0,5,0" ,
	"SET POS HighKickerA 0,5,0" ,
	"WAIT  1000",
	"PLAY BGM LastBoss",
	"FADE OUT UpperBlack 255 3 0",
	"FADE OUT GameScript 255 3 50",
	"ATTACH AGENT Boss4 VIEW AI_1" ,		
	"WAIT  1000",
	"ATTACH AGENT Zako5 VIEW AI_2" ,		
	"WAIT  1000",
	"ATTACH AGENT Zako6 VIEW AI_3" ,		
}
EventScriptData["MissionStart"]={
	"VISIBLE TheEnd false" ,
	"WAIT  1000",
--[[	"ATTACH SCENE Ready" ,
	"VISIBLE Ready true" ,
	"ZOOM Ready 0,0,640,300,1000" ,
	"WAIT  1200",
	"ZOOM Ready 512,256,0,0,1000" ,
	"VISIBLE Ready false" ,
--]]	
--	"ATTACH SCENE Fight" ,
	"VISIBLE Fight true" ,
	"ZOOM Fight 0,0,640,300,1000" ,
	"WAIT  1200",
	"FLY CharaInScript -200,590,66,590 500" ,	
	"ZOOM Fight 512,256,0,0,500" ,
	"VISIBLE Fight false" ,
--]]
--[[	
	"ATTACH SCENE Font_F" ,
	"ATTACH SCENE Font_I" ,
	"ATTACH SCENE Font_G" ,
	"ATTACH SCENE Font_H" ,
	"ATTACH SCENE Font_T" ,
--	"ATTACH SCENE Font_Exp" ,
	"VISIBLE Font_F true" ,
	"VISIBLE Font_I true" ,
	"VISIBLE Font_G true" ,
	"VISIBLE Font_H true" ,
	"VISIBLE Font_T true" ,
--	"VISIBLE Font_Exp true" ,
	"FLY Font_F 900,340,100,340,500" ,
	"WAIT 500",
	"FLY Font_I 900,340,230,340,500" ,
	"WAIT 500",
	"FLY Font_G 900,340,360,340,500" ,
	"WAIT 500",
	"FLY Font_H 900,340,490,340,500" ,
	"WAIT 500",
	"FLY Font_T 900,340,620,340,500" ,
	"WAIT 500",
--	"FLY Font_Bikkuri 900,750,100,340,500" ,
	"WAIT 2000",
	"VISIBLE Font_F false" ,
	"VISIBLE Font_I false" ,
	"VISIBLE Font_G false" ,
	"VISIBLE Font_H false" ,
	"VISIBLE Font_T false" ,
--	"VISIBLE Font_Exp false" ,
--]]
}
EventScriptData["EnterMission"]={
	"WAIT 200",
	"DISPLAY MSG MissionEnterClickedScript1 IN GameScript" ,
	"WAIT 1000",
	"FLY CharaInScript 66,590,-200,590 500" ,
	"WAIT 1000",
	"CHANGE TEX CharaInScript KungfuGuy3.bmp" ,
	"FLY CharaInScript -200,590,66,590 500" ,	
	"DISPLAY MSG MissionEnterClickedScript2 IN GameScript" ,
	"WAIT 1000",	
	"CHANGE  SCENE stage2_1  0.2 10" ,
}
EventScriptData["MissionClear"]={
	"CHANGE TEX transition1 WallPaint.bmp" ,
	"WAIT  1000",
	"MISSION_CLEAR " ,
	"ATTACH SCENE StageClear" ,
	"VISIBLE StageClear true" ,
	"ZOOM StageClear 0,0,512,512,1000" ,
	"WAIT  1000",
	"PLAY BGM win" ,
	"WAIT  3000",
	"FLY CharaInScript 66,590,-200,590 500" ,
	"WAIT  500",
	"CHANGE TEX CharaInScript PlayerChara3.bmp" ,
	"FLY CharaInScript -200,590,66,590 500" ,
	"WAIT 1000",
	"DISPLAY MSG GoodScript IN GameScript" ,
	"WAIT 1000",
	"DISPLAY MSG GoBackScript IN GameScript" ,
	"WAIT 2000",
	
--	"CHANGE SCENE PreStage2_1 0.2 10" ,
	"CHANGE SCENE StageSelect 0.2 10" ,
}
EventScriptData["StageClear1"]={
	"WAIT  1000",
	"ATTACH SCENE StageClear" ,
	"VISIBLE StageClear true" ,
	"ZOOM StageClear 0,0,512,512,1000" ,
	"WAIT  1000",
	"PLAY BGM win" ,
	"WAIT  3000",
--	"CHANGE SCENE PreStage2_1 0.2 10" ,
	"CHANGE SCENE stage2_1 0.2 10" ,
}
EventScriptData["StageClear2"]={
	"WAIT  1000",
	"ATTACH SCENE StageClear" ,
	"VISIBLE StageClear true" ,
	"ZOOM StageClear 0,0,512,512,1000" ,
	"WAIT  1000",
	"PLAY BGM win" ,
	"WAIT  3000",
	"CHANGE SCENE stage3_1 0.2 10" ,
}
EventScriptData["StageClear3"]={
	"WAIT  1000",
	"ATTACH SCENE StageClear" ,
	"ATTACH SCENE TheEnd" ,
	"VISIBLE StageClear true" ,
	"ZOOM StageClear 0,0,512,512,1000" ,
	"WAIT  1000",
	"PLAY BGM win" ,
	"WAIT  8000",
	"ZOOM StageClear 512,512,0,0,1000" ,
	"WAIT  1000",
	"VISIBLE TheEnd true" ,
	"ZOOM TheEnd 0,0,512,256,1000" ,
	"WAIT  4000",	
	"CHANGE SCENE TitleMenu 0.2 10" ,
}

GameMissionParam["stage1_1"]={
	name="stage1_1",
	scene="Resident",
	defeatEnemyNum=3,
	camera=1,--CAMMODE_Parallel,
--	camera=CAMMODE_CloseUp,
	cameraOffset={ 6 , -9 },
	minY=0,
	maxY=100,
	script="stage1_1Enter",
	targetLock=false,
	targetCamObj="townBox1",
	revive=false,
	missionStart=true,
}
GameMissionParam["stage1_2"]={
	name="stage1_2",
	defeatEnemyNum=5,
	camera=1,--CAMMODE_Parallel,
--[[	cameraOffset={ 0 , 0 },
--	minY=-4,
--	maxY=0,	
--]]
	cameraOffset={ 4 , -5 },
	minY=0,
	maxY=100,
	targetLock=true,
	script="stage1_2Enter",
	revive=false,
	missionStart=false,
}
GameMissionParam["stage1_3"]={
	name="stage1_3",
	defeatEnemyNum=8,
	camera=1,--CAMMODE_Parallel,
--[[	cameraOffset={ 0 , 0 },
--	minY=-4,
--	maxY=0,	
--]]
	cameraOffset={ 6 , -7 },
	minY=0,
	maxY=100,
	targetLock=true,
	script="stage1_3Enter",
	revive=true,
	missionStart=true,
}
GameMissionParam["stage1_4"]={
	name="stage1_4",
	defeatEnemyNum=5,
	camera=1,--CAMMODE_Parallel,
--[[	cameraOffset={ 0 , 0 },
--	minY=-4,
--	maxY=0,	
--]]
	cameraOffset={ 4 , -5 },
	minY=0,
	maxY=100,
	targetLock=true,
	script="stage1_4Enter",
	revive=true,
	missionStart=false,
}
GameMissionParam["stage2_1"]={
	name="stage2_1",
	defeatEnemyNum=2,
	camera=1,--CAMMODE_Parallel,
--	cameraOffset={ 1.5 , 1.5 },
	cameraOffset={ 6 , -7 },
	minY=-10,
	maxY=100,	
	targetLock=false,
	targetCamObj="stage2_1Box1",
	script="stage2_1Enter",
	revive=false,
	missionStart=true,
}
GameMissionParam["stage2_2"]={
	name="stage2_2",
	defeatEnemyNum=4,
	camera=1,--CAMMODE_Parallel,
--	cameraOffset={ 1.5 , 1.5 },
	cameraOffset={ 6 , -8.5 },
--	cameraOffset={ 4 , -5 },
	minY=0,
	maxY=5,	
	targetLock=true,
	script="stage2_2Enter",
	revive=false,
	missionStart=true,
}
GameMissionParam["stage3_1"]={
	name="stage3_1",
	defeatEnemyNum=7,--14,
	camera=1,--CAMMODE_Parallel,
	cameraOffset={ 1.5 , 1.5 },
	minY=-5,
	maxY=100,	
	targetLock=true,	
	script="stage3_1Enter",
	revive=false,
	missionStart=true,
}
GameMissionParam["stage3_2"]={
	name="stage3_2",
	defeatEnemyNum=3,
	camera=0,--CAMMODE_Parallel,
	cameraOffset={ 1.5 , 1.5 },
	minY=-5,
	maxY=100,	
	targetLock=true,
	script="stage3_2Enter",
	revive=false,
	missionStart=true,
}
GameMissionParam["stage3_3"]={
	name="stage3_3",
	defeatEnemyNum=2,
	camera=0,--CAMMODE_Parallel,
	cameraOffset={ 1.5 , 1.5 },
	targetLock=true,
	minY=-5,
	maxY=100,	
	script="stage3_3Enter",
	revive=false,
	missionStart=true,
}
gQuaW = FullWidth()/4;
gQuaH = FullHeight()/4;
gHalfW = gQuaW*2;
gHalfH = gQuaH*2;
function CreateImages()
	local gImageList={
		{ name="title", pos={420,340},size={840,680},texture="WallPaint.bmp",blend=Graphics.BLEND_LINEAR , alpha=255 },
		{ name="transition1", pos={gHalfW,gHalfH},size={FullWidth(),FullHeight()},texture="black.bmp",blend=Graphics.BLEND_LINEAR },
--		{ name="charaselect", pos={gHalfW/2,100},size={512,128},texture="WallPaint.bmp",blend=Graphics.BLEND_LINEAR },
		{ name="stageselect", pos={gHalfW,gHalfH},size={FullWidth(),FullHeight()},texture="StageMap.bmp",blend=Graphics.BLEND_LINEAR },
--		{ name="stageselect", pos={gHalfW,gHalfH},size={FullWidth(),FullHeight()},texture="Underground2.bmp",blend=Graphics.BLEND_LINEAR },
		{ name="continue", alpha=220,pos={420,340},size={512,300},texture="WindowView.dds",blend=Graphics.BLEND_LINEAR },
		{ name="StageClear", alpha=200, pos={420,340},size={0,0},texture="StageClear.bmp",blend=Graphics.BLEND_LINEAR },
		{ name="OptionWindow", alpha=220,pos={gHalfW,gHalfH},size={FullWidth(),FullHeight()},texture="WindowView.dds",blend=Graphics.BLEND_LINEAR },
--		{ name="mission", alpha=220,pos={gHalfW,gHalfH},size={640,480},texture="TiledWindow.bmp",blend=Graphics.BLEND_LINEAR },
		{ name="mission", alpha=220,pos={gHalfW,gHalfH},size={640,480},texture="Button2.bmp",blend=Graphics.BLEND_LINEAR },
		{ name="HelpGameCommand", alpha=220,pos={gHalfW,gHalfH+50},size={800,340},texture="HelpGameCommand.bmp",blend=Graphics.BLEND_LINEAR },
		{ name="Fight", pos={gHalfW,gHalfH},size={0,0},texture="Fight3.bmp",blend=Graphics.BLEND_LINEAR },
		{ name="goSign", pos={FullWidth()-120,gHalfH},size={200,200},texture="GoSign.bmp",blend=Graphics.BLEND_LINEAR },
		{ name="num0", pos={500,500},size={100,200},texture="nums.dds",uv={ 0,0,0.1,1},
			blend=Graphics.BLEND_LINEAR, },
		{ name="cursor", pos={0,0},size={50,50},texture="Cursor.bmp",
			blend=Graphics.BLEND_LINEAR,
		},
		{ name="loading", pos={550,600},size={100,100},texture="NowLoading.dds",--texture="Loading.bmp",
			blend=Graphics.BLEND_LINEAR,
			effect={
	--		  "ExplodeEffect1" , ParaparaAnimation["ExplodeEffect1"] 
			  "NowLoading" , ParaparaAnimation["NowLoading"] 
			},
		},
		{ name="loadingStr", pos={700,600},size={200,50},texture="NowLoadingStr.bmp",blend=Graphics.BLEND_LINEAR },
		{ name="image_exp", pos={gHalfW,gHalfH},size={200,200},texture="explode.png",blend=Graphics.BLEND_LINEAR },

	}
	IterateFunc( gImageList , CreateImage2 );
end
CreateImages();

--[[	
		{ name="StageSelectWindow", pos={gHalfW,gHalfH},size={FullWidth(),FullHeight()},texture="StageSelectWindow.bmp",blend=Graphics.BLEND_LINEAR },
	--	{ name="titleMenu", pos={gHalfW,gHalfH},size={FullWidth(),FullHeight()},texture="titleMenu.bmp",blend=Graphics.BLEND_LINEAR },
	--	{ name="optionMenu", pos={gHalfW,gHalfH},size={FullWidth(),FullHeight()},texture="OptionMenu.bmp",blend=Graphics.BLEND_LINEAR },
	--	{ name="gameLecture1", pos={gHalfW,gHalfH},size={FullWidth(),FullHeight()},texture="gameLecture1.bmp",blend=Graphics.BLEND_LINEAR },
	--	{ name="menuBG", pos={gHalfW,gHalfH},size={FullWidth(),FullHeight()},texture="TitleMenuBack.bmp",blend=Graphics.BLEND_LINEAR },
	--	{ name="transition2", pos={gHalfW,gHalfH},size={FullWidth(),FullHeight()},texture="gameover1.dds",blend=Graphics.BLEND_LINEAR },
	--	{ name="stageselect_filter", pos={gHalfW,gHalfH},size={FullWidth(),FullHeight()},texture="gradation3.dds",blend=Graphics.BLEND_LINEAR },
	--	{ name="msg_bg1", pos={200,200},size={200,200},texture="button.bmp",blend=Graphics.BLEND_LINEAR },
	--	{ name="menu_button", pos={50,50},size={100,50},texture="MenuButton.bmp",blend=Graphics.BLEND_LINEAR },
	--	{ name="charaselect", pos={gHalfW,gHalfH},size={512,512},texture="CharaSelectWindow.bmp",blend=Graphics.BLEND_LINEAR },		
--		{ name="presented", pos={420,340},size={840,480},texture="presented.bmp",blend=Graphics.BLEND_LINEAR , alpha=0 },
--		{ name="transition1", pos={gHalfW,gHalfH},size={FullWidth(),FullHeight()},texture="WallPaint.bmp",blend=Graphics.BLEND_LINEAR },
--		{ name="MainWindow", pos={gHalfW,gHalfH},size={FullWidth(),FullHeight()},texture="WindowSkin.bmp",blend=Graphics.BLEND_LINEAR },
--		{ name="charaselect", pos={gHalfW/2,100},size={512,128},texture="WindowView.dds",blend=Graphics.BLEND_LINEAR },
--		{ name="charaselect", pos={gHalfW/2,100},size={512,128},texture="wallBrick2.bmp",blend=Graphics.BLEND_LINEAR },
		{ name="Ready", pos={gHalfW,gHalfH},size={0,0},texture="Ready2.bmp",blend=Graphics.BLEND_LINEAR },
--		{ name="clear", pos={gHalfW,gHalfH},size={200,90},texture="clear.bmp",blend=Graphics.BLEND_LINEAR },
	--	{ name="help1", pos={gHalfW,gHalfH+100},size={FullWidth()-50,FullHeight()/2},texture="HelpGameCommand.bmp",blend=Graphics.BLEND_LINEAR },
	--	{ name="divBar", pos={687,211},size={128,128},texture="DivisionBar.bmp",blend=Graphics.BLEND_LINEAR },
		{ name="TheEnd", alpha=200, pos={420,340},size={0,0},texture="TheEnd.bmp",blend=Graphics.BLEND_LINEAR },
--]]


ItemData1={ 
	type="health",
	name="Juice1" ,
--	file="Juice.x",
--	file="Knife.x",
	file="Burger.x",
	pos=Vec3(0,5,0) ,
	angle=Vec3(0) ,
	scale=Vec3(0.9,0.9,0.9) ,
	blend=SceneNode.TYPE_STATIC_OPAQUE ,
	HitSoundName = "busu1",
	DamagePoint=10,
	collision="Juice",
}
ItemData2={ 
	type="health",
	name="Burger1" ,
	file="Burger.x",
	pos=Vec3(0,0,0) ,
	angle=Vec3(0) ,
	scale=Vec3(0.4,0.4,0.4) ,
	blend=SceneNode.TYPE_STATIC_OPAQUE 
}
ItemData3={ 
	type="weapon",
	name="sord" ,
	file="rangiku.x",
	pos=Vec3(0,0,0) ,
	angle=Vec3(0) ,
	scale=Vec3(0.4,0.4,0.4) ,
	blend=SceneNode.TYPE_STATIC_OPAQUE 
}
ItemData4={ 
	type="armor",
	name="yoroi" ,
	file="yoroi.x",
	pos=Vec3(0,0,0) ,
	angle=Vec3(0) ,
	scale=Vec3(1.4) ,
	blend=SceneNode.TYPE_STATIC_OPAQUE 
}
ParaparaAnimation={}
ParaparaAnimation["HitEffect1"]={
	Texturename="hitEffect.bmp",
	TextureWidth = 1024,
	TextureHeight = 128,
	Key = { 
		{ 0,0,0,128,128 }, -- Time , U,V,W,H
		{ 15,128,0,128,128 },
		{ 30,128*2,0,128,128 },
		{ 45,128*3,0,128,128 },
		{ 60,128*4,0,128,128 },
		{ 75,128*5,0,128,128 },
--		{ 90,128*6,0,128,128 },
--		{ 105,128*7,0,128,128 },
	}
}
ParaparaAnimation["ParticleEffect"]={
	Texturename="particle.png",
	TextureWidth = 512,
	TextureHeight = 128,
	Key = { 
		{ 0,0,0,128,128 }, -- Time , U,V,W,H
		{ 15,100,0,128,128 },
		{ 30,100*2,0,128,128 },
		{ 45,100*3,0,128,128 },
		{ 60,100*4,0,128,128 },
	}
}
ParaparaAnimation["HitEffect2"]={
	Texturename="s_delete01.png",
	TextureWidth = 960,
	TextureHeight = 192,
	Key = { 
		{ 0,0,0,192,192 }, -- Time , U,V,W,H
		{ 5,192,0,192,192 },
		{ 10,192*2,0,192,192 },
		{ 15,192*3,0,192,192 },
		{ 20,192*4,0,192,192 }
	}
}
ParaparaAnimation["FireEffect1"]={
	Texturename="efe_fire03.png",
	TextureWidth = 1024,
	TextureHeight = 128,
	Key = { 
		{ 0,0,0,128,128 }, -- Time , U,V,W,H
		{ 5,128,0,128,128 },
		{ 10,128*2,0,128,128 },
		{ 15,128*3,0,128,128 },
		{ 20,128*4,0,128,128 },
		{ 25,128*5,0,128,128 },
		{ 30,128*6,0,128,128 }
	}
}
ParaparaAnimation["ThunderEffect1"]={
	Texturename="efe_than.png",
	TextureWidth = 512,
	TextureHeight = 240,
	Key = { 
		{ 0,0,0,64,240 }, -- Time , U,V,W,H
		{ 5,64,0,64,240 },
		{ 10,64*2,0,64,240 },
		{ 15,64*3,0,64,240 },
		{ 20,64*4,0,64,240 },
		{ 25,64*5,0,64,240 },
		{ 30,64*6,0,64,240 },
		{ 35,64*7,0,64,240 }
	}
}
ParaparaAnimation["ExplodeEffect1"]={
	Texturename="explode.png",
--	Texturename="particle.bmp",
	TextureWidth = 256,
	TextureHeight = 256,
	Key = { 
		{ 0,0,0,64,64 }, -- Time , U,V,W,H
		{ 5,64,0,64,64 },
		{ 10,64*2,0,64,64 },
		{ 15,64*3,0,64,64 },
		
		{ 20,0,64,64,64 },
		{ 25,64,64,64,64 },
		{ 30,64*2,64,64,64 },
		{ 35,64*3,64,64,64 },
		
		{ 40,0,64*2,64,64 },
		{ 45,64,64*2,64,64 },
		{ 50,64*2,64*2,64,64 },
		{ 55,64*3,64*2,64,64 },
		
		{ 60,0,64*3,64,64 },
		{ 65,64,64*3,64,64 },
		{ 70,64*2,64*3,64,64 },
		{ 75,64*3,64*3,64,64 }
		
		
	}
}

ParaparaAnimation["NowLoading"]={
--	Texturename="loading.dds",
	TextureWidth = 256,
	TextureHeight = 128,
	Key = { 
		{ 0,0,0,64,64 }, -- Time , U,V,W,H
		{ 15,64,0,64,64 },
		{ 30,64*2,0,64,64 },
		{ 45,64*3,0,64,64 },
		
		{ 60,0,64,64,64 },
		{ 75,64,64,64,64 },
		{ 90,64*2,64,64,64 },
		{ 105,64*3,64,64,64 },
--[[		
		{ 0,0,0,64,64 }, -- Time , U,V,W,H
		{ 5,64,0,64,64 },
		{ 10,64*2,0,64,64 },
		{ 15,64*3,0,64,64 },
		
		{ 20,0,64,64,64 },
		{ 25,64,64,64,64 },
		{ 30,64*2,64,64,64 },
		{ 35,64*3,64,64,64 },
--]]			
	}
}


ParticleData["paticleYellow"] = { 
	allNum=100,
	lifetime=0.7,
	name="particleYellow" ,
	pos={0,0,5},
	width=0.3,
	height=0.3,
	texture="particleYellow.dds",
	uv={0,0,1,1},
	nodeType=SceneNode.TYPE_FRONT_ALPHA,
	blendMode=Graphics.BLEND_ADDITIVE,
	isMove=  true,
}
ParticleData["paticleGreen"] = { 
	allNum=30,
	lifetime=0.3,
	name="particleGreen" ,
	pos={0,0,5},
	width=0.2,
	height=0.2,
--		texture="Sprite.jpg",
	texture="particleGreen.bmp",
	uv={0,0,1,1},
	nodeType=SceneNode.TYPE_FRONT_ALPHA,
	blendMode=Graphics.BLEND_ADDITIVE,
	isMove=  true,
	
}
ParticleData["paticleBlue"] = { 
	allNum=30,
	lifetime=0.3,
	name="particleBlue" ,
	pos={0,0,5},
	width=0.6,
	height=0.6,
--		texture="Sprite.jpg",
	texture="particleBlue.bmp",
	uv={0,0,1,1},
	nodeType=SceneNode.TYPE_FRONT_ALPHA,
	blendMode=Graphics.BLEND_ADDITIVE,
	isMove=  true,
}
ParticleData["hitEffect"] = {  
	allNum=20,
	lifetime=0.2,
	name="hitEffect" ,
	pos={0,0,5},
	width=0.5,
	height=0.5,
--	texture="hitEffect2.bmp",
--	texture="hitEft1.bmp",
	texture="DagekiHit.bmp",
--	texture="explode.png",
	uv={0,0,1,1},
--[[	effect={
		"ExplodeEffect1" , ParaparaAnimation["ExplodeEffect1"] 
--		"HitEffect1" , ParaparaAnimation["HitEffect1"] 
--		"NovaEffect" , ParaparaAnimation["NovaEffect"] 
	},		
--]]
	nodeType=SceneNode.TYPE_FRONT_ALPHA,
	blendMode=Graphics.BLEND_ADDITIVE,
	isMove=  false,
}	
billdata = { 
	name="billboard_1" ,
	pos={0,0,0},
	angle={0,0,0},
	width=1,
	height=1,
	texture="explode.png",
	uv={0,0,1,1},
	effect={
	  "ExplodeEffect1" , ParaparaAnimation["ExplodeEffect1"] 
	},
	nodeType=SceneNode.TYPE_FRONT_ALPHA,
	blendMode=Graphics.BLEND_ADDITIVE
	
}
billdata2 = { 
	name="billboard_2" ,
	pos={0.5,0,0},
	angle={0,0,0},
	width=1,
	height=1,
	texture="explode.png",
	uv={0,0,1,1},
	effect={
	  "ExplodeEffect1" , ParaparaAnimation["ExplodeEffect1"] 
	},
	nodeType=SceneNode.TYPE_FRONT_ALPHA,
	blendMode=Graphics.BLEND_ADDITIVE
	
}

SceneParam["CharaSelect"]={}
SceneParam["CharaSelect"]["Initial_State"]={
	Update={
		LightUp={
			{ pos={ 0,0,-1 }, },
		},
		ChangeSceneState={
			{ state="Main_State" },
		},
		SetCameraPos={
			{ id=0 , lookAt={ 0,2,0 },pos={ 2,3,-5 } },
		},
	
	},
}
SceneParam["CharaSelect"]["Main_State"]={
}

SceneParam["Loading"]={}
SceneParam["Loading"].isLoad=true;
SceneParam["Loading"]["Initial_State"]={
	Update={
		isLoadTrue={
			{ }
		},
		ChangeSceneState={
			{ state="Main_State" },
		}
	},
}
SceneParam["Loading"]["Main_State"]={
	Update={
		ChangeSceneWhenLoadFinish={
			{ name="TitleMenu" },
		}
			
	}
--]]
}
SceneParam["PreStage1"]={}
SceneParam["PreStage1"].isLoad=true;
SceneParam["PreStage1"]["Initial_State"]={
	Update={
		isLoadTrue={
			{ }
		},
		ChangeSceneState={
			{ state="Main_State" },
		}
	},
}
SceneParam["PreStage1"]["Main_State"]={
	Update={
		ChangeSceneLoadFinishAndEnterTriggered={
			{ name="stage1_1" },
		}
			
	}
--]]
}
SceneParam["PreStage1_2"]={}
SceneParam["PreStage1_2"].isLoad=true;
SceneParam["PreStage1_2"]["Initial_State"]={
	Update={
		isLoadTrue={
			{ }
		},
		ChangeSceneState={
			{ state="Main_State" },
		}
	},
}
SceneParam["PreStage1_2"]["Main_State"]={
	Update={
		ChangeSceneLoadFinishAndEnterTriggered={
			{ name="stage1_2" },
		}
			
	}
--]]
}
SceneParam["PreStage2_1"]={}
SceneParam["PreStage2_1"].isLoad=true;
SceneParam["PreStage2_1"]["Initial_State"]={
	Update={
		isLoadTrue={
			{ }
		},
		ChangeSceneState={
			{ state="Main_State" },
		}
	},
}
SceneParam["PreStage2_1"]["Main_State"]={
	Update={
		ChangeSceneLoadFinishAndEnterTriggered={
			{ name="stage2_1" },
		}
			
	}
--]]
}

SceneParam["Settings"]={}
SceneParam["Settings"]["Initial_State"]={
	Update={
		ChangeSceneState={
			{ state="Main_State" },
		}
	},
}
SceneParam["Settings"]["Main_State"]={
}

SceneParam["stage1_1"]={  Main_State = {  Update = {  EnemyCount = {{  IsNum = 10,  Then = "CHANGE SCENE stage1_2",}
,}
,  SetLightParam = {{  isUse = true,  index = 0,  col = {0.56999999284744,0.49000000953674,0.31999999284744,}
,  amb = {0.20000000298023,0.20000000298023,0.15000000596046,}
,  atten = 5,  pos = {0,1.0999999046326,0,}
,}
,{  isUse = true,  index = 1,  col = {0.80000001192093,0.60000002384186,0.36000001430511,}
,  amb = {0.2,0.2,0.2,}
,  atten = 5.8000001907349,  pos = {-3.5,3,-0.20000000298023,}
,}
,{  isUse = true,  index = 2,  col = {0.80000001192093,0.63999998569489,0.36000001430511,}
,  amb = {0.2,0.2,0.2,}
,  atten = 6.3000001907349,  pos = {22.5,3,-0.20000000298023,}
,}
,{  isUse = false,  index = 3,}
,}
,}
,}
,  Initial_State = {  Update = {  SetCameraPos = {{  id = 0,  lookAt = {0,2,0,}
,  pos = {0,4,-1,}
,}
,}
,  LoadScene = {{  sceneFile = "level_Residence.lua",  name = "stage1_1",  movableRect = {-100,100,500,-60,}
,}
,}
,  ChangeSceneState = {{  state = "Main_State",}
,}
,}
,}
,}

SceneParam["stage1_2"]={  Main_State = {  Update = {  SetLightParam = {{  isUse = true,  index = 0,  col = {0.34,0.53,0.58,}
,  amb = {0.20000000298023,0.15000000596046,0.10000000149012,}
,  atten = 10,  pos = {0,-2.0999999046326,0,}
,}
,{  isUse = true,  index = 1,  col = {0.74,0.99,1,}
,  amb = {0.2,0.2,0.2,}
,  atten = 19.5,  pos = {0,2.6,0,}
,}
,{  isUse = true,  index = 2,  col = {0.50000000596046,0.68000001907349,0.81000001192093,}
,  amb = {0.2,0.2,0.2,}
,  atten = 20,  pos = {11.499999237061,2.7000001907349,2.38419e-007,}
,}
,{  isUse = false,  index = 3,}
,}
,}
,}
,  Initial_State = {  Update = {  ChangeSceneState = {{  state = "Main_State",}
,}
,  LoadScene = {{  name = "stage1_2",  sceneFile = "level_ResidenceNight.lua",}
,}
,}
,}
,}

SceneParam["stage1_3"]={  Main_State = {  Update = {  SetLightParam = {{  isUse = true,  index = 0,  col = {0.75,0.46999999880791,0.090000003576279,}
,  amb = {0.20000000298023,0.15000000596046,0.10000000149012,}
,  atten = 10,  pos = {0,-2.0999999046326,0,}
,}
,{  isUse = true,  index = 1,  col = {0.86000001430511,0.76999998092651,0.17000000178814,}
,  amb = {0.2,0.2,0.2,}
,  atten = 18.700000762939,  pos = {0,4.4000000953674,-0.40000000596046,}
,}
,{  isUse = true,  index = 2,  col = {0.40999999642372,0.68000000715256,0.98000001907349,}
,  amb = {0.2,0.2,0.2,}
,  atten = 17.10000038147,  pos = {17.5,5.0999999046326,-1.0999997854233,}
,}
,{  isUse = false,  index = 3,}
,}
,}
,}
,  Initial_State = {  Update = {  ChangeSceneState = {{  state = "Main_State",}
,}
,  LoadScene = {{  name = "stage1_3",  sceneFile = "level_Hideout.lua",}
,}
,}
,}
,}

SceneParam["stage1_4"]={  Main_State = {  Update = {  SetLightParam = {{  isUse = true,  index = 0,  col = {0.34,0.53,0.58,}
,  amb = {0.20000000298023,0.15000000596046,0.10000000149012,}
,  atten = 10,  pos = {0,-2.0999999046326,0,}
,}
,{  isUse = true,  index = 1,  col = {0.74,0.99,1,}
,  amb = {0.2,0.2,0.2,}
,  atten = 19.5,  pos = {0,2.6,0,}
,}
,{  isUse = true,  index = 2,  col = {0.50000000596046,0.68000001907349,0.81000001192093,}
,  amb = {0.2,0.2,0.2,}
,  atten = 20,  pos = {11.499999237061,2.7000001907349,2.38419e-007,}
,}
,{  isUse = false,  index = 3,}
,}
,}
,}
,  Initial_State = {  Update = {  ChangeSceneState = {{  state = "Main_State",}
,}
,  LoadScene = {{  name = "stage1_4",  sceneFile = "level_FightClub.lua",}
,}
,}
,}
,}

SceneParam["stage2_1"]={  Main_State = {  Update = {  SetLightParam = {{  isUse = true,  index = 0,  col = {0.80000001192093,0.69999998807907,0.60000002384186,}
,  amb = {0.20000000298023,0.15000000596046,0.10000000149012,}
,  atten = 5,  pos = {1,-0.10000000149012,-0.5,}
,}
,{  isUse = true,  index = 1,  col = {0.63999998569489,1,1,}
,  amb = {0.2,0.2,0.2,}
,  atten = 24,  pos = {3.2000000476837,4.8000001907349,-1.1000000238419,}
,}
,{  isUse = true,  index = 2,  col = {1,1,1,}
,  amb = {0.2,0.2,0.2,}
,  atten = 19.299999237061,  pos = {26.5,4.1999998092651,-1.1000000238419,}
,}
,{  isUse = false,  index = 3,}
,}
,}
,}
,  Initial_State = {  Update = {  LoadScene = {{  name = "stage2_1",  sceneFile = "level_Street.lua",}
,}
,  ChangeSceneState = {{  state = "Main_State",}
,}
,}
,}
,}

SceneParam["stage2_2"]={  Main_State = {  Update = {  SetLightParam = {{  isUse = true,  index = 0,  col = {0.34,0.53,0.58,}
,  amb = {0.20000000298023,0.15000000596046,0.10000000149012,}
,  atten = 10,  pos = {0,-2.0999999046326,0,}
,}
,{  isUse = true,  index = 1,  col = {0.74,0.99,1,}
,  amb = {0.2,0.2,0.2,}
,  atten = 19.5,  pos = {0,2.6,0,}
,}
,{  isUse = true,  index = 2,  col = {0.50000000596046,0.68000001907349,0.81000001192093,}
,  amb = {0.2,0.2,0.2,}
,  atten = 20,  pos = {11.499999237061,2.7000001907349,2.38419e-007,}
,}
,{  isUse = false,  index = 3,}
,}
,}
,}
,  Initial_State = {  Update = {  ChangeSceneState = {{  state = "Main_State",}
,}
,  LoadScene = {{  name = "stage2_2",  sceneFile = "level_Platform.lua",}
,}
,}
,}
,}

SceneParam["stage3_1"]={  Main_State = {  Update = {  SetLightParam = {{  isUse = true,  index = 0,  col = {0.34,0.53,0.58,}
,  amb = {0.20000000298023,0.15000000596046,0.10000000149012,}
,  atten = 10,  pos = {0,-2.0999999046326,0,}
,}
,{  isUse = true,  index = 1,  col = {0.74,0.99,1,}
,  amb = {0.2,0.2,0.2,}
,  atten = 19.5,  pos = {0,2.6,0,}
,}
,{  isUse = true,  index = 2,  col = {0.50000000596046,0.68000001907349,0.81000001192093,}
,  amb = {0.2,0.2,0.2,}
,  atten = 20,  pos = {11.499999237061,2.7000001907349,2.38419e-007,}
,}
,{  isUse = false,  index = 3,}
,}
,}
,}
,  Initial_State = {  Update = {  ChangeSceneState = {{  state = "Main_State",}
,}
,  LoadScene = {{  name = "stage3_1",  sceneFile = "level_FightClub.lua",}
,}
,}
,}
,}

SceneParam["stage3_2"]={  Main_State = {  Update = {  SetLightParam = {{  isUse = true,  index = 0,  col = {0.80000001192093,0.80000001192093,0.80000001192093,}
,  amb = {0.20000000298023,0.20000000298023,0.20000000298023,}
,  atten = 5,  pos = {1.7999999523163,0.40000000596046,4.3000001907349,}
,}
,{  isUse = true,  index = 1,  col = {1,1,1,}
,  amb = {0.2,0.2,0.2,}
,  G = {  speed = 4,  amp = 1,}
,  atten = 4.0999999046326,  pos = {4.5999999046326,2,2.5999999046326,}
,}
,{  isUse = true,  index = 2,  col = {0.28000000119209,0.28000000119209,0.31000000238419,}
,  amb = {0.2,0.2,0.2,}
,  atten = 10,  pos = {-15.199999809265,1.8999999761581,2.4000000953674,}
,}
,{  isUse = false,  index = 3,}
,}
,}
,}
,  Initial_State = {  Update = {  ChangeSceneState = {{  state = "Main_State",}
,}
,  LoadScene = {{  name = "stage3_2",  sceneFile = "level_PreLastFloor.lua",}
,}
,}
,}
,}


SceneParam["stage3_3"]={}
SceneParam["stage3_3"]["Initial_State"]={
	Update={
		LoadScene={
			{ 
				sceneFile="level_LastFloor.lua",
				name="stage3_3",
--				minHeight=0,
--				movableRect={-10,10,20,-10},
			},
		},
		ChangeSceneState={
			{ state="Main_State" },
		}
	},		
}
SceneParam["stage3_3"]["Main_State"]={
	Update={
		SetLightParam={
			{ isUse=true , index=0 , pos={1,3,4} , amb={0.2,0.2,0.2} , atten=5 , col={ 0.8,0.8,0.8} },
			{ isUse=false , index=1 , pos={21,1,4} , amb={0.2,0.2,0.2} , atten=15 , col={ 1,1,0} , },
			{ isUse=false , index=2 , pos={1,3,-0.8} , amb={0.2,0.2,0.2} , atten=10 , col={ 1,1,1} },
			{ isUse=false , index=3 , },
		},
	}
}

SceneParam["StageSelect"]={  Main_State = {}
,  Initial_State = {  Update = {  ChangeSceneState = {{  state = "Main_State",}
,}
,}
,}
,}



SceneParam["Title"]={}
SceneParam["Title"]["Initial_State"]={
	Update={
		ChangeSceneState={
			{ state="Main_State" },
		}
	},
}
SceneParam["Title"]["Main_State"]={
	EnterToChangeState={
		"TitleMenu",
	},
}

SceneParam["TitleMenu"]={  Main_State = {}  
,  Initial_State = {  Update = {  
 ChangeSceneState = {{  state = "Main_State",}
,}
,}
,}
,}

TitleBgmFiles={
--	"Z08AYK0104_48kbps_s",
--	"DoubleDragon",
}
BgmFiles={
--	"bgm_maoudamashii_neorock14_s",
--	"bgm_maoudamashii_neorock16_s",
	"bgm_maoudamashii_neorock17_s",
	"bgm_maoudamashii_neorock18",
--	"bgm_maoudamashii_neorock32",
	"bgm_maoudamashii_neorock37_s",
	"bgm_maoudamashii_neorock18_clear",
	"BYK00035_s",
}
SeFiles={
--[[
--	"Karaburi",
--	"Jump",
--	"Sliding",
--	"Hit01",
--	"Hit02",
--	"Hit03",
--	"Guard01",
--	"Special01",
--]]
	"tm2_swing000",
	"swing01",
	"swing03",
	"swing05",
	"swing06",
	"swing06_e",
	"tm2_hit004",
	"tm2_hit005",
	"tm2_slash003",
	"slash",
	"se_maoudamashii_se_pc03",
	"se_maoudamashii_system18",
	"se_maoudamashii_system20",
	"se_maoudamashii_system21",
	"se_maoudamashii_system28",
	"se_maoudamashii_system31",
	
	"hit05a",
	"hit09",
	"hit10",
	"hit57",
	"hit_p0222223333",
	"push03",
	"busu1",
	"voice_ha",
	"voice_nua",
	"voice_gu",
	"voice_gu_law",
	"door01",
	"door03",
	"step07",
	"eat05",
	"bosu35",
	"hit_p01_a",
	"hit_p01_c",
	
--]]
}
SoundMap={
--	Title={ "" , false },
--	Title={ name="bgm_maoudamashii_neorock18" , loop=false },
--	TitleMenu={ name="bgm_maoudamashii_neorock18" , loop=false },
--	TitleMenu={ name="bgm_maoudamashii_neorock18_clear" , loop=false },
	TitleMenu={ name="crazy_cat" , loop=false },
	StageSelect={ name="crazy_cat" , loop=true },
--	StageSelect="Z04AYK0067_48kbps_s",
--	stage1_1={ name="bgm_maoudamashii_neorock37_s" , loop=true },
--	stage1_1={ name="link" , loop=false },
	firstAppear={ name="crazy_cat" , loop=true },
--	stage1_2={ name="bgm_maoudamashii_neorock37_s" , loop=true },
--	stage2_1={ name="bgm_maoudamashii_neorock37_s" , loop=true },
	stage1_1={ name="track025_japan_underground_s" , loop=true },
	stage1_2={ name="track025_japan_underground_s" , loop=true },
	stage1_3={ name="bgm_maoudamashii_neorock06_s" , loop=true },
	stage1_4={ name="bgm_maoudamashii_neorock28_s" , loop=true },
	stage2_1={ name="husinsha" , loop=true },
	stage2_2={ name="orange" , loop=true },
--	stage2_2={ name="bgm_maoudamashii_neorock17_s" , loop=true },
----	stage3_2={ name="game_maoudamashii_6_dangeon11_s" , loop=false },
--	Boss="Z05BFI0016_48kbps_s",
	Boss={ name="bgm_maoudamashii_cyber09" , loop=true },
	win={ name="bgm_maoudamashii_neorock18_clear" , loop=false },
--[[	
	stage3_1={ name="bgm_maoudamashii_neorock36_s" , loop=true },
	stage3_2={ name="solid_infinity" , loop=true },
	LastBoss= { name="bgm_maoudamashii_neorock09_s" , loop=true },
--]]
}
SeMap={
--	cursor="se_maoudamashii_se_pc03",
--	enter="push03",
	cursor="se_maoudamashii_se_pc03",
	enter="hit57",
}

TriggerVolData["toStage1_3"]={
	name="toStage1_3",
	chara="Player",
--	radious=1.5,
	changeAfter=Process.KILLED,
--	activatedAllScene=true,
	activatedSceneName={
		"stage1_1", "stage1_2",
	},
	box={ 2,2,2 },
	active=false,
	alphaWav={ amp=0.8, speed=3 },
}
TriggerVolData["toStage1_4"]={
	name="toStage1_4",
	chara="Player",
--	radious=1.5,
	changeAfter=Process.KILLED,
--	activatedAllScene=true,
	activatedSceneName={
		"stage1_3",
	},
	box={ 2,2,2 },
	active=false,
	alphaWav={ amp=0.8, speed=3 },
}	
TriggerVolData["toStage2_1"]={
	name="toStage2_1",
	radious=1.5,
	chara="Player",
	changeAfter=Process.KILLED,
--	activatedAllScene=true,
	activatedSceneName={
		"stage1_2",
	},
	active=false,
	alphaWav={ amp=0.8, speed=3 },
}	
TriggerVolData["toStage2_2"]={
	name="toStage2_2",
	radious=1.5,
	chara="Player",
	changeAfter=Process.KILLED,
--	activatedAllScene=true,
	activatedSceneName={
		"stage2_1",
	},
	active=false,
	alphaWav={ amp=0.8, speed=3 },
}	
TriggerVolData["toStage3_2"]={
	name="toStage3_2",
	radious=1.5,
	chara="Player",
	changeAfter=Process.KILLED,
--	activatedAllScene=true,
	activatedSceneName={
		"stage3_1",
	},
	active=false,
	alphaWav={ amp=0.8, speed=3 },
}	
TriggerVolData["toStage3_3"]={
	name="toStage3_3",
	radious=1.5,
	chara="Player",
	changeAfter=Process.KILLED,
--	activatedAllScene=true,
	activatedSceneName={
		"stage3_2",
	},
	active=false,
	alphaWav={ amp=0.8, speed=3 },
}	

ViewProp["TitleMenu"]={
	activate=false,
	image="MainWindow",
	size={ 512 , 512 },
	pos={ FullWidth()/2 , FullHeight()/2 },
	zorder=1,
}
ViewProp["CharaSelect"]={
	activate=false,
	image="charaselect",
	size={ FullWidth() , FullHeight()*3/4 },
	pos={ FullWidth()/2 , FullHeight()/2-100 },
	zorder=1,
}
ViewProp["StageSelect"]={
	activate=false,
	image="stageselect",
--	size={ FullWidth() , FullHeight() },
	size={ FullWidth() , FullHeight()/5*4 },
	pos={ FullWidth()/2 , FullHeight()/2 },
--	pos={ FullWidth()/2 , FullHeight()/2 - 100 },
--	pos={ FullWidth()/2 , FullHeight()/4*3 },
	zorder=2,
}
ViewProp["Mission"]={
	sound="se_maoudamashii_system31",
	activate=false,
	image="mission",
--	size={ FullWidth() , FullHeight() },
	size={ FullWidth()-100 , FullHeight()/4*3 },
	pos={ FullWidth()/2 , FullHeight()/2 },
--	pos={ FullWidth()/2 , FullHeight()/2 - 100 },
--	pos={ FullWidth()/2 , FullHeight()/4*3 },
	zorder=3,
}
ViewProp["Option"]={
	sound="se_maoudamashii_system31",
	activate=false,
	image="OptionWindow",
	size={ 512 , 512 },
	pos={ FullWidth()/2 , FullHeight()/2  },
	zorder=5,
}
ViewProp["PauseMenu"]={
	sound="se_maoudamashii_system31",
	activate=false,
	image="OptionWindow",
	size={ 512 , 512 },
	pos={ FullWidth()/2 , FullHeight()/2  },
	zorder=5,
}
ViewProp["Settings"]={
	sound="se_maoudamashii_system31",
	activate=false,
	image="OptionWindow",
	size={ 640 , 480 },
	pos={ FullWidth()/2 , FullHeight()/2  },
	zorder=1,
}
ViewProp["Continue"]={
	activate=false,
	image="continue",
	size={ 512 , 300 },
	pos={ FullWidth()/2 , FullHeight()/2  },
	zorder=1,
}
ViewProp["StageClear"]={
	activate=false,
	image="stageClear",
	size={ 512 , 400 },
	pos={ FullWidth()/2 , FullHeight()/2  },
	zorder=1,
}
ViewProp["GameUI"]={
	activate=false,
	zorder=1,
}

AgentPhysicalProcess={}
AgentPhysicalProcess.Update=function( proc , data )
	local role = Character.getRollType( data["name"] );
	local agent = Character.get( role );
	local prop = Character.getProperty( agent:name() );
	if agent then
		local state = agent:getFSM():currentStateName();
		--݂̃Q[[h(C[W[Ƃm[})ɂANṼRXgT
--[[		if IsKeyExist( PhysicalCostMap , gGameMode ) then
			if IsKeyExist( PhysicalCostMap[ gGameMode ] , state ) then
				prop["physical"] = prop["physical"] + PhysicalCostMap[ gGameMode ][ state ];
			end
--]]
		if not( state == data["prevState"] ) then
			data["elapsedMilli"] = 0;--data["elapsedMilli"] - 10;
		end
		if IsKeyExist( PhysicalCostMap , data["fatigability"] ) then
			if IsKeyExist( PhysicalCostMap[ data["fatigability"] ] , state ) then
				prop["physical"] = prop["physical"] 
				 + PhysicalCostMap[ data["fatigability"] ][ state ]-- * data["elapsedMilli"]/100;
			end
			data["elapsedMilli"] = data["elapsedMilli"] + Framework():oneFrameTime();
			if prop["physical"] > 100 then
				prop["physical"] = 100;
			elseif prop["physical"] < 0 then
				prop["physical"] = 0;
			end
		end
	end
	data["prevState"] = state;
	if role == "Player" then
		ChangeWidthHPMeter( "Player" , "HealthMeter1" );
		local pm = GUI_ProgressBar.get( "PhysicalMeter1" );
		if pm then
			if prop["physical"] > 20 then
				pm["BarImage"]:setTexture( "HP.bmp" );
			else
				pm["BarImage"]:setTexture( "ButtonFrame3.bmp" );
			end
			pm.setWidthPercent( prop["physical"]/100 );
		end
	end
end

function LOCK_MOVECommandListener( ip )
	local t = ip:getToken();
	local PM = GetPhysicsManager();
	local phys = PM:currentPhysicalSceneState();
	if not phys then
		return;
	end
	if t == "true" then
		local mX = ip:getFloat();
		local pX = ip:getFloat();
		phys:setMovableX( mX , pX );
	else
		phys:restoreMovableRectGlobal();
	end
--]]
end

function OPEN_DOORCommandListener( ip )
	local sceneName = Native.Methods.CurrentSceneName();
	local doorName = ip:getToken();
	if IsKeyExist( OpenCloseDoorParam , sceneName ) then
		for i=1, #OpenCloseDoorParam[ sceneName ],1 do
			local t = OpenCloseDoorParam[ sceneName ][i];
			if t.name == doorName then
				local state = ip:getToken();
				local sound = ip:getToken();
				OpenTheDoor( sceneName , i  , state , sound );			
			end
		end
	end
end	

function OpenTheDoor( sceneName , dataId , state , sound )
--	OpenCloseDoorParam[ sceneName ][ dataId ].name = name;
	OpenCloseDoorParam[ sceneName ][ dataId ].state = state;
	Native.Methods.PlaySe( sound );
end

--XN[㉺̃ubN][tF[hAEgUI\
function AppearGameUI()
	_("FADE OUT UpperBlack 255 3 0");
	_("FADE OUT GameScript 255 3 50");
end

function DisappearGameUI()
	_("FADE IN UpperBlack 20 3 255");
	_("FADE IN GameScript 20 3 255");
end

------------------------------------------------------
--stage1_1

toStage1_3_TriggeredListener=function( data )
--		_("CHANGE STATE Gody JumpUp_State" );
--		Character.get("Player"):addPos( Vec3(0,0.1,0) );
--		_("CHANGE SCENE stage2_1 0.2 10");
	local scenename = Native.Methods.CurrentSceneName();
	if scenename == "stage1_1" then
		_("CHANGE SCENE stage1_3 0.2 10" );
--		_("PLAY SCRIPT MissionClear" );
--		gStageClearData["stage1_1"] =true;	
	elseif scenename == "stage1_2" then
		_("CHANGE SCENE stage1_3 0.2 10" );
	end
end

toStage1_4_TriggeredListener=function( data )
	_("CHANGE SCENE stage1_4 0.2 10" );
end

toStage2_1_TriggeredListener=function( data )
--	_("CHANGE SCENE stage2_1 0.2 10");
end
	
toStage2_2_TriggeredListener=function( data )
--	_("PLAY SCRIPT MissionClear" );
	_("CHANGE SCENE stage2_2 0.2 10");
--	_("OPEN_DOOR stage2_1Door open door01" );
end
	
toStage3_2_TriggeredListener=function( data )
	_("CHANGE SCENE stage3_2 0.2 10");
--	_("OPEN_DOOR stage2_1Door open door01" );
end

toStage3_3_TriggeredListener=function( data )
	_("CHANGE SCENE stage3_3 0.2 10");
--	_("OPEN_DOOR stage2_1Door open door01" );
end

function CamTgt_townBox1_ChangedListener( data )
	gCamTgtChangeData.lock = false;
	gCamTgtChangeData.obj = "townBox2";
	OpenTheDoor( "stage1_1" , 2  , "open" , "door01" );
	gRailCameraData["InitialPos"][2] = 6;
	gRailCameraData["InitialPos"][3] = -10;
	AppearGameUI();
--	_("ATTACH AGENT Zako1 VIEW AI_1" );
end

function CamTgt_townBox2_ChangedListener( data )
	gCamTgtChangeData.lock = true;
	gCamTgtChangeData.obj = "townBox3";
	_("PLAY SCRIPT CamTgt_townBox2_Changed" );
--[[	OpenTheDoor( 3 , "townDoor3" , "open" , "door01" );
	OpenTheDoor( 4 , "townDoor4" , "open" , "door01" );
--]]
	AppearGameUI();
	gRailCameraData["InitialPos"][2] = 6;
	gRailCameraData["InitialPos"][3] = -12;
end

function stage1_1Zako1DeadListener( data )
	gRailCameraData["InitialPos"][2] = 6;
	gRailCameraData["InitialPos"][3] = -7;
	_( "CHANGE CAMTARGET Player" );
	DisappearGameUI();
	
	_( "LOCK_MOVE false" );
end

function stage1_1_EnemyDefeated1TimesListener( data )
	gRailCameraData["InitialPos"][2] = 6;
	gRailCameraData["InitialPos"][3] = -7;
	_("PLAY SCRIPT stage1_1EnemyDefeated1Times");
	--͂RlĂ炤
	GameMissionParam["stage1_1"]["defeatEnemyNum"] = 3; 
end

------------------------------------------------------
--stage1_3

function stage1_3_EnemyDefeated1TimesListener( data )
	gRailCameraData["InitialPos"][2] = 5.5;
	gRailCameraData["InitialPos"][3] = -6.5;
	_("PLAY SCRIPT stage1_3EnemyDefeated1Times");
	--͂RlĂ炤
	GameMissionParam["stage1_1"]["defeatEnemyNum"] = 3; 
end

------------------------------------------------------
--stage2_1

function CamTgt_stage2_1Box1_ChangedListener( data )
	gCamTgtChangeData.lock = false;
	gCamTgtChangeData.obj = "stage2_1Fence2";
--	OpenTheDoor( 2 , "townDoor2" , "open" , "door01" );
	
	gRailCameraData["InitialPos"][2] = 6;
	gRailCameraData["InitialPos"][3] = -10;
	AppearGameUI();
	_("ENABLE AI Zako1 true" );
	_("ENABLE AI Zako3 true" );
end

function CamTgt_stage2_1Fence2_ChangedListener( data )
	gCamTgtChangeData.lock = false;
	gCamTgtChangeData.obj = "stage2_1Fence3";
--	_("PLAY SCRIPT CamTgt_townBox2_Changed" );
--[[	OpenTheDoor( 3 , "townDoor3" , "open" , "door01" );
	OpenTheDoor( 4 , "townDoor4" , "open" , "door01" );
--]]
	AppearGameUI();

	_("ENABLE AI Zako1 true" );
	_("ENABLE AI Zako2 true" );
	_("ENABLE AI Zako3 true" );

	gRailCameraData["InitialPos"][2] = 6;
	gRailCameraData["InitialPos"][3] = -12;
end

function CamTgt_stage2_1Fence3_ChangedListener( data )
	gCamTgtChangeData.lock = true;
--	gCamTgtChangeData.obj = "townBox3";
	_("PLAY SCRIPT CamTgt_stage2_1Fence3Changed" );
	_("ENABLE AI Zako1 true" );
	_("ENABLE AI Zako3 true" );
	AppearGameUI();

	gRailCameraData["InitialPos"][2] = 6;
	gRailCameraData["InitialPos"][3] = -12;
end

function stage2_1_EnemyDefeated1TimesListener( data )
	gRailCameraData["InitialPos"][2] = 6;
	gRailCameraData["InitialPos"][3] = -7;
	--͂Rl|
	GameMissionParam["stage2_1"]["defeatEnemyNum"] = 3; 	
	_( "CHANGE CAMTARGET Player" );
	_( "LOCK_MOVE false" );
	--G̏oʒu֏uԈړB
	local pos = GetSceneManager():get( "stage2_1Fence2" ):position();
	Character.get( "Zako1" ):setPosition( Vec3( pos.x-1.5 , pos.y , pos.z-2 ) );
	Character.get( "Zako2" ):setPosition( Vec3( pos.x+1 , pos.y , pos.z-4 ) );
	Character.get( "Zako3" ):setPosition( Vec3( pos.x+3 , pos.y , pos.z-3 ) );
	_("PLAY SCRIPT stage2_1EnemyDefeated1Times");
end
	
function stage2_1_EnemyDefeated2TimesListener( data )
	gRailCameraData["InitialPos"][2] = 6;
	gRailCameraData["InitialPos"][3] = -7;
	_( "CHANGE CAMTARGET Player" );
	_( "LOCK_MOVE false" );
	GameMissionParam["stage2_1"]["defeatEnemyNum"] = 2; 	
--	DisappearGameUI();
--	_("PLAY SCRIPT stage2_1EnemyDefeated2Times");
end

function stage2_1_EnemyDefeated3TimesListener( data )
	gRailCameraData["InitialPos"][2] = 6;
	gRailCameraData["InitialPos"][3] = -7;
	_( "LOCK_MOVE false" );
--	_("PLAY SCRIPT stage2_1EnemyDefeated3Times");
	_("GOSIGN" );
	_( "CHANGE CAMTARGET Player" );
	_("ACTIVATE TRIGVOL toStage2_2 true");	
	gStageClearData["stage2_1"] =true;

--	gCamId = 2;
--	_("ATTACH AGENT Boss1 VIEW AI_2" );
--	Native.Methods.PlayBgm( "Boss" );
--	local boss = Character.get( "Boss1" );
--	local pos = GetSceneManager():get( "toStage2_2" ):position();
--	boss:setPosition( pos );
--	CameraFight2DProcess_State.target2 = "Boss1";
end
------------------------------------------------------
function CamTgt_stage2_2pillar1_ChangedListener( data )
	gCamTgtChangeData.lock = true;
	gCamTgtChangeData.obj = "pillar2";
	_("PLAY SCRIPT CamTgt_stage2_2pillar1Changed" );
	_("ENABLE AI Zako1 true" );
	_("ENABLE AI Zako3 true" );
	AppearGameUI();

	gRailCameraData["InitialPos"][2] = 6;
	gRailCameraData["InitialPos"][3] = -12;
end

function AttachAgentDoorFront( name , role , view , doorName , ofsx , ofsz )
	local obj = GetSceneManager():get( doorName );
	if obj then
		local pos = obj:position();
		pos.x = pos.x + ofsx;
		pos.z = pos.z + ofsz;
		_("SET POS "..name.." "..pos.x.." "..pos.y.." "..pos.z );
		_("ATTACH AGENT "..role.." VIEW "..view );
	end
end

function townDoor1OpenedListener( data )
--[[
	AttachAgentDoorFront( "Gody" , "Player" , "Player_1" , "townDoor1" );
--	AttachAgentDoorFront( "Abore" , "Player" , "Player_1" , "townDoor1" );
	gRailCameraData["InitialPos"][2] = 6;
	gRailCameraData["InitialPos"][3] = -7;
	Native.Methods.PlayBgm( "appearPlayer" );
	gCamId = 1;
	local agent = Character.get("Player" );
	agent:setAngle( Vec3( 0,-90,0 ) );
--]]	
end

function townDoor2OpenedListener( data )
	AttachAgentDoorFront( "ZeedA" , "Zako1" , "AI_1" , "townDoor2", 1,-2 );
end

function townDoor3OpenedListener( data )
	AttachAgentDoorFront( "ZeedB" , "Zako2" , "AI_2" , "townDoor3",2,-2 );
end

function townDoor4OpenedListener( data )
	AttachAgentDoorFront( "JohnA" , "Zako3" , "AI_3" , "townDoor4" ,1,-2);
end

function AgentViewAttachedListener( data )
	local paramName = CharaData[ data.name ].battleStyle .. "_Fight_".."Normal";
--	SetAI_FightInputParam( data["viewName"] , paramName );
	local agent = Character.get( data.role );
	if IsKeyExist( AI_FightInputParamMap , paramName ) then
		SetAI_FightInputParam( data["viewName"] , AI_FightInputParamMap[ paramName ] );
	 end
	SetAI_StateParam( data["viewName"] , AI_StateData["Base_Normal"] );
	local bt = agent:brain():behaviorTree();
	bt:setBehavName( "GoStraight" );
	CreateBehavValByGameMode( bt );
end


function CreateBehavValByGameMode( behavTree )	
	assert( IsKeyExist( BehavCostMap , gGameMode ) );
	local t = BehavCostMap[ gGameMode ];
	for k,v in pairs( t ) do
		behavTree:createBehavVal( k , v );
	end
end

function KILL_ENEMIES_CommandListener( ip )
	AI_1View:attachAgent( nil );
	AI_2View:attachAgent( nil );
	AI_3View:attachAgent( nil );
	AI_4View:attachAgent( nil );	
end

function DamageListener( data )
	local name = data.attackedName;
	local prop = Character.getProperty( name );
	local ag = GetSceneManager():get( name ) ;
	if not ag then
		return;
	end
	if data.power >= 5 then
		prop["blowUp"] = true;
	end
	prop["accumDamage"] = prop["accumDamage"] + data.power; 
	local fsm = ag:getFSM();
	if prop["blowUp"] then
		prop["accumDamage"] = 0;
		fsm:changeState( "BlewUpDown_State" );
		prop["blowUp"] = false;
	else
		if CharaData[ name ]["middleDamageTh"] <= prop["accumDamage"]  then
			fsm:changeState( "MiddleDamaged_State" );
			prop["blowUp"] = true;
		else
			fsm:changeState( "SmallDamaged_State" );
		end
	end
	ag:damage( data.power );
end

function FindAndAddBehavScoreListener( data )
	local role = Character.getRollType( data["name"] );
	local agent = Character.get( role );
	local bt = agent:brain():behaviorTree();		
--	if IsKeyExist( BehavScorePtMap , role ) then
	local t = nil;
	if string.find( role , "Zako" ) then
		t = BehavScorePtMap[ "Zako" ];
	elseif  string.find( role , "Boss" ) then
		t = BehavScorePtMap[ "Boss" ];		
	end
	if t then
		local e = data["evtType"];
		if IsKeyExist( t , e ) then			
			bt:addBehavScore( t[ e ]["behav"] , t[ e ]["score"] );
		end
	end
--]]
end

function LookAtMeListener( data )
	local ip = data["value"]
	local agent = GetSceneManager():get( data["name"] );
	local chdata = CharaData[ data["name"] ];
	local behav = "Hover";
	local score = 1;
	if ip >= 0.3 then		
		behav = chdata["personal"]["doNotLookAtMe"][1];
		score = chdata["personal"]["doNotLookAtMe"][2];
	elseif ip <= 0  then
		behav = chdata["personal"]["lookAtMe"][1];
		score = chdata["personal"]["lookAtMe"][2];
	end
	local bt = agent:brain():behaviorTree();
	bt:addBehavScore( behav , score );	
end

function Distance13Listener( data )
	local agent = GetSceneManager():get( data["name"] );
	local distance = data["value"]
	if distance > 5 then
		agent:brain():behaviorTree():addBehavScore( "Aggressive" , 1 );	
	else
		agent:brain():behaviorTree():addBehavScore( "Away" , 1 );	
	end
end

function Distance23Listener( data )
	local agent = GetSceneManager():get( data["name"] );
	local distance = data["value"]
	if distance < 1 then
		agent:brain():behaviorTree():addBehavScore( "Away" , 3 );	
	end
end
	
function PlayerPickUpAnimFinishedListener( data )
	_("VISIBLE Juice1 false");
	Native.Methods.PlaySe( "eat05" );	
	local agent = GetSceneManager():get( data.name );
	local hp = agent:hitpoint() + 20;
	local maxHp = CharaData[ agent:name() ].hitPoint;
	if hp >= maxHp then
		hp = maxHp;
	end
	agent:setHitPoint( hp );
end
	
function AnimationTimeListener( data )
	local agent = GetSceneManager():get( data.name );
	local prop = Character.getProperty( agent:name() );
	if data.type == "BackDropped" then
		agent:getFSM():changeState( "BlewUpDown_State" );
		agent:damage( 5 );
	elseif data.type =="ItemGet" then
		local itemprop = Item.getProperty( "Juice1" );
		local item = Item.get( "Juice1" );
		--ACeɃA^b`
		if item then
			if prop then
				prop["ItemGettable"] = false;
				prop["ItemAttach"] = true;
			end
			if itemprop then
				itemprop["attached"] = true;
				itemprop["move"] = false;
				itemprop["owner"] = data.name;
			end
			item.attachAgent( agent , "HandR_Joint","BladeR_Joint" );
--			item.attachAgent( agent , "BladeR_Joint","HandR_Joint" );
		end
--[[	elseif data.type == "ItemThrowed" then
		if item then
				if prop then
					prop["ItemGettable"] = false;
					prop["ItemAttach"] = false;
				end
				if itemprop then
					itemprop["attached"] = false;
					itemprop["move"] = true;
					itemprop["owner"] = data.name;
				end
				--ACe𓊂
				local dir = Vec3();
				agent:getDirection( dir );
				dir.y = 0;
				dir = dir * 0.5;
				item.translate( dir );
				item.rotate( Vec3(10,0,0));
		end		
--]]
	end
end

function AgentMovedListener( data )
	local m = data["move"];
	table.insert( gQueuedEvent , data );
end

function PlayerDeadListener( data )
--	AttachView("Continue");
--	ActivateCharaView( false );
--	CharacterView:activateAgent( false );
	gStageClearData["defeated"] = true;
	_("CHANGE SCENE StageSelect 0.2 10" );
--[[	
	if data["name"] == "Player2" then
		local pic = GUI_Picture.create( PictureData["StageClear"] );
		pic.process:changeMode( Process.INITIALIZING );
		Native.Methods.PlayBgm( "win" );
	end
--]]
--	_("SET POS "..data["name"].." 0 5 3");	
end

function PopEnemy( )
	local enem = EnemyQueue.front();
	if enem then
		if enem.name then
			if Revive( enem["name"] ) then
	--			if enem.pos then
	--				_("SET POS "..data["name"].." "..enem.pos[1].." "..enem.pos[2].." "..enem.pos[3]);
	--			end
				EnemyQueue.pop_front();
				return true;
			end
		end
		return false;
	else
		return false;
	end
end

function EnemyDeadListener( data )
	local sceneName = Native.Methods.CurrentSceneName();
	if data.name then
		local role = Character.getRollType( data["name"] );
		TriggerEvent( sceneName..role.."Dead" , "a" );
		local agent = GetSceneManager():get( data["name"] );
		--URȂ݂
		if gIsRevive then
			if string.find( role , "Zako" ) then
				Revive( role );
				local pos = agent:position();
				agent:setPosition( Vec3( pos.x,pos.y+5,pos.z) );
			end
		end
--		local vn = agent:attachedViewName();
--		local view = GetViewManager():view( vn );
--		view:attachAgent( nil );
--		Revive( role );
	end
	if IsKeyExist( GameMissionParam , sceneName ) then
		local mp = GameMissionParam[ sceneName ];
		if mp.defeatEnemyNum then
			gEnemyDeadNum = gEnemyDeadNum + 1;
			if gEnemyDeadNum == mp["defeatEnemyNum"] then
				gEnemyDeadNum = 0;
				gEnemyDefeatNum = gEnemyDefeatNum + 1;
				TriggerEvent( sceneName.."_EnemyDefeated"..gEnemyDefeatNum.."Times" , {} );
			end
			local cnt = GUI_Numeric.get("DefeatCount");
--			local cnttgt = GUI_Numeric.get("DefeatCountTarget");
			if cnt then
				cnt.setNumber( gEnemyDeadNum );
			end
		end
	end
end

function StageCleared( )
--	CommandQueue.create( "EvtStageClear" , EventScriptData["StageClear"]);	
	_("CHANGE SCENE StageSelect 0.1 15");	
end

function PlayerOn_stage1_1_toNextListener( data )
	_("CHANGE SCENE stage1_2 0.1 15");
end

function PlayerOn_stage1_1_toNextListener( data )
	if data.name then
		local roll = Character.getRollType( data.name );
		if roll == "Player" or
		  roll == "Player2" then
			_("CHANGE SCENE stage1_2 0.1 15");
		end
	end
end

function AgentOnFloorListener( data )
--[[	if data.name then
		local role = Character.getRollType( data["name"] );
		if role == "Player" then
			if data.polyCenter then
				Camera.setLookAt( data["polyCenter"] );
			end
		end		
	end
--]]
end

function PlayerDamagedListener( data )
--	ChangeWidthHPMeter( data , "HealthMeter1" );
end

function Player2DamagedListener( data )
--	ChangeWidthHPMeter( data , "HealthMeter2" );
end

function AgentWallCollisionListener( data )
	local pl = Character.get("Player");
--	if pl:getFSM():currentStateName() == "JumpUp_State" then
		if pl:command():isTriggered( J ) then
			pl:addAngle( Vec3( 0,180,0 ) );
			pl:getFSM():changeState( "JumpUp_State");
			local p = pl:getProcessor():process( "Animation" );
--			p:setData( AnimationParam["Ninja2"]["Swan"] );
			p:setData( AnimationParam["Common"]["ZenchuUp"] );
			local arg = {
				ProcessName="Animation" ,
				ProcessMode=Process.INITIALIZING
			}
			StateFunctions["ChangeProcessMode"]( pl , arg );			

		end
--	end
--[[	local scene = Native.Methods.CurrentSceneName();
	if scene == "stage1_1" then	
		if data["meshName"] == "dd3St1ToNext" then
			_("CHANGE SCENE stage1_2 0.1 15");
		end
	elseif scene == "stage3_2" then
		if gOpenedStage3_2Door then
			if data["meshName"] == "preLastDoorR" then
				_("CHANGE SCENE stage3_3 0.1 15");
			end
		end
	end
--]]
--[[	elseif currSceneName == "stage2_2" then
--		if data["meshName"] == "dd2st2_radder" then
		if data["meshName"] == "forestLadder" then
			_("CHANGE STATE "..data["name"].." Ladder_State");
		elseif data["meshName"] == "tile_15" then
			_("CHANGE SCENE stage1_2 0.1 15");
		end
	end
--]]
end

--[[
	Agenttile_9Collision="CHANGE SCENE Stage2 0.2 10 "
	Agenttile_1Collision="CHANGE STATE Player BoundWall_State"
	Agenttile_2Collision="CHANGE STATE Player Ladder_State"
	Agenttile_3Collision="CHANGE STATE Player Ladder_State"
--]]



--AI_StateDatago[XĂ`hXe[g̃f[^쐬
for k,v in pairs( AI_FightInputData ) do
	AI_FightInputParamMap[ k ] = AI_InputParam();	--AI_InputParam : lCeBuCppɒ`
	for i=1,#v,1 do
		AI_FightInputParamMap[ k ]:inputKey( v[i] );
	end
--]]
end


function HitObjColEnterListener( data )
	local a = data["name1"];
	local b = data["name2"];	
	local sm = GetSceneManager();

	local A = HitObject.get( a );
	local roleB=Character.getRollType( b );
	
	if A and roleB then
		if roleB == "Player" then
			if A.name == "stage1_1ElevDoorLow" then
				A.move();
				--A.rotate();
			end
		end
	end
end


function ItemCollisionEnterListener( data )
--[[	local a = data["name1"];
	local b = data["name2"];	
	local sm = GetSceneManager();
	local A = sm:get( a );
	local B = sm:get( b );

if A:isVisible() and B:isVisible() then	
	--TODO: this is sample
	if b == "Gody" then
		if a== "Juice1" then
			local propA = Character.getProperty( b );
			if propA then
				propA["ItemGettable"] = true;
				propA["ItemAttach"] = false;
			end
			return;
		end
	end
end
--]]
end

function ItemCollisionOffListener( data )
	local a = data["name1"];
	local b = data["name2"];	
	local sm = GetSceneManager();
	local A = sm:get( a );
	local B = sm:get( b );
--TODO: this is sample
if b == "Gody" then
	if a== "Juice1" then
		local itemprop = Item.getProperty( "Juice1" );
		local propA = Character.getProperty( b );
		propA["ItemGettable"] = false;
		propA["ItemAttach"] = false;
--[[		if propA and itemprop then
			if itemprop.attached and not itemprop["attached"] then
				propA["ItemGettable"] = false;
				propA["ItemAttach"] = false;
			end
		end
--]]	
		return;
	end
end

end

function ItemCollisionContactListener( data )
	local a = data["name1"];
	local b = data["name2"];	
	local sm = GetSceneManager();
	local propA = Item.getProperty( a );
	local propB = Character.getProperty( b );
--TODO: this is sample
if propA and propB then
	local weapon = sm:get( a );
	local damaged = sm:get( b );
	if a== "Juice1" then
--[[		if propA.move and propA.owner then
			if not ( b == propA["owner"] ) then
				if propA["move"] then
					propA["attached"] = false;
					propA["move"] = false;
					propA["owner"] = "";
					propB["ItemGettable"] = false;
					propB["ItemAttach"] = false;
					local itm = Item.get( a );
					damaged:getFSM():changeState( "BlewUpDown_State" );
--					DamageToAgentBrain( weapon , damaged , weapon:position() , itm , "particleYellow" );
--					if itm then
					itm.stop();
					Native.Methods.SetVisible( a , false );
--					end					
				end
			else
			end
		end
--]]
	end
	return;
end
--[[
	local A = HitObject.get( a );
	local B = sm:get( b );
	
if A and B then
if A.name == "Stage1_2_Door" then
	local stateB = B:getFSM():currentStateName();	
	local tm =B:animationControl():Time();
	local atkData = Character.getData( B:name() ).process["AttackHit"]["data"]
	local animname = B:animationControl():currentAnimeName();
	if not IsKeyExist( atkData , animname ) then
		return;
	end
	local aData = atkData[ animname ];
	if ( aData[ "BeginTime" ] <  tm ) and ( tm < aData[ "EndTime" ] ) then
		A.jag();
		if A.hitSound then
			GetSoundManager():playSe( A["hitSound"] );	
		end
	end	
end	
end
--]]
end

--ŨRWXi[B
--RWĂƂ̃R[obN
function AttackCollisionContactListener( data )
	local a = data["name1"];
	local b = data["name2"];	
	local sm = GetSceneManager();
	local A = sm:get( a );
	local B = sm:get( b );
	if not ( A and B ) then
		return;
	end
	local roleA=Character.getRollType( a );
	local roleB=Character.getRollType( b );
	if not ( roleA and roleB ) then
		return;
	end
	if not ( ( A:isActive()  ) and ( B:isActive() ) ) then
		return;
	end
	local stateA = A:getFSM():currentStateName();
	local stateB = B:getFSM():currentStateName();
	local posA=A:position();
	local dif = A:position() - B:position();
--[[	--ZƂɍU悤ɂ?
	if dif.z >= 0.5 then
--		return;
	end
--]]
	local temp = function( attacker,attacked )
		local tm =attacker:animationControl():Time();
		local atkData = Character.getData( attacker:name() ).process["AttackHit"]["data"];
		local animname = attacker:animationControl():currentAnimeName();
		if not IsKeyExist( atkData , animname ) then
			return;
		end
		local aData = atkData[ animname ];
		if ( aData[ "BeginTime" ] <  tm ) and ( tm < aData[ "EndTime" ] ) then
			AttackHit( attacker , attacked , atkData );
			Native.PhysicsManager():enableDetectPair( a , b , false );
--[[			local col = Native.PhysicsManager():collision( a );
			if col then
--				col:enableDetect( false );
			end
--]]
			return true;
		end
		return false;		
	end
	if stateA == "Attack_State"
			or 
	  stateA == "Grappling_State" then
		temp( A , B );
	end
	if stateB == "Attack_State"
			or 
	  stateB == "Grappling_State" then
		temp( B , A );
	end
Native.Methods.OutputDebugStr( "pair{ "..a..","..b.."}" );	
end


function EnterMission( param )
	local scene = Native.Methods.CurrentSceneState();
--	scene:attachView( "Character");
	scene:attachAgentView( "Player_1");
	scene:attachAgentView( "Player_2");
	scene:attachAgentView( "AI_1");
	scene:attachAgentView( "AI_2");
	scene:attachAgentView( "AI_3");
	scene:attachAgentView( "AI_4");
--	scene:attachAgentView( "NPC");
	Player_1View:attachAgent( nil );
	Player_2View:attachAgent( nil );
	AI_1View:attachAgent( nil );
	AI_2View:attachAgent( nil );
	AI_3View:attachAgent( nil );
	AI_4View:attachAgent( nil );
	NPCView:attachAgent( nil );
--	_( "ENABLE AI NPC true" );
	ActivateCharaView( true );
--	CharacterView:activate( true );
--	CharacterView:setZOrder(0);
--	AttachView( "Character" );
	
	local playerName = Character.getCharacterName( "Player");	
			
	Particle.attach( "particleYellow" );
	Particle.attach( "particleGreen" );
	Particle.attach( "particleBlue" );
	Particle.attach( "hitEffect" );
	GetPhysicsManager():activate(true );
	
--	pb.increment = pb.frameW/25;
	
--	_("FADE IN HealthMeter1 0 2 255");
--	_("FADE IN barHealthMeter1 0 2 255");
--	_("FLY BAR HealthMeter1 UP 1000");
--	Animation2D.fadeIn( { name="HealthMeter1",speed=2,threshold=255,alpha=0} );
--	Animation2D.fadeIn( { name="barHealthMeter1",speed=2,threshold=255,alpha=0} );

	ShowSystemIcon();
			
--	_("ATTACH SCENE goSign");	
--	local pic = GUI_Picture.create( PictureData["Fight"] );
--	local pic = GUI_Picture.create( PictureData["StageStart"] );
	local gu = GetViewManager():view( "GlobalUI" );
	if gu then
--		GetViewManager():attach( "GlobalUI" );
		gu:enableUpdate( true );
	end
	gu = GetViewManager():view( "GameUI" );
	if gu then
--		GetViewManager():attach( "GameUI" );
		gu:enableUpdate( true );
	end
	GameUIView:activate( true );
--	_("ATTACH SCENE help1");
--]]	
	GameUIView:attachNode( "goSign");
	GameUIView:attachNode( "StageClear");
	GameUIView:attachNode( "TheEnd");
	GameUIView:attachNode( "Fight");	
	AttachView( "GlobalUI" );
	AttachView( "GameUI" );
	DetachView( "Mission" );
	DetachView( "PauseMenu" );
	DetachView( "Option" );
	
	_("ATTACH SCENE HelpGameCommand" );
	_("VISIBLE StageClear false") ;
	_("VISIBLE TheEnd false") ;
	_("VISIBLE goSign false") ;
	_("VISIBLE help1 false" );
	_("VISIBLE divBar false");
	_("LOCK_MOVE false" );
--	_("FADE IN UpperBlack 20 3 255" );
--	_("FADE IN GameScript 20 3 255");
	
--	gCamTgtChangeData.lock = true;
		
	if Config["edit"] then
		_("ATTACH SCENE PointingBall");
		_("ATTACH SCENE SelectedGeometry");
	end
	gEnemyDeadNum = 0;
	gEnemyDefeatNum = 0;
	local name = param["name"];
	Native.Methods.CurrentSceneState():attachCurrentSceneView( name );
	if param.script then
		_("PLAY SCRIPT "..param["script"] );
	end
	if param["missionStart"] then
		_("PLAY SCRIPT MissionStart" );
	end
	if param.defeatEnemyNum then
--[[		_("ATTACH SCENE divBar");
		_("VISIBLE divBar true");
		_("VISIBLE DefeatCountTarget true");
--]]
		local cnttgt = GUI_Numeric.get("DefeatCountTarget");
		if cnttgt then
			cnttgt.setNumber( param["defeatEnemyNum"] );
		end
	end
	if param["camera"] == CAMMODE_Parallel then
		gRailCameraData["InitialPos"][2] = param["cameraOffset"][1];
		gRailCameraData["InitialPos"][3] = param["cameraOffset"][2];
		gCamId =CAMMODE_Parallel;
	elseif param["camera"] == CAMMODE_CloseUp then
--		Camera.changeState("CameraCloseUp");
		gCamId =CAMMODE_CloseUp;		
	end
	
	if param.minY then
		gRailCameraData["minY"] = param["minY"];
	end	
	if param.maxY then
		gRailCameraData["maxY"] = param["maxY"];
	end	
	--J^[QbgIuWFNgɋ߂Â烍bN邩
	gCamTgtChangeData.lock = param["targetLock"];
	if not param["targetLock"] then
		gCamTgtChangeData.obj = param["targetCamObj"];
	else
		gCamTgtChangeData.obj = "";
	end
	gIsRevive = param["revive"];
--]]
	GetPhysicsManager():getFSM():initState( param["name"] );
	ProcessClass.changeProcMode( "LvProg" , Process.WAITING );
	ProcessClass.changeProcMode( "GoSign" , Process.WAITING );
	
	SetCamSubjPlayer( );

	Revive( "Player");
	Revive( "Player2");
	Revive( "Zako1");
	Revive( "Zako2");
	Revive( "Zako3");
	Revive( "Zako4");
	Revive( "Zako5");
	Revive( "Zako6");
--	Revive( "Zako7");
--	Revive( "Zako8");
--	Revive( "Zako9");
--	Revive( "Zako10");
	Revive( "Boss1");
	Revive( "Boss2");
	Revive( "Boss3");
	Revive( "Boss4");

	for i=1,6,1 do
		_("ENABLE AI Zako"..i.." true" );
	end
	for i=1,4,1 do
		_("ENABLE AI Boss"..i.." true" );
	end
--	_("LOCK_MOVE false" );
--]]
--[[
	local meter1 = GUI_ProgressBar.get( "HealthMeter1" );
	local meter2 = GUI_ProgressBar.get( "HealthMeter2" );
	InitHPMeterWidth( meter1 );
	InitHPMeterWidth( meter2 );
--]]	
end

function InitHPMeterWidth( hpm )
	local w = hpm.FrameImage:width();
	hpm.setWidth( w );
end

function SetCamSubjPlayer()
	local charaName = Character.getCharacterName( "Player" );
	gRailCameraData["SubjectName"]=charaName;
	gCameraCloseUpData["SubjectName"]=charaName;
end

--[[
local sord = Item.create( ItemData3 );
sord.attachScene();
local yoroi = Item.create( ItemData4 );
yoroi.attachScene();
--	local graph = scene:graph();
	local graph = Stage1View:graph();
	graph:show( true );
	BuildGraphSegment( 
		 graph ,
		"graph_node1_",
		Vec3(-7,0,0 ),
		4 , 4 ,
		6,3 );
	BuildGraphSegment( 
		graph ,
		"graph_node2_",
		Vec3(7,0,0 ),
		3 , 3 ,
		4,4 );
	graph:linkNodes( "graph_node1_3" , "graph_node2_0" );
--	graph:linkNodes( "graph_node1_7" , "graph_node2_4" );
--	graph:linkNodes( "graph_node1_11" , "graph_node2_8" );
--	graph:linkNodes( "graph_node1_15" , "graph_node2_12" );

--]]		

function SceneLoading_EnterListener( data )
--	TriggerEvents( gTitleMenuEnterEvtList );
--[[	TriggerEvents( gLoadReqList1 );
	_("ATTACH SCENE loading");
	_("ATTACH SCENE loadingStr");
	
	for k,v in pairs( TitleBgmFiles ) do
		GetSoundManager():loadBgm( v );
	end
	--]]
end

--
function InitSystem()
--	local camData = Framework():resourceData( "camera.txt" );
--	_( camData );

	GUI_Button.mouseClick = true;
	GUI_Button.mouseOnly =false;
--	GUI_Button.mouseClick = false;
--	GUI_Button.mouseOnly = false;
	--Edit Mode On
	if Config["edit"] then
		GUI_Editor.attachProcessManager();
	end
	--Creation of FuzzySet
	CreateFuzzySet( FuzzySet["distance"] );
	CreateFuzzySet( FuzzySet["pain"] );
--[[	
	local SM = GetSceneManager();
	local ball = SM:get( "PointingBall" );
	if ball then
		ball:setVisible( false );
	end
	local sg = SM:get( "SelectedGeometry" );
	if sg then
		sg:setVisible( false );
	end
--]]	

--	_("VISIBLE PointingBall false" );
--	_("VISIBLE SelectedGeometry false" );
	
	--WCXeBbÑ{^ԍQ[R}hɕϊ}bvo^
	local vc = GetViewManager():viewController()
	local pvc = Player_1View:controller();
	for i=1,#gJoystickButtonMap, 1 do
		local t = gJoystickButtonMap[i];
		vc:controller():setJoystickButtonToCommand( t[1] , t[2] );
		pvc:setJoystickButtonToCommand( t[1] , t[2] );
	end

--	EnemyQueue = Queue.create();
	Camera.init( CameraMap );
	Native.Methods.AttachProcess( "Loading" , ShowLoadingImageProcess , {} );		
	Native.Methods.AttachProcess( "LoadingStrAlpha" , AlphaWaveProcess_State , { name="loadingStr",speed=2,} );		
	Native.Methods.AttachProcess( "Test" , gTestProcess , {} );		
	Native.Methods.AttachProcess( "CamTgtChange" , CamTgtChangeProcess , gCamTgtChangeData );
	Native.Methods.AttachProcess( "ShowComHelp" , ShowCommandHelpProcess , "abeshi!" );
	
--	Native.Methods.AttachProcess( "PlayerPhysical" , AgentPhysicalProcess , { name="Player" });
	
	--hÅJvZX쐬
--	for i=1,#gOpenCloseDoorDataArray,1 do
--		Native.Methods.AttachProcess( "DoorOpen"..i , OpenCloseDoorProcess , gOpenCloseDoorDataArray[i] );
--	end
	for k,v in pairs( ParticleData ) do
		Particle.create( v);
	end
	GetEventManager():enableLog( "Contact" , false );

	CloneChara( "Zeed" , "ZeedA" );
	CloneChara( "Zeed" , "ZeedB" );
	CloneChara( "Zeed" , "ZeedC" );
	CloneChara( "Zeed" , "ZeedD" );
	CloneChara( "John" , "JohnA" );
	CloneChara( "John" , "JohnB" );
	CloneChara( "HighKicker" , "HighKickerA" );
	CloneChara( "HighKicker" , "HighKickerB" );
	CloneChara( "HighKicker" , "HighKickerC" );
	CloneChara( "HighKicker" , "HighKickerD" );
	CloneChara( "Roper" , "RoperA" );
	CloneChara( "Roper" , "RoperB" );
	CharaData["HighKickerB"]["material"]={
		{ 1, Mat_Ash05 , 0 } ,
		{ 2, Mat_Ash02 , 0 } ,		
		{ 3, Mat_Ash02 , 0 } ,		
	}
	CharaData["HighKickerC"]["material"]=CharaData["HighKickerB"]["material"];
	CharaData["ZeedB"]["mesh"]={
		"ShoulderSpike"
	};
	CharaData["ZeedB"]["hitPoint"] = 10;
	CharaData["ZeedB"]["personal"]={
		doNotLookAtMe={ "Hover" , 1 },		
		lookAtMe={ "Aggressive" , 5 },
	};
	
	--Mapping Character Role to Name
	for k,v in pairs( CharaNameMap ) do
		Character.setNameMap( k , v  );	
	end
		
	--Creation of Player Character
	for k,v in pairs( CharaData ) do
		Character.create( v );
	end
	
	local tp1 = GameLib.AttachProcess( "throw1", ThrowProcess_State, {} );
	local tp2 = GameLib.AttachProcess( "throw2", ThrowProcess_State, {} );
	tp1:getAny()["isReady"] = true;
	tp2:getAny()["isReady"] = true;
	
	GameLib.AttachProcess( "Test2" , gTestProcess2 , {} );	

	--Create global gui components
--	GUI_TextBox.create( TextBoxData["Script"] );
	GUI_Picture.create( PictureData["UpperBlack"] );
	GUI_TextBox.create( TextBoxData["MissionScript"] );
	GUI_TextBox.create( TextBoxData["GameScript"] );
	GUI_Button.create( ButtonData["OptionMenu"] );
	GUI_Button.create( ButtonData["WindowMode"] );
	GUI_Button.create( ButtonData["PauseMenu"] );
	GUI_Button.create( ButtonData["Back"] );
	GUI_Button.create( ButtonData["Help"] );
--[[	GUI_Button.create( ButtonData["WASD"] );
	GUI_Button.create( ButtonData["M"] );
	GUI_Button.create( ButtonData["N"] );
	GUI_Button.create( ButtonData["J"] );
	GUI_Button.create( ButtonData["K"] );
--]]
	GUI_Picture.create( PictureData["CharaInScript"] );
--	GUI_Picture.create( PictureData["HelpGameCommand"] );
--	GUI_Button.create( ButtonData["Player1Chara"] );
	
	GUI_ProgressBar.create( ProgressBarData["HealthMeter1"] );
--	GUI_ProgressBar.create( ProgressBarData["HealthMeter2"] );
	GUI_ProgressBar.create( ProgressBarData["PhysicalMeter1"] );
--	GUI_ProgressBar.create( ProgressBarData["PhysicalMeter2"] );
	--Show FPS
--	local nume = GUI_Numeric.create( GUI_NumericFrameRateData );
--	nume.setNumber(60);
--]]
--[[
	nume = GUI_Numeric.create( GUI_NumEnemDefCntData );
	nume.setNumber(0);
	nume = GUI_Numeric.create( GUI_NumEnemDefTgtData );
	nume.setNumber(10);
--]]	

	--Load BGM and SE wave files
	for k,v in pairs( BgmFiles ) do
--		GetSoundManager():loadBgm( v );
	end
	for k,v in pairs( SeFiles ) do
		GetSoundManager():loadSe( v );
	end
	
	--
--	GetPhysicsManager():setContactDelayTick( GameProperty["contactDelayTick"] );

	GlobalUIView:activate( true );
	GlobalUIView:setZOrder(100);
	GlobalUIView:attachNode( "cursor" );
	GlobalUIView:attachNode( "loading" );
	GlobalUIView:attachNode( "loadingStr" );
	
	ProcessClass.create("CamJag", CamJagProcess_State , gCamJagData , Process.WAITING);
	
--	SetViewProp( CharaSelectView , ViewProp["CharaSelect"] );
	SetViewProp( StageSelectView , ViewProp["StageSelect"] );
	SetViewProp( MissionView , ViewProp["Mission"] );
	SetViewProp( OptionView , ViewProp["Option"] );
	SetViewProp( PauseMenuView , ViewProp["PauseMenu"] );
	SetViewProp( ContinueView , ViewProp["Continue"] );
	SetViewProp( StageClearView , ViewProp["StageClear"] );
	SetViewProp( GameUIView , ViewProp["GameUI"] );
	SetViewProp( SettingsView , ViewProp["Settings"] );
	gCamCurveProcess0 = GameLib.CreateCameraCurveProcessA( "CamCourse0", CAMMODE_Course0  );
	gCamCurveProcess1 = GameLib.CreateCameraCurveProcessA( "CamCourse1",CAMMODE_Course1  );
	gCamCurveProcess2 = GameLib.CreateCameraCurveProcessA( "CamCourse2",CAMMODE_Course2  );
	
	SetCamSubjPlayer( );

	Camera.fsm.createState( "CameraCloseUp" , CameraCloseUpProcess_State , gCameraCloseUpData );
	Camera.fsm.createState( "RailCamera" , ParallelCameraProcess_State , gRailCameraData );
	Camera.fsm.createState( "CameraFight2D" , CameraFight2DProcess_State , gFight2DCamData );
	Camera.fsm.createState( "CameraComb" , CombCameraProcess_State , gCombCamData );
	Camera.fsm.createState( "CameraLerp" , LerpCameraProcess_State , gCamLerpData );
	Camera.fsm.setState( "CameraCourse0" , gCamCurveProcess0 );
	Camera.fsm.setState( "CameraCourse1" , gCamCurveProcess1);
	Camera.fsm.setState( "CameraCourse2" , gCamCurveProcess2 );
	Camera.fsm.createState( "CameraEdit" , EditCameraProcess_State , {} );
		
	Camera.changeState("RailCamera");
--	Camera.changeState("CameraLerp");
	
	--uɐi߃TCṽvZX
--	ProcessClass.create( "LvProg" , LevelProgressProcess , LevelProgData , Process.WAITING  )
	ProcessClass.create( "GoSign" , ShowGoSignProcess , ShowGoSignData , Process.INITIALIZING )
end

--^Cgʂɂ͂ߓƂ̃R[obN
function SceneTitle_EnterListener( data )
	GetParser():setMaxGetTokenNumPerFrame( 30 );
	GUI_Picture.create( PictureData["TitleLogo1"] );
	GUI_Picture.create( PictureData["TitleLogo2"] );
	InitSystem();
	_("PLAY SCRIPT title" );
	TriggerEvents( gLoadReqList );
end

function Stage1ClearedListener( data )
	local st2 = GUI_Button.create( ButtonData["Stage2"] );		
	StageSelectGUIArrayData={
		array={
			{ GUI_Button.get("Stage1" ) , st2, },
		}
	}
end

--^Cgj[ʂɂ͂ߓƂ̃R[obN	
function SceneTitleMenu_EnterListener( data )
	Native.Methods.CurrentSceneState():clearView();
	
	--p[T[1t[̓ǂݍ݃g[N50ɐݒ
	GetParser():setMaxGetTokenNumPerFrame( 50 );	
	
	--^Cgj[r[A^b`
	AttachView( "TitleMenu" );
	AttachGlobalUIView();
	
	local backBtn = GUI_Button.get( "Back" );
	local opt = GUI_Button.get( "OptionMenu" );
	local winMode = GUI_Button.get( "WindowMode" );
	TitleMenuGUIArrayData={
		array={
			{ GUI_Button.create( ButtonData["GameStart"] ) },
--			{ GUI_Button.create( ButtonData["SurvivalMode"] ) },
--			{ GUI_Button.create( ButtonData["TrainingMode"] ) },
			{ GUI_Button.create( ButtonData["GameExit"] ) },
--			{ opt , winMode },
		}
	} 
--[[	CharaSelectGUIArrayData={
		array={
			{ GUI_Button.create( ButtonData["Chara1"] ),
			GUI_Button.create( ButtonData["Chara2"] ) ,	
			backBtn ,
			
--			GUI_Button.create( ButtonData["Chara3"] ) ,		
--			GUI_Button.create( ButtonData["Chara4"] ) ,				
			 },
		}
	}
--]]	
--[[
		StageSelectGUIArrayData={
			array={
				{ GUI_Button.create( ButtonData["Stage1"] ),
				GUI_Button.create( ButtonData["Stage2"] ) ,			
				GUI_Button.create( ButtonData["Stage3"] ) ,			
				backBtn,
				},
				{ GUI_Button.create( ButtonData["Stage4"] ) ,},
				{ opt },
			}
		}
		StageSelectView:attach(  CursorMoveProcess_State , StageSelectGUIArrayData );		
--]]
	StageSelectGUIArrayData={
		array={
			{ GUI_Button.create( ButtonData["Stage1"] ),
			backBtn },
			{ opt },
		}
	}
--]]
	PauseMenuGUIArrayData={
		array={
			{ GUI_Button.create( ButtonData["ResumeGame"] ) } ,
			{ GUI_Button.create( ButtonData["ReturnStageSelect"] ) } ,
			{ GUI_Button.create( ButtonData["ReturnTitleMenu"] ) },			
		}
	}
	local bgm = GUI_ProgressBar.create( ProgressBarData["BGMVol"] );
--	bgm.increment = 1;
	local se = GUI_ProgressBar.create( ProgressBarData["SEVol"] );
--	se.increment = 1;
		
	OptionGUIArrayData={
		array={
			{ GUI_Button.create( ButtonData["BgmUpper"] ), backBtn },
			{ GUI_Button.create( ButtonData["BgmDowner"] ), backBtn },
			{ GUI_Button.create( ButtonData["SeUpper"] ), backBtn },
			{ GUI_Button.create( ButtonData["SeDowner"] ), backBtn },
			{ GUI_Button.create( ButtonData["Easy"] ) ,
			  GUI_Button.create( ButtonData["Normal"] ) ,
			  GUI_Button.create( ButtonData["Hard"] ) , backBtn },			
		}
	}
	ContinueGUIArrayData={
		array={
			{ GUI_Button.create( ButtonData["ContinueYes"] ),
			GUI_Button.create( ButtonData["ContinueNo"] ) ,			
			 },
		}
	}
	GUI_Picture.create( PictureData["Stage1View"] );
	GUI_Picture.create( PictureData["MissionStr"] );
--	GUI_Picture.create( PictureData["CharaSelStr"] );
--	GUI_Button.create( ButtonData["MissionEnter"] );
	
	MissionGUIArrayData={
		array={
			{  GUI_Button.create( ButtonData["MissionEnter"] ), 
			 GUI_Button.create( ButtonData["MissionCancel"] ), }
		}
	}
--]]	
--	local pb = GUI_ProgressBar.create( ProgressBarData["HealthMeter1"] );
	TitleMenuView:attach( CursorMoveProcess_State , TitleMenuGUIArrayData );
--	CharaSelectView:attach(  CursorMoveProcess_State , CharaSelectGUIArrayData );
	StageSelectView:attach(  CursorMoveProcess_State , StageSelectGUIArrayData );
	MissionView:attach(  CursorMoveProcess_State , MissionGUIArrayData );
	OptionView:attach(  CursorMoveProcess_State , OptionGUIArrayData );
	PauseMenuView:attach(  CursorMoveProcess_State , PauseMenuGUIArrayData );
	SettingsView:attach(  CursorMoveProcess_State , SettingsGUIArrayData );
	ContinueView:attach(  CursorMoveProcess_State , ContinueGUIArrayData );
--	GameUIView:attach(  CursorMoveProcess_State , GameGUIArrayData );
--]]	
	_("PLAY SCRIPT PreTitleMenuEnter" );
--	GetViewManager():attach( "TitleMenu");
--	CharaSelectView:setParentView( TitleMenuView );
--	StageSelectView:setParentView( CharaSelectView );
--	OptionView:setParentView( TitleMenuView );
	MissionView:setParentView( StageSelectView );
--	SetViewProp( TitleMenuView , ViewProp["TitleMenu"] );
	
--	GlobalUIView:attachNode( "loading" );
--	GlobalUIView:attachNode( "loadingStr" );
	ClearScriptText();
		
end

--[[	
	SettingsGUIArrayData={ 
		array={
			{ GUI_Button.create( ButtonData["Easy"] ) } ,
			{ GUI_Button.create( ButtonData["Normal"] ) },
			{ GUI_Button.create( ButtonData["Hard"] ) },
		}
	}
--]]

function ClearScriptText()
	local st = GUI_TextBox.get( "Script" );
	if st then
		st.clearText();
	end
end

function SceneSettings_EnterListener( data )
	
end

function SceneOptionMenu_EnterListener( data )
	_("ATTACH SCENE optionMenu" );
	local ud = GUI_UpDownBar.create( UpDownBarData["BGMVol"] );
	ud.increment = 1;
	local crsData={
		sceneName="OptionMenu",
		buttonList={
			{ ud },
		}
	}		
	CursorMoveProcess_State.changeGroup( crsData );			
end

function SceneGameLecture_EnterListener( data )
	_("ATTACH SCENE gameLecture1" );
	local crsData={
		sceneName="GameLecture",
		buttonList={
			{ GUI_Button.create( ButtonData["Prev"] ) } ,
			{ GUI_Button.create( ButtonData["Next"] ) },
		}
	}	
	CursorMoveProcess_State.changeGroup( crsData );	
	
end


function SceneCharaSelect_EnterListener( data )
	AttachView( "CharaSelect" );
--	GUI_Selector.create( SelectorButtonSampleData );
--	_("DISPLAY PICTURE CharaSelectCap" );
	GetPhysicsManager():activate( false );
	ShowSystemIcon();
	
	AttachGlobalUIView();
--	GUI_TextBox.create( TextBoxData["TitleMenuComment"] );
end

function SceneStageSelect_EnterListener( data )
	--Execute Command Lines
--	_("ATTACH SCENE stageselect");
	local v = GetViewManager():view( "StageSelect");
--	GetViewManager():viewController():setCurrentView(  v );	
	local gui = GetViewManager():view( "GlobalUI" );
	if gui then
		GetViewManager():attach( "GlobalUI" );
		gui:enableUpdate( true );
	end
--	GUI_Button.create( ButtonData["Chara"] );
	
--	ClearScriptText();
end

function AttachEditorView()
	_( "ATTACH SCENE PointingBall" );
--	_( "ATTACH SCENE SelectedGeometry" );
	_( "ATTACH SCENE EditorView" );
	GUI_Button.create( ButtonData["CamTra"] );
	GUI_Button.create( ButtonData["CamRot"] );
end

function DetachEditorView()
	GetSceneManager():get("PointingBall"):die();
	GetSceneManager():get("SelectedGeometry"):die();
	GetSceneManager():get("EditorView"):die();
end

function SceneStage1_1_EnterListener( data )	
--	_("VISIBLE ffst1ground false");
	
end

function SceneStage1_2_EnterListener( data )
--]]
end

function SceneStage2_1_EnterListener( data )
end

function SceneStage2_2_EnterListener( data )

end

function SceneStage3_1_EnterListener( data )
end

function SceneStage3_2_EnterListener( data )
end

function SceneStage1_1_LoadedListener( data )
	SetTitleCamPos();
	gIsReadyTitleScene = true;
--[[	local doorL = HitObject.create( HitObjectData["stage1_1ElevDoorLow"] );	
	local p  =GetSceneManager():get( "stage1_1ElevDoorLow" ):position();
	doorL.pos1 = Vec3( p.x , p.y , p.z );
	doorL.pos2 = Vec3( p.x , p.y , p.z );
	doorL.pos2.y = doorL.pos2.y + 3;
	doorL.dir = -1;
	doorL.attachScene();
--]]
end

function SceneStage1_2_LoadedListener( data )
--	local doorL = HitObject.create( HitObjectData["stage1_2DoorL"] );	
--	doorL.pos = GetSceneManager():get( "stage1_2DoorL" ):position();
--	doorL.attachScene();	
end

function SceneStage1_3_LoadedListener( data )
	_("VISIBLE HideoutCol false" );
end

function SceneStage2_1_LoadedListener( data )
	_("VISIBLE preBoxRingCol false" );
end

function SceneStage2_2_LoadedListener( data )
	_("VISIBLE platFormCol false" );
end

function TriggerVol_toStage1_2Vol_EnterListener(data)
--	GetEventManager():triggerEvent( "PreProcessAttach", gFadeInProcessData );	
end

function TriggerVol_toStage2_1Vol_EnterListener(data)
--[[	local transitData={
		name="ToStage2",
		wait=0.2,
		speed=10,
	}
	TransitionEvent.create( transitData )
--]]
--	_("CHANGE_STATE "..data.entityName.." BlewUp_State" );
end

function CreatePlayerPosListener( data )
	local file= File.createOut( data["name"] );
	
end

function CameraCurve_WaitListener( data )
	
end

SceneInit["TitleMenu"]=function()
--	GetViewManager():viewController():backToPrevView();
--	OptionView:setParentView( TitleMenuView );
--	--TEh{[
--	SetSoundVolCommon( "BGMVol" , gBgmVol );
--	SetSoundVolCommon( "SEVol" , gSeVol );
	Native.Methods.SetBgmVol( gBgmVol );
	Native.Methods.SetSeVol( gSeVol );
--	Native.Methods.CurrentSceneState():attachCurrentSceneView( "stage1_1" );
	
	AttachView( "TitleMenu" );
	_("CHANGE TEX transition1 WallPaint.bmp" );

	if gIsReadyTitleScene then
		SetTitleCamPos();
	end
end
SceneInit["Settings"]=function()
	AttachView( "Settings" );
	_("CHANGE TEX transition1 WallPaint.bmp" );
	
end
SceneInit["CharaSelect"]=function()
--	GetViewManager():viewController():backToPrevView();
	MissionView:setVisible( false );
	AttachView( "CharaSelect" );
	_("CHANGE TEX transition1 WallPaint.bmp" );
--	GetPhysicsManager():activate(false );
--
end

SceneInit["StageSelect"]=function()
--	GetViewManager():viewController():backToPrevView();
	_("VISIBLE HelpGameCommand false" );
	MissionView:setVisible( false );
	DetachView( "Mission");
--	AttachView( "StageSelect" );
--	GetPhysicsManager():activate(false );
	gActiveHelp = false;
	if gStageClearData["first"] then
		_("PLAY SCRIPT StageSelectFirstEnter" );		
		gStageClearData["first"] = false;
	else
		_("PLAY SCRIPT StageSelectEnter" );
	end
	--Xe[WNA󋵂Cxg}l[W֑M
	TriggerEvent( "IsStageClear" , gStageClearData );
	gStageClearData["defeated"] = false;
end

function StageSelectFirstEnter_FinishedListener( data )
	local backBtn = GUI_Button.create( ButtonData["Back"] );
	local opt = GUI_Button.create( ButtonData["OptionMenu"] );
	StageSelectGUIArrayData={
		array={
			{ GUI_Button.create( ButtonData["Stage1"] ),
--			GUI_Button.create( ButtonData["Stage2"] ) ,			
--			GUI_Button.create( ButtonData["Stage3"] ) ,			
--			GUI_Button.create( ButtonData["Stage4"] ) ,			
			backBtn },
			{ opt },
		}
	}
	StageSelectView:attach(  CursorMoveProcess_State , StageSelectGUIArrayData );
--]]
end

gStageAdded={
	stage1_2=false, --UnderGround
	stage2_1=false, --Street
	stage2_2=false, --Platform
}

function stage1_1_ClearedListener( data )
	if not gStageAdded["stage2_1"] then
		_("CHANGE TEX Stage1 WhitePoint.bmp" );
		_("CHANGE_FOCUS_TEX Stage1 WhitePointFocus.bmp" );	
		gStageAdded["stage2_1"] = true;
		EventScriptData["StageSelectEnter"][8] = 
		"DISPLAY MSG MissionAddScript IN GameScript";
		local backBtn = GUI_Button.get( "Back" );
		local opt = GUI_Button.get( "OptionMenu" );
		StageSelectGUIArrayData={
			array={
				{ GUI_Button.create( ButtonData["Stage1"] ),
				GUI_Button.create( ButtonData["Stage2"] ) ,			
		--			GUI_Button.create( ButtonData["Stage3"] ) ,			
		--			GUI_Button.create( ButtonData["Stage4"] ) ,			
				backBtn },
				{ opt },
			}
		}
		StageSelectView:attach(  CursorMoveProcess_State , StageSelectGUIArrayData );	
	end
--]]	
end

function stage2_1_ClearedListener( data )
--[[	if not gStageAdded["stage2_2"] then
		_("CHANGE TEX Stage2 WhitePoint.bmp" );
		_("CHANGE_FOCUS_TEX Stage2 WhitePointFocus.bmp" );	
		gStageAdded["stage2_2"] = true;
		EventScriptData["StageSelectEnter"][8] =
		"DISPLAY MSG MissionAddScript IN GameScript";
		local backBtn = GUI_Button.get( "Back" );
		local opt = GUI_Button.get( "OptionMenu" );
		StageSelectGUIArrayData={
			array={
				{ GUI_Button.create( ButtonData["Stage1"] ),
				GUI_Button.create( ButtonData["Stage2"] ) ,			
				GUI_Button.create( ButtonData["Stage3"] ) ,			
	--			GUI_Button.create( ButtonData["Stage4"] ) ,			
				backBtn },
				{ opt },
			}
		}
		StageSelectView:attach(  CursorMoveProcess_State , StageSelectGUIArrayData );		
	end
	--]]
end

function stage2_2_ClearedListener( data )
--[[	if not gStageAdded["stage1_2"] then
		gStageAdded["stage1_2"] = true;
		_("CHANGE TEX Stage3 WhitePoint.bmp" );
		_("CHANGE_FOCUS_TEX Stage3 WhitePointFocus.bmp" );	

		--Stage1stage1_1stage1_2
--		_("CHANGE TEX Stage1 RedPoint.bmp" );
--		_("CHANGE_FOCUS_TEX Stage1 RedPointFocus.bmp" );	
		
		EventScriptData["StageSelectEnter"][8] =
		"DISPLAY MSG MissionAddScript IN GameScript";
		local backBtn = GUI_Button.get( "Back" );
		local opt = GUI_Button.get( "OptionMenu" );
		StageSelectGUIArrayData={
			array={
				{ GUI_Button.create( ButtonData["Stage1"] ),
				GUI_Button.create( ButtonData["Stage2"] ) ,			
				GUI_Button.create( ButtonData["Stage3"] ) ,			
				backBtn,
				},
				{ GUI_Button.create( ButtonData["Stage4"] ) ,},
				{ opt },
			}
		}
		StageSelectView:attach(  CursorMoveProcess_State , StageSelectGUIArrayData );		

	end
--]]
end

function IsStageClearListener( data )	
	if data["defeated"] then
		EventScriptData["StageSelectEnter"][8] =
		"DISPLAY MSG DefeatedScript IN GameScript";
		return;
	end
	EventScriptData["StageSelectEnter"][8] =
	"DISPLAY MSG PleaseSelect IN GameScript";
	if data["stage1_2"] then
		TriggerEvent( "stage1_2Cleared" , "I am dummy" );
	end
	if data["stage2_2"] then
		TriggerEvent( "stage2_2Cleared" , "I am dummy" );
	end
	if data["stage2_1"] then
		TriggerEvent( "stage2_1Cleared" , "I am dummy" );
	end
	if data["stage1_1"] then
		TriggerEvent( "stage1_1Cleared" , "I am dummy" );
	end
end

SceneInit["stage1_1"]=function( )
	TriggerEvent( "ParseFile" , { file="BeginningFight.cam", arch=true } );

	_( "SET POS Gody -6,0.1,0" );
	_( "SET POS ZeedA 8.67,0.1,1.38" );
	_( "SET POS JohnA 9.67,0.1,-5" );
	_( "SET POS ZeedB -5.57,0.1,-4.6" );
	_( "SET POS JohnB -5.67,0.1,1.38" );
--	_( "SET POS toStage1_3 0,0,0" );
	_( "SET ANGLE Gody 0,-90,0" );
	
	EnterMission( GameMissionParam["stage1_1"] );
	GameMissionParam["stage1_1"]["defeatEnemyNum"] = 3; 	
	TriggerVolume.create(  TriggerVolData["toStage1_3"] );
	local scene = Native.Methods.CurrentSceneState();
	local sceneName = scene:name();	
	--Door̊JvZX
	for i=1,#OpenCloseDoorParam[ "stage1_1" ],1 do
		local t = OpenCloseDoorParam[ "stage1_1" ][ i ];
		local name = "DoorOpen_stage1_1_"..i;
		local proc = GetProcessManager():process( name )
		if proc then
			t["state"] = "wait";
			proc:changeMode( Process.INITIALIZING );
		else
			Native.Methods.AttachProcess( name , OpenCloseDoorProcess , t );
		end
	end

--]]
--[[	local juice = Item.create( ItemData1 );
	juice.attachScene();
	juice.rotate( Vec3(0,2,0) );
--	_("PLAY SCRIPT PlayGame" );
--]]		
--	_("ATTACH SCENE toStage1_2Vol");
	--Camera.lock();
--	_("VISIBLE toStage1_2 false");
end
SceneInit["stage1_2"]=function( )
	_(  "SET POS Gody -5,1,-2" );
	_(  "SET POS MaskMan 5,0,-2" );
	_( "SET ANGLE Gody 0,-90,0" );
	_( "SET ANGLE MaskMan 0,90,0" );
	TriggerVolume.create(  TriggerVolData["toStage1_3"] );
	
--	AI_1View:enableControl( false );
--	Character.get( "Player" ):movable( false );
	EnterMission( GameMissionParam["stage1_2"] );
end
SceneInit["stage1_3"]=function( )
	_(  "SET POS Gody -5,1,-2" );
	_(  "SET POS ZeedA 4.17,0.1,3" );
	_(  "SET POS ZeedB 5.57,0.1,-3.38" );
	_(  "SET POS JohnA 7,0.1,3" );
	_(  "SET POS JohnB 4.67,0.1,-3.38" );
	_( "SET ANGLE Gody 0,-90,0" );
	TriggerVolume.create(  TriggerVolData["toStage1_4"] );

--	AI_1View:enableControl( false );
--	Character.get( "Player" ):movable( false );
	EnterMission( GameMissionParam["stage1_3"] );
end
SceneInit["stage1_4"]=function( )
	_(  "SET POS Gody -5,1,-2" );
	_(  "SET POS MaskMan 5,0,-2" );
	_(  "SET POS ZeedA 6,5,-3" );
	_(  "SET POS ZeedB 6,5,1" );
	_(  "SET POS JohnA 5,5,1" );
	_(  "SET POS JohnB 6,5,-3" );
	_(  "SET POS James 5,0.1,1" );
	_( "SET ANGLE Gody 0,-90,0" );
	_( "SET ANGLE MaskMan 0,90,0" );
	_( "SET ANGLE James 0,90,0" );
	_( "SET ANGLE ZeedA 0,90,0" );
	_( "SET ANGLE ZeedB 0,-90,0" );
	_( "SET ANGLE JohnA 0,90,0" );
	_( "SET ANGLE JohnB 0,-90,0" );
	
	TriggerEvent( "ParseFile" , { file="MovieSceneAtFightClub.cam", arch=true } );
	
--	AI_1View:enableControl( false );
--	Character.get( "Player" ):movable( false );
	EnterMission( GameMissionParam["stage1_4"] );
end
SceneInit["stage2_1"]=function( )
	_(  "SET POS Gody -5,0.1,0" );
	_(  "SET POS ZeedA 4.17,0.1,3" );
	_(  "SET POS ZeedB -5.57,0.1,-3.38" );
	_(  "SET POS JohnA 7,0.1,3" );
	_(  "SET POS JohnB -4.67,0.1,-3.38" );
	_( "SET ANGLE Gody 0,-90,0" );

	EnterMission( GameMissionParam["stage2_1"] );
	GameMissionParam["stage2_1"]["defeatEnemyNum"] = 2; 	
	TriggerVolume.create(  TriggerVolData["toStage2_2"] );
--	local cam = GetSceneManager():camera( gCamId );
--	cam:setPosition( Vec3( -3,3,-5 ) );
--	TriggerVolume.create( ToStage2_1Data );
--	_("ATTACH SCENE toStage2_1Vol");
--	Camera.changeState("CameraCloseUp");
end
SceneInit["stage2_2"]=function( )
	_(   "SET POS Gody -18,0.1,-2"  );
	_(   "SET POS ZeedA 15,0.1,-1"  );
	_(   "SET POS ZeedB 15,0.1,-2"  );
	_(   "SET POS JohnA 22,0.1,-1"  );
	_(   "SET POS JohnB 20,0.1,-2"  );
--	_(   "SET POS HighKickerC 17,0.1,-3"  );
	_(   "SET POS Macho 24,0.1,-1"  );
	_( "SET ANGLE Gody 0,-90,0" );
	
	EnterMission( GameMissionParam["stage2_2"] );
--	gRailCameraData["InitialPos"][2] = 6;
--	gRailCameraData["InitialPos"][3] = -7;
	gCamId = 1;
	Camera.setPosId( Vec3( 0,5,-5) , CAMMODE_CloseUp );
	AppearGameUI();
--	gIsRevive = false;
--	_("VISIBLE platFormCol false" );
--	TriggerVolume.create( ToStage2_1Data );
--	_("ATTACH SCENE toStage2_1Vol");
end
SceneInit["stage3_1"]=function( )
	EnterMission( GameMissionParam["stage3_1"] );
	TriggerVolume.create(  TriggerVolData["toStage3_2"] );
	gRailCameraData["InitialPos"][2] = 6;
	gRailCameraData["InitialPos"][2] = 6;
	gRailCameraData["InitialPos"][3] = -7;
	gCamId = 1;
	gIsRevive = true;
	
--	_("ATTACH SCENE toStage2_1Vol");
end
SceneInit["stage3_2"]=function( )
	EnterMission( GameMissionParam["stage3_2"] );
	TriggerVolume.create(  TriggerVolData["toStage3_3"] );
	gRailCameraData["InitialPos"][2] = 6;
	gRailCameraData["InitialPos"][3] = -7;
	gCamId = 1;
--	CameraFight2DProcess_State.target1 = "Player";
--	CameraFight2DProcess_State.target2 = "Boss3";
	gIsRevive = false;
	gOpenedStage3_2Door = false;
	CharaData["Todo"]["personal"]={ 
		doNotLookAtMe={ "Wait" , 10 },		
		lookAtMe={ "Away" , 10 },
	};	
--	TriggerVolume.create( ToStage2_1Data );
--	_("ATTACH SCENE toStage2_1Vol");
end
SceneInit["stage3_3"]=function( )
	EnterMission( GameMissionParam["stage3_3"] );
	gRailCameraData["InitialPos"][2] = 6;
	gRailCameraData["InitialPos"][3] = -7;
	gCamId = 1;
--	CameraFight2DProcess_State.target1 = "Player";
--	CameraFight2DProcess_State.target2 = "Boss3";
	gIsRevive = false;
--	TriggerVolume.create( ToStage2_1Data );
--	_("ATTACH SCENE toStage2_1Vol");
end

temp = StopWatch();
function stage1_1ElevDoorLow_MovedListener( data )
	local p = Character.get("Player");
	local pos  =GetSceneManager():get( data ):position();
	pos.y = pos.y + 15;
	pos.z = pos.z - 2;
	local moveData={
		name=p:name(),
		time=1000,
		coef=0,
		timer=temp,
		pos1=p:position(),
		pos2 = pos,
		dir=1,
	}
	ProcessClass.create( "PlayerMove2F" , MoveProcess , moveData , Process.INITIALIZING );
--	p:setPosition( pos );
end

function MissionStart_FinishedListener( data )
	local sceneName = Native.Methods.CurrentSceneName();
	_("PLAY SCRIPT "..sceneName.."Enter" );
end

function JagCam()
	--Jag Camera
	ProcessClass.changeProcMode( "CamJag" , Process.INITIALIZING );
end

GameProperty={
	contactDelayTick=5,
	
}

VM = GetViewManager();
--View Creation
SystemMenuView = VM:view( "SystemMenu");
TitleMenuView = VM:view( "TitleMenu");
OptionView = VM:view( "Option");
PauseMenuView = VM:view( "PauseMenu");
SettingsView = VM:view( "Settings");
CharaSelectView = VM:view( "CharaSelect");
StageSelectView = VM:view( "StageSelect");
MissionView = VM:view( "Mission");
Stage1View = VM:view( "stage1_1");
Stage2View = VM:view( "stage1_2");
Stage3View = VM:view( "stage2_1");
Stage4View = VM:view( "stage2_2");
Stage5View = VM:view( "stage3_1");
Stage6View = VM:view( "stage3_2");
--CharacterView = VM:view( "Character");
Player_1View = VM:view( "Player_1" );
Player_2View = VM:view( "Player_2" );
AI_1View = VM:view( "AI_1" );
AI_2View = VM:view( "AI_2" );
AI_3View = VM:view( "AI_3" );
AI_4View = VM:view( "AI_4" );
NPCView = VM:view( "NPC" );
GlobalUIView = VM:view( "GlobalUI");
GameUIView = VM:view( "GameUI");
ContinueView = VM:view( "Continue");
StageClearView = VM:view( "StageClear");

CAMMODE_CloseUp = 0
CAMMODE_Parallel = 1
CAMMODE_Fight2D = 2
CAMMODE_Comb = 3
CAMMODE_Course0=4
CAMMODE_Course1=5
CAMMODE_Course2=6
CAMMODE_Lerp=7
CAMMODE_Edit=8

gCamCurveProcess = nil;
gEnemyDeadNum = 0;
gEnemyDefeatNum = 0;
gIsRevive = true;
gOpenedStage3_2Door = false;
gGameMode = "Normal";
gBgmVol = 87;
gSeVol = 90;
gIsReadyTitleScene = false;
gCurrSelectedStage = "stage1_1";
gStageClearData = {
	first=true,
	defeated=false,
	stage1_1=false,
	stage2_1=false,
	stage2_2=false,
}	

function SetTitleCamPos()
	_("CHANGE CAMTARGET townDoor2");
	Camera.setPosId( Vec3( -10,0.2,-8 ) , 0 );
end

OpenCloseDoorParam={}
OpenCloseDoorParam["stage1_1"]={
	{
		name="townDoor1",
		initAngle={ 0,0,0 },
		angleTickOpen=3,
		angleTickClose=-5,
		addedTick=0,
		currTick=0,
		threshold=90,
		closeSound="door01",
		state="wait",
	},
	{
		name="townDoor2",
		initAngle={ 0,0,0 },
		angleTickOpen=4,
		angleTickClose=-4,
		addedTick=0,
		currTick=0,
		threshold=90,
		closeSound="door01",
		state="wait",
	},
	{
		name="townDoor3",
		initAngle={ 0,0,0 },
		angleTickOpen=3,
		angleTickClose=-5,
		addedTick=0,
		currTick=0,
		threshold=90,
		closeSound="door01",
		state="wait",
	},
	{
		name="townDoor4",
		initAngle={ 0,0,0 },
		angleTickOpen=3,
		angleTickClose=-5,
		addedTick=0,
		currTick=0,
		threshold=90,
		closeSound="door01",
		state="wait",
	}
}


gTimer = StopWatch();
TIMER_ID_CameraJag=0;

gCamJagData={
	time=200,
	timer=StopWatch(),
	
}
gCamTgtChangeData={
	role="Player",
	obj="townBox1",
	lock=false,
	threshold=1,
	movableX={ -4 , 4 },
}
--L[̃IuWFNg̉{ -x , x }܂œ
gMovableXData={
	townBox1={ -4,4 },
	townBox2={ -5,5 },
	stage2_1Box1={ -5,5 },
	stage2_1Fence2= { -4,4 },	
	stage2_1Fence3= { -6,2 },	
}

HitObjectData["stage1_1ElevDoorLow"] = {
	name="stage1_1ElevDoorLow",
	radious=2,
	time=1000,
	coef=0,
	timer=StopWatch(),
	collision="stage1_1ElevDoorLow",
	sound="door03",
	axisAngle1={ 0,1,0 , 0 },
	axisAngle2={ 0,1,0 , -130 },	
}

LevelProgData={
	thSec = 10000,
}
ShowGoSignData={
	name="goSign", 
	speed=4,
	notifyTimes=5,
}
path = Framework():dataPath();
datapath = "../Lua/data/";
modelPath = path.."/model/";

ShowFrameRate={}
ShowFrameRate.Update=function(p,d)
end

Light = {
	Type="Directional",
	Diffuse={ 1,1,1,1 },
	Ambient={ 1,1,1,1 },
	Specular={ 1,1,1,1 },
	Direction={ -0.5,1,1 },
	Range=500
}
lighting = LightingProcess( Light );
--gLightDir =Vec3(1,10,-1)
gLightDir =Vec3(1,4.4,3)
gLightDir2 =Vec3(10,1,-1)
gLightDir3 =Vec3(10,1,-1)
gLightCol =Vec3(1);
--gLightCol2 =Vec3(1,144/255,0)
gLightCol2 =Vec3(1)
gLightCol3 =Vec3(0.8,0,0)
gLightAtten = 10;
gLightAtten2 = 5;
gAmb = Vec3(0.2);
PhysicalCostMap={}
--[[
PhysicalCostMap["Easy"]={
	Attack_State=-0.34,
--	Run_State=-0.1,
	Kawashi_State=-0.1,
	Walk_State=0.2,
	Wait_State=0.8,
	Down_State=1,
	BlewUpDown_State=0.8,
}
PhysicalCostMap["Hard"]={
	Attack_State=-0.85,
	Run_State=-0.1,
	Kawashi_State=-0.3,
	Walk_State=0.2,
	Wait_State=0.7,
	Down_State=1,
	BlewUpDown_State=0.8,
}
--]]
PhysicalCostMap["Easily"]={
	Attack_State=-1,
	Run_State=-0.1,
	Kawashi_State=-0.3,
	Walk_State=-0.2,
	Wait_State=0.1,
	Down_State=1,
	JumpUp_State=-0.1,
	BlewUpDown_State=0.2,
}
PhysicalCostMap["Normal"]={
	Attack_State=-0.5,
	Run_State=-0.1,
	Kawashi_State=-0.3,
	Walk_State=0.2,
	Wait_State=0.7,
	Down_State=1,
	JumpUp_State=-0.4,
	BlewUpDown_State=0.8,
}
PhysicalCostMap["Hard"]={
	Attack_State=-0.34,
--	Run_State=-0.1,
	Kawashi_State=-0.1,
	Walk_State=0.2,
	Wait_State=0.8,
	Down_State=1,
	JumpUp_State=-0.7,	
	BlewUpDown_State=0.8,
}
--[[
--]]
TitleLogo3FadeInAndOutData={
	name="TitleLogo3",
	fadeInSpeed=10,
	waitTime=0.5,
	fadeOutSpeed=10,
	alphaThreshold=250,
	fadeOutKilledEvent=function()
--		GUI_Button.create( ButtonData["PressStart"] )
--		_("CHANGE SCENE TitleMenu 0.2 10 ");
	end
}
TitleLogo2FadeInAndOutData={
	name="TitleLogo2",
	fadeInSpeed=10,
	waitTime=0.5,
	fadeOutSpeed=10,
	alphaThreshold=250,
	fadeOutKilledEvent=function()
		GUI_Picture.create( PictureData["TitleLogo3"] );
		FadeInAndOutProcess.create( TitleLogo3FadeInAndOutData );
	end
}
TitleLogo1FadeInAndOutData={
	name="TitleLogo1",
	fadeInSpeed=10,
	waitTime=0.5,
	fadeOutSpeed=10,
	alphaThreshold=250,
	fadeOutKilledEvent=function()
		_("CHANGE SCENE stage1_1 0.2 10" );
	end
}
gLoadReqList={
--	{ "ParseFile" , { file="Lua/MyScript/Script.txt", arch=false } },
--	{ "ParseFile" , { file="Lua/MyScript/AI_Behavior.txt", arch=false } },
--	{ "ParseFile" , { file="MovieSceneAtFightClub.cam", arch=true } },
--	{ "ParseFile" , { file="BeginningFight.cam", arch=true } },
	{ "ParseFile" , { file="Script.txt", arch=true } },
	{ "ParseFile" , { file="AI_Behavior.txt", arch=true } },
	{ "ParseFile" , { file="FightClubScene_anim.txt", arch=true } },
	{ "ParseFile" , { file="Animation.txt", arch=true } },
	
	{ "StartLoadingModel" ,{ file="Guy_converted.lua",mesh="Guy", frame="Guy", } },
	{ "StartLoadingModel" ,{ file="JamesHead_converted.lua",mesh="JamesHead" } },
	{ "StartLoadingModel" ,{ file="GodyHead.lua",mesh="GodyHead" } },
	{ "StartLoadingModel" ,{ file="SkinHead_Converted.lua",mesh="SkinHead" } },
	{ "StartLoadingModel" ,{ file="BaseBody_Converted.lua",mesh="BaseBody" , frame="BaseBody" } },
	{ "StartLoadingModel" ,{ file="HighKicker_converted.lua",mesh="HighKicker",frame="HighKicker" } },		
	{ "StartLoadingModel" ,{ file="MachoBody_converted.lua",mesh="MachoBody",frame="MachoBody" } },		
	{ "StartLoadingModel" ,{ file="MachoHead_converted.lua",mesh="MachoHead" } },		
	{ "StartLoadingModel" ,{ file="LongHair.lua",mesh="LongHair" } },
	{ "StartLoadingModel" ,{ file="ShoulderSpike_converted.lua",mesh="ShoulderSpike" } },
	{ "StartLoadingModel" ,{ file="Bandana_converted.lua",mesh="Bandana" } },
	{ "StartLoadingModel" ,{ file="FabMask_converted.lua",mesh="FabMask" } },
}
gRailCameraData={
	threashold={ 0.1 ,1, 3 },
	offset={ 1,2,0},
	InitialPos={ 0,6,-8 },
	Height=5,
	Pitch=30,
	MaxDistance=7,
	MinDistance=4,
	cameraId=1,
	minY=0,
	maxY=100,
	nearDist=5,
	farSpeedX=0.008,
	speedZ=0.1,
	nearSpeedX=0.01
}
gCameraCloseUpData={
	ProcessKilledDistance=9,
	ApproachSpeed = 0.005,
	LookAtOffset=Vec3(0,1,0),
	EyeOffset=Vec3(0,4,0),
	cameraId=0,
	minY=4,
}
gCamLerpData={
	IdA = CAMMODE_Parallel,
	IdB = CAMMODE_CloseUp,--CAMMODE_Fight2D,
	coef = 1,
	setId = CAMMODE_Lerp,
}
gFight2DCamData={
	cameraId=2,
}
gCombCamData={
	cameraId=2,
}

CameraMap={
	CameraCloseUp=0,
	RailCamera=1,
	CameraFight2D=2,
	CameraComb=3,
	CameraCourse=4,
}

AgentAdditionalStateList={
	ItemGettable_State=false,
	WeaponArmed_State=false,
	
}

function ShowSystemIcon()
--	GUI_Button.create( ButtonData["Size"] );
--	GUI_Button.create( ButtonData["Sound"] );
--	_("ATTACH SCENE cursor" );	
end

function SimpleDistanceCull( agent1 , agent2 , th )
	local dif = Vec3();
	dif:setSub( agent1:position() , agent2:position() );
	if dif:length() < th then
		agent2:setVisible( true );
		local proc = agent2:getProcessor();
--		proc:process("Animation"):changeMode( Process.WAITING );
--		proc:process("FlipAnimation"):changeMode( Process.WAITING );
	else
		agent2:setVisible( false );
		local proc = agent2:getProcessor();
--		proc:process("Animation"):changeMode( Process.WAITING );
--		proc:process("FlipAnimation"):changeMode( Process.WAITING );
		agent2:update();
	end
end

function ChangeWidthHPMeter( role , guiName )
	local agent = Character.get( role );
	local chdat = Character.getData( agent:name() );
	if chdat then
		local meter = GUI_ProgressBar.get( guiName );
		if meter and agent then
			local percent = agent:hitpoint() / chdat["hitPoint"];
			meter.setWidthPercent( percent );
		end
--[[		local t = - data["damagePoint"] * meter.width / chdat["hitPoint"];
		meter.increment = 1;
		meter.addWidth(  t );
--]]		
	end
end

gTestProcess={}
gTestProcess.Initialize=function(p,d)
	Native.Methods.SetBgmVol( gBgmVol );
	Native.Methods.SetSeVol( gSeVol );
	p:changeMode( Process.ACTIVATED );
end
gTestProcess.Update=function(p,d)
	local scene = Native.Methods.CurrentSceneState();

Dout( "Current Scene is :"..scene:name() );	
local  sv = scene:sceneView();
if sv then
Dout( "Current SceneView is :"..sv:name() );	
end
	CameraMove();
	CameraRotate();
	lighting:update();
	
	Native.Methods.SetBgmVol( gBgmVol );
	Native.Methods.SetSeVol( gSeVol );

	local p = Character.get( "Player" );
	local z1 = Character.get( "Zako1" );
	local z2 = Character.get( "Zako2" );
	local z3 = Character.get( "Zako3" );
	local z4 = Character.get( "Zako4" );
	local z5 = Character.get( "Zako5" );
	local b1 = Character.get( "Boss1" );

local ppos = p:position();	
Dout( "PlayerPos:"..ppos.x.." "..ppos.y.." "..ppos.z );
--[[
	if p and z1 and z2 and b1 and z3 and z4 and z5 then
		SimpleDistanceCull( p , z1 , 12 )
		SimpleDistanceCull( p , z2 , 12 )
		SimpleDistanceCull( p , z3 , 12 )
		SimpleDistanceCull( p , z4 , 12 )
		SimpleDistanceCull( p , z5 , 12 )
		SimpleDistanceCull( p , b1 , 12 )
	end
--]]	

	local f = Framework():frameRate()
	local fra = GUI_Numeric.get("FrameRate");
	if fra then
		fra.setNumber( f );
	end
	
	local mx = GetMouse():x();
	local my = GetMouse():y();
	local fW =FullWidth(); 
	local fH =FullHeight(); 
	local cur = GetSceneManager():get( "cursor" );
--[[	if cur then
		local scname = scene:name();
		if ( scname == "TitleMenu" ) or
		( scname == "CharaSelect" ) or 
		( scname == "StageSelect" ) then
			cur:setAlpha( 250 );
			GlobalUIView:setAlpha( 250 );
		else
			if my > fH - 100 then
				GlobalUIView:setAlpha( 250 );
			else
				GlobalUIView:setAlpha( 70 );
			end
			cur:setAlpha( 120 );
		end
	end
	
--]]	
end

 gTimer = StopWatch();
gTestProcess2={}
gTestProcess2.Initialize=function(process,data)
	_("ATTACH SCENE cursor");
	gTimer:start(0);
	process:changeMode( Process.ACTIVATED );
end
gTestProcess2.Update=function(process,data)
	local cur = GetSceneManager():get("cursor");
	local mx = GetMouse():x();
	local my = GetMouse():y();
	cur:setPosition( mx , my );
	Particle.update();
	local p=  Character.get("Zako1");
	if p then
		if p:isVisible() then
Dout( "ANIME : "..p:animationControl():currentAnimeName() );

		end
	end
--[[
	if IsKeyTriggered( "f" ) then	
	gStageClearData["stage2_2"] = true;
	end
	if IsKeyTriggered( "u" ) then	
		gCamId = 0;
	elseif IsKeyTriggered( "i" ) then	
		gCamId = 1;
	elseif IsKeyTriggered( "o" ) then	
		gCamId = 2;
	elseif IsKeyTriggered( "r" ) then
		gCamId = 4;
	elseif IsKeyTriggered( "t" ) then
		gCamId = 5;
	elseif IsKeyTriggered( "y" ) then
		gCamId = 6;
--		serialize( CameraData , GetOutput( "test.txt" ) );
--		Camera.changeState("CameraCourse");
	end
	
	if IsKeyTriggered( "1" ) then
		_("CHANGE SCENE TitleMenu 0.2 10");
	end	
	if IsKeyTriggered( "2" ) then
		_("CHANGE SCENE stage1_1 0.2 10");
	end	
	if IsKeyTriggered( "3" ) then
		_("CHANGE SCENE stage1_2 0.2 10");
	end
	if IsKeyTriggered( "4" ) then
		_("CHANGE SCENE stage1_3 0.2 10");
	end
	if IsKeyTriggered( "5" ) then
		_("CHANGE SCENE stage1_4 0.2 10");
	end
	if IsKeyTriggered( "6" ) then
		_("CHANGE SCENE stage2_1 0.2 10");
	end
	if IsKeyTriggered( "7" ) then
		_("CHANGE SCENE stage2_2 0.2 10");
	end
	if IsKeyTriggered( "8" ) then
--		_("CHANGE SCENE stage3_3 0.2 10");
	end
--]]
	local scene = Native.Methods.CurrentSceneName();
	local vc = GetViewManager():viewController()
	if ( scene == "stage1_1" ) or
	( scene == "stage1_3" ) or
	( scene == "stage1_4" ) or
	( scene == "stage2_1" ) or
	( scene == "stage2_2" ) then
		local isStart = vc:controller():isTriggered( PSController.PS_START );
--		local isStart = pvc:isTriggered( PSController.PS_START );
		local isSpace = IsKeyTriggered( " " );
		if  isStart or isSpace then
			Button_PauseMenu_ClickedListener( "" );
		end
	end
--[[		local p = GetSceneManager():get("Player");
		local path = GetSceneManager():get("Zako1"):pathPlanner();
		path:setTarget( p );
		path:enableGuide( true );
		path:showPath( true );
		local graph = Native.Methods.CurrentSceneState():graph()
		path:setGraph( graph );
		path:start();
--]]
--[[			local p=GetSceneManager():get("Player"):position();
		local particleData={
			setname="particleBlue",
			pos={p.x,p.y,p.z}
		}
		Particle.trigger( particleData );
--]]

--[[	local z1=GetSceneManager():get("Zako1");
	if z1  then
		if GetSceneManager():isInsideFrustum( z1:position() , 1 ) then
			Dout("INSIDE ZAKO1 ");
		end
	end
--]]
--		for k,v in pairs( Native.Keyboard ) do
--			if Native.Methods.IsKeyTriggered( v ) then
	GetSceneManager():setCameraId( gCamId );		
--		end		
end
--[[
LevelProgressProcess={}
LevelProgressProcess.Initialize=function(p , data )
	data["prevCamPos"] = Camera.position();
	data["time"] = os.clock();
	data["timeElapsed"] = 0;
	
	p:changeMode( Process.ACTIVATED );
end
LevelProgressProcess.Update=function(p , data )
	local prevpos = data["prevCamPos"];
	if Camera.isLock then
		if EnemyQueue.isEmpty() then
			Camera.unlock();
			local gs = GetProcessManager():process("GoSign");
			if gs then
				gs:changeMode( Process.ACTIVATED);
			end
		end
	else
		if Camera.position() == prevpos then
			if data.time then
				local oneFrameTime = os.difftime( os.clock() , data["time"] );
				data["timeElapsed"] = data["timeElapsed"] + oneFrameTime*1000;
Dout("Cam Unlocked elapsed :"..data["timeElapsed"] );
				if data["timeElapsed"] > data["thSec"] then
					data["timeElapsed"] = 0;
					local gs = GetProcessManager():process("GoSign");
					if gs then
						gs:changeMode( Process.ACTIVATED);
					end					
				end
			end
		end

	end
	data["prevCamPos"] = Camera.position();
	data["time"] = os.clock();
end
--]]
ShowGoSignProcess={}
ShowGoSignProcess.Initialize=function( p , d )	
	local img = GetSceneManager():get( d["name"] );
	if img then
		img:setVisible( false );
	end
	d["times"] = 0;
	AlphaWaveProcess_State.Initialize( p , d );
	p:changeMode( Process.WAITING );
end
ShowGoSignProcess.Update=function( p , d )
	local img = GetSceneManager():get( d["name"] );
	if img then
		img:setVisible( true );
		AlphaWaveProcess_State.Update( p , d );
		if img:alpha() == 255 then
			GetSoundManager():playSe( "se_maoudamashii_system28" );
			d["times"] = d["times"] + 1;
			if d["times"] > d["notifyTimes"] then
				d["times"] = 0;
				img:setVisible( false );
				p:changeMode( Process.WAITING );
			end
		end
		
	end
end

function AtkDataSerialize() 
	local out = GetOutput("atkdata.lua");
	local o = {}
	for k,v in pairs( AttackHitProcessData ) do
		for animname,t in pairs( v ) do
			o[ animname ] = t;
		end
	end
	out:write( "AttackHitProcessData={" );
	serialize( o , out );
end

function Button_PressStart_ClickedListener( data )
	_("CHANGE SCENE TitleMenu 0.2 10");		
end

function Button_GameExit_ClickedListener( data )
	local evtdata={
		trigger=function()
			
		end,
		event=function()
		end,
		changeAfter=Process.KILLED,
		activate=function()
			return true;
		end
	}
	local transitData={
		name="ToExit",
		wait=0.2,
		speed=10,
	}
--	TransitionEvent.create( transitData )
--	Native.Methods.AttachProcess( "FinishTransition" , EventTriggerProcess_State ,  );
	Native.Methods.RequestEnd();
end

function SetCharaVisible( name , t )
	local c = Character.get( name );
	if c then
		c:setVisible( t );
	end
end

function SetCharaAI( name , t )
	local c = Character.get( name );
	if c then
		c:enableAI( t );	
	end
end

function Button_GameLecture_ClickedListener( data )
	_("CHANGE SCENE GameLecture 0.2 10");
end

function Button_GameStart_ClickedListener( data )
	Character.nameMap["Player"] = "Gody";	
	Character.setPlayer( "Player");
--	_("PLAY SCRIPT PlayGame" );
--	TitleMenuView:setVisible( false );
	
--	_("CHANGE SCENE CharaSelect 0.2 10 ");	
	_("CHANGE SCENE StageSelect 0.2 10 ");	
--	_("CHANGE SCENE Settings 0.2 10 ");	
--	AttachView("Mission" );
--	Button_Chara1_ClickedListener( data );
	
end

function Button_GameStart_EnterListener( data )
	_("DISPLAY MSG GameStartComment IN GameScript" )
end

function Button_OptionMenu_EnterListener( data )
	_("DISPLAY MSG OptionMenu IN GameScript" )
end

function Button_HelpMenu_EnterListener( data )
	_("DISPLAY MSG HelpMenu IN GameScript" )
end

function SetSoundVolCommon( name , vol )
	local bar = GUI_ProgressBar.get( name );
	local percent = ( vol - 80 ) / 20; --SoundVolumeMax100
	if percent >= 1 then
		percent = 1;
	end
	bar.setWidthPercent( percent );
	if name == "BGMVol" then
		Native.Methods.SetBgmVol( vol );--80 + bgm.currentW/ bgm.width * 20 );
	elseif name == "SEVol" then
		Native.Methods.SetSeVol( vol );--80 + bgm.currentW/ bgm.width * 20 );	
	end
end

function Button_BgmUpper_ClickedListener( data )
	gBgmVol = gBgmVol + 2;
	if gBgmVol >= 100 then
		gBgmVol = 100;
	end
	SetSoundVolCommon( "BGMVol" , gBgmVol );
end

function Button_BgmDowner_ClickedListener( data )
	gBgmVol = gBgmVol - 2;
	if gBgmVol <= 80 then
		gBgmVol = 80;
	end
	SetSoundVolCommon( "BGMVol" , gBgmVol );
end

function Button_SeUpper_ClickedListener( data )
	gSeVol = gSeVol + 2;
	if gSeVol >= 100 then
		gSeVol = 100;
	end
	SetSoundVolCommon( "SEVol" , gSeVol );
end

function Button_SeDowner_ClickedListener( data )
	gSeVol = gSeVol - 2;
	if gSeVol <= 80 then
		gSeVol = 80;
	end
	SetSoundVolCommon( "SEVol" , gSeVol );
end

function Button_WindowMode_ClickedListener( data )
	Native.Methods.toggleWindowMode();
end

function Button_OptionMenu_ClickedListener( data )	
--[[	
	if OptionView:isActive() then
		OptionView:activate( false );
		OptionView:setVisible( false );
		ActivateCharaView( true );		
	else
		ActivateCharaView( false);		
		AttachView( "Option" );
	end
--]]
--	ActivateCharaView( false);
	DetachView( "Mission" );
--	OptionView:activate( true );
--	OptionView:setVisible( true );
	AttachView( "Option" );
--	ActivateBackButton( true );
end

function Button_PauseMenu_ClickedListener( data )
--	ButtonData["PauseMenu"]["activatedAllScene"] = false;
	ActivateCharaView( false);
	AttachView( "PauseMenu" ); 
end


function ActivateBackButton( t )
	local back = GUI_Button.get("Back");
	back.active = t;
end

function Button_Back_ClickedListener( data )
	local scene = Native.Methods.CurrentSceneName();
	local view = GetViewManager():currentViewName();
	if scene == "TitleMenu" then
		DetachView( "Option" );	
		AttachView( "TitleMenu" );
	elseif scene == "CharaSelect" then
		DetachView( "Option" );
		_("CHANGE SCENE TitleMenu 0.2 10" );
	elseif scene == "StageSelect" then
		if view == "StageSelect" then
			_("CHANGE SCENE TitleMenu 0.2 10" );		
		elseif view == "Option" then
			DetachView("Mission" );
			DetachView("Option" );
			AttachView( "StageSelect" );
		end
	else
		DetachView( "Option" );	
		ActivateCharaView( true );
--]]
	end
end

function Button_Help_ClickedListener( data )
--[[	local help=GetSceneManager():get("help1");
	if help then
		if help:isVisible() then
			help:setVisible( false );
		else
			help:setVisible( true );		
		end
	end
--]]

	local proc = ShowCommandHelpProcess.instance;
	if gActiveHelp then
		_("VISIBLE HelpGameCommand false" );
		gActiveHelp = false;
		_("DISPLAY MSG dummy IN GameScript" );
	else
		gActiveHelp = true;
		_("VISIBLE HelpGameCommand true" );
		if proc then
			proc:changeMode( Process.ACTIVATED );
		end
	end	
end

function Button_Sound_ClickedListener( data )
	local ud = GUI_UpDownBar.create( UpDownBarData["BGMVol"] );
	ud.increment = 1;
	local crsData={
		sceneName="Title",
		buttonList={
			{ ud },
		}
	}		
	CursorMoveProcess_State.changeGroup( crsData );		
end

--TODO : 
function ToExitWait_KilledListener( data )
	Native.Methods.RequestEnd();
end

function Button_Next_ClickedListener( data )
	
	GetSceneManager():get("gameLecture1"):setVisible( false );
	_("ATTACH SCENE gameLecture2");
	
end

function Button_Chara1_EnterListener( data )
	_("DISPLAY MSG Chara1Script IN GameScript" )
end

function Button_Chara2_EnterListener( data )
	_("DISPLAY MSG Chara2Script IN GameScript" )
end

function Button_Chara3_EnterListener( data )
	_("DISPLAY MSG Chara3Script IN GameScript" )
end

function ToStage1( )
	_("CHANGE SCENE stage1_1 0.2 10 ");
end

function CharaClickedCommon( name )
--	_("CHANGE SCENE StageSelect 0.2 10 ");
--	_("CHANGE SCENE PreStage1 0.2 10 ");
	_("CHANGE SCENE stage1_1 0.2 10 ");
--	_("PLAY SCRIPT PlayGame") ;
end

function Button_Chara1_ClickedListener( data )
--	GetSceneManager():get("Player"):controller():setJoystickId( GameLib.JoystickID.PLAYER_1 );
	Character.setNameMap( "Player" , "Gody" );
	Character.setNameMap( "Player2" , "Riki" );
--	Character.setPlayer( "Player");
--	AttachView( "StageSelect" );
--	ToStage1( )	
--	_("CHANGE TEX CharaInScript PlayerChara1.bmp" );
	_("CHANGE TEX CharaInScript KungfuGuy4.bmp" );
	CharaClickedCommon( "Gody" );
end

function Button_Chara2_ClickedListener( data )
	Character.setNameMap( "Player" , "Abore" );
	Character.setNameMap( "Player2" , "Gody" );
--	AttachView( "StageSelect" );
--	ToStage1( )	
--	_("CHANGE TEX CharaInScript PlayerChara2.bmp" );
	_("CHANGE TEX CharaInScript KungfuGuy3.bmp" );
	CharaClickedCommon( "Riki" );
--	_("CHANGE SCENE stage1_1 0.2 10 ");
end

function Button_Chara3_ClickedListener( data )
	Character.nameMap["Player"] = "Abore";	
	_("CHANGE TEX CharaInScript PlayerChara3.bmp" );
	CharaClickedCommon( "Abore" );
end

function Button_Chara4_ClickedListener( data )
	Character.nameMap["Player"] = "Ryu";	
	_("CHANGE TEX CharaInScript PlayerChara4.bmp" );
	CharaClickedCommon( "Ryu" );
end

function Button_TitleMenuBack_ClickedListener( data )
	_("CHANGE SCENE TitleMenu 0.2 10 ");
end

function Button_ContinueYes_ClickedListener( data )
--	GetViewManager():attach( "Option");
	
	ContinueView:activate( false );
	ContinueView:setVisible( false);
--	CharacterView:activateAgent( true );
	ActivateCharaView( true );
	
	Revive( "Player" );
	local p = Character.get("Player");
	local pos = p:position();
	p:setPosition( Vec3( pos.x , pos.y+5,pos.z ) );
	local meter = GUI_ProgressBar.get( "HealthMeter1" );
	meter.increment = 1;
	meter.addWidth(  meter.width );
	
end

function Button_ContinueNo_ClickedListener( data )
	ContinueView:setVisible( false);
	ActivateCharaView( true );
	
	_("CHANGE SCENE TitleMenu 0.2 10");
end

function Button_Stage1_EnterListener( data )
--	_("DISPLAY MSG stage1_1Script IN GameScript" )
end
	
function Button_Stage2_EnterListener( data )
--	_("DISPLAY MSG stage1_2Script IN GameScript" )
end

function Button_Stage3_EnterListener( data )
--	_("DISPLAY MSG stage2_1Script IN GameScript" )
end

function Button_Stage1_ClickedListener( data )
--	_("CHANGE SCENE PreStage1 0.2 10");
--	GetSceneStateManager():getFSM():changeState( "stage1_1" );	
	AttachView( "Mission" );
	--stage2_2NAĂstage1_2
--[[	if gStageClearData["stage2_2"] then
		gCurrSelectedStage = "stage1_2";
		_("CHANGE TEX Stage1View StageResident.bmp" );
		_("DISPLAY MSG Stage4Script IN MissionScript" );
	else
--]]		gCurrSelectedStage = "stage1_1";

	_("CHANGE TEX Stage1View Face_FabMask.bmp" );
--		_("CHANGE TEX Stage1View StageResident.bmp" );
		_("DISPLAY MSG Stage1Script IN MissionScript" );
--	end	
	_("DISPLAY MSG StageClickedScript IN GameScript" );
end

function Button_Stage2_ClickedListener( data )
	AttachView( "Mission" );
	gCurrSelectedStage = "stage2_1";
--	_("CHANGE TEX Stage1View StagePrePlatform.bmp" );
	_("CHANGE TEX Stage1View Face_Bob.bmp" );
	_("DISPLAY MSG Stage2Script IN MissionScript" );
	_("DISPLAY MSG StageClickedScript IN GameScript" );
end

function Button_Stage3_ClickedListener( data )
	AttachView( "Mission" );
	gCurrSelectedStage = "stage2_2";
	_("CHANGE TEX Stage1View StagePlatform.bmp" );
	_("DISPLAY MSG Stage3Script IN MissionScript" )
	_("DISPLAY MSG StageClickedScript IN GameScript" );
end

function Button_Stage3_ClickedListener( data )
	AttachView( "Mission" );
	gCurrSelectedStage = "stage2_2";
	_("CHANGE TEX Stage1View StagePlatform.bmp" );
	_("DISPLAY MSG Stage3Script IN MissionScript" )
	_("DISPLAY MSG StageClickedScript IN GameScript" );
end

function Button_Stage4_ClickedListener( data )
	AttachView( "Mission" );
	gCurrSelectedStage = "stage1_3";
	_("CHANGE TEX Stage1View Face_FabMask.bmp" );
	_("DISPLAY MSG Stage4Script IN MissionScript" )
	_("DISPLAY MSG StageClickedScript IN GameScript" );
end

function Button_stage1_1_ClickedListener( data )
--	_("CHANGE SCENE PreStage1 0.2 10");
	_("CHANGE SCENE stage2_1 0.2 10 ");
end

function Button_stage1_2_ClickedListener( data )
--	_("CHANGE SCENE PreStage1_2 0.2 10 ");
	_("CHANGE SCENE stage2_2 0.2 10 ");
	
end

function Button_stage2_1_ClickedListener( data )
--	_("CHANGE SCENE PreStage2_1 0.2 10");
--	_("CHANGE SCENE stage2_2 0.2 10 ");
end

function Button_MissionEnter_ClickedListener(data )
	_("PLAY SCRIPT EnterMission" );
	local num = #EventScriptData["EnterMission"];
	--̃V[ɏăV[J
	EventScriptData["EnterMission"][ num ]=
	 "CHANGE SCENE " ..gCurrSelectedStage.."  0.2 10";
--	GetViewManager():viewController():backToPrevView();
end

function Button_MissionCancel_ClickedListener(data )
	GetViewManager():viewController():backToPrevView();
end

function Button_CharaSelectBack_ClickedListener( data )
	_("CHANGE SCENE CharaSelect 0.2 10 ");
end

function Button_CamTra_ClickedListener( data )
--	_( "SET POS Player 1,1,1" );
end 

function Picture_Fight_TriggeredListener( data )
--[[	_("ATTACH SCENE Player");
	_("ATTACH SCENE Zako1");
--	_("ATTACH SCENE Zako2");
	
	_("SET POS Player -3 5 0");
	_("SET POS Zako1 3 5 0");
--	_("ATTACH SCENE Zako2");
--	_("SET POS Zako2 0 5 3");

--	Character.setPlayer( "Player" );
	
	GetSceneManager():get("Player"):enableAI( false) ;
--	_("ATTACH SCENE Zako2");	
--]]
end

function Picture_StageStart_TriggeredListener( data )

end

function Picture_StageClear_TriggeredListener( data )
end

function ClearCapFadeIn_KilledListener( data )	
	if Native.Methods.CurrentSceneName() == "stage1_2" then
		_("CHANGE SCENE stage2_1 0.2 10");
	elseif Native.Methods.CurrentSceneName() == "stage2_2" then
		_("CHANGE SCENE stage3_1 0.2 10");
	elseif Native.Methods.CurrentSceneName() == "stage3_2" then
--		_("CHANGE SCENE stage2_1");
	end
	
end

function StageStartFadeOut_KilledListener( data )	
	local enemies={
		{ name="Zako1",pos={5,2,0} },
		{ name="Zako2",pos={10,2,0} },
		{ name="Boss1",pos={5,2,0} },
	};
	QueueEnemy( enemies );	
--	Camera.lock();
	
end

function Button_ItemNotSelect_EnterListener( data )
	_("DISPLAY MSG ItemNotSelectScript IN GameScript" )
end

function Button_Juice_EnterListener( data )
	_("DISPLAY MSG JuiceScript IN GameScript" )
end

function Button_Burger_EnterListener( data )
	_("DISPLAY MSG BurgerScript IN GameScript" )
end

function Button_Juice_ClickedListener( data )
	_("DISPLAY MSG healthUpS IN GameScript" )
	 local b = GUI_Button.create( ButtonData["Burger"] );
	CursorMoveProcess_State.pushBackGUI(  b , 1 )
	CursorMoveProcess_State.instance:changeMode( Process.INITIALIZING );
end

function Button_Burger_ClickedListener( data )
	_("DISPLAY MSG healthUpM IN GameScript" )
end

gElapsedMilli = 0;
gHintId = 0;
gActiveHelp = false;
gHintNum = 10;
ShowCommandHelpProcess={}
ShowCommandHelpProcess.instance=nil;
ShowCommandHelpProcess.Initialize=function(process,data)
	if not gActiveHelp then
		return;
	end
	ShowCommandHelpProcess.instance = process;
	gElapsedMilli = gElapsedMilli + Framework():oneFrameTime();
	if gElapsedMilli >= 5000 then
		process:changeMode( Process.ACTIVATED );
	end
end
ShowCommandHelpProcess.Update=function(process,data)
	gElapsedMilli = 0;
	_("DISPLAY MSG Hint"..gHintId.." IN GameScript" );
	gHintId = gHintId + 1;
	if gHintId > gHintNum then
		gHintId = 0;
	end
	process:changeMode( Process.INITIALIZING );
end

ButtonData["Back"]={  holdFocus=true,views={  "Option" , "CharaSelect" , "Settings", "StageSelect" },  isOnFocus = false,  entered = false,  activatedSceneName = {"TitleMenu","stage1_1","stage1_2","stage2_1","stage2_2","CharaSelect",}
,  IsAfterRender = false,  isFirst = true,  activatedAllScene = true,  isFloating = true,  pos = {758,89,} , active=false , clickedSound=""
,  isHaveCaption = true,  focusAlpha = 0,  tex = "back-2-1.png",  blend = 0,  isMouseOnly = false,  width = 106,  onMouse = false,  name = "Back",  isDrag = true,  height = 106,  alpha = 255,  onFocus = false,  onEdit = false,}

ButtonData["BgmDowner"]={  view = "Option",  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"Title","TitleMenu","stage1_1","stage1_2","stage2_1","stage2_2","stage3_1","stage3_2","stage3_3","CharaSelect",}
,  mouseOnly = false,  pos = {622,291,}
,  isFirst = true,  IsAfterRender = false,  isFloating = true,  tex = "DownArrow.bmp",  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "Difficulty",  scale = {1.1777092218399,1.122422337532,}
,  pos = {199,422,}
,}
,}
,  blend = 0,  width = 50,  holdFocus = true,  alpha = 255,  onMouse = false,  name = "BgmDowner",  height = 50,  isDrag = true,  onFocus = false,  onEdit = false,}

ButtonData["BgmUpper"]={  view = "Option",  isDrag = true,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"Title","TitleMenu","stage1_1","stage1_2","stage2_1","stage2_2","stage3_1","stage3_2","stage3_3","CharaSelect",}
,  mouseOnly = false,  isFirst = true,  pos = {622,248,}
,  IsAfterRender = false,  isFloating = true,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "BgmVol",  scale = {1.1777092218399,1.122422337532,}
,  pos = {192,206,}
,}
,},holdFocus=true
,  blend = 0,  width = 50,  tex = "UpArrow.bmp",  alpha = 255,  name = "BgmUpper",  onMouse = false,  height = 50,  onFocus = false,  isOnFocus = false,  onEdit = false,}

ButtonData["Burger"]={
  isFloating = true,
  isOnFocus = false,
  focustex = "OnFocus3.bmp",
  entered = false,
  activatedSceneName = {
"stage1_1",
"stage1_2",
}
,
  IsAfterRender = false,
  isFirst = true,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
240,
563,
}
,
  blend = 0,
  width = 101,
  alpha = 255,
  isDrag = true,
  name = "Burger",
  tex = "Burger.bmp",
  height = 96,
  onMouse = false,
  onFocus = false,
  onEdit = false,
}

ButtonData["CamRot"]={
  isFloating = true,
  cappos = {
692,
72,
}
,
  update = CameraRotate,
  focustex = "gradation1Purple.dds",
  entered = false,
  activatedAllScene=true,
  isFirst = true,
  capscale = {
0.82999801635742,
0.6199996471405,
}
,
  pos = {
765,
83,
}
,
  blend = 0,
  isHaveCaption = true,
  focusAlpha = 0,
  text = {
{
  id = "CamRot",
  scale = {
0.65000033378601,
0.64000034332275,
}
,
  pos = {
699,
72,
}
,
}
,
}
,
  alpha = 255,
  width = 188,
  onMouse = false,
  height = 26,
  name = "CamRot",
  onFocus = false,
  tex = "gradation1.dds",
  isOnFocus = true,
  isDrag = true,
  onEdit = false,
}

ButtonData["CamTra"]={
  isFloating = true,
  cappos = {
692,
41,
}
,
  isDrag = true,
  focustex = "gradation1Purple.dds",
  entered = false,
  activatedAllScene=true,
  isFirst = true,
  capscale = {
0.82999801635742,
0.6199996471405,
}
,
  pos = {
760,
53,
}
,
  alpha = 255,
  isHaveCaption = true,
  focusAlpha = 0,
  text = {
{
  id = "CamTra",
  scale = {
0.69000029563904,
0.62000036239624,
}
,
  pos = {
696,
42,
}
,
}
,
}
,
  blend = 0,
  width = 177,
  name = "CamTra",
  height = 28,
  onMouse = false,
  onFocus = false,
  tex = "gradation1.dds",
  isOnFocus = true,
  update = CameraMove,
  onEdit = false,
}

ButtonData["Chara3"]={  view = "CharaSelect",  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"TitleMenu","CharaSelect",}
,  IsAfterRender = false,  isFirst = true,  pos = {249,484,}
,  isFloating = true,  zoomScl = {1,1,}
,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "CharaName3",  scale = {1.7999997138977,1.0700005292892,}
,  pos = {230,521,}
,}
,}
,  blend = 0,  width = 316,  tex = "PlayerChara3.bmp",  alpha = 255,  name = "Chara3",  onMouse = false,  height = 248,  onFocus = false,  isDrag = true,  onEdit = false,}

ButtonData["Chara4"]={  view = "CharaSelect",  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"TitleMenu","CharaSelect",}
,  IsAfterRender = false,  isFirst = true,  pos = {607,486,}
,  isFloating = true,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "CharaName4",  scale = {1.7300000190735,1.0700005292892,}
,  pos = {654,520,}
,}
,}
,  blend = 0,  width = 319,  alpha = 255,  tex = "PlayerChara4.bmp",  name = "Chara4",  isDrag = true,  height = 280,  onMouse = false,  onFocus = false,  onEdit = false,}

ButtonData["Character"]={   isOnFocus = false,  focustex = "OnFocus3.bmp",  entered = false,  activatedSceneName = {"StageSelect","stage1_1","stage1_2","stage2_1","stage2_2",}
,  IsAfterRender = false,  isFirst = true,  pos = {134,592,}
,  isFloating = true,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "Chara",  scale = {0.5,0.5,}
,  pos = {200,0,}
,}
,}
,  alpha = 255,  width = 270,  isDrag = true,  tex = "Button3.bmp",  name = "Character",  blend = 0,  height = 53,  onMouse = false,  onFocus = false,  onEdit = false,}

ButtonData["CharaSelectBack"]={
  cappos = {
659,
311,
}
,
  isDrag = true,
  focustex = "OnFocus2.bmp",
  changeAfter = 4,
  entered = false,
  activatedSceneName = {
"StageSelect",
}
,
  isFirst = true,
  capscale = {
0.99999994039536,
0.9300000667572,
}
,
  focusAlpha = 0,
  blend = 0,
  width = 111,
  pos = {
689,
304,
}
,
  name = "CharaSelectBack",
  height = 115,
  tex = "back-2-1.png",
  onFocus = false,
  onMouse = false,
  onEdit = false,
}

ButtonData["ContinueYes"]={  view = "Continue",  isOnFocus = false,  focustex = "OnFocus3.bmp",  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage2_1","stage2_2"}
,  IsAfterRender = false,  isFirst = true,  pos = {215,237,}
,  isHaveCaption = true,  focusAlpha = 0,  isFloating = true,  alpha = 255,  width = 183,  isDrag = true,  tex = "StageStreet.bmp",  name = "ContinueYes",  blend = 0,  height = 172,  onMouse = false,  onFocus = false,  onEdit = false,}

ButtonData["ContinueNo"]={  view = "Continue",  isOnFocus = false,  focustex = "OnFocus3.bmp",  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage2_1","stage2_2"}
,  IsAfterRender = false,  isFirst = true,  pos = {315,237,}
,  isHaveCaption = true,  focusAlpha = 0,  isFloating = true,  alpha = 255,  width = 183,  isDrag = true,  tex = "StageStreet.bmp",  name = "ContinueYes",  blend = 0,  height = 172,  onMouse = false,  onFocus = false,  onEdit = false,}


ButtonData["ContinueNo"]={  view = "Continue",  isOnFocus = false,  focustex = "OnFocus3.bmp",  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage2_1","stage2_2",}
,  IsAfterRender = false,  isFirst = true,  pos = {556,395,}
,  isFloating = true,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "ContinueNo",  scale = {1.4699996709824,0.95000076293945,}
,  pos = {531,378,}
,}
,},holdFocus = true
,  alpha = 255,  width = 211,  isDrag = true,  tex = "Button2.bmp",  onMouse = false,  blend = 0,  height = 83,  name = "ContinueNo",  onFocus = false,  onEdit = false,}

ButtonData["ContinueYes"]={  view = "Continue",  isOnFocus = false,  focustex = "OnFocus3.bmp",  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage2_1","stage2_2",}
,  IsAfterRender = false,  isFirst = true,  pos = {302,395,}
,  isFloating = true,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "ContinueYes",  scale = {1.7199995517731,1.1300005912781,}
,  pos = {253,371,}
,}
,},holdFocus = true
,  alpha = 255,  width = 219,  isDrag = true,  tex = "Button2.bmp",  onMouse = false,  blend = 0,  height = 84,  name = "ContinueYes",  onFocus = false,  onEdit = false,}

ButtonData["Easy"]={  isFloating = true,  focusAlphaWave = {  speed = 1,}
,  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"Settings",}
,  IsAfterRender = false,  isFirst = true,  pos = {270,512,}
,  isDrag = true,  blend = 0,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "Easy",  scale = {1.207709312439,0.7624226808548,}
,  pos = {228,495,}
,}
,}
,  alpha = 255,  width = 159,  holdFocus = true,  tex = "Button2.bmp",  onMouse = false,  name = "Easy",  height = 66,  view = "Option",  onFocus = false,  zoomScl = {1,1,}
,}

ButtonData["GameExit"]={  view = "TitleMenu",  focusAlphaWave = {  speed = 1,}
,  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"Title","TitleMenu",}
,  IsAfterRender = false,  isFirst = true,  pos = {393,539,}
,  isDrag = true,  zoomScl = {1,1,}
,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "GameExit",  scale = {1.3800001144409,0.6900007724762,}
,  pos = {304,513,}
,}
,},clickedSound="door01"
,  alpha = 0,  width = 350,  holdFocus = true,  tex = "Button2.bmp",  onMouse = false,  name = "GameExit",  height = 61,  isFloating = true,  blend = 0,  onFocus = false,}

ButtonData["GameLecture"]={
  isFloating = true,
  isOnFocus = false,
  focustex = "OnFocus2.bmp",
  entered = false,
  activatedSceneName = {
"Title","TitleMenu",
}
,
  IsAfterRender = false,
  isFirst = true,
  isHaveCaption = true,
  focusAlpha = 0,
  text = {
{
  id = "GameLecture",
  scale = {
1.2038094997406,
1.0305882692337,
}
,
  pos = {
335,
249,
}
,
}
,
}
,
  alpha = 255,
  width = 564,
  pos = {
431,
264,
}
,
  isDrag = true,
  onMouse = false,
  tex = "ButtonFrame2.bmp",
  height = 59,
  blend = 0,
  name = "GameLecture",
  onFocus = false,
}

ButtonData["GameStart"]={  view = "TitleMenu",  focusAlphaWave = {  speed = 1,}
,  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"Title","TitleMenu",}
,  IsAfterRender = false,  isFirst = true,  pos = {395,452,}
,  isDrag = true,  alpha = 0,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "GameStart",  scale = {1.0977094173431,0.63242280483246,}
,  pos = {305,428,}
,}
,},clickedSound="hit57"
,  blend = 0,  width = 353,  holdFocus = true,  tex = "Button2.bmp",  onMouse = false,  name = "GameStart",  height = 60,  isFloating = true,  onFocus = false,  zoomScl = {1,1,}
,}

ButtonData["Hard"]={  isFloating = true,  focusAlphaWave = {  speed = 1,}
,  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"Settings",}
,  IsAfterRender = false,  isFirst = true,  pos = {579,512,}
,  isDrag = true,  blend = 0,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "Hard",  scale = {1.207709312439,0.7624226808548,}
,  pos = {540,496,}
,}
,}
,  alpha = 255,  width = 148,  holdFocus = true,  tex = "Button2.bmp",  onMouse = false,  name = "Hard",  height = 64,  view = "Option",  onFocus = false,  zoomScl = {1,1,}
,}

ButtonData["Help"]={  view = "GlobalUI",  isOnFocus = false,  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage1_3","stage1_4","stage2_1","stage2_2",}
,  mouseOnly = true,  isFirst = true,  pos = {797,638,}
,  isFloating = true,  IsAfterRender = false,  isHaveCaption = true,  focusAlpha = 0,  tex = "helpIcon2.png",  alpha = 255,  isMouseOnly = true,  width = 80,  onMouse = false,  name = "Help",  isDrag = true,  height = 80,  blend = 0,  onFocus = false,  onEdit = false,}

ButtonData["ItemNotSelect"]={
  isFloating = true,
  isOnFocus = false,
  focustex = "OnFocus3.bmp",
  entered = false,
  activatedSceneName = {
"stage1_1",
"stage1_2",
}
,
  IsAfterRender = false,
  isFirst = true,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
63,
556,
}
,
  blend = 0,
  width = 100,
  alpha = 255,
  isDrag = true,
  name = "ItemNotSelect",
  tex = "ItemNotSelect.bmp",
  height = 100,
  onMouse = false,
  onFocus = false,
  onEdit = false,
}

ButtonData["J"]={  view = "GlobalUI",  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage1_3","stage1_4","stage2_1","stage2_2","stage3_1","stage3_2","stage3_3"}
,  mouseOnly = true,  isFirst = true,  pos = {756,550,}, text = {{  id = "Operation4",  scale = {1.0680952072144,0.84941244125366,}
,  pos = {91,296,}
,}
,}
,  IsAfterRender = false,  isHaveCaption = true,  focusAlpha = 0,  isFloating = true,  blend = 0,  width = 50,  tex = "Button2.bmp",  alpha = 255,  onMouse = false,  name = "J",  height = 50,  isDrag = true,  onFocus = false,  onEdit = false,}

ButtonData["Juice"]={
  isFloating = true,
  isOnFocus = false,
  focustex = "OnFocus3.bmp",
  entered = false,
  activatedSceneName = {
"stage1_1",
"stage1_2",
}
,
  IsAfterRender = false,
  isFirst = true,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
152,
563,
}

,
  blend = 0,
  width = 100,
  alpha = 255,
  isDrag = true,
  name = "Juice",
  tex = "Juice.bmp",
  height = 100,
  onMouse = false,
  onFocus = false,
  onEdit = false,
}

ButtonData["K"]={  view = "GlobalUI",  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage1_3","stage1_4","stage2_1","stage2_2","stage3_1","stage3_2","stage3_3"}
,  mouseOnly = true,  isFirst = true,  pos = {806,550,}, text = {{  id = "Operation5",  scale = {1.0680952072144,0.84941244125366,}
,  pos = {91,296,}
,}
,}
,  IsAfterRender = false,  isHaveCaption = true,  focusAlpha = 0,  isFloating = true,  blend = 0,  width = 50,  tex = "Button2.bmp",  alpha = 255,  onMouse = false,  name = "K",  height = 50,  isDrag = true,  onFocus = false,  onEdit = false,}

ButtonData["Burger"]={
  isFloating = true,
  isOnFocus = false,
  focustex = "OnFocus3.bmp",
  entered = false,
  activatedSceneName = {
"stage1_1",
"stage1_2",
}
,
  IsAfterRender = false,
  isFirst = true,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
240,
563,
}
,
  blend = 0,
  width = 101,
  alpha = 255,
  isDrag = true,
  name = "Burger",
  tex = "Burger.bmp",
  height = 96,
  onMouse = false,
  onFocus = false,
  onEdit = false,
}

ButtonData["M"]={  view = "GlobalUI",  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage1_3","stage1_4","stage2_1","stage2_2","stage3_1","stage3_2","stage3_3"}
,  mouseOnly = true,  isFirst = true,  pos = {750,500,} , text = {{  id = "Operation2",  scale = {1.0680952072144,0.84941244125366,}
,  pos = {91,296,}
,}
,}
,  IsAfterRender = false,  isHaveCaption = true,  focusAlpha = 0,  isFloating = true,  blend = 0,  width = 50,  tex = "Button2.bmp",  alpha = 255,  onMouse = false,  name = "M",  height = 50,  isDrag = true,  onFocus = false,  onEdit = false,}

ButtonData["Menu"]={
  pos = {
640,
50,
}
,
  width = 400,
  focusAlpha = 0,
  onMouse = false,
  blend = 0,
  focustex = "OnFocus1.bmp",
  height = 90,
  entered = false,
  name = "Menu",
  activatedSceneName = {
"Stage1",
"Stage2",
}
,
  tex = "MenuButton.bmp",
  focusSize = {
400,
90,
}
,
  isFirst = true,
  onFocus = false,
}

ButtonData["MissionCancel"]={  view = "Mission",  isOnFocus = false,  focustex = "OnFocus3.bmp",  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage2_1","stage2_2",}
,  IsAfterRender = false,  isFirst = true,  pos = {598,482,}
,  isFloating = true,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "MissionCancel",  scale = {1.689999461174,1.1900005340576,}
,  pos = {516,458,}
,}
,} ,clickedSound="se_maoudamashii_system18",holdFocus=true
,  alpha = 255,  width = 253,  isDrag = true,  tex = "Button2.bmp",  name = "MissionCancel",  blend = 0,  height = 82,  onMouse = false,  onFocus = false,  onEdit = false,}

ButtonData["MissionEnter"]={    isOnFocus = false,  focustex = "OnFocus3.bmp",  entered = false,  activatedSceneName = { "PreStage1","PreStage2_1","stage1_1","stage1_2","stage2_1","stage2_2",}
,  IsAfterRender = false,  isFirst = true,  pos = {264,482,}
,  isFloating = true,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "MissionEnter",  scale = {1.8599994182587,1.3500003814697,}
,  pos = {189,454,}
,}
,},holdFocus=true,view="Mission",clickedSound="hit57"
,  alpha = 255,  width = 258,  isDrag = true,  tex = "Button2.bmp",  onMouse = false,  blend = 0,  height = 86,  name = "MissionEnter",  onFocus = false,  onEdit = false,}

ButtonData["N"]={  view = "GlobalUI",  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage1_3","stage1_4","stage2_1","stage2_2","stage3_1","stage3_2","stage3_3"}
,  mouseOnly = true,  isFirst = true,  pos = {806,500,}, text = {{  id = "Operation3",  scale = {1.0680952072144,0.84941244125366,}
,  pos = {91,296,}
,}
,}
,  IsAfterRender = false,  isHaveCaption = true,  focusAlpha = 0,  isFloating = true,  blend = 0,  width = 50,  tex = "Button2.bmp",  alpha = 255,  onMouse = false,  name = "N",  height = 50,  isDrag = true,  onFocus = false,  onEdit = false,}

ButtonData["Next"]={
  isFloating = true,
  isDrag = true,
  focustex = "OnFocus2.bmp",
  entered = false,
  activatedSceneName = {
"GameLecture",
}
,
  IsAfterRender = false,
  isFirst = true,
  isHaveCaption = true,
  focusAlpha = 0,
  alpha = 255,
  width = 100,
  pos = {
728,
561,
}
,
  isOnFocus = false,
  name = "Next",
  height = 100,
  tex = "RightArrow.bmp",
  blend = 0,
  onMouse = false,
  onFocus = false,
}

ButtonData["Normal"]={  isFloating = true,  focusAlphaWave = {  speed = 1,}
,  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"Settings",}
,  IsAfterRender = false,  isFirst = true,  pos = {427,512,}
,  isDrag = true,  blend = 0,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "Normal",  scale = {1.207709312439,0.7624226808548,}
,  pos = {370,497,}
,}
,}
,  alpha = 255,  width = 157,  holdFocus = true,  tex = "Button2.bmp",  onMouse = false,  name = "Normal",  height = 65,  view = "Option",  onFocus = false,  zoomScl = {1,1,}
,}

ButtonData["Option"]={  view = "TitleMenu",  focusAlphaWave = {  speed = 1,}
,  isDrag = true,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"Title","TitleMenu",}
,  IsAfterRender = false,  isFirst = true,  pos = {633,434,}
,  isFloating = true,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "Option",  scale = {1.0400002002716,0.58000081777573,}
,  pos = {507,415,}
,}
,}
,  blend = 0,  width = 347,  isOnFocus = false,  tex = "Button2.bmp",  name = "Option",  onMouse = false,  height = 60,  alpha = 255,  onFocus = false,  zoomScl = {1,1,}
,}

ButtonData["OptionMenu"]={  view = "GlobalUI",  isOnFocus = false, 
 entered = false, 
 activatedSceneName = { "StageSelect" }
,  IsAfterRender = false,  isFirst = true,  --activatedAllScene = true,  
isFloating = true,  pos = {741,640,},holdFocus=true
,  isHaveCaption = true,  focusAlpha = 0,  tex = "gearIcon.bmp",  
alpha = 255,    width = 85,  onMouse = false,  
name = "OptionMenu",  isDrag = true,  height = 85,  blend = 0,  
onFocus = false,  onEdit = false,}

ButtonData["PauseMenu"]={  view = "GlobalUI",  isOnFocus = false,  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage2_1","stage2_2","stage3_1","stage3_2","stage3_3" }
,  IsAfterRender = false,  isFirst = true, isFloating = true,  pos = {758,89,}
,  isHaveCaption = true,  focusAlpha = 0,  tex = "PauseMenu.bmp",  blend = 0,  isMouseOnly = false,  width = 106,  onMouse = false,  name = "PauseMenu",  isDrag = true,  height = 106,  alpha = 255,  onFocus = false,  onEdit = false,}

ButtonData["PauseMenu"]={  view = "GameUI",  isOnFocus = false,  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage2_1","stage2_2",}
,  mouseOnly = true,  activatedAllScene = true,  isFirst = true,  IsAfterRender = false,  isFloating = true,  tex = "PauseMenu.bmp",  isHaveCaption = true,  focusAlpha = 0,  pos = {430,111,}
,  blend = 0,  isMouseOnly = false,  onMouse = false,  width = 103,  name = "PauseMenu",  isDrag = true,  height = 25,  alpha = 255,  onFocus = false,  onEdit = false,}

ButtonData["PressStart"]={
  isFloating = true,
  isOnFocus = true,
  focustex = "OnFocus1.bmp",
  entered = false,
  activatedSceneName = {
"Title",
}
,
  isFirst = true,
  pos = {
423,
534,
}
,
  isHaveCaption = true,
  focusAlpha = 0,
  text = {
{
  id = "PressStart",
  scale = {
1.6399984359741,
1.1000008583069,
}
,
  pos = {
267,
515,
}
,
}
,
}
,
  alpha = 255,
  width = 908,
  isDrag = true,
  blend = 0,
  name = "PressStart",
  height = 89,
  tex = "Start.bmp",
  onMouse = false,
  onFocus = false,
  onEdit = false,
--  uv={ 0, 0.8 , 1 , 1},
}

ButtonData["Prev"]={
  isFloating = true,
  isDrag = true,
  focustex = "OnFocus2.bmp",
  entered = false,
  activatedSceneName = {
"GameLecture",
}
,
  IsAfterRender = false,
  isFirst = true,
  isHaveCaption = true,
  focusAlpha = 0,
  alpha = 255,
  width = 100,
  pos = {
90,
558,
}
,
  isOnFocus = false,
  name = "Prev",
  height = 100,
  tex = "LeftArrow.bmp",
  blend = 0,
  onMouse = false,
  onFocus = false,
}

ButtonData["ResumeGame"]={  view = "PauseMenu",  focusAlphaWave = {  speed = 1,}
,  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage2_1","stage2_2",}
,  IsAfterRender = false,  isFirst = true,  pos = {422,253,}
,  isDrag = true,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "ResumeGame",  scale = {1.207709312439,0.78242272138596,}
,  pos = {298,239,}
,}
,},holdFocus=true,
  alpha = 255,  width = 450,  blend = 0,  tex = "Button2.bmp",  onMouse = false,  name = "ResumeGame",  height = 66,  isFloating = true,  onFocus = false,  zoomScl = {1.3,1.3,}
,}

ButtonData["ReturnStageSelect"]={  isFloating = true,  focusAlphaWave = {  speed = 1,}
,  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage2_1","stage2_2",}
,  IsAfterRender = false,  isFirst = true,  pos = {424,342,}
,  isDrag = true,  blend = 0,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "ReturnStageSelect",  scale = {1.207709312439,0.7624226808548,}
,  pos = {218,329,}
,}
,}
,  alpha = 255,  width = 449,  holdFocus = true,  tex = "Button2.bmp",  onMouse = false,  name = "ReturnStageSelect",  height = 67,  view = "PauseMenu",  onFocus = false,  zoomScl = {1.3,1.3,}
,}

ButtonData["ReturnTitleMenu"]={  isFloating = true,  focusAlphaWave = {  speed = 1,}
,  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage2_1","stage2_2",}
,  IsAfterRender = false,  isFirst = true,  pos = {424,432,}
,  isDrag = true,  blend = 0,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "ReturnTitleMenu",  scale = {1.207709312439,0.7624226808548,}
,  pos = {233,418,}
,}
,}
,  alpha = 255,  width = 449,  holdFocus = true,  tex = "Button2.bmp",  onMouse = false,  name = "ReturnTitleMenu",  height = 67,  view = "PauseMenu",  onFocus = false,  zoomScl = {1.3,1.3,}
,}

ButtonData["SeDowner"]={ holdFocus=true, view = "Option",  isDrag = true,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"Title","TitleMenu","stage1_1","stage1_2","stage2_1","stage2_2","stage3_1","stage3_2","stage3_3","CharaSelect",}
,  mouseOnly = false,  isFirst = true,  pos = {622,418,}
,  IsAfterRender = false,  isHaveCaption = true,  focusAlpha = 0,  isFloating = true,  blend = 0,  width = 50,  tex = "DownArrow.bmp",  alpha = 255,  name = "SeDowner",  onMouse = false,  height = 50,  onFocus = false,  isOnFocus = false,  onEdit = false,}

ButtonData["SeUpper"]={ holdFocus=true, view = "Option",  isDrag = true,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"Title","TitleMenu","stage1_1","stage1_2","stage2_1","stage2_2","stage3_1","stage3_2","stage3_3","CharaSelect",}
,  mouseOnly = false,  isFirst = true,  pos = {621,372,}
,  IsAfterRender = false,  isFloating = true,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "SeVol",  scale = {1.2777092456818,1.0624223947525,}
,  pos = {195,319,}
,}
,}
,  blend = 0,  width = 50,  tex = "UpArrow.bmp",  alpha = 255,  name = "SeUpper",  onMouse = false,  height = 50,  onFocus = false,  isOnFocus = false,  onEdit = false,}

ButtonData["Size"]={
view="GameUI",
mouseOnly=true,
activatedAllScene = true, 
--activatedAllScene = true,
  isFloating = true,
  isOnFocus = false,
--  focustex = "OnFocus2.bmp",
  entered = false,
activatedSceneName = {"stage1_1","stage1_2","stage2_1","stage2_2",},
  IsAfterRender = false,
  isFirst = true,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
805,
35,
}
,
  blend = 0,
  width = 50,
  alpha = 255,
  isDrag = true,
  onMouse = false,
  tex = "Size.bmp",
  height = 50,
  name = "Size",
  onFocus = false,
  onEdit = false,
}

ButtonData["Sound"]={
  isFloating = true,
  isOnFocus = false,
  focustex = "OnFocus2.bmp",
  entered = false,
  activatedSceneName = {
"Title",
"TitleMenu",
"stage1_1",
"stage1_2",
"CharaSelect",
}
,
  IsAfterRender = false,
  isFirst = true,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
740,
35,
}
,
  blend = 0,
  width = 50,
  alpha = 255,
  isDrag = true,
  onMouse = false,
  tex = "Onpu.bmp",
  height = 50,
  name = "Sound",
  onFocus = false,
  onEdit = false,
}

ButtonData["Stage1"]={  view = "StageSelect",  enterSound = "se_maoudamashii_system28",  isOnFocus = false,  focustex = "RedPointFocus.bmp",  entered = false,  activatedSceneName = {"TitleMenu","StageSelect","CharaSelect",}
,  IsAfterRender = false,  isFirst = true,  pos = {129,324,}
,  isFloating = true,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "stage1_1",  scale = {1.0680952072144,0.84941244125366,}
,  pos = {91,296,}
,}
,},textColor=0x111111,holdFocus=true,focusAlphaWave = {  speed = 3,}
,  alpha = 255,  width = 83,  isDrag = true,  tex = "RedPoint.bmp",  onMouse = false,  blend = 0,  height = 80,  name = "Stage1",  onFocus = false,  onEdit = false,}

ButtonData["Stage2"]={  view = "StageSelect",  enterSound = "se_maoudamashii_system28",  isOnFocus = false,  focustex = "RedPointFocus.bmp",  entered = false,  activatedSceneName = {"StageSelect",}
,  IsAfterRender = false,  isFirst = true,  pos = {308,225,}
,  isFloating = true,  textColor = 2236962,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "stage1_2",  scale = {0.78809517621994,0.99941229820251,}
,  pos = {213,196,}
,}
,},holdFocus=true,focusAlphaWave = {  speed =3,}
,  alpha = 255,  width = 66,  tex = "RedPoint.bmp",  isDrag = true,  onMouse = false,  name = "Stage2",  height = 71,  blend = 0,  onFocus = false,  onEdit = false,}

ButtonData["Stage3"]={  view = "StageSelect",  isOnFocus = false,  focustex = "RedPointFocus.bmp",  entered = false,  activatedSceneName = {"StageSelect",}
,  IsAfterRender = false,  isFirst = true,  pos = {487,156,}
,  isFloating = true,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "stage2_1",  scale = {1.2648524045944,0.74065804481506,}
,  pos = {407,136,}
,}
,}, enterSound="se_maoudamashii_system28",holdFocus=true,focusAlphaWave = {  speed = 3,}
,textColor=0x333333,  alpha = 255,  width = 65,  isDrag = true,  tex = "RedPoint.bmp",  name = "Stage3",  blend = 0,  height = 80,  onMouse = false,  onFocus = false,  onEdit = false,}

ButtonData["Stage4"]={  view = "StageSelect",  enterSound = "se_maoudamashii_system28",  focusAlphaWave = {  speed = 3,}
,  isOnFocus = false,  focustex = "RedPointFocus.bmp",  entered = false,  activatedSceneName = {"StageSelect",}
,  IsAfterRender = false,  pos = {500,300,}
,  isFirst = true,  isFloating = true,  textColor = 3355443,  tex = "RedPoint.bmp",  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "stage2_2",  scale = {1.2648524045944,0.74065804481506,}
,  pos = {471,291,}
,}
,}
,  alpha = 255,  width = 60,  holdFocus = true,  isDrag = true,  onMouse = false,  name = "Stage4",  height = 75,  blend = 0,  onFocus = false,  onEdit = false,}

ButtonData["StageSelect"]={
  isFloating = true,
  cappos = {
303,
81,
}
,
  isOnFocus = false,
  focustex = "OnFocus2.bmp",
  entered = false,
  activatedSceneName = {
"StageSelect",
}
,
  IsAfterRender = false,
  isFirst = true,
  capscale = {
1.5,
1.5,
}
,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
473,
102,
}
,
  blend = 0,
  width = 570,
  isDrag = true,
  alpha = 255,
  onMouse = false,
  tex = "ButtonFrame2.bmp",
  height = 119,
  name = "StageSelect",
  onFocus = false,
  onEdit = false,
}

ButtonData["SurvivalMode"]={  view = "TitleMenu",  focusAlphaWave = {  speed = 1,}
,  isDrag = true,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"Title","TitleMenu",}
,  IsAfterRender = false,  isFirst = true,  pos = {633,434,}
,  isFloating = true,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "SurvivalMode",  scale = {1.0400002002716,0.58000081777573,}
,  pos = {507,415,}
,}
,}
,  blend = 0,  width = 347,  isOnFocus = false,  tex = "Button2.bmp",  name = "SurvivalMode",  onMouse = false,  height = 60,  alpha = 0,  onFocus = false,  zoomScl = {1,1,}
,}

ButtonData["TitleMenuBack"]={
  cappos = {
665,
128,
}
,
  isDrag = true,
  focustex = "OnFocus2.bmp",
  changeAfter = 4,
  entered = false,
  activatedSceneName = {
"CharaSelect",
}
,
  isFirst = true,
  capscale = {
0.97000002861023,
0.94000005722046,
}
,
  focusAlpha = 0,
  blend = 0,
  width = 99,
  pos = {
672,
465,
}
,
  name = "TitleMenuBack",
  height = 110,
  tex = "back-2-1.png",
  onFocus = false,
  onMouse = false,
  onEdit = false,
}

ButtonData["TrainingMode"]={  view = "TitleMenu",  focusAlphaWave = {  speed = 1,}
,  isDrag = true,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"Title","TitleMenu",}
,  IsAfterRender = false,  isFirst = true,  pos = {256,524,}
,  isFloating = true,  isHaveCaption = true,  focusAlpha = 0,  text = {{  id = "TrainingMode",  scale = {1.0400002002716,0.58000081777573,}
,  pos = {128,501,}
,}
,}
,  blend = 0,  width = 347,  isOnFocus = false,  tex = "Button2.bmp",  name = "TrainingMode",  onMouse = false,  height = 60,  alpha = 0,  onFocus = false,  zoomScl = {1,1,}
,}

ButtonData["WASD"]={  view = "GlobalUI",  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage1_3","stage1_4","stage2_1","stage2_2","stage3_1","stage3_2","stage3_3"}
,  mouseOnly = true,  isFirst = true,  pos = {100,500,}
,  IsAfterRender = false,  isHaveCaption = true,  focusAlpha = 0,  isFloating = true,  blend = 0,  width = 50,  tex = "Button2.bmp",  alpha = 255,  onMouse = false,  name = "WASD",  height = 50,  isDrag = true,  onFocus = false,  onEdit = false,}

ButtonData["WindowMode"]={  view = "GlobalUI",  isOnFocus = false,  focustex = "OnFocus2.bmp",  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage1_3","stage1_4","stage2_1","stage2_2","stage3_1","stage3_2","stage3_3"}
,  mouseOnly = true,  isFirst = true,  pos = {806,33,}
,  IsAfterRender = false,  isHaveCaption = true,  focusAlpha = 0,  isFloating = true,  blend = 0,  width = 50,  tex = "Size.bmp",  alpha = 255,  onMouse = false,  name = "WindowMode",  height = 50,  isDrag = true,  onFocus = false,  onEdit = false,}


GUI_NumericFrameRateData={
	name="FrameRate",
	view="GlobalUI",
	activatedAllScene=true,
	pos={ FullWidth()-25, 25} ,--FullHeight()-50 },
	numberTex="nums.dds",
	numberTexPixelWidth=102,
	numberTexPixelWidthMax=1024,
	  activatedSceneName = {
	  "Title",
	"TitleMenu",
	"CharaSelect",
	"stage1_1",
	},
	digitNum=2,
	digitSize={ 25,50 },
	showThreshold=1,
--[[
	upDownControl={
		width = 50,
		height = 50,
		focusAlpha = 0,
		focustex = "OnFocus2.bmp",			  
		alpha = 255,
		
	}
--]]	
}
GUI_NumEnemDefCntData={
	name="DefeatCount",
	view="GameUI",
--	activatedAllScene=true,
	pos={ 623, 217 } ,--FullHeight()-50 },
	numberTex="nums.dds",
	numberTexPixelWidth=102,
	numberTexPixelWidthMax=1024,
	  activatedSceneName = {
	"stage1_1",
	"stage1_2",
	"stage2_1",
	"stage2_2",
	},
	digitNum=2,
	digitSize={ 35,75 },
	showThreshold=1,
}
GUI_NumEnemDefTgtData={
	name="DefeatCountTarget",
	view="GameUI",
--	activatedAllScene=true,
	pos={ 753, 223 } ,--FullHeight()-50 },
	numberTex="nums.dds",
	numberTexPixelWidth=102,
	numberTexPixelWidthMax=1024,
	  activatedSceneName = {
	"stage1_1",
	"stage1_2",
	"stage2_1",
	"stage2_2",
	},
	digitNum=2,
	digitSize={ 35,75 },
	showThreshold=1,
}


PictureData["CharaInScript"]={  view = "GlobalUI",  cappos = {85,483,}
,  gradual = 0.05,  isOnFocus = true,  entered = false,  activatedSceneName = {"StageSelect","stage1_1","stage1_2","stage1_3","stage1_4","stage2_1","stage2_2",}
,  isFirst = true,  capscale = {1.219998717308,1.7300002574921,}
,  pos = {-66,590,}
,  isHaveCaption = true,  focusAlpha = 0,  isFloating = true,  alpha = 255,  width = 245,  isDrag = true,  height = 211,  onMouse = false,  blend = 0,  tex = "KungfuGuy3.bmp",  name = "CharaInScript",  onFocus = false,  onEdit = false,}

PictureData["CharaSelectCap"]={
  isFloating = true,
  cappos = {
85,
483,
}
,
  gradual = 0.05,
  isOnFocus = true,
  entered = false,
  activatedSceneName = {
"CharaSelect",
}
,
  isFirst = true,
  capscale = {
1.219998717308,
1.7300002574921,
}
,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
264,
120,
}
,
  alpha = 255,
  width = 588,
  isDrag = true,
  blend = 0,
  name = "CharaSelectCap",
  height = 215,
  tex = "CharaSelectStr.bmp",
  onMouse = false,
  onFocus = false,
  onEdit = false,
}

PictureData["CharaSelStr"]={  view = "CharaSelect",  cappos = {85,483,}
,  gradual = 0.05,  isOnFocus = true,  entered = false,  activatedSceneName = {"CharaSelect",}
,  isFirst = true,  capscale = {1.219998717308,1.7300002574921,}
,  pos = {363,63,}
,  isHaveCaption = true,  focusAlpha = 0,  isFloating = true,  alpha = 255,  width = 726,  isDrag = true,  height = 140,  onMouse = false,  blend = 0,  tex = "CharaSelStr.bmp",  name = "CharaSelStr",  onFocus = false,  onEdit = false,}

PictureData["FaceGra1"]={
  isFloating = true,
  cappos = {
85,
483,
}
,
  gradual = 0.05,
  isOnFocus = true,
  entered = false,
  activatedSceneName = {
"Stage1",
"Stage2",
"Stage3",
}
,
  isFirst = true,
  capscale = {
1.219998717308,
1.7300002574921,
}
,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
85,
117,
}
,
  alpha = 255,
  width = 121,
  isDrag = true,
  blend = 0,
  onMouse = false,
  height = 98,
  tex = "FaceGra1.bmp",
  name = "FaceGra1",
  onFocus = false,
  onEdit = false,
}

PictureData["FaceGra2"]={
  isFloating = true,
  cappos = {
85,
483,
}
,
  gradual = 0.05,
  isOnFocus = true,
  entered = false,
  activatedSceneName = {
"Stage1",
"Stage2",
"Stage3",
}
,
  isFirst = true,
  capscale = {
1.219998717308,
1.7300002574921,
}
,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
747,
121,
}
,
  alpha = 255,
  width = 117,
  isDrag = true,
  blend = 0,
  name = "FaceGra2",
  height = 106,
  tex = "FaceGra2.bmp",
  onMouse = false,
  onFocus = false,
  onEdit = false,
}

PictureData["FaceGra3"]={
  isFloating = true,
  cappos = {
85,
483,
}
,
  gradual = 0.05,
  isOnFocus = true,
  entered = false,
  activatedSceneName = {
"Stage1","Stage2","Stage3",
}
,
  isFirst = true,
  capscale = {
1.219998717308,
1.7300002574921,
}
,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
264,
120,
}
,
  alpha = 255,
  width = 588,
  isDrag = true,
  blend = 0,
  name = "FaceGra3",
  height = 215,
  tex = "FaceGra3.bmp",
  onMouse = false,
  onFocus = false,
  onEdit = false,
}

PictureData["Fight"]={
  isFloating = true,
  cappos = {
85,
483,
}
,
  gradual = 0.05,
  isOnFocus = true,
  entered = false,
  activatedSceneName = {
"stage1_1",
"stage1_2",
"Stage2_1",
"Stage2_2",
"Stage3_1",
"Stage3_2",
}
,
  isFirst = true,
  capscale = {
1.219998717308,
1.7300002574921,
}
,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
500,
300,
}
,
  alpha = 255,
  width = 2,
  isDrag = true,
  blend = 0,
  onMouse = false,
  height = 1,
  tex = "Fight.bmp",
  name = "Fight",
  onFocus = false,
  onEdit = false,
  --TODO: GUI_Picture.lua must be loaded previously
  update={
	{ func=GUI_Picture.addSize , data={ 
			maxW=550,	
			maxH=470,  
			speedW=5,
			speedH=2,
		}
	},
--	{ func=GUI_Picture.wait , data={ waitTime=1,} },
	{ func=GUI_Picture.move , data={ dir={-1,0 },speed={15,0} , dst={-500,300 },err=10 }, } 
  },
}

PictureData["HelpGameCommand"]={  view = "GlobalUI",  cappos = {100,-100,}
,  gradual = 0.05,  isOnFocus = true,  entered = false,  activatedSceneName = {"stage1_1","stage1_2","stage1_3","stage1_4","stage2_1","stage2_2","stage3_1","stage3_2","stage3_3",}
,  isFirst = true,  capscale = {1.219998717308,1.7300002574921,}
,  pos = {405,446,}
,  isHaveCaption = true,  focusAlpha = 0,  isFloating = true,  alpha = 220,  width = 804,  isDrag = true,  height = 339,  name = "HelpGameCommand",  blend = 0,  tex = "HelpGameCommand.bmp",  onMouse = false,  onFocus = false,  onEdit = false,}

PictureData["MissionStr"]={  view = "Mission",  cappos = {85,483,}
,  gradual = 0.05,  isOnFocus = true,  entered = false,  activatedSceneName = {"StageSelect",}
,  isFirst = true,  capscale = {1.219998717308,1.7300002574921,}
,  pos = {502,148,}
,  isHaveCaption = true,  focusAlpha = 0,  isFloating = true,  alpha = 255,  width = 777,  isDrag = true,  height = 116,  name = "MissionStr",  blend = 0,  tex = "MissionStr.bmp",  onMouse = false,  onFocus = false,  onEdit = false,}

PictureData["Stage1View"]={  view = "Mission",  cappos = {85,483,}
,  gradual = 0.05,  isOnFocus = true,  entered = false,  activatedSceneName = {"StageSelect",}
,  isFirst = true,  capscale = {1.219998717308,1.7300002574921,}
,  pos = {186,292,}
,  isHaveCaption = true,  focusAlpha = 0,  isFloating = true,  alpha = 255,  width = 169,  isDrag = true,  height = 152,  name = "Stage1View",  blend = 0,  tex = "StageResident.bmp",  onMouse = false,  onFocus = false,  onEdit = false,}

PictureData["StageClear"]={
view="GameUI",
  isFloating = true,
  cappos = {
85,
483,
}
,
  gradual = 0.05,
  isOnFocus = true,
  entered = false,
  activatedSceneName = {
"stage1_1",
"stage1_2",
"stage2_1",
"stage2_2",
"Stage3_1",
"Stage3_2",
}
,
  isFirst = true,
  capscale = {
1.219998717308,
1.7300002574921,
}
,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
windowW/2,
300,
}
,
  alpha = 255,
  width = 512,
  isDrag = true,
  blend = 0,
  onMouse = false,
  height = 512,
  tex = "StageClear.bmp",
  name = "StageClear",
  onFocus = false,
  onEdit = false,
  --TODO: GUI_Picture.lua must be loaded previously
  --[[
  processes={
	{ name="ClearCapFadeIn",state=FadeInProcess_State,data={
		name="StageClear",
		alpha=1,
		threshold=250,
		speed=2
		}
	}
  },
  update={
	{ func=GUI_Picture.addSize , data={ 
			maxW=550,	
			maxH=470,  
			speedW=5,
			speedH=2,
		}
	},

--	{ func=GUI_Picture.wait , data={ waitTime=2,} },
--	{ func=GUI_Picture.move , data={ dir={-1,0 },speed={15,0} , dst={-500,300 },err=10 }, } 
  },
  --]]
}

PictureData["StageSelectCap"]={
  isFloating = true,
  cappos = {
85,
483,
}
,
  gradual = 0.05,
  isOnFocus = true,
  entered = false,
  activatedSceneName = {
"StageSelect",
}
,
  isFirst = true,
  capscale = {
1.219998717308,
1.7300002574921,
}
,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
264,
120,
}
,
  alpha = 255,
  width = 588,
  isDrag = true,
  blend = 0,
  name = "StageSelectCap",
  height = 215,
  tex = "StageSelectStr.bmp",
  onMouse = false,
  onFocus = false,
  onEdit = false,
}

PictureData["StageStart"]={
  isFloating = true,
  cappos = {
85,
483,
}
,
  gradual = 0.05,
  isOnFocus = true,
  entered = false,
  activatedSceneName = {
"stage1_1",
"stage1_2",
"Stage2_1",
"Stage2_2",
"Stage3_1",
"Stage3_2",
}
,
  isFirst = true,
  capscale = {
1.219998717308,
1.7300002574921,
}
,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
windowW,
300,
}
,
  alpha = 1,
  width = windowW*2,
--  width = 0,
  isDrag = true,
  blend = 0,
  onMouse = false,
  height = 350,
--  height = 0,

  tex = "StageStart.bmp",
  name = "StageStart",
  onFocus = false,
  onEdit = false,
  --TODO: GUI_Picture.lua must be loaded previously
  processes={
	{ name="StageStartFadeIn",state=FadeInProcess_State,data={
		name="StageStart",
		alpha=1,
		threshold=150,
		speed=2
		},
		next={
			name="StageStartWait",state=WaitProcess_State,data={
				time=1,
				after=Process.KILLED,
			},
			next={ name="StageStartFadeOut",state=FadeOutProcess_State,data={
				name="StageStart",
				alpha=150,
				threshold=0,
				speed=2
				},
			
			}
		}
	}
  },
--  update={
--[[	{ func=GUI_Picture.addSize , data={ 
			maxW=800,	
			maxH=350,  
			speedW=5,
			speedH=2,
		}
	},
--]]
--	{ func=GUI_Picture.wait , data={ waitTime=2,} },
--	{ func=GUI_Picture.move , data={ dir={-1,0 },speed={1,0} , dst={-500,300 },err=10 }, } 
  --},
 --]]
 
}

PictureData["TitleLogo1"]={  isFloating = true,  cappos = {100,-100,}
,  gradual = 0.05,  isOnFocus = true,  entered = false,  activatedSceneName = {"Title","TitleMenu",}
,  isFirst = true,  capscale = {1.219998717308,1.7300002574921,}
,  isHaveCaption = true,  focusAlpha = 0,  pos = {392,192,}
,  alpha = 0,  width = 686,  isDrag = true,  blend = 0,  onMouse = false,  height = 200,  tex = "StreetsOf.bmp",  name = "TitleLogo1",  onFocus = false,  onEdit = false,}

PictureData["TitleLogo2"]={  isFloating = true,  cappos = {100,-100,}
,  gradual = 0.05,  isOnFocus = true,  entered = false,  activatedSceneName = {"Title","TitleMenu",}
,  isFirst = true,  capscale = {1.219998717308,1.7300002574921,}
,  isHaveCaption = true,  focusAlpha = 0,  pos = {540,338,}
,  alpha = 0,  width = 499,  isDrag = true,  blend = 0,  onMouse = false,  height = 193,  tex = "Punk.bmp",  name = "TitleLogo2",  onFocus = false,  onEdit = false,}

PictureData["TitleLogo3"]={
  isFloating = true,
  cappos = {
100,
-100,
}
,
  gradual = 0.05,
  isOnFocus = true,
  entered = false,
  activatedSceneName = {
"Title",
}
,
  isFirst = true,
  capscale = {
1.219998717308,
1.7300002574921,
}
,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
FullWidth()/2,
FullHeight()/2,
}
,
  alpha = 255,
  width = 512,
  isDrag = true,
  blend = 0,
  onMouse = false,
  height = 512,
  tex = "cregit2.bmp",
  name = "TitleLogo3",
  onFocus = false,
  onEdit = false,
  --TODO: GUI_Picture.lua must be loaded previously
--  update={
--	{ func=GUI_Picture.move , data={ dir={0,1 },speed={0,2} , dst={200,200 },err=10 }, } 
-- },
}

PictureData["UpperBlack"]={  view = "GlobalUI",  cappos = {85,483,}
,  gradual = 0.05,  isOnFocus = true,  entered = false,  activatedSceneName = {"TitleMenu","stage1_1","stage1_2","stage1_3","stage1_4","stage2_1","stage2_2","stage3_1","stage3_2","stage3_3",}
,  isFirst = true,  capscale = {1.219998717308,1.7300002574921,}
,  pos = {424,34,}
,  isHaveCaption = true,  focusAlpha = 0,  isFloating = true,  alpha = 255,  width = 848,  isDrag = true,  height = 121,  name = "UpperBlack",  blend = 0,  tex = "Black.bmp",  onMouse = false,  onFocus = false,  onEdit = false,}


ProgressBarData["BGMVol"]={  view = "Option",  isDrag = true,  entered = false,  activatedSceneName = {"Title","OptionMenu","TitleMenu","stage1_1","stage1_2","stage2_1",}
,  IsAfterRender = false,  isFirst = true,  currentW = 110,  isHaveCaption = true,  bartex = "ButtonFrame3.bmp",  increment = 1,  blend = 0,  width = 252,  incrementType = "size",  onMouse = false,  name = "BGMVol",  barpos = {326,248,}
,  height = 57,  tex = "ButtonFrame.bmp",  alpha = 255,  pos = {452,277,}
,}

ProgressBarData["HealthMeter1"]={  view = "GameUI",  isDrag = true,  entered = false,  bartex = "Life.bmp",  IsAfterRender = false,  isFirst = true,  barpos = {90,14,}
,  isHaveCaption = true,  alpha = 255,  width = 352,  incrementType = "size",  name = "HealthMeter1",  onMouse = false,  blend = 0,  height = 25,  activatedSceneName = {"stage1_1","stage1_2","stage2_1","stage2_2","stage3_1","stage3_2","stage3_3"}
,  tex = "BgmFrame.bmp",  pos = {266,26,}
,}

ProgressBarData["HealthMeter2"]={  view = "GameUI",  isDrag = true,  entered = false,  bartex = "HP.bmp",  IsAfterRender = false,  isFirst = true,  barpos = {424,32,}
,  isHaveCaption = true,  alpha = 255,  width = 352,  incrementType = "size",  name = "HealthMeter2",  onMouse = false,  blend = 0,  height = 25,  activatedSceneName = {"stage1_1","stage1_2","stage2_1","stage2_2",}
,  tex = "BgmFrame.bmp",  pos = {600,44,}
,}

ProgressBarData["NowLoading"]={
  barpos = {
24,
19,
}
,
  pos = {
200,
44,
}
,
  isHaveCaption = true,
  alpha = 255,
  name = "NowLoading",
  blend = 0,
  width = 200,
  height = 25,
  bartex = "HP.bmp",
  entered = false,
  activatedSceneName = {
  "Title",
  "TitleMenu",
  "CharaSelect",
  "StageSelect",
"Stage1",
"Stage2",
"Stage3",
}
,
  tex = "HPMeterFrame.bmp",
  IsAfterRender = false,
  isDrag = true,
  isFirst = true,
}

ProgressBarData["PhysicalMeter1"]={  view = "GameUI",  isDrag = true,  entered = false,  bartex = "HP.bmp",  IsAfterRender = false,  isFirst = true,  barpos = {90,45,}
,  isHaveCaption = true,  alpha = 255,  width = 297,  incrementType = "size",  name = "PhysicalMeter1",  onMouse = false,  blend = 0,  height = 20,  activatedSceneName = {"stage1_1","stage1_2","stage2_1","stage2_2",}
,  tex = "BgmFrame.bmp",  pos = {239,55,}
,}

ProgressBarData["PhysicalMeter2"]={  view = "GameUI",  isDrag = true,  entered = false,  bartex = "HP.bmp",  IsAfterRender = false,  isFirst = true,  barpos = {24,32,}
,  isHaveCaption = true,  alpha = 255,  width = 352,  incrementType = "size",  onMouse = false,  name = "PhysicalMeter2",  blend = 0,  tex = "BgmFrame.bmp",  activatedSceneName = {"stage1_1","stage1_2","stage2_1","stage2_2" }
,  height = 25,  pos = {400,144,}
,}

ProgressBarData["SEVol"]={  view = "Option",  isDrag = true,  entered = false,  activatedSceneName = {"Title","OptionMenu","TitleMenu","stage1_1","stage1_2","stage2_1",}
,  IsAfterRender = false,  isFirst = true,  currentW = 100,  isHaveCaption = true,  bartex = "ButtonFrame3.bmp",  increment = 1,  blend = 0,  width = 248,  incrementType = "size",  onMouse = false,  name = "SEVol",  barpos = {325,363,}
,  height = 54,  tex = "ButtonFrame.bmp",  alpha = 255,  pos = {449,390,}
,}


TextBoxData["GameScript"]={  view = "GlobalUI",  lines = 2,  active = false,  gradual = 0.05,  isOnFocus = true,  currLine = 1,  entered = false,  activatedAllScene = true,  isFloating = true,  cappos = {80,20,}
,  isFirst = true,  capscale = {0.8,0.8,}
,  showLimiteSec = true,  height = 93,  isHaveCaption = true,  focusAlpha = 0,  isDrag = true,  alpha = 255,  width = 871,  name = "GameScript",  blend = 0,  onMouse = false,  pos = {421,646,}
,  tex = "Black.bmp",  onEdit = false,  onFocus = false,  labelLines = {}
,}

TextBoxData["MissionScript"]={  view = "Mission",  lines = 2,  active = false,  gradual = 0.05,  isOnFocus = true,  currLine = 1,  entered = false,  activatedSceneName = {"StageSelect","stage1_1","stage1_2","stage2_1","stage2_2",}
,  activatedAllScene = true,  isFloating = true,  cappos = {24,40,}
,  isFirst = true,  capscale = {0.8,0.8,}
,  showLimiteSec = true,  height = 157,  isHaveCaption = true,  focusAlpha = 0,  isDrag = true,  alpha = 200,  width = 446,  name = "MissionScript",  blend = 0,  onMouse = false,  pos = {522,310,}
,  tex = "Black.bmp",  onEdit = false,  onFocus = false,  labelLines = {}
,}

TextBoxData["OptionWindow"]={
  isFloating = true,
  cappos = {
85,
483,
}
,
  gradual = 0.05,
  isOnFocus = true,
  entered = false,
  activatedSceneName = {
"TitleMenu",
}
,
  isFirst = true,
  capscale = {
1.219998717308,
1.7300002574921,
}
,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
442,
255,
}
,
  alpha = 255,
  width = 535,
  isDrag = true,
  blend = 0,
  name = "OptionWindow",
  height = 294,
  tex = "Option.bmp",
  onMouse = false,
  onFocus = false,
  onEdit = false,
}

TextBoxData["Script"]={  view = "GlobalUI",  lines = 2,  active = false,  gradual = 0.05,  isOnFocus = true,  currLine = 1,  entered = false,  activatedSceneName = {"TitleMenu","CharaSelect","StageSelect",}--"stage1_1","stage1_2","stage2_1","stage2_2",}  activatedAllScene = true, 
, isFloating = true,  cappos = {30,20,}
,  isFirst = true,  capscale = {0.8,0.8,}
,  showLimiteSec = true,  height = 55,  isHaveCaption = true,  focusAlpha = 0,  isDrag = true,  alpha = 200,  width = 869,  name = "Script",  blend = 0,  onMouse = false,  pos = {418,640,}
,  tex = "RedTape.bmp",  onEdit = false,  onFocus = false,  labelLines = {}
,}

TextBoxData["Tech"]={
  isFloating = true,
  cappos = {
85,
483,
}
,
  gradual = 0.05,
  isOnFocus = true,
  entered = false,
  activatedSceneName = {
"CharaSelect",
}
,
  isFirst = true,
  capscale = {
1.219998717308,
1.7300002574921,
}
,
  pos = {
488,
516,
}
,
  isHaveCaption = true,
  focusAlpha = 0,
  text = {
  TurboKick = {
  scale = {
}
,
  pos = {
}
,
}
,
  TurboPunch = {
  scale = {
}
,
  pos = {
}
,
}
,
}
,
  alpha = 255,
  width = 231,
  isDrag = true,
  blend = 0,
  name = "Tech",
  height = 171,
  tex = "WindowSkin.bmp",
  onMouse = false,
  onFocus = false,
  onEdit = false,
}

TextBoxData["TitleMenuComment"]={
  view="GlobalUI",
  activatedAllScene=true,
  isFloating = true,
  cappos = {
100,
600,
}
,
  gradual = 0.05,
  isOnFocus = true,
  entered = false,
  activatedSceneName = {
"TitleMenu",
}
,
  isFirst = true,
  capscale = {
1,1
}
,
  isHaveCaption = true,
  focusAlpha = 0,
  pos = {
416,
680,
}
,
  alpha = 255,
  width = 844,
  isDrag = true,
  blend = 0,
  onMouse = false,
  height = 242,
--  tex = "Black.bmp",
  tex = "concrete.dds",
  name = "TitleMenuComment",
  onFocus = false,
  onEdit = false,
}



